

ScanDTTApp.prototype = top.getFramework().createBaseApp();

function ScanDTTApp() {
}

ScanDTTApp.prototype.create = function() {  
	try
	{
		this._objErrorInfo = new Object();
		this._objErrorInfo._applicationName = 'ScanDTTApp';
		this._ui = this.fw.createSimpleFormUI("popupStarted");	
		this._ui.setForm(this.createForm());
		//variabile per l'utilizzo di referImageToLayout e referImageToIFrame
		this.pageLayout = this.fw.getLayoutManager().getLayout("popupStarted"); 
			
		
	}catch(ecc){
		this._objErrorInfo._methodName = 'create';
		this._objErrorInfo._obException = ecc;
		this.handleError();
		
	}
	return true;
}; 
ScanDTTApp.prototype.createForm=function() {

	try{	
		
		
		this._form = this.fw.createForm("helpForm");
		this._form.addField({ name: 'hiddenField', type: this._form.TYPE_HIDDEN, value:'' });
		this._form.setHandler(this);
		
		return this._form;
	}catch(ecc)
	{
		this._objErrorInfo._methodName ='createForm';
		this._objErrorInfo._obException = ecc;
		this.handleError();
	}
};


/*
*la seguente funzione testa se l'utente � al primo accesso. Nel caso del primo accesso l'applicazione 
*mostra delle pagine per confermare la linea telefonica sulla quale si sta accedendo all'applicazione
*nel secondo caso invece viene invocato un fetcher che controlla se il MAC address fisico � uguale 
*al MAC address provisionato e se la linea su cui il STB � connesso � uguale alla linea su cui l'utente 
*� provisionato 
*/

ScanDTTApp.prototype.init = function() { 
	try{
	
		this.sendLoadAppTrap("ScanDTTApp");
		
		var interval = (this.fw.getConfig().SCAN_INTERVAL == null) ? 60000 : this.fw.getConfig().SCAN_INTERVAL;
		this.scanInterval = this.fw.getTimer().setTimeout(interval, this.startDTTScan,this);
		this.fw._bScanAvviato = true;
		this.modalita=1;
		this.referImageToLayout("popupStarted","./dtt_up","/ovaImages/elementi_sfondo/scan_dtt_up1.gif");
		this.referImageToLayout("popupStarted","./dtt_down","/ovaImages/elementi_sfondo/scan_dtt_down1.gif");
		this.disegnaButton1();
		this.stato_dtt=0;
		this.isRigth=false;
		this._ui.redraw();
		
	}catch(ecc){
		this._objErrorInfo._methodName = 'init';
		this._objErrorInfo._obException = ecc;
		this.handleError();
	
	}
	return true;  
	
};

ScanDTTApp.prototype.startDTTScan = function(){
	this.isRigth==false;
	this.eventKeyEnter();
}

ScanDTTApp.prototype.fin = function() {
	try
	{	
		if(this.scanInterval){
			this.fw.getTimer().clearTimeout(this.scanInterval);
		}			
		this._standByTimer=null;
		
	}catch(ecc){
		this._objErrorInfo._methodName = 'fin';
		this._objErrorInfo._obException = ecc;
		this.handleError();
	}
	return true;
	
};


ScanDTTApp.prototype.eventKeyEnter = function() {
	
	if(this.isRigth==false){
		if (this.modalita==1){
					this.modalita=2;
					this.referImageToLayout("popupStarted","./dtt_up","/ovaImages/elementi_sfondo/scan_dtt_up2.gif");
					this.referImageToLayout("popupStarted","./dtt_down","/ovaImages/1pixelclear.gif");
					if(this.scanInterval){
						this.fw.getTimer().clearTimeout(this.scanInterval);
						}
					this.referImageToLayout("popupStarted","./popupStartedNew","/ovaImages/elementi_sfondo/dtt/impostazioni_Digitale_Terre_1.gif");		
					this.fw.getDTT().startScan();
					}
	}else{
		if(this.fw.getDTT().scanInProgress()==true){
			this.fw.getDTT().stopScan();
		}else{
			this.loadApp("/ovaServices/getapp/GetApp.jsp?urlapp=startup&app1=StartupApp&app2=Logger&app3=Sender&app4=AutoUpdate");
		} 		
	}	
	return true;	
};

ScanDTTApp.prototype.eventKeyScrollUp = function() {
	return true;
};

ScanDTTApp.prototype.eventKeyScrollDown = function() {
	return true;
};

ScanDTTApp.prototype.eventKeyPause = function() {
	return true;
};

ScanDTTApp.prototype.eventKeyPlay = function() {
	return true;
};

ScanDTTApp.prototype.eventKeyRwd = function() {
	return true;
};
ScanDTTApp.prototype.eventKeyEye = function() {
	return true;
};

ScanDTTApp.prototype.eventKeyFwd = function() {
	return true;
};

ScanDTTApp.prototype.eventKeyVolUp = function() {
	return true;
};

ScanDTTApp.prototype.eventKeyVolDown = function() {
	return true;
};

ScanDTTApp.prototype.eventKeyMute = function() {
	return true;
};

ScanDTTApp.prototype.eventKeyHot1 = function() {
	return true;
};

ScanDTTApp.prototype.eventKeyHot2 = function() {
	
	return true;
};

ScanDTTApp.prototype.eventKeyHot3 = function() {
	return true;
};

ScanDTTApp.prototype.eventKeyHot4 = function() {	  
	return true;
};

ScanDTTApp.prototype.eventKeyUp = function() {
	return true;
};

ScanDTTApp.prototype.eventKeyDown = function() {
	return true;
};

ScanDTTApp.prototype.eventKeyLeft = function() {
	try{
		this.isRigth=false;
		this.disegnaButton1();
}catch(ecc){
		this._objErrorInfo._methodName = 'eventKeyLeft';
		this._objErrorInfo._obException = ecc;
		this.handleError();
	
	}
	return true;			
};

ScanDTTApp.prototype.eventKeyRight = function() {
	try{
		this.isRigth=true;
		this.disegnaButton2();
}catch(ecc){
		this._objErrorInfo._methodName = 'eventKeyRight';
		this._objErrorInfo._obException = ecc;
		this.handleError();
	
	}
	return true;			
};



ScanDTTApp.prototype.eventDTTScanProgress=function(par){

	try{
		if(this.stato_dtt==0){
			if (par>0 && par < 20){
				this.referImageToLayout("popupStarted","./popupStartedNew","/ovaImages/elementi_sfondo/dtt/impostazioni_Digitale_Terre_1.gif");
			}else if (par>10 && par < 40){
				this.referImageToLayout("popupStarted","./popupStartedNew","/ovaImages/elementi_sfondo/dtt/impostazioni_Digitale_Terre_2.gif");
			}else if (par>30 && par < 50){
				this.referImageToLayout("popupStarted","./popupStartedNew","/ovaImages/elementi_sfondo/dtt/impostazioni_Digitale_Terre_3.gif");
			}else if (par>40 && par < 60){			
				this.referImageToLayout("popupStarted","./popupStartedNew","/ovaImages/elementi_sfondo/dtt/impostazioni_Digitale_Terre_4.gif");
			}	if (par>50 && par < 70){
				this.referImageToLayout("popupStarted","./popupStartedNew","/ovaImages/elementi_sfondo/dtt/impostazioni_Digitale_Terre_5.gif");
			}else if (par>60 && par < 80){
				this.referImageToLayout("popupStarted","./popupStartedNew","/ovaImages/elementi_sfondo/dtt/impostazioni_Digitale_Terre_6.gif");
			}else if (par>70 && par < 90){
				this.referImageToLayout("popupStarted","./popupStartedNew","/ovaImages/elementi_sfondo/dtt/impostazioni_Digitale_Terre_7.gif");
			}else if (par>80 && par < 110){
				this.referImageToLayout("popupStarted","./popupStartedNew","/ovaImages/elementi_sfondo/dtt/impostazioni_Digitale_Terre_8.gif");
			}
		}	
	
	}catch(ecc){
		this._objErrorInfo._methodName = 'eventDTTScanProgress';
		this._objErrorInfo._obException = ecc;
		this.handleError();
	
	}
	return true;	
};      

ScanDTTApp.prototype.eventDTTScanComplete=function(par){
	try{
		if(this.stato_dtt==0){
			this.referImageToLayout("popupStarted","./popupStartedNew","/ovaImages/1pixelclear.gif");
		}
		this.trapServiceList();
		
		//rinftresco la struttura dello zapper/zapping dopo aver effettuato la scansione DTT
		this.refreshZapper(true);
		
		this.loadApp("/ovaServices/getapp/GetApp.jsp?urlapp=startup&app1=StartupApp&app2=Logger&app3=Sender&app4=AutoUpdate");
		
	}catch(ecc){
		this._objErrorInfo._methodName = 'eventDTTScanComplete';
		this._objErrorInfo._obException = ecc;
		this.handleError();
		
	}
	return true;	
};      

ScanDTTApp.prototype.eventDTTScanStarted=function(par){
	try{
		this.stato_dtt=0;
		this.referImageToLayout("popupStarted","./popupStartedNew","/ovaImages/1pixelclear.gif");

		
	}catch(ecc){
		this._objErrorInfo._methodName = 'eventDTTScanStarted';
		this._objErrorInfo._obException = ecc;
		this.handleError();
		
	}
	return true;	
};      
ScanDTTApp.prototype.eventDTTScanStopped=function(par){
	try
	{
		if(this.stato_dtt==0){
			this.referImageToLayout("popupStarted","./popupStartedNew","/ovaImages/1pixelclear.gif");
			this.stato_dtt==1;
		}
		
		this.loadApp("/ovaServices/getapp/GetApp.jsp?urlapp=startup&app1=StartupApp&app2=Logger&app3=Sender&app4=AutoUpdate");

	
	}catch(ecc){
		this._objErrorInfo._methodName = 'eventDTTScanStopped';
		this._objErrorInfo._obException = ecc;
		this.handleError();
	
	}
	return true;	
};      
ScanDTTApp.prototype.eventDTTScanFailed=function(par){
	try{
		if(this.stato_dtt==0){
			this.referImageToLayout("popupStarted","./popupStartedNew","/ovaImages/avanzamento_digitale_Terrestre.gif");
			this.stato_dtt==1;
		}
		this.loadApp("/ovaServices/getapp/GetApp.jsp?urlapp=startup&app1=StartupApp&app2=Logger&app3=Sender&app4=AutoUpdate");
	}catch(ecc){
		this._objErrorInfo._methodName = 'eventDTTScanFailed';
		this._objErrorInfo._obException = ecc;
		this.handleError();
		
	}
	return true;	
} ;

ScanDTTApp.prototype.disegnaButton1=function(){
	try{
		this.referImageToLayout("popupStarted","./button1","/ovaImages/avviaRicercaOn.gif");
		this.referImageToLayout("popupStarted","./button2","/ovaImages/annullaRicercaOff.gif");
	}catch(ecc){
		this._objErrorInfo._methodName = 'disegnaButton1';
		this._objErrorInfo._obException = ecc;
		this.handleError();
		
	}
	
	return true;	
};
      
ScanDTTApp.prototype.disegnaButton2=function(){
	try{	
		this.referImageToLayout("popupStarted","./button1","/ovaImages/avviaRicercaOff.gif");
		this.referImageToLayout("popupStarted","./button2","/ovaImages/annullaRicercaOn.gif");
	}catch(ecc){
		this._objErrorInfo._methodName = 'disegnaButton2';
		this._objErrorInfo._obException = ecc;
		this.handleError();
		
	} 
	return true;	
};      

ScanDTTApp.prototype.eventKeyMenu = function() {
	try
	{		
		this.eventKeyEye();	
	}catch(ecc){
		this._objErrorInfo._methodName = 'eventKeyMenu';
		this._objErrorInfo._obException = ecc;
		this.handleError();
	}finally{
		return true;
	}
};

ScanDTTApp.prototype.eventKeyNumeric=function(digit){ 
	return true;
};