

AutoUpdate.prototype = top.getFramework().createBaseApp();     

function AutoUpdate(fw){
	
	
	this.fw=fw;
	this.type=null;
	
	this.initVal();
	//this.fristUpdateTimer();
	
	this._objErrorInfo = new Object();
	this._objErrorInfo._applicationName = 'AutoUpdate';
	this._objErrorInfo._methodName = '';
   this._objErrorInfo._obException =new Object();
};

AutoUpdate.prototype.initVal=function(){
	try{
	
	this.fw.rebootable = false;
	this.fw.isInactive = false;
	
	
	try{
		this.currOvaVer=this.getOvaVer();
	}catch(e){
		this.currOvaVer='0.0';
	}
	try{
		this.currFwVer=navigator.Get_sw_version();
	}catch(e){	
		this.currFwVer='0.0';
	}
	
	
	this.START_TIME=null;
	this.STOP_TIME=null;
	this.REQUEST_TIME=null;
	/* START_UPDATE_TIME: '1' */
	this.START_TIME=this.fw.getConfig().START_UPDATE_TIME;
	if(this.START_TIME==null){
		this.START_TIME=2;
	}
	/* STOP_UPDATE_TIME: '23' */
	this.STOP_TIME=this.fw.getConfig().STOP_UPDATE_TIME;
	if(this.STOP_TIME==null){
		this.STOP_TIME=6;
	}
	/* REQUEST_UPDATE_TIME: '90' */
	this.REQUEST_TIME=this.fw.getConfig().REQUEST_UPDATE_TIME;
	if(this.REQUEST_TIME==null){
		this.REQUEST_TIME=30;
	}
	this.frequencyTimer = parseInt(this.REQUEST_TIME)*60*1000;
	
	//calcolo dello sfasamento iniziale con le penultime 2 cifre dell'acc_recid
	var ran_number=this.fw.getUserInfo().getAccountID(); 
	var stNum = ran_number.toString();
	var lun =stNum.length;
	var minuti =stNum.substr(lun - 3,lun - 2);
	this.shiftTime=parseInt(minuti)*60*1000;
	
	this.frequencyTimerShift=this.frequencyTimer+this.shiftTime;
	
	this._continueAutoUpdateTimer=this.fw.getTimer().setTimeout(this.frequencyTimerShift, this._continueAutoUpdate, this);
	this.fw.arrTimerUpdate[0]=this._continueAutoUpdateTimer;//non resetta il timer in standby
		
	}catch(ecc){
	return true;
	}

};




AutoUpdate.prototype._continueAutoUpdate=function(){
	
	try
	{
		if(this._continueAutoUpdateTimer){
			this.fw.getTimer().clearTimeout(this._continueAutoUpdateTimer);
			this._continueAutoUpdateTimer=null;
		}
		
		this._continueAutoUpdateTimer=this.fw.getTimer().setTimeout(this.frequencyTimer, this._continueAutoUpdate, this);
		this.fw.arrTimerUpdate[0]=this._continueAutoUpdateTimer;//non resetta il timer in standby
		
		var data_temp=this.fw.getOSD().getTime();
		var orarioFinestra=new Date();
		orarioFinestra.setTime(data_temp);	
		var ore = orarioFinestra.getUTCHours();	
		
		  
		if (ore > this.START_TIME-1 && ore <= this.STOP_TIME) {
		//gestione STB PIRELLI
		 var platformType=this.fw.getAppManager()._path;
		 if(platformType=='telsey')
			 this.fw.getFetcher().fetchLater("/ovaServices/management/StbFwVersionFetch.jsp", this, this._getUpdate);
		  else if(platformType=='pirelli_sd' || platformType=='pirelli_dtt')
		  	this.fw.getFetcher().fetchLater("/ovaServices/management/StbFwVersionFetch.jsp?stb_type=PIRELLI", this,this._getUpdate); 	 		 	
		
		}
		
		return true;
		
	}catch(ecc){
	
		return true;
	}
	
};


AutoUpdate.prototype._getUpdate=function(obj){
try{	
		
		if(obj && obj.errorCode){  
				this.newOvaVer=this.currOvaVer;
				 this.newFwVer=this.currFwVer;
		}else{
			try{			
				this.newOvaVer=obj.content[0].stb_ova_version;
				this.newFwVer=obj.content[0].stb_fw_version;
						
			}catch(ecc){
				this.newOvaVer=this.currOvaVer;
				this.newFwVer=this.currFwVer;	
			}		
		}
		
		if((this.newOvaVer!=this.currOvaVer) || (this.newFwVer!=this.currFwVer)){
		   this.fw.rebootable = true;
		 	if(this.fw.power==false){
		 	
			try{
				
				navigator.Reboot();//rebootta
			}
			catch(e)
			{
				return true;
				//this.getPlogger("errore_navigator.Reboot()");
			}
			}
		
		}
		
			return true;
}catch(ecc){
		return true;
}	

};

		

