

StartupApp.prototype = top.getFramework().createBaseApp();

function StartupApp() {
}

StartupApp.prototype.create = function() {
	try
	{
		
omc.logger.addEntry("StartupApp.prototype.create");
		
		// creazione del nuovo oggetto per callPPVSKYFetcherla gestione delle nuove trap in caso di catch
		this._objErrorInfo = new Object();
		this._objErrorInfo._applicationName = 'StartupApp';
		this._objErrorInfo._methodName = '';
		this._objErrorInfo._obException = new Object();
		if (this.fw.power==null || this.fw.power==undefined){
			this.fw.power=true;
		}
		if (this.fw.ovaVersion==null || this.fw.ovaVersion==undefined){
			this.fw.ovaVersion=this.getOvaVer();
		}
// 		/* Impostazione Layout in layoutMod, precaricato in fase di inizializzazione (.create) in framework.js */
		/* se commento tutto quello che c'è dopo e lascio questo si blocca tutto lo stesso a GetApp.html in 
		   chiusura */
		this.fw.getLayoutManager().setLayout("loadingLayout");
		var layoutManager = this.fw.getLayoutManager();
		this.creaMatriceFetcher();
		if (this.fw.arrTimerUpdate==null || this.fw.arrTimerUpdate==undefined){
			this.fw.arrTimerUpdate = new Array();  
		}
		if (this.fw.arrTimer==null || this.fw.arrTimer==undefined){
			this.fw.arrTimer = new Array(); 
		}

		this.fw.callerApp='StartupApp';
		// istanzia un nuovo oggetto globale del framework che serve per lanciare TRAP SNMP
		/* commentando questo non parte */
		/* Setta un nuovo logger e send_trap per vedere su console SIGNON e BROWSING */
		if (this.fw.LoggerApp==null || this.fw.LoggerApp==undefined){	
			this.fw.LoggerApp=new Logger(this.fw);
		}
		
		/* Aprire e vedere AutoUpdate per capire */
		if (this.fw.AutoUpdateApp==null || this.fw.AutoUpdateApp==undefined){
			this.fw.AutoUpdateApp=new AutoUpdate(this.fw);
		}
		if (this.fw.ratingCheckBTV==null || this.fw.ratingCheckBTV==undefined){
			this.fw.ratingCheckBTV=true;
		}
		if (this.fw.EpgConfig==null || this.fw.EpgConfig==undefined){
			this.fw.EpgConfig = new Object();
		}
		
		//inizializzo la variabile che contiene la versione del framework che gira sul stb
		if (this.fw.currentFwVersion==null || this.fw.currentFwVersion==undefined){
			try{
				this.fw.currentFwVersion=navigator.Get_sw_version();
			}catch(e){
				this.fw.currentFwVersion='0.0'; //caso browserino e di recovery
			}
		}
	}catch(ecc){
		this._objErrorInfo._methodName = 'create';
		this._objErrorInfo._obException = ecc;
		this.handleError();
	}
	return true;
}; 

/* Chiamata dalla callback relativa a NormalBoot.html */
StartupApp.prototype.inizializza = function() {
	try
	{	/* Inizialmente non entra */
		
		/* da index.html si ha STARTUP_DELAY_APP: '300000' */
		var delay_standby=this.fw.getConfig().STARTUP_DELAY_APP;
		if (!delay_standby) // di default aspetta 5 minuti prima dello standby
		{
			delay_standby=300000;
		}
		
		// carico la matrice contenente il menu 
		this.matrixFetch();
		
		/* ho provato a commentarlo e non cambia, almeno inizialmente essendo un timeout
		   Ecco perchè dopo un tot la pagina muore se non si fa niente */
// 		this._standByTimer=this.fw.getTimer().setTimeout(delay_standby, this.goStandBy, this);
		
		this.fw.getLayoutManager().setLayout("loadingLayout");
		/* Se commento questo l'immagine non parte */
		this.eventGotEpgConfiguration();

	}catch(ecc){
	
		this._objErrorInfo._methodName = 'inizializza';
		this._objErrorInfo._obException = ecc;
		this.handleError();
	}
	return true;
}; 

StartupApp.prototype.matrixFetch = function(){
	try
	{
//		{myIndex: 0,menuName: 'ROOT',menuParent: -1,menuChilds: [1,436],lastChildIndexSelected: 0,applicationConfig: {}},
//		{myIndex: 1,menuName: 'Tv',menuParent: 0,menuChilds: [2],lastChildIndexSelected: 0,applicationConfig: {}},
		this.fw.menuArray = new Array();
		omc.logger.addEntry("###### StartupApp.matrixFetch : "+this.fw.VERSIONE_MOD_CANALI);
		switch(this.fw.VERSIONE_MOD_CANALI){
		case 0:
			
			omc.logger.addEntry("###### StartupApp.matrixFetch : 0");
			this.fw.menuArray = [
			      	            {myIndex: 0,menuName: 'Opzioni',menuParent: -1,menuChilds: [1,4],lastChildIndexSelected: 0,applicationConfig: {}}, 	 			
			      				{myIndex: 1,menuName: 'Impostazioni'      ,menuParent: 0,menuChilds: [2,3],lastChildIndexSelected: 0,applicationConfig: {}},
			      				{myIndex: 2,menuName: 'Set Top Box'       ,menuParent: 1,menuChilds: [],lastChildIndexSelected: 0,applicationConfig: eval({name:'Stb'        ,catNumber:501,action:'loadApp',resume:false, categoryId: 84,categoryImg:'', categoryName:'',box:'',appReturn:'',imgVert:'subItem_',ottimizzato:true,url:'/ovaServices/getapp/HomeImpostazioniSTBApp.html?urlapp=impostazioni&app1=ImpostazioniSTBApp',imgTabName:'stb.png'})},
			      				{myIndex: 3,menuName: 'Digitale Terrestre',menuParent: 1,menuChilds: [],lastChildIndexSelected: 0,applicationConfig: eval({name:'Televisione',catNumber:501,action:'loadApp',resume:false, categoryId: 84,categoryImg:'', categoryName:'',box:'',appReturn:'',imgVert:'subItem_',ottimizzato:true,url:'/ovaServices/getapp/ScanDTTSettingsApp.html?urlapp=impostazioni&app1=ScanDTTSettingsApp',imgTabName:'televisione.png'})}, 				
			      				{myIndex: 4,menuName: 'Aiuto'              ,menuParent: 0,menuChilds: [5,6,7],lastChildIndexSelected: 0,applicationConfig: {}},			
			      				{myIndex: 5,menuName: 'Uso del Telecomando',menuParent: 4,menuChilds: [],lastChildIndexSelected: 0,applicationConfig: eval({name:'telecomando'      ,catNumber:501,action:'loadApp',resume:false, categoryId: 84,categoryImg:'', categoryName:'',box:'',appReturn:'',imgVert:'subItem_',ottimizzato:true,url:'/ovaServices/getapp/GetAppTelecomando.html?urlapp=help&app1=HelpRemoteControllerAppRes',imgTabName:'telecomando.png'})},
			      				{myIndex: 6,menuName: 'Installazione'      ,menuParent: 4,menuChilds: [],lastChildIndexSelected: 0,applicationConfig: eval({name:'installazione'    ,catNumber:501,action:'loadApp',resume:false, categoryId: 84,categoryImg:'', categoryName:'',box:'',appReturn:'',imgVert:'subItem_',ottimizzato:true,url:'/ovaServices/getapp/GetAppInstallazione.html?urlapp=help&app1=HelpInstallationAppRes',imgTabName:'installazione.png'})},
			      				{myIndex: 7,menuName: 'Soluzione Problemi' ,menuParent: 4,menuChilds: [],lastChildIndexSelected: 0,applicationConfig: eval({name:'SoluzioneProblemi',catNumber:501,action:'loadApp',resume:false, categoryId: 84,categoryImg:'', categoryName:'',box:'',appReturn:'',imgVert:'subItem_',ottimizzato:true,url:'/ovaServices/getapp/GetAppSoluzione.html?urlapp=help&app1=HelpProblemSolveAppRes',imgTabName:'soluzione_problemi.png'})}
			      				
			      				];
			break;
		case 1:
			omc.logger.addEntry("###### StartupApp.matrixFetch : 1 ");
			this.fw.menuArray = [
			     	            {myIndex: 0,menuName: 'Opzioni',menuParent: -1,menuChilds: [1,5],lastChildIndexSelected: 0,applicationConfig: {}},
			     	 			
			     				{myIndex: 1,menuName: 'Impostazioni'      ,menuParent: 0,menuChilds: [2,3,4],lastChildIndexSelected: 0,applicationConfig: {}},
			     				{myIndex: 2,menuName: 'Set Top Box'       ,menuParent: 1,menuChilds: [],lastChildIndexSelected: 0,applicationConfig: eval({name:'Stb'        ,catNumber:501,action:'loadApp',resume:false, categoryId: 84,categoryImg:'', categoryName:'',box:'',appReturn:'',imgVert:'subItem_',ottimizzato:true,url:'/ovaServices/getapp/HomeImpostazioniSTBApp.html?urlapp=impostazioni&app1=ImpostazioniSTBApp',imgTabName:'stb.png'})},
			     				{myIndex: 3,menuName: 'Digitale Terrestre',menuParent: 1,menuChilds: [],lastChildIndexSelected: 0,applicationConfig: eval({name:'Televisione',catNumber:501,action:'loadApp',resume:false, categoryId: 84,categoryImg:'', categoryName:'',box:'',appReturn:'',imgVert:'subItem_',ottimizzato:true,url:'/ovaServices/getapp/ScanDTTSettingsApp.html?urlapp=impostazioni&app1=ScanDTTSettingsApp',imgTabName:'televisione.png'})},
			     				{myIndex: 4,menuName: 'Preferiti'         ,menuParent: 1,menuChilds: [],lastChildIndexSelected: 0,applicationConfig: eval({name:'Preferiti'  ,catNumber:501,action:'loadApp',resume:false, categoryId: 84,categoryImg:'', categoryName:'',box:'',appReturn:'',imgVert:'subItem_',ottimizzato:true,url:'/ovaServices/getapp/GetAppPreferiti.html?urlapp=impostazioni&app1=PreferitiApp',imgTabName:'preferiti.png'})},
			     				
			     				{myIndex: 5,menuName: 'Aiuto'              ,menuParent: 0,menuChilds: [6,7,8,9],lastChildIndexSelected: 0,applicationConfig: {}},			
			     				{myIndex: 6,menuName: 'Uso del Telecomando',menuParent: 5,menuChilds: [],lastChildIndexSelected: 0,applicationConfig: eval({name:'telecomando'      ,catNumber:501,action:'loadApp',resume:false, categoryId: 84,categoryImg:'', categoryName:'',box:'',appReturn:'',imgVert:'subItem_',ottimizzato:true,url:'/ovaServices/getapp/GetAppTelecomando.html?urlapp=help&app1=HelpRemoteControllerAppRes',imgTabName:'telecomando.png'})},
			     				{myIndex: 7,menuName: 'Installazione'      ,menuParent: 5,menuChilds: [],lastChildIndexSelected: 0,applicationConfig: eval({name:'installazione'    ,catNumber:501,action:'loadApp',resume:false, categoryId: 84,categoryImg:'', categoryName:'',box:'',appReturn:'',imgVert:'subItem_',ottimizzato:true,url:'/ovaServices/getapp/GetAppInstallazione.html?urlapp=help&app1=HelpInstallationAppRes',imgTabName:'installazione.png'})},
			     				{myIndex: 8,menuName: 'Soluzione Problemi' ,menuParent: 5,menuChilds: [],lastChildIndexSelected: 0,applicationConfig: eval({name:'SoluzioneProblemi',catNumber:501,action:'loadApp',resume:false, categoryId: 84,categoryImg:'', categoryName:'',box:'',appReturn:'',imgVert:'subItem_',ottimizzato:true,url:'/ovaServices/getapp/GetAppSoluzione.html?urlapp=help&app1=HelpProblemSolveAppRes',imgTabName:'soluzione_problemi.png'})},
			     				{myIndex: 9,menuName: 'Configura Preferiti' ,menuParent: 5,menuChilds: [],lastChildIndexSelected: 0,applicationConfig: eval({name:'ConfiguraPreferiti',catNumber:501,action:'loadApp',resume:false, categoryId: 84,categoryImg:'', categoryName:'',box:'',appReturn:'',imgVert:'subItem_',ottimizzato:true,url:'/ovaServices/getapp/GetAppHelpPreferiti.html?urlapp=help&app1=HelpPreferiti',imgTabName:'configura_preferiti.png'})}
			     				];
			break;
		case 2:
			omc.logger.addEntry("###### StartupApp.matrixFetch : 2 ");
			this.fw.menuArray = [
			     	            {myIndex: 0,menuName: 'Opzioni',menuParent: -1,menuChilds: [1,5],lastChildIndexSelected: 0,applicationConfig: {}},
			     	 			
			     				{myIndex: 1,menuName: 'Impostazioni'      ,menuParent: 0,menuChilds: [2,3,4],lastChildIndexSelected: 0,applicationConfig: {}},
			     				{myIndex: 2,menuName: 'Set Top Box'       ,menuParent: 1,menuChilds: [],lastChildIndexSelected: 0,applicationConfig: eval({name:'Stb'        ,catNumber:501,action:'loadApp',resume:false, categoryId: 84,categoryImg:'', categoryName:'',box:'',appReturn:'',imgVert:'subItem_',ottimizzato:true,url:'/ovaServices/getapp/HomeImpostazioniSTBApp.html?urlapp=impostazioni&app1=ImpostazioniSTBApp',imgTabName:'stb.png'})},
			     				{myIndex: 3,menuName: 'Digitale Terrestre',menuParent: 1,menuChilds: [],lastChildIndexSelected: 0,applicationConfig: eval({name:'Televisione',catNumber:501,action:'loadApp',resume:false, categoryId: 84,categoryImg:'', categoryName:'',box:'',appReturn:'',imgVert:'subItem_',ottimizzato:true,url:'/ovaServices/getapp/ScanDTTSettingsApp.html?urlapp=impostazioni&app1=ScanDTTSettingsApp',imgTabName:'televisione.png'})},
			     				{myIndex: 4,menuName: 'ModificaCanali'    ,menuParent: 1,menuChilds: [],lastChildIndexSelected: 0,applicationConfig: eval({name:'ModificaCanali'  ,catNumber:501,action:'loadApp',resume:false, categoryId: 84,categoryImg:'', categoryName:'',box:'',appReturn:'',imgVert:'subItem_',ottimizzato:true,url:'/ovaServices/getapp/GetAppModificaCanali.html?urlapp=impostazioni&app1=ModificaCanali',imgTabName:'ModificaCanali.png'})},
			     				
			     				{myIndex: 5,menuName: 'Aiuto'              ,menuParent: 0,menuChilds: [6,7,8],lastChildIndexSelected: 0,applicationConfig: {}},			
			     				{myIndex: 6,menuName: 'Uso del Telecomando',menuParent: 5,menuChilds: [],lastChildIndexSelected: 0,applicationConfig: eval({name:'telecomando'      ,catNumber:501,action:'loadApp',resume:false, categoryId: 84,categoryImg:'', categoryName:'',box:'',appReturn:'',imgVert:'subItem_',ottimizzato:true,url:'/ovaServices/getapp/GetAppTelecomando.html?urlapp=help&app1=HelpRemoteControllerAppRes',imgTabName:'telecomando.png'})},
			     				{myIndex: 7,menuName: 'Installazione'      ,menuParent: 5,menuChilds: [],lastChildIndexSelected: 0,applicationConfig: eval({name:'installazione'    ,catNumber:501,action:'loadApp',resume:false, categoryId: 84,categoryImg:'', categoryName:'',box:'',appReturn:'',imgVert:'subItem_',ottimizzato:true,url:'/ovaServices/getapp/GetAppInstallazione.html?urlapp=help&app1=HelpInstallationAppRes',imgTabName:'installazione.png'})},
			     				{myIndex: 8,menuName: 'Soluzione Problemi' ,menuParent: 5,menuChilds: [],lastChildIndexSelected: 0,applicationConfig: eval({name:'SoluzioneProblemi',catNumber:501,action:'loadApp',resume:false, categoryId: 84,categoryImg:'', categoryName:'',box:'',appReturn:'',imgVert:'subItem_',ottimizzato:true,url:'/ovaServices/getapp/GetAppSoluzione.html?urlapp=help&app1=HelpProblemSolveAppRes',imgTabName:'soluzione_problemi.png'})}
			     				];
			break;
		case 3:
			omc.logger.addEntry("###### StartupApp.matrixFetch : 2 ");
			this.fw.menuArray = [
			     	            {myIndex: 0,menuName: 'Opzioni',menuParent: -1,menuChilds: [1,5],lastChildIndexSelected: 0,applicationConfig: {}},
			     	 			
			     				{myIndex: 1,menuName: 'Impostazioni'      ,menuParent: 0,menuChilds: [2,3,4,9],lastChildIndexSelected: 0,applicationConfig: {}},
			     				{myIndex: 2,menuName: 'Set Top Box'       ,menuParent: 1,menuChilds: [],lastChildIndexSelected: 0,applicationConfig: eval({name:'Stb'        ,catNumber:501,action:'loadApp',resume:false, categoryId: 84,categoryImg:'', categoryName:'',box:'',appReturn:'',imgVert:'subItem_',ottimizzato:true,url:'/ovaServices/getapp/HomeImpostazioniSTBApp.html?urlapp=impostazioni&app1=ImpostazioniSTBApp',imgTabName:'stb.png'})},
			     				{myIndex: 3,menuName: 'Digitale Terrestre',menuParent: 1,menuChilds: [],lastChildIndexSelected: 0,applicationConfig: eval({name:'Televisione',catNumber:501,action:'loadApp',resume:false, categoryId: 84,categoryImg:'', categoryName:'',box:'',appReturn:'',imgVert:'subItem_',ottimizzato:true,url:'/ovaServices/getapp/ScanDTTSettingsApp.html?urlapp=impostazioni&app1=ScanDTTSettingsApp',imgTabName:'televisione.png'})},
			     				{myIndex: 4,menuName: 'ModificaCanali'    ,menuParent: 1,menuChilds: [],lastChildIndexSelected: 0,applicationConfig: eval({name:'ModificaCanali'  ,catNumber:501,action:'loadApp',resume:false, categoryId: 84,categoryImg:'', categoryName:'',box:'',appReturn:'',imgVert:'subItem_',ottimizzato:true,url:'/ovaServices/getapp/GetAppModificaCanali.html?urlapp=impostazioni&app1=ModificaCanali',imgTabName:'ModificaCanali.png'})},
			     				
			     				
			     				{myIndex: 5,menuName: 'Aiuto'              ,menuParent: 0,menuChilds: [6,7,8,10],lastChildIndexSelected: 0,applicationConfig: {}},			
			     				{myIndex: 6,menuName: 'Uso del Telecomando',menuParent: 5,menuChilds: [],lastChildIndexSelected: 0,applicationConfig: eval({name:'telecomando'      ,catNumber:501,action:'loadApp',resume:false, categoryId: 84,categoryImg:'', categoryName:'',box:'',appReturn:'',imgVert:'subItem_',ottimizzato:true,url:'/ovaServices/getapp/GetAppTelecomando.html?urlapp=help&app1=HelpRemoteControllerAppRes',imgTabName:'telecomando.png'})},
			     				{myIndex: 7,menuName: 'Installazione'      ,menuParent: 5,menuChilds: [],lastChildIndexSelected: 0,applicationConfig: eval({name:'installazione'    ,catNumber:501,action:'loadApp',resume:false, categoryId: 84,categoryImg:'', categoryName:'',box:'',appReturn:'',imgVert:'subItem_',ottimizzato:true,url:'/ovaServices/getapp/GetAppInstallazione.html?urlapp=help&app1=HelpInstallationAppRes',imgTabName:'installazione.png'})},
			     				{myIndex: 8,menuName: 'Soluzione Problemi' ,menuParent: 5,menuChilds: [],lastChildIndexSelected: 0,applicationConfig: eval({name:'SoluzioneProblemi',catNumber:501,action:'loadApp',resume:false, categoryId: 84,categoryImg:'', categoryName:'',box:'',appReturn:'',imgVert:'subItem_',ottimizzato:true,url:'/ovaServices/getapp/GetAppSoluzione.html?urlapp=help&app1=HelpProblemSolveAppRes',imgTabName:'soluzione_problemi.png'})},
			     				{myIndex: 9,menuName: 'Preferiti'         ,menuParent: 1,menuChilds: [],lastChildIndexSelected: 0,applicationConfig: eval({name:'Preferiti'  ,catNumber:501,action:'loadApp',resume:false, categoryId: 84,categoryImg:'', categoryName:'',box:'',appReturn:'',imgVert:'subItem_',ottimizzato:true,url:'/ovaServices/getapp/GetAppPreferiti.html?urlapp=impostazioni&app1=PreferitiApp',imgTabName:'preferiti.png'})},
			     				{myIndex: 10,menuName: 'Configura Preferiti' ,menuParent: 5,menuChilds: [],lastChildIndexSelected: 0,applicationConfig: eval({name:'ConfiguraPreferiti',catNumber:501,action:'loadApp',resume:false, categoryId: 84,categoryImg:'', categoryName:'',box:'',appReturn:'',imgVert:'subItem_',ottimizzato:true,url:'/ovaServices/getapp/GetAppHelpPreferiti.html?urlapp=help&app1=HelpPreferiti',imgTabName:'configura_preferiti.png'})}
			     				];
			break;
		}  		                     
							
	}catch(ecc){
		this._objErrorInfo._methodName = 'matrixFetch';			
		this._objErrorInfo._obException = ecc;
		this.handleError();
	}
	return true;
};	
	
/*
*la seguente funzione testa se l'utente � al primo accesso. Nel caso del primo accesso l'applicazione 
*mostra delle pagine per confermare la linea telefonica sulla quale si sta accedendo all'applicazione
*nel secondo caso invece viene invocato un fetcher che controlla se il MAC address fisico � uguale 
*al MAC address provisionato e se la linea su cui il STB � connesso � uguale alla linea su cui l'utente 
*� provisionato 
*/

StartupApp.prototype.init = function() { 
	try{	
		omc.logger.addEntry("StartupApp.prototype.init");
		/* Questa funzione viene definita in BaseApp.js */
		this.sendLoadAppTrap("StartupApp");
		this.fw.zapperChanged = false;
		this.fw.eyePressed = false;
		
//		try{
//			this.fw.TILAB_ROOT = navigator.getEnv("TILAB_ROOT");
//		}catch(e){
//			omc.logger.addEntry("############################# FRESCO SENZA JSEXT NAVIGATOR:GETENV()#############");
//			this.fw.TILAB_ROOT = "/mnt/thttpd/tilab_root/";
//			
//		}
		
		 
		this.fw.URL_IMG_ZAPP_DEFAULT = this.fw.getConfig().URL_IMG_ZAPP_DEFAULT;
		this.fw.URL_IMG_ZAPP_FAV     = this.fw.getConfig().URL_IMG_ZAPP_FAV;
		this.fw.URL_HTML             = this.fw.getConfig().URL_HTML;		
		this.fw.OMC_LOGGER_ENABLED = eval(this.fw.getConfig().OMC_LOGGER_ENABLED);
		this.fw.VERSIONE_MOD_CANALI = eval(this.fw.getConfig().VERSIONE_MOD_CANALI);
		this.fw.DATA_ORA_ENABLED = eval(this.fw.getConfig().DATA_ORA_ENABLED);
		
		
		
		omc.logger.addEntry("#############################");
		omc.logger.addEntry("########## CARICO PREFS ##############");
		omc.logger.addEntry("#############################");
		
		omc.logger.addEntry("this.fw.TILAB_ROOT : "+this.fw.TILAB_ROOT);
		omc.logger.addEntry("this.fw.URL_IMG_ZAPP_DEFAULT : "+this.fw.URL_IMG_ZAPP_DEFAULT);
		omc.logger.addEntry("this.fw.URL_IMG_ZAPP_FAV : "+this.fw.URL_IMG_ZAPP_FAV);
		omc.logger.addEntry("this.fw.URL_HTML_ZAPP_FAV : "+this.fw.URL_HTML);
		omc.logger.addEntry("this.fw.OMC_LOGGER_ENABLED : "+this.fw.OMC_LOGGER_ENABLED);
		omc.logger.addEntry("this.fw.DATA_ORA_ENABLED : "+this.fw.DATA_ORA_ENABLED);
		
		omc.logger.addEntry("this.fw.VERSIONE_MOD_CANALI : "+this.fw.VERSIONE_MOD_CANALI +" [0 =fav-off/can-off];[1=fav-on/can-off];[2=fav-off/can-on];[3 fav-on/can-on]");
		
		omc.logger.addEntry("#############################");
		omc.logger.addEntry("########## FINE CARICO PREFS ##########");
		omc.logger.addEntry("#############################");
		
		
		
		
		/* sono sicuro di essere un utente DTT */
		this.fw.UserEnableDTT='Y';
		this._initStart();  //nuovo metodo che esegue il codice che attualmente viene eseguito nella init
		
		//Non fa più comparire l'occhio
		this.fw.getTimer().setTimeout(4000,this.eventKeyEye,this);
	}catch(ecc){
		this._objErrorInfo._methodName = 'init';
		this._objErrorInfo._obException = ecc;
		this.handleError();
	}
	return true;  
};

StartupApp.prototype._initStart = function() { 
	try{
		
		this.fw.getFetcher().fetchNow("file://"+this.fw.TILAB_ROOT+this.fw.URL_HTML + "Boot.html", this,this._gotBoot);
		

	}catch(ecc){
		this._objErrorInfo._methodName = '_initStart';
		this._objErrorInfo._obException = ecc;
		this.handleError();
	}
	return true;  
	
};


StartupApp.prototype._gotBoot = function(obj) { 
	try{	
		
		if(obj.firstTime != undefined)
			this.fw.firstTimeBootBox = eval(obj.firstTime);
		else
			this.fw.firstTimeBootBox = true;
		if(this.fw.OMC_LOGGER_ENABLED)
			omc.logger.addEntry("#################### 3 StartupApp._gotBoot - firstTimeBoot: "+this.fw.firstTimeBootBox);
		
		if(obj.regione){
			if(obj.regione!=''){
				this.fw.regioneCanaliDefault= obj.regione;
				if(this.fw.OMC_LOGGER_ENABLED)omc.logger.addEntry("####################  StartupApp._gotBoot - this.fw.regioneCanaliDefault: "+this.fw.regioneCanaliDefault);
			}else{
				this.fw.regioneCanaliDefault= "Default";
			}
		}else{
			this.fw.regioneCanaliDefault= "Default";
		}
		
		if(obj.ordinamentoCanali){
			if(obj.ordinamentoCanali!=''){
				this.fw.ORDINAMENTO_CANALI_FATTO= eval(obj.ordinamentoCanali);
				if(this.fw.OMC_LOGGER_ENABLED)omc.logger.addEntry("####################  StartupApp._gotBoot - ordinamentoCanali: "+this.fw.ORDINAMENTO_CANALI_FATTO);
			}else{
				this.fw.ORDINAMENTO_CANALI_FATTO= false;
			}
		}else{
			this.fw.ORDINAMENTO_CANALI_FATTO= false;
		}
		
		if(obj.preferitiON){
			if(obj.preferitiON!=''){
				this.fw.ShowPreferiti= eval(obj.preferitiON);
				if(this.fw.OMC_LOGGER_ENABLED)
					omc.logger.addEntry("####################  StartupApp._gotBoot - preferitiON: "+this.fw.ShowPreferiti);
			}else{
				this.fw.ShowPreferiti= 0;
			}
		}else{
			this.fw.ShowPreferiti= 0;
		}
		
		if(obj.firstTime != undefined)
			this.fw.cgiHasFinished= eval(obj.cgiHasFinished);
		else
			this.fw.cgiHasFinished = true;
		
		if(this.fw.OMC_LOGGER_ENABLED)
			omc.logger.addEntry("####################  StartupApp._gotBoot - cgiHasFinished  "+this.fw.cgiHasFinished);
		
		this._initStart_After_Boot();
	}catch(ecc){
		this._objErrorInfo._methodName = '_initStart';
		this._objErrorInfo._obException = ecc;
		this.handleError();
	}
	return true;  
	
};


StartupApp.prototype._initStart_After_Boot = function() { 
	try{
		//carichiamo l'array di framework con le label che l'utente puo' vedere
		//forziamo la chiamata al fetcher senza controllare se i pacchetti dell�utente sono cambiati
		//e costruisce la matrice unica di zapping;
		
 		this.caricaZapperInfoDefault(); 	
 		if(this.fw.OMC_LOGGER_ENABLED)omc.logger.addEntry("#################### 4 StartupApp._initStart_After_Boot - caricaZapperInfoDefault OK");
 		this.caricaZapperInfoPreferiti(); 		
 		if(this.fw.OMC_LOGGER_ENABLED)omc.logger.addEntry("#################### 4 StartupApp._initStart_After_Boot - caricaZapperInfoPreferiti OK");
		if(this.fw.IsCLIConfirmed==null){
			this.fw.IsCLIConfirmed=false;
		}	 
		
		var users=this.fw.getUserInfo().getUsers();
		var MAC_ADDR="";
		var STB_IP_addr="";
		//millisecondi dell�ora attuale di boot
		this.fw.boot_time = this.fw.getOSD().getTime();
		this.inizializza();
		

	}catch(ecc){
		this._objErrorInfo._methodName = '_initStart';
		this._objErrorInfo._obException = ecc;
		this.handleError();
	}
	return true;  
	
};

StartupApp.prototype.goStandBy = function() 
{
	try
	{		
		var layoutManager = this.fw.getLayoutManager();
		layoutManager.setLayoutVisible("diretteCalcioAcquistiLayoutZ3", false );
		this.fw.getTimer().clearTimeout(this._standByTimer);
		this._standByTimer=null;
		this.eventKeyPower();	
	}catch(ecc){
		this._objErrorInfo._methodName = 'goStandBy';
		this._objErrorInfo._obException = ecc;
		this.handleError();
	}	
	return true;
};

StartupApp.prototype.fin = function() {
	try
	{		
		var layoutManager = this.fw.getLayoutManager();
		layoutManager.setLayoutVisible("diretteCalcioAcquistiLayoutZ3", false );
		if(this._standByTimer){
		this.fw.getTimer().clearTimeout(this._standByTimer);
	}
	this._standByTimer=null;
	
	if(this._resumeStartTimer){
	   this.fw.getTimer().clearTimeout(this._resumeStartTimer);
	   this._resumeStartTimer = null;
	}
	
	}catch(ecc){
		this._objErrorInfo._methodName = 'fin';
		this._objErrorInfo._obException = ecc;
		this.handleError();
	}
	return true;
	
};


StartupApp.prototype.eventKeyEye  = function() 
{
try
	{	
		 //Parte HomeTvApp e disabilita immagine 
		this.AvviaHomeTvApp();
	}catch(ecc){
		this._objErrorInfo._methodName = 'eventKeyEye';
		this._objErrorInfo._obException = ecc;
		this.handleError();
	}finally{
	  return true;
	}
	
	
};

StartupApp.prototype.eventKeyInternet  = function() {
	return true;
};

StartupApp.prototype.eventKeyFilm  = function() {
	return true;
};

StartupApp.prototype.eventKeyEnter = function() {
	return true;	
};

StartupApp.prototype.eventKeyScrollUp = function() {
	return true;
};

StartupApp.prototype.eventKeyScrollDown = function() {
		return true;
};

StartupApp.prototype.eventKeyPause = function() {
		return true;
};

StartupApp.prototype.eventKeyPlay = function() {
		return true;
};

StartupApp.prototype.eventKeyRwd = function() {
		return true;
};

StartupApp.prototype.eventKeyFwd = function() {
		return true;
};

StartupApp.prototype.eventKeyVolUp = function() {
		return true;
};

StartupApp.prototype.eventKeyVolDown = function() {
		return true;
};

StartupApp.prototype.eventKeyMute = function() {
		return true;
};

StartupApp.prototype.eventKeyHot1 = function() {
		return true;
};

StartupApp.prototype.eventKeyHot2 = function() {
		return true;
};

StartupApp.prototype.eventKeyHot3 = function() {
		return true;
};

StartupApp.prototype.eventKeyHot4 = function() {	  
		return true;
};

StartupApp.prototype.eventKeyUp = function() {
		return true;
};

StartupApp.prototype.eventKeyDown = function() {
		return true;
};

StartupApp.prototype.eventKeyLeft = function() {
		return true;
};

StartupApp.prototype.eventKeyRight = function() {
		return true;
};

StartupApp.prototype.eventKeyMenu = function() {
	try
	{		
		this.eventKeyEye();	
	}catch(ecc){
		this._objErrorInfo._methodName = 'eventKeyMenu';
		this._objErrorInfo._obException = ecc;
		this.handleError();
	}finally{
	  return true;
	}
};

StartupApp.prototype.eventKeyWeb = function() {
		return true;
};

StartupApp.prototype.eventKeyBack = function() {
		return true;
};

StartupApp.prototype.eventKeyEsc = function() {
		return true;
};

StartupApp.prototype.eventKeyTV = function() {
		return true;
};

StartupApp.prototype.eventKeyRefresh = function() {
		return true;
};

StartupApp.prototype.eventKeyNumeric = function(digit) {
		return true;
};

StartupApp.prototype.eventKeyStop = function() {
		return true;
};

StartupApp.prototype.checkMail = function(mailAddress)
{
	try
	{	
		var bRet = false;
		if (mailAddress != null && mailAddress != '')
		{
			bRet = true;
		}
		return bRet;
	}catch(ecc){
		this._objErrorInfo._methodName = 'checkMail';
		this._objErrorInfo._obException = ecc;
		this.handleError();
		return false;
	}
};

StartupApp.prototype.AvviaHomeTvApp=function(){ 
	try{
		var layoutManager = this.fw.getLayoutManager();
		layoutManager.setLayoutVisible("diretteCalcioAcquistiLayoutZ3", false );
		if(this._standByTimer){
			this.fw.getTimer().clearTimeout(this._standByTimer);
			this._standByTimer=null;
	   	}
		this.fw.eyePressed = true;
		//all'avvio aspetto che il zapper sia aggiornato correttamente prima di 
		//chiamare la homeTvApp ed effettuare la jump 
		 /* questo lo ho verificato, è cambiato in BaseApp.prototype.eventZapperChanged
		partendo da caricaZapperInfoDefault */
		this.canaliLocalProg = 0;		
		this.inizio = 0;
		if(this.fw.zapperChanged){
			this.canali = this.getZapper();
			if (this.fw.refreshImmagZapper == 1){
			omc.logger.addEntry("################ STARTUP this.fw.firstTimeBootBox: "+this.fw.firstTimeBootBox+" this.fw.cgiHasFinished: "+this.fw.cgiHasFinished);
				if(this.fw.firstTimeBootBox || !this.fw.cgiHasFinished){
					omc.logger.addEntry("################ STARTUP CREA IMMAGINI");
					if(this.getPreferiti().length !=0){
						this.creaImmaginiZapperPreferiti();
					}
					this.creaImmaginiZapperDefault();	
				}else {				
					omc.logger.addEntry("################ STARTUP CARICA IMMAGINI");
					this.caricaImmaginiZapperDefault();
					this.caricaImmaginiZapperPreferiti();
				}
				// questo tempo mi permette di pre-caricare le immagini dello zapperone
				//this.LoadAppHomeTvApp();
				this.fw.getTimer().setTimeout(1*this.canali.length, this.LoadAppHomeTvApp, this);
 				//omc.logger.addEntry("this.canaliLocalProg: "+this.canaliLocalProg);
 				//omc.logger.addEntry("this.inizio: "+((this.inizio+4)*((this.inizio+1)+this.canaliLocalProg)));
 				//this.fw.getTimer().setTimeout((this.inizio+4)*((this.inizio+1)+this.canaliLocalProg), this.LoadAppHomeTvApp, this);
				this.fw.refreshImmagZapper = 0;
			}
			this.fw.checkMail = true;
 		}
	}catch(ecc){
		omc.logger.addEntry("ECCEZIONE STARTUP AvviaHomeTvApp : "+ecc.message);
		this._objErrorInfo._methodName = 'AvviaHomeTvApp';
		this._objErrorInfo._obException = ecc;
		this.handleError();		
	} 
	return true;
};

StartupApp.prototype.LoadAppHomeTvApp=function(){ 
	try{
		this.loadApp("/ovaServices/getapp/HomeTvApp.html",null);
	}catch(ecc){
		this._objErrorInfo._methodName = 'LoadAppHomeTvApp';
		this._objErrorInfo._obException = ecc;
		this.handleError();
	} 
	return true;
}

StartupApp.prototype.eventGotEpgConfiguration = function ()
{
	try
	{

		var layoutManager = this.fw.getLayoutManager();
		layoutManager.setLayoutVisible("diretteCalcioAcquistiLayoutZ3", true );
		
	}
	catch(ecc)
	{
		this._objErrorInfo._methodName = 'eventGotEpgConfiguration';
		this._objErrorInfo._obException = ecc;				
		this.handleError();			
	}	
};
