 OvaAppManager.prototype._currentUserLocaleCode = "en_US"; 
 
 /* Inizializzazione di BaseApp */
 OvaAppManager.prototype=top.getFramework().createBaseApp();
 
 function OvaAppManager(){ }  
 
 OvaAppManager.prototype.create=function(){ 
 	this._stores={};
 	// -------------------MODIFICA AL FW -------------------------------
	if(this.fw.getConfig().PROFONDITA_BACK!=null)
 	{
 	   this.profondita=this.fw.getConfig().PROFONDITA_BACK;
 	}
 	else // default
 	{
 	   this.profondita=5;
 	}
 	
 	if(this.fw.getConfig().BACK_CIRCOLARE!=null)
 	{
 	   this.back_circolare=eval(this.fw.getConfig().BACK_CIRCOLARE);
 	}
 	else // default
 	{
 	   this.back_circolare=false;   
 	}
 	
 	this.urlArr=new Array();
 	this.argumentsArr=new Array();
 	this._firstTime=true; //fa pescare la prima applicazione dal giusto url
 	this._utenteDemo=false;//di default non siamo in modalit� demo
 	// -------------------------------------------------------------
 };  
 
 OvaAppManager.prototype.getCurrentApp=function(){ 
 	return this._currentApp; 
 };  
 
/* Inizialmente passa /ovaServices/getapp/GetApp.html */
/* Esempio chiamata da BaseApp.js, in particolare da _loadApp, passa homeTVApp.html */
 OvaAppManager.prototype.loadApp=function(url)
 { 
//System.out.println("$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$"+url);
   // ------MODIFICA ACCENTURE disabilita navigazione
 	//this.fw.getEventManager().disableNav();
	//-----------------------------
//  	top.getFetcher().sendDebugTrap("Ci sono: "+url);
	/* Nel caso di chiamata da OvaBootstrap.js con this.fw.getAppManager().loadApp(this._defaultAppURL); con  
	   _defaultAppURL che vale /ovaServices/getapp/GetApp.html, ritorna ancora null xchè non è registrato */
	
 	this.fw.getEventManager().handleEvent("eventAppLoadStart", url); 

 	if(arguments.length<=1){ 
		/* Caso di url = /ovaServices/getapp/GetApp.html e chiamata da OvaBootstrap.js */
 		this._appParams=[]; 
 	} 
 	else { 
 		this._appParams=this.fw.getUtil().argsToArr(arguments); 
 		this._appParams.shift();
 	}
 
 	this._url=url; 	
 	if(this.fw.OMC_LOGGER_ENABLED)omc.logger.addEntry("OvaAppManager.loadApp _argumentsApps: "+this._url);
 		
 	//--------------------------- MODIFICA AL FW----------------------------------------------------------------
 	//modifica al framework per tenere traccia delle ultime n=this.profondita applicazioni chiamate 
  	this.storeApp(url,arguments);//memorizza nella coda l'ultimo url e i paramentri passati

  	//modifica al framework per alterare la directory in cui prendere le applicazioni 
 	var appURL=this._url;
	/* this._firstTime è settato true in create di OvaAppManager */
 	if(this._firstTime)// � eseguito solo la prima volta che si istanzia OvaAppManager
 	{
 	    this._firstTime=false;
 	    this._path=this.SelectPlatform();//individua l'istanza di piattaforma corrente
	    /* path molto probabilmente sarà pirelli_dtt */
 	}
 	appURL = this.fw.getUtil().appendParamToURL(appURL,"path",this._path); //modifica invocazione JSP con il campo path=platform_related che localizza la cartella app in cui prendere le js

 	if(this.fw.OMC_LOGGER_ENABLED)omc.logger.addEntry("OvaAppManager.loadApp appURL "+appURL);

  	/* Di default è settato a false */
	if(this._utenteDemo)
	 	appURL = this.fw.getUtil().appendParamToURL(appURL,"UtenteDemo", ""); 
	 
	//--------------------------------------------------------------------------------------------

    	this._currentUserLocaleCode=this.fw.getUserInfo().getLocale(); 
 	appURL = this.fw.getUtil().appendParamToURL(appURL,"locale", this._currentUserLocaleCode); 
 	
// 	omc.logger.addEntry("appURL: "+appURL);
	/* Così creo un fetchRequestObject ... fino ad arrivare a this.fw.getOSD().fetchURL(fetchRequestObject.url); 
	   dove carica la pagina relativa cioè GetApp.html che però crea dentro un fetchObject */
 	/* se lo commento si pianta subito le scritte rosse, cioè dopo OvaDTT.prototype.createChannels(...) */
// 	top.getFetcher().sendDebugTrap("Ci sono: "+appURL);
	this.fw.getFetcher().fetchNow(appURL, this, this.eventAppFetched);
 };  
 
 OvaAppManager.prototype.isAppCached=function(url) { 
 	var appURL=this.fw.getUtil().appendParamToURL(url, "locale", this.fw.getUserInfo().getLocale()); 
 	return (this.fw.getFetcher().isCached(appURL)!=null); 
 };  
 
/* Chiamata come Callback da fetchNow (in particolare da eventFetchCompleted) e GetApp.html, inoltre obj --> 
   FetchObject.data definito direttamente in GetApp.html */
 OvaAppManager.prototype.eventAppFetched=function(obj) 
 { 	
	 if(this.fw.OMC_LOGGER_ENABLED)omc.logger.addEntry("OvaAppManager.prototype.eventAppFetched ");
 	if(this._currentApp!=null)
 	{
 		if(this._appEventId)
 		{ 
// 			top.getFetcher().sendDebugTrap("Ci sono1: "+this._appEventId);
			/* nel caso di homeTvApp, elimino l'handler "app" definito grazie a _currentApp */
 			this.fw.getEventManager().unregisterEventHandler(this._appEventId); 
 		} 
 		this._currentApp.fin(); 
 		this._currentApp=null;
 	} 
	/* obj.app --> data.app definito in GetApp.html */
	/* lo stesso vale per homeTvApp.html */
// 	omc.logger.addEntry("OvaAppManager.prototype.eventAppFetched1 ");
 	this._currentApp=obj.app; 
// 	omc.logger.addEntry("OvaAppManager.prototype.eventAppFetched2 ");
 	this._currentApp.fw=this.fw; 
 	this._currentApp.resources=this.fw.createResourceStrings();
 	this._currentApp.resources.setData(obj.resources); 
 	this._currentApp.errors=this.fw.createErrors(); 
 	this._currentApp.errors.setData(obj.errors); 
	/* Inizialmente store sarà vuota */
 	var store=this._stores[this._url]; 
 	if(!store){ 
 		store=new Object(); 
 		this._stores[this._url]=store; 
 	} 

 	this._currentApp.store=store; 
 	var em=this.fw.getEventManager();
 	/* handler -- > this._currentApp, handlerName --> "app", Registrazione evento
	   OvaEventManager.prototype.registerEventHandler=function(handler, handlerName, priority )
	   allo stato attuale ho solo 2 registrazioni.
	   Lo salva come oggetto _handler composto da un campo id, un campo a 0 ed un ultimo campo entry. 
	   Quest'ultimo è composto entry={id:id, name:handlerName, handler:handler, priority:priority} */
 	this._appEventId = em.registerEventHandler(this._currentApp, "app"); 
	
	/* Debug per poter visualizzare su console */
	//top.getFetcher().sendDebugTrap("Ci sono");
// 	omc.logger.addEntry("CI SONO ");
	/* In fase iniziale dovrebbe essere non vera la prima condizione */
 	if( this._currentUserLocaleCode==this._currentApp.getCurrentLocaleCode())
 	{ 
//  		top.getFetcher().sendDebugTrap("Ci sono: ");
 		if(!this._currentApp.__created)
 		{	//top.getFetcher().sendDebugTrap("Ci sono1: ");
// 			omc.logger.addEntry("CI SONO 1");
 			this._currentApp.create(); 
 			this._currentApp.__created=true; 
 			this._currentApp.setCurrentLocaleCode(this._currentUserLocaleCode); 
 		} 
 	}
 	else{  
		/* lancia create della funzione specificata in GetApp.html ed in StartUpApp.js */
		/* crea istanze di Logger.js, Sender.js e AutoUpdate.js e le dichiara nel fw così
		   posso vederle e usarle ovunque nell'applicazione */
 		this._currentApp.create(); 
 		this._currentApp.__created=true; 
 		this._currentApp.setCurrentLocaleCode(this._currentUserLocaleCode); 
 	}  
	/*  */
 	this._currentApp.init.apply(this._currentApp, this._appParams); 
 	
 	//----MODIFICA ACCENTURE riabilita navigazione
 	//this.fw.getEventManager().enableNav();
 	//-----------------------------------
// 	top.getFetcher().sendDebugTrap("Ci sono1: ");
 	this.fw.getEventManager().handleEvent("eventAppLoadComplete", this._url); 
// 	if (this.fw.ImageLibOff != null){
// 	var LOCAL_DTT_START_INDEX = (this.fw.getConfig().LOCAL_DTT_START_INDEX == null) ? 900 : this.fw.getConfig().LOCAL_DTT_START_INDEX;
// // 			this.ImageLibOn = new Array();
// // 			this.ImageLibOff = new Array();
// // 			this.ImageLibOnCGI = new Array();
// // 	this.ImageLibOffCGI = new Array();
// 	this.canali = this.getZapper();
// 	for (i = 0; this.canali[i].ZappingId < LOCAL_DTT_START_INDEX; i++){			
// 
// 			while (!this.fw.ImageLibOff[this.canali[i].ChanName].complete)
// 				omc.logger.addEntry("Caricato");
// 
// 	}
// 	}

};  

OvaAppManager.prototype.getCurrentAppUrl=function(){ 
	return this._url; 
};

OvaAppManager.prototype.getCurrentAppParam=function(){ 
	return this._appParams; 
};

OvaAppManager.prototype.getNextAppUrl=function(){
	
	if(this.urlArr.length >1) 
		return this.urlArr[1];
	else 
		return null;	
};


//restituisce la url dell'applicazione su cui atterra il back da fullscreen
OvaAppManager.prototype.getNextAppFullScreenUrl=function(){
	
	if(this.urlArr.length >1) 
		return this.urlArr[0];
	else 
		return null;	
};

OvaAppManager.prototype.getNextAppParam=function(){
	 
	 if(this.urlArr.length >1) 
		return this.argumentsArr[1];
	else 
		return null;	
	
};



//---------------MODIFICA AL FW-----INIZIO METODI PROPRIETARI: --------------------------------------------------

// serve per gestire i ritorni nell'applicazione MenuApp con i giusti sottomenu esplosi
OvaAppManager.prototype.storeMenuApp=function(catNumber)
{
    var urlApp="/ovaServices/getapp/GetApp.jsp?urlapp=menu&app1=MenuApp";
    var arg=new Array();
    var cat_numb=new Array();
    cat_numb.unshift(catNumber);
    arg.unshift(urlApp,cat_numb);
    this.storeApp(urlApp,arg);
    return true;
};

// memorizza l'ultima applicazione di back (se non fa parte della lista delle interdette)
OvaAppManager.prototype.storeApp=function(urlApp,argumentsApp)
{      
   try{
 	
      if(urlApp=="/ovaServices/wizard/Cortesia.jsp"||urlApp=="/ovaServices/getapp/GetApp.jsp?urlapp=videospace&app1=FullScreenVideoApp"|| urlApp=="/ovaServices/getapp/GetApp.jsp?urlapp=sport&app1=SquadraDelCuoreCRMApp") {
      	 //this.getPlogger('urlApp'+urlApp);
      	  	// this.getPlogger('this.urlArr[0]'+this.urlArr[0]);
         // elimina il vicolo cieco su guarda: 
         // se vai in fullscreen provenendo dalla pagina di acquisto (vuol dire che hai acquistato il vod)
         // sostituisci nella backhistory delle app, al passo precedente, la pagina di acquisto con quella di guarda
      		if(this.urlArr[0]=="/ovaServices/getapp/GetApp.jsp?urlapp=videospace&app1=VideoFilmDetailApp") {
            		this.urlArr[0]="/ovaServices/getapp/GetApp.jsp?urlapp=sport&app1=HomeIshowApp";
			this.argumentsArr[0][0]="/ovaServices/getapp/GetApp.jsp?urlapp=sport&app1=HomeIshowApp";
         	} else if(this.urlArr[0]=="/ovaServices/getapp/GetApp.jsp?urlapp=vanity&app1=VanityAcquistoApp") {
            		this.urlArr[0]="/ovaServices/getapp/GetApp.jsp?urlapp=vanity&app1=AdultXXXGuardaApp";
            		this.argumentsArr[0][0]="/ovaServices/getapp/GetApp.jsp?urlapp=vanity&app1=AdultXXXGuardaApp"; 
         	}
         	// elimina il vicolo cieco su acquisto di un evento sportivo replica: 
         	// se vai in fullscreen provenendo dalla pagina di acquisto vuol dire che hai acquistato l'evento 
         	// (a meno che non sia l'espansione del video in preview nel box in alto a destra: in tal caso .hot1=true)
         	// si elimina nella backhistory delle app, la pagina di acquisto.      
         	else if(this.urlArr[0]=="/ovaServices/getapp/GetApp.jsp?urlapp=vanity&app1=VanityAbbonamentoApp") {
            		this.deleteLastBackApp();
         	}
         	else if(this.urlArr[0]=="/ovaServices/getapp/GetApp.jsp?urlapp=sport&app1=DiretteCalcioAcquistiApp") {
            		this.deleteLastBackApp();
         	}         
         	else if(this.urlArr[0]=="/ovaServices/getapp/GetApp.jsp?urlapp=sport&app1=BenettonVerdeApp") {
            		this.deleteLastBackApp();          
         	}
      }else if(urlApp=="/ovaServices/getapp/GetApp.jsp?urlapp=listingplus&app1=ListingCommonApp") {
        		if(this.urlArr[0]=="/ovaServices/getapp/GetApp.jsp?urlapp=listingplus&app1=ListingCommonApp") {
          			this.deleteLastBackApp(); 
        		}
      }else if(urlApp=="/ovaServices/getapp/GetApp.jsp?urlapp=tvspace&app1=TvFullScreenApp" && !this._appParams[0].hot1) {
         // this._appParams[0].hot1=true parametro passato dalla pagina di acquisto al tvfullscreen nel caso espansione atomo video preview
         // elimina il vicolo cieco su acquisto di un evento sportivo diretta e sulla visione dei canali Sky : 
         // se vai in tvfullscreen provenendo dalla pagina di acquisto vuol dire che hai acquistato l'evento 
         // (a meno che non sia l'espansione del video in preview nel box in alto a destra: in tal caso .hot1=true)
         // si elimina nella backhistory delle app, la pagina di acquisto. 
      		if(   this.urlArr[0]=="/ovaServices/getapp/GetApp.jsp?urlapp=sport&app1=DiretteCalcioAcquistiApp"
            	|| this.urlArr[0]=="/ovaServices/getapp/GetApp.jsp?urlapp=sport&app1=DiretteBasketAcquistiApp"
            	|| this.urlArr[0]=="/ovaServices/getapp/GetApp.jsp?urlapp=sport&app1=AcquistoAbbonamentoCalcioApp") {     
            	this.deleteLastBackApp();
      		}
      } if(urlApp=="/ovaServices/getapp/GetApp.jsp?urlapp=tvspace&app1=TvFullScreenApp" && (this.urlArr[0]=="/ovaServices/getapp/GetApp.jsp?urlapp=sky&app1=SkyAcquistiApp")) {
      	   		this.deleteLastBackApp();
      }
     if(urlApp=="/ovaServices/getapp/GetApp.jsp?urlapp=sky&app1=TvFullScreenSkyApp" && (this.urlArr[0]=="/ovaServices/getapp/GetApp.jsp?urlapp=sky&app1=SkyAcquistiApp")) {
      	   this.deleteLastBackApp();
     }
     else if(urlApp=="/ovaServices/getapp/GetApp.jsp?urlapp=sport&app1=CalendarioCalcioListingApp" && (this.urlArr[0]=="/ovaServices/getapp/GetApp.jsp?urlapp=sport&app1=CalendarioCalcioListingSuccApp")) {
      	this.deleteLastBackApp();
     }
     else if(urlApp=="/ovaServices/getapp/GetApp.jsp?urlapp=sport&app1=CalendarioCalcioListingSuccApp" && (this.urlArr[0]=="/ovaServices/getapp/GetApp.jsp?urlapp=sport&app1=CalendarioCalcioListingApp"))
     {
 	this.deleteLastBackApp();
     }
     else if(urlApp=="/ovaServices/getapp/GetApp.jsp?urlapp=sport&app1=HomeIshowApp")
      {
         if(  this.urlArr[0]=="/ovaServices/getapp/GetApp.jsp?urlapp=vanity&app1=VanityAbbonamentoApp"
            ||this.urlArr[0]=="/ovaServices/getapp/GetApp.jsp?urlapp=videospace&app1=VideoFilmDetailApp")
         {
            this.deleteLastBackApp(); 
         }
      }
       else if(urlApp=="/ovaServices/getapp/GetApp.jsp?urlapp=videospace&app1=VideoFilmDetailApp")
      {
         if(this.urlArr[0]=="/ovaServices/getapp/GetApp.jsp?urlapp=sport&app1=HomeIshowApp") 
         {
            this.deleteLastBackApp(); 
           
         }
      }
      else if(urlApp=="/ovaServices/getapp/GetApp.jsp?urlapp=vanity&app1=AdultXXXGuardaApp")
      {
      	
         if(   this.urlArr[0]=="/ovaServices/getapp/GetApp.jsp?urlapp=vanity&app1=VanityAcquistoApp"
            || this.urlArr[0]=="/ovaServices/getapp/GetApp.jsp?urlapp=vanity&app1=VanityAbbonamentoApp")
         {
            this.deleteLastBackApp(); 
         }
      }/*else if(urlApp=="/ovaServices/getapp/GetApp.jsp?urlapp=ricercacanali&app1=RicercaCanaliApp"){
      	  if( this.urlArr[0]=="/ovaServices/getapp/GetApp.jsp?urlapp=ricercacanali&app1=ListingRicercaCanaliApp&app2=ListingRicercaCanaliElementUI") 
         {
            //this.deleteLastBackApp(); 
         }
      }*/
      /********* inizio modifiche per musica *********************/
      else if(urlApp=="/ovaServices/getapp/GetApp.jsp?urlapp=musica&app1=MusicIshowApp")//se sto in Concerti-guarda(Repliche) non devo ritornare in acquisti altrimenti entra in loop e riapro guarda
      {
         if(   this.urlArr[0]=="/ovaServices/getapp/GetApp.jsp?urlapp=musica&app1=ReplicheMusicaAcquistiApp") //se la url di destinazione del back � la pagina di acquista la skippo cosi non entro in loop
         {
            this.deleteLastBackApp(); 
         }
      }
      else if(urlApp=="/ovaServices/getapp/GetApp.jsp?urlapp=musica&app1=MusicaDiretteIshowApp")//se sto in Concerti-guarda (Dirette) non devo ritornare in acquisti altrimenti entra in loop e riapro guarda
      {
         if(   this.urlArr[0]=="/ovaServices/getapp/GetApp.jsp?urlapp=musica&app1=DiretteMusicaAcquistiApp") //se la url di destinazione del back � la pagina di acquista la skippo cosi non entro in loop
         {
            this.deleteLastBackApp(); 
         }
      }
      /********* fine modifiche per musica *********************/
   }  	 
   catch(e)
   {
      this.getPlogger("Errore_in_storeApp");
   }
	finally{
			
	   if(this.NoBackApp(urlApp,argumentsApp)) //verifica che l'url non faccia parte di quelli interdetti dal back
	   {	 
	 	   // crea spazio per un nuovo elemento spostando tutti gli altri di una posizione a destra
	 	   this.urlArr.unshift(urlApp);
	 	   this.argumentsArr.unshift(argumentsApp);
	 	
	 	   //elimina ultimo elemento dell'array qualora si superi la massima profondit� consentita
	      if(this.urlArr.length>this.profondita)
	      {  
	         this.urlArr.pop();
	 	      this.argumentsArr.pop();
	 	   }
	   }	
 	   return true;  
 	}
};

// filtra le applicazioni memorizzate nella storia della cache di back
OvaAppManager.prototype.NoBackApp=function(urlApp,argumentsApp)
{	   
	  
	this.status=true;
	switch(urlApp)
	{
		// lista delle applicazioni interdette dal back
      //condizioni di acquisto scheda prodotto
  
  case "/ovaServices/getapp/GetApp.jsp?urlapp=dtt&app1=ScanDTTApp":
		this.status=false;
		break;    
  case "/ovaServices/getapp/GetApp.jsp?urlapp=tvspace&app1=PpvChannelListingApp":
		this.status=false;
		break; 
	case "/ovaServices/getapp/GetApp.jsp?urlapp=tvspace&app1=PpvChannelListingSportApp":
		this.status=false;
		break;   	  
      
      // pagina fullscreenvideo
  case "/ovaServices/getapp/GetApp.jsp?urlapp=videospace&app1=FullScreenVideoApp":
		this.status=false;
		break;   
       
      // pagina tvfullscreenvideo         
  case "/ovaServices/getapp/GetApp.jsp?urlapp=tvspace&app1=TvFullScreenApp":
 		this.status=false;
		break;   
      
  case "/ovaServices/getapp/GetApp.jsp?urlapp=sky&app1=TvFullScreenSkyApp":
 		this.status=false;
		break;   
  
      // pagina seleziona squadra del cuore con abbonamento squadra del cuore abilitato dal CRM (ma squadra non scelta)
  case "/ovaServices/getapp/GetApp.jsp?urlapp=sport&app1=SquadraDelCuoreCRMApp":
		this.status=false;
		break;         		         
		
		// pagina dell'occhio allo startup
  case "/ovaServices/getapp/GetApp.jsp?urlapp=startup&app1=StartupApp&app2=Logger&app3=Sender&app4=AutoUpdate":
		this.status=false;
		break;
		// pagina di cortesia intro vanity e cortesia generale
  case "/ovaServices/getapp/GetApp.jsp?urlapp=vanity&app1=CortesiaVanityApp":
		this.status=false;
		break;
	case "/ovaServices/wizard/Cortesia.jsp":
		this.status=false;
		break;	
	// pagina di cortesia sky e acquisto sky
  case "/ovaServices/getapp/GetApp.jsp?urlapp=sky&app1=cortesiaSkyApp":
		this.status=false;
		break;		
  case "/ovaServices/getapp/GetApp.jsp?urlapp=sky&app1=CortesiaSkyAcquistoApp":
		this.status=false;
		break;	
      // pagina screen saver
  case "/ovaServices/getapp/GetApp.jsp?urlapp=screensaver&app1=ScreenSaverApp":
		this.deleteLastBackApp(); // elimina un passaggio in piu' nell'applicazione chiamante
		this.status=false;
		break;
      
		// pagina di errore
	case "/ovaServices/getapp/GetApp.jsp?urlapp=wizard&app1=ErrorApp":
		this.status=false;
		break;
				
		// preview dei vod in fullscreen
	case "/ovaServices/getapp/GetApp.jsp?urlapp=mail&app1=MailboxApp":
		//this.deleteLastBackApp(); // � Mailbox a reinserire la pagina da cui proviene
		this.status=false;
		break;
		
		//--------- internet & mail ---------------------------		
	case "/ovaServices/getapp/GetApp.jsp?urlapp=standby&app1=BrowserStandbyApp":
		this.status=false;
		break;
		
		
	case "/ovaServices/getapp/GetApp.jsp?urlapp=web&app1=WebSurfingApp":
		this.status=false;
		break;				
		
		//--------- wizard: -----------------------------------
	
	case "/ovaServices/getapp/GetApp.jsp?urlapp=wizard&app1=RichiestaPinAcquistoApp":
		this.deleteLastBackApp(); // elimina un passaggio in piu' in MenuApp
		this.status=false;
		break;
		
	case "/ovaServices/getapp/GetApp.jsp?urlapp=wizard&app1=ParentalControlLevelApp":
		this.status=false;
		break;		
		
	case "/ovaServices/getapp/GetApp.jsp?urlapp=wizard&app1=ParentalControlCodeApp":
		this.status=false;
		break;			
	
	case "/ovaServices/getapp/GetApp.jsp?urlapp=wizard&app1=RiepilogoAccountApp":
		this.status=false;
		break;	
		
	case '/ovaServices/getapp/GetApp.jsp?urlapp=wizard&app1=BenvenutoWizardApp':
		this.status=false;
		break;	
		
		
	case "/ovaServices/getapp/GetApp.jsp?urlapp=wizard&app1=RegistrazioneAccountApp":
		this.status=false;
		break;	
		
	case "/ovaServices/getapp/GetApp.jsp?urlapp=wizard&app1=ConfermaAccountApp":
		this.status=false;
		break;	
		//--- end wizard -----------------------------------------
		
		
		//----- parental control: --------------------------------
	case "/ovaServices/getapp/GetApp.jsp?urlapp=parentalcontrol&app1=ParentalControlApp":
		//this.deleteLastBackApp(); // elimina un passaggio in piu' in fullscreen (NON TOGLIERE!)
		this.status=false;
		break;
		
	case "/ovaServices/getapp/GetApp.jsp?urlapp=parentalcontrol&app1=ParentalControlBTVApp":
		//this.deleteLastBackApp(); // elimina un passaggio in piu' in fullscreen (NON TOGLIERE!)
		this.status=false;
		break;
		
		//----- end parental control -----------------------------
		
		//--- IMPOSTAZIONI -------	
	case "/ovaServices/getapp/GetApp.jsp?urlapp=impostazioni&app1=HomeImpostazioniApp":
		 this.status=false;
		 break;
		
  case "/ovaServices/getapp/GetApp.jsp?urlapp=settings&app1=YourAccountListingApp":
		 this.status=false;
		 break;
		 
  case "/ovaServices/getapp/GetApp.jsp?urlapp=impostazioni&app1=ControlloAcquistiApp&app2=ControlloAcquistiAppElementUI":
		 this.status=false;
		 break;
		
  case "/ovaServices/getapp/GetApp.jsp?urlapp=impostazioni&app1=ControlloAcquistiDetailsApp":
		 this.status=false;
		 break;
  
  case "/ovaServices/getapp/GetApp.jsp?urlapp=impostazioni&app1=NoteLegaliApp":
		 this.status=false;
		 break;
		
  case "/ovaServices/getapp/GetApp.jsp?urlapp=impostazioni&app1=PrivacyApp":
		 this.status=false;
		 break;
	
	
   case "/ovaServices/getapp/GetApp.jsp?urlapp=impostazioni&app1=ImpostazioniSTBApp":
		 this.status=false;
		 break;
	
	//--------------Carta di credito-------------------------
	case "/ovaServices/getapp/GetApp.jsp?urlapp=cartadicredito&app1=EsitoTransazioneApp":
		 this.status=false;
		 break;	 
	case "/ovaServices/getapp/GetApp.jsp?urlapp=cartadicredito&app1=RiepilogoCartaDiCreditoApp":
		 this.status=false;
		 break;	 
	case "/ovaServices/getapp/GetApp.jsp?urlapp=cartadicredito&app1=AcquistoCartaDiCreditoApp":
		 this.status=false;
		 break;	 	 
	//--------------carta di credito------------------------------------	 	 
		
  case "/ovaServices/getapp/GetApp.jsp?urlapp=impostazioni&app1=AreaTestApp":	
		 this.status=false;
		 break;
	
	case "/ovaServices/getapp/GetApp.jsp?urlapp=impostazioni&app1=TestAcquistoApp":	 
		 this.status=false;
		 break;
		 
		 //---- pin: ----------------------------------------------
		 // pin acquisto
	case "/ovaServices/getapp/GetApp.jsp?urlapp=impostazioni&app1=ChangePinApp":
		 this.status=false;
		 break;
		
		 //pin parental control
		
	case "/ovaServices/getapp/GetApp.jsp?urlapp=impostazioni&app1=ParentalControlSettingsApp":
		 this.status=false;
		 break;	
		  //------ end pin ------------------------------------------
		
		  //ConfermaCLI
	case "/ovaServices/getapp/GetApp.jsp?urlapp=wizard&app1=ConfermaCLIApp":
		 this.status=false;
		 break;	
		
	}
	
	return this.status;
};

OvaAppManager.prototype.eliminaPagineNonValide=function(){
  
     	//sposta il primo elemento alla fine dell'array (per rendere circolare la pila)
     	if(this.back_circolare)
     	{
         this.urlArr.push(this.urlArr[0]);
       	this.argumentsArr.push(this.argumentsArr[0]);
      }
      
      try{ 
         // elimina le applicazioni ripetute (avendo eliminato le pagine di fullscreen, di espansione atomo video ecc, possono presentarsi delle ripetizioni
         // guarda-->fullscreen-->(stop)guarda che diventerebbe guarda-->guarda e quindi ora solo: guarda)
         while(this.urlArr.length >1 && this.urlArr[0]=="/ovaServices/getapp/GetApp.jsp?urlapp=sky&app1=HomeSkyApp" && this.urlArr[0]!="/ovaServices/getapp/GetApp.jsp?urlapp=menu&app1=MenuApp" && this.urlArr[0]==this.urlArr[1])
         { 	
              this.deleteLastBackApp();              
         }
         
          while(this.urlArr.length >1 && this.urlArr[0]=="/ovaServices/getapp/GetApp.jsp?urlapp=sport&app1=DiretteCalcioSquadraDelQApp" && this.urlArr[0]==this.urlArr[1])
         { 	
              this.deleteLastBackApp();              
         }
        
         while(this.urlArr.length >1 && this.urlArr[0]=="/ovaServices/getapp/GetApp.jsp?urlapp=sport&app1=HomeIshowApp" && this.urlArr[0]==this.urlArr[1])
         { 	
              this.deleteLastBackApp();              
         }
         
         while(this.urlArr.length >1 && this.urlArr[0]=="/ovaServices/getapp/GetApp.jsp?urlapp=rai&app1=ArchivioRaiGuardaApp" && this.urlArr[0]==this.urlArr[1])
         { 	
              this.deleteLastBackApp();              
         }
         
         while(this.urlArr.length >1 && this.urlArr[0]=="/ovaServices/getapp/GetApp.jsp?urlapp=videospace&app1=VideoFilmDetailApp" && this.urlArr[0]==this.urlArr[1])
         { 	
              this.deleteLastBackApp();              
         }
         
         while(this.urlArr.length >1 && this.urlArr[0]=="/ovaServices/getapp/GetApp.jsp?urlapp=sport&app1=DiretteCalcioAcquistiApp" && this.urlArr[0]==this.urlArr[1])
         { 	
              this.deleteLastBackApp();              
         }
         
         while(this.urlArr.length >1 && this.urlArr[0]=="/ovaServices/getapp/GetApp.jsp?urlapp=sport&app1=DiretteBasketAcquistiApp" && this.urlArr[0]==this.urlArr[1])
         { 	
              this.deleteLastBackApp();              
         }
         
         if(this.status)
            this.deleteLastBackApp()
         this.status=true;     
         
         //elimina passaggi in pagine di acquisto se il vod o il ppv o l'abbonamento � stato acquistato successivamente
         while(this.urlArr.length >1 && this.PaginaAcqSenzaGuardaContenutoAcquistato())
         ;     
      }
      catch(e)
      {
         this.getPlogger("Errore_in_eliminaPagineNonValide");
      }
      finally{
         return true;
      }
};


// esegue il back alla penultima applicazione memorizzata
OvaAppManager.prototype.tastoBack=function()
{
	   
	
	   
	  
	if(this.urlArr.length >1 || (!this.status && this.urlArr.length >0))
 	{   
	   // ------MODIFICA ACCENTURE disabilita navigazione
 	   //this.fw.getEventManager().disableNav();
 	   //-----------------------------
 	 
	   this.eliminaPagineNonValide();
     	      	
     var app = this.urlArr[0];
		      	  
     	//il primo elemento � l'applicazione da ripristinare     
		     			     	
     	this.fw.getEventManager().handleEvent("eventAppLoadStart", this.urlArr[0]); 
     	if(this.argumentsArr[0].length<=1){ 
     		this._appParams=[]; 
     	} 
     	else { 
     		this._appParams=this.fw.getUtil().argsToArr(this.argumentsArr[0]); 
     		this._appParams.shift();
     	} 
     	this._currentUserLocaleCode=this.fw.getUserInfo().getLocale(); 
     	var appURL= this.urlArr[0];
     	this._url=this.urlArr[0];
     	appURL = this.fw.getUtil().appendParamToURL(appURL,"path",this._path); //modifica invocazione JSP con il campo path=platform_related che localizza la cartella app in cui prendere le js
      appURL = this.fw.getUtil().appendParamToURL(appURL,"locale",this._currentUserLocaleCode); 
     	this.fw.getFetcher().fetchNow(appURL, this, this.eventAppFetched);
 	}
 	return true;
};

// E' invocato solo da MenuApp (inquanto questo metodo � invocato nell'override locale di EventKeyTV..)
// esegue il back alla penultima applicazione memorizzata 
OvaAppManager.prototype.tastoBackMenuApp=function()
{
		
    if(this.urlArr.length >1 && (this.urlArr[1]=="/ovaServices/getapp/GetApp.jsp?urlapp=menu&app1=MenuApp"))
    { 	
    	//se la stessa applicazione � presente nell'history della menu pi� volte
    	//di seguito si elimina, altrimenti andiamo in loop
    	
    	while( (this.argumentsArr[0][1] == this.argumentsArr[1][1]) && (this.urlArr[1]=="/ovaServices/getapp/GetApp.jsp?urlapp=menu&app1=MenuApp")){
    		
    		this.deleteLastBackApp();
    		if(this.urlArr[1]==undefined)
    		{
    			break;
    		}
    	}
      //sposta il primo elemento alla fine dell'array (per rendere circolare la pila)
     	if(this.back_circolare)
     	{
        this.urlArr.push(this.urlArr[0]);
       	this.argumentsArr.push(this.argumentsArr[0]);
      }
    	//elimina il primo elemento 
  		if(this.urlArr.length >1 && (this.urlArr[1]=="/ovaServices/getapp/GetApp.jsp?urlapp=menu&app1=MenuApp"))
  		{
  			this.deleteLastBackApp();
  			
      	this._currentApp.init(this.argumentsArr[0][1]);
      }else{
      	
      	 this.tastoBack();
      }
      
    }
    else{
      this.tastoBack();
    }
    return true;
};

OvaAppManager.prototype.PaginaAcqSenzaGuardaContenutoAcquistato=function()
{
   var trovato=false;
   if(this.urlArr.length >1 
   
   
   
      && this.urlArr[0]=="/ovaServices/getapp/GetApp.jsp?urlapp=sport&app1=DiretteCalcioAcquistiApp" 
      || this.urlArr[0]=="/ovaServices/getapp/GetApp.jsp?urlapp=sport&app1=DiretteBasketAcquistiApp"
      || this.urlArr[0]=="/ovaServices/getapp/GetApp.jsp?urlapp=sport&app1=DiretteCalcioSquadraDelQApp"
      || this.urlArr[0]=="/ovaServices/getapp/GetApp.jsp?urlapp=vanity&app1=VanityAbbonamentoApp"
      || this.urlArr[0]=="/ovaServices/getapp/GetApp.jsp?urlapp=sport&app1=AcquistoAbbonamentoCalcioApp"
      // se sono entrato nella pagina di Sky con digitazione numerica 80X e non compro l'abbonamento
      // poi esco successivamente rientro e lo compro (storia 20 posizioni!)...non devo piu' vedere anche la vecchia pagina (quando non l'evevo ancora comprato)
      || this.urlArr[0]=="/ovaServices/getapp/GetApp.jsp?urlapp=sky&app1=SkyAcquistiApp"
      || (this.urlArr[0]=="/ovaServices/getapp/GetApp.jsp?urlapp=sky&app1=HomeSkyApp" && this.argumentsArr[0][1]!=null) ) 
   {
   	// gestione abbonamenti
      // se � stato acquistato l'abbonamento o il singolo evento ppv non tornare col back nella pagina di acquisto (che ti porterebbe in fullscreen)
      if(this.fw.abb!=null)
      {
         var j=0;
         while(j<this.fw.abb.length && !trovato)
         {
             if(  this.fw.abb[j]=="AcalcA"
                ||this.fw.abb[j]=="AsqcuA"
                ||this.fw.abb[j]=="AplayA"
                ||this.fw.abb[j]=="AplayB"
                ||this.fw.abb[j]=="AskciA")
             {
                 this.deleteLastBackApp();                 
                 trovato=true;
             } 
             j++;
         }         
      }// gestione acquisto ppv
      else if( this.urlArr[0]!="/ovaServices/getapp/GetApp.jsp?urlapp=sky&app1=SkyAcquistiApp" && this.urlArr[0]!="/ovaServices/getapp/GetApp.jsp?urlapp=sky&app1=HomeSkyApp")
      { 
         if(this.fw.getUserInfo().isPpvProgramPurchased(this.argumentsArr[0][2].schdid)) 
         {  
            this.deleteLastBackApp();            
            trovato=true;
         }      
      }
   } // gestione acquisto vod
   else if(this.urlArr.length >1 && this.urlArr[0]=="/ovaServices/getapp/GetApp.jsp?urlapp=sport&app1=BenettonVerdeApp")
   {
      if(this.fw.vodacq!=null)
      {
         var j=0;
         while(j<this.fw.vodacq.length && !trovato)
         {
             if(this.fw.vodacq[j]==this.argumentsArr[0][2].schdid)
             {
                 // se il vod � nella lista degli acquistati non tornare col back nella pagina di acquisto (che ti porterebbe in fullscreen)
                 this.deleteLastBackApp();
                 trovato=true;
             } 
             j++;
         }
      }
   }
   return trovato;
};

//svuota tutta la storia della cache di back
OvaAppManager.prototype.flushBack=function()
{
    this.urlArr=new Array();
 	 this.argumentsArr=new Array();
 	 this.fw.abb=null;
    this.fw.vodacq=null;
    return true;
};

//cancella l'ultima applicazione inserita nella storia della cache di back
OvaAppManager.prototype.deleteLastBackApp=function()
{
	//elimina il primo elemento se ce n'e' almeno uno
	if(this.urlArr.length>1) //se non ci sono elementi this.urlArr.length=null (undefined)
	{
      this.urlArr.shift();
	    this.argumentsArr.shift();
	}
    return true;
};  

// restituisce l'applicazione dove andr� il back
OvaAppManager.prototype.lastApp=function()
{
   if(this.urlArr.length>1)
   {
      return this.urlArr[1];
   }
   else
      return null;
};

//utile al fine di debug per testare la history assegnandolo ad esempio provvisoriamente
//in BaseApp su un HotKey...
OvaAppManager.prototype.printBackHistory=function()
{
	if(this.urlArr.length >0)
	{
    	for(i=0;i<this.urlArr.length;i++)
     	{
     	  
     	    var param=this.fw.getUtil().argsToArr(this.argumentsArr[i]);

     	    this.getPlogger("Arg["+i+"]="+param.join(";"));
        }
    }
   // else
       // this.getPlogger("HistoryEmpty");
    return true;
};  

OvaAppManager.prototype.deepPrintBackHistory=function()
{
     var param=this.fw.getUtil().argsToArr(this.argumentsArr[0]);
  
     var url_param_serialized="";
     for (i=0;i<param.length;i++)
     {
      if(typeof param[i]=='object' && param[i]!=null)
      {
         this.getPlogger("Arg["+i+"]=obj");
         for (var j in param[i])
         {
            if(typeof param[i][j]=='object' && param[i][j]!=null) 
            {
               this.getPlogger("Arg["+i+"]["+j+"]=obj");
               for (var k in param[i][j])
               {
                  this.getPlogger("Arg["+i+"]"+"["+j+"]["+k+"]="+param[i][j][k]);
                  url_param_serialized=url_param_serialized+"|Arg["+i+"]"+"["+j+"]["+k+"]="+param[i][j][k];
               }
            }
            else if(param[i][j]==null)
            {
               this.getPlogger("Arg["+i+"]["+j+"]=NULL");
               url_param_serialized=url_param_serialized+"|Arg["+i+"]["+j+"]=null";
            }
            else   
            {
               this.getPlogger("Arg["+i+"]["+j+"]="+param[i][j]);
               url_param_serialized=url_param_serialized+"|Arg["+i+"]["+j+"]="+param[i][j];
            }
             
         }
      }
      else if(param[i]==null)
      {
         this.getPlogger("Arg["+i+"]=NULL");
         url_param_serialized=url_param_serialized+"|Arg["+i+"]=null";
      }
      else
      {
         this.getPlogger("Arg["+i+"]="+param[i]);
         url_param_serialized=url_param_serialized+"|Arg["+i+"]="+param[i];
      }
     }
     return url_param_serialized;
};

OvaAppManager.prototype.SelectPlatform=function()
{
    var path;
    var navig=navigator.userAgent.split("ANT");
    
    
   var tempPirelli2 = "";
    if(navig[0]){
      var tempPirelli1 = navig[0].split(";");
      if(tempPirelli1[1]){
    		 var tempPirelli2 = this.trimAll(tempPirelli1[1]).toLowerCase();
    	}
    }	
   
    var navig_temp='ANT'+navig[1];
    var navig_temp2=navig_temp.split(";");
    this_navigator=navig_temp2[0];
   
    switch(this_navigator)
    {
    
    /*   file platform.xml
    <!-- Amino browser -->       
    <platform name="amino">ANTFresco/4.10.04</platform> 
    <!-- userAgent=Mozilla/4.08 (compatible; Amino; ANTFresco/4.10.04.08; Linux2.4.20/ppc) -->
    <platform name="amino">ANTFresco/4.10.04.08</platform> 
    <platform name="amino">ANTFresco/4.10.04.09</platform> 
   
    <!-- browser PC che punta a telsey con file config.txt_telsey->config.txt adeguato -->
    <platform name="telsey">ANTFresco/4.10.25.devel</platform> 
    <platform name="telsey">ANTFresco/4.10.36.devel</platform> 
    <platform name="telsey">ANTFresco/4.10.48.devel</platform>
    <platform name="telsey">ANTFresco/4.10.50.07</platform>
    <!-- userAgent=Mozilla/4.08 (compatible; Telsey ANT Fresco/4.10.50.08.devel; Linux2.4.12/i586) -->
    <platform name="telsey">Telsey ANT Fresco/4.10.50.08.devel</platform>
    */
      
        //---------  STB AMINO

	     case 'ANTFresco/4.10.04':
        // vecchi Amino 
        path='amino';
        break;
        
	     case 'ANTFresco/4.10.04.08':
        // ex Amino Alice STB246 
        // Mozilla/4.08 (compatible; Amino; ANTFresco/4.10.04.08; Linux2.4.20/ppc) 
        // firmware A110.alcatel.0.9.0-TI-sec200)
        path='amino';
        break;

	     case 'ANTFresco/4.10.04.09':
        // attuale Amino Alice STB246 
        // Mozilla/4.08 (compatible; Amino; ANTFresco/4.10.04.09; Linux2.4.20/ppc) 
        // firmware 0.9.4-A110-alcatel303-ti-0.0.3-DIO
        path='amino';
        break;  
        
        //--------- BROWSER PC TELSEY
       
        case 'ANTFresco/4.10.25.devel':
        // BROWSER PC vecchio
        path='telsey';
        break;   
         
        case 'ANTFresco/4.10.36.devel':
        //  BROWSER PC vecchio   
        path='telsey';
        break;  
        
        /* ormai in disuso
        case 'ANTFresco/4.10.44':
        path='telsey';
        break; 
           
        case 'ANT Fresco/4.10.48':
        path='telsey';
        break; */
   
        case 'ANTFresco/4.10.48.devel':
        path='telsey';
        break; 
               
        case 'ANTFresco/4.10.50.07':
        // BROWSER PC ultima versione
        // Mozilla/4.08 (compatible; ANTFresco/4.10.50.07; NT5.01sp2/x86)
        path='telsey';
        break;  
        
        //--------- STB TELSEY
        
        case 'ANT Fresco/4.10.50.08.devel':
        // STB Telsey ultima versione 245
        // Mozilla/4.08 (compatible; Telsey ANT Fresco/4.10.50.08.devel; Linux2.4.12/i586) 
        path='telsey';
        break;  
        
        //--------- STB PIRELLI
        
        case 'ANT Fresco/4.10.50.19.devel':
        //
        // "Mozilla/4.08%20(compatible;%20PirelliSD%20ANT%20Fresco/4.10.50.19.devel;%20Linux2.4.30-tango2-2.7.147.0/mips)\
        
        path='pirelli_dtt';
        break; 
        
        case 'ANT Fresco/4.10.50.21.devel':
        
        	if(tempPirelli2=="pirellidtt"){
        		path='pirelli_dtt';
        	}else{
        		path='pirelli_sd';
        	}
         break; 
        //--------- DEFAULT
        
        //se non riconosce il path usa un la root di apps
        default:
        path='telsey';
        break;             
    }
    
    return path;
};

//--------- GESTIONE DEMO ----------- //

OvaAppManager.prototype.StartDemo=function(){
   this._istanza_demo=0;
   this.GoDemo();
};

OvaAppManager.prototype.GoDemo=function(){
      this._istanza_demo++;
      var data_stp=new Date().getTime();
      var url_fetch="/ovaApps/"+this._path+"/demouser/demouser.jsp?tpcache=N&time_stamp="+data_stp;
      this.fw.getFetcher().fetchNow(url_fetch,this,this._gotDemoMove);
      return true;
}; 

OvaAppManager.prototype.settaPinAcquistoRicordaPin_Rating4=function(){
   // inserisce pin acquisto e non richiede il suo inserimento:
var tempoz=new Date();
this.fw.getFetcher().fetchNow("/ovaServices/settings/ChangePinFetch.jsp?tpcache=N&tempoz="+tempoz.getTime()+"&confirmNewPin=111111&usrRecid="+this.fw.getUserInfo().getAccountID()+"&purchase_confirm=N",this,this.getFetch);
// non richiede il pin di acquisto:
this.fw.getFetcher().fetchNow("/ovaServices/confirmPurchases/ConfirmPurchasesFetcher.jsp?tpcache=N&tempoz="+tempoz.getTime()+"&account_id="+this.fw.getUserInfo().getAccountID()+"&purchase_confirm=N",this,this.getFetch); 
this.getPlogger("***Setta_pin_acquisto_a_111111_e_ricorda_pin***");
// setta il rating 
this.fw.getFetcher().fetchNow("/ovaServices/settings/ChangeRatingFetch.jsp?tpcache=N&tempoz="+tempoz.getTime()+"&usrRecid="+this.fw.getUserInfo().getUserID()+"&ratingid=4",this,this.getFetch);
this.getPlogger("***Setta_assenza_di_rating***");
return true;
};

OvaAppManager.prototype.getFetch=function(obj){
   return true;
};

OvaAppManager.prototype._gotDemoMove=function(obj) {
   if(obj!=null && obj.content!=null && obj.content.length >0) 
   {
      this._demoMove=obj.content;
      this._nextMove=0;
      this._lastMove=this._demoMove.length;
      
      var MAC_ADDR='';
      if(this._path=="telsey")
      {
         try{
            MAC_ADDR=navigator.GetMACAddress().toUpperCase();
         } catch(e)
         {
            MAC_ADDR='00:00:00:00:00:00'; //default il browser per PC
         }
      }
      else if(this._path=="amino")
      {
          try{
            MAC_ADDR=ASTB.GetMacAddress().toUpperCase();
         } catch(e)
         {
            MAC_ADDR='00:00:00:00:00:00'; //default il browser per PC
         }
      }
      var mac_ammesso=false;
      if(this._demoMove[0].MAC_ADDR!=null)
      {
         var mac_ammessi=this._demoMove[0].MAC_ADDR.split("|");
         for(k=0;k<mac_ammessi.length;k++)
         {
            if((mac_ammessi[k].toUpperCase())==MAC_ADDR)
            {
               this.getPlogger("***MAC_ADDR:"+MAC_ADDR+"_AMMESSO!!***")
               mac_ammesso=true;
            }
         }
      }
      
      if(mac_ammesso)
      {
         this.getPlogger("***StartDemo!!!!***");
         this.getPlogger("---------------------");
         this.getPlogger("***IstanzaDemo_"+this._istanza_demo+"***");
          //pulisce la storia del back
         this.flushBack();
         //elimina gli acquisti vod e abbonamenti
         this.deleteAcquistiAbbonamenti();
         //setta il pin di acquisto,imposta il ricorda pin per l'acquisto, setta il rating a 4
         this.settaPinAcquistoRicordaPin_Rating4();
      
         //attiva l'append del parametro UtenteDemo all'url del LoadApp
         this._utenteDemo=true;

         this._delayDemoAppDefault=this._demoMove[0].delay_event_time;
         if(this._demoMove[0].istanze!=null)
         {
            this._istanze=this._demoMove[0].istanze;
            if(this._istanza_demo==1)
               this.getPlogger("***Numero_istanze="+this._istanze+"***")
         }
         else
            this._istanze=1;

         this.getPlogger("***this._delayDemoApp="+this._delayDemoAppDefault+"***");
         this.fw._changeAppTimer=this.fw.getTimer().setTimeout(this._delayDemoAppDefault, this.DemoLoadApp, this);
      }
      else
      {
         this._utenteDemo=false;
         this.getPlogger("***StopDemo:MAC_ADDRESS:_"+MAC_ADDR+"_Non_Ammesso_in_Demo!!***");
      }
   }  
   else
   {
       this._utenteDemo=false;
       this.getPlogger("***StopDemo:NoDataForDemo***");
   }
 
  return true;
};

OvaAppManager.prototype.DemoLoadApp=function(){
      if(this._nextMove< this._lastMove)
      {
         this.fw.getTimer().clearTimeout(this.fw._changeAppTimer);
         var indice=this._nextMove+(this._istanza_demo-1)*this._lastMove;
         this.getPlogger("***NextMove["+indice+"]="+this._demoMove[this._nextMove].evento+";param="+this._demoMove[this._nextMove].parametro+"***");
         var methodApp=this._demoMove[this._nextMove].evento;
         var paramMethodApp=this._demoMove[this._nextMove].parametro;
         
         //se presente questo parametro varia il delay_event_time per il prossimo evento
         if(this._demoMove[this._nextMove].delay_event_time!=null)
            this._delayDemoApp=this._demoMove[this._nextMove].delay_event_time
         else 
            this._delayDemoApp=this._delayDemoAppDefault;
   
         var nextMove="this._currentApp."+methodApp+".apply(this._currentApp";
         
         if(paramMethodApp=='')
            nextMove=nextMove+");";
         else 
         {   
            if(methodApp=="changeApp")
            {
               this._currentApp.changePage=paramMethodApp;
               nextMove=nextMove+");";
            }
            else if(methodApp=="eventKeyNumeric")
            {
               var paramDigit=new Array();
               paramDigit.unshift(paramMethodApp);
               var nextMove=nextMove +",paramDigit);"; 
            }
         }
         this._nextMove++;
         
         try{
            eval(nextMove);
         }
         catch(e){
            this.getPlogger("***Comando_non_supportato***");
         }
       	this.fw._changeAppTimer=this.fw.getTimer().setTimeout(this._delayDemoApp, this.DemoLoadApp, this);
      }
      else
      {        
         if(this._istanza_demo<this._istanze)
         {
            //pulisce la storia del back
            this.flushBack();
            //elimina gli acquisti vod e abbonamenti
            this.deleteAcquistiAbbonamenti();
            
            this.GoDemo();
         }
         else  
            this.StopDemo();
      }
     	return true;
 }; 
 
OvaAppManager.prototype.StopDemo=function()
{  
   this.fw.getTimer().clearTimeout(this.fw._changeAppTimer);
   this.fw._changeAppTimer=null;
   this._delayDemoApp=0;
   this._istanza_demo=0;
   this._demoMove=null;
   this._nextMove=0;
   this._lastMove=0; 
   //pulisce la storia del back
   this.flushBack();
    //elimina gli acquisti vod e abbonamenti
   this.deleteAcquistiAbbonamenti();
   
   this._utenteDemo=false;
   this.getPlogger("***StopDemo:EndDemo***");
   this.getPlogger("---------------------");
   return true;       
};
 
OvaAppManager.prototype.deleteAcquistiAbbonamenti=function()
{  
  this._acc=this.fw.getUserInfo().getAccountID();
  var data_stp=new Date().getTime();
  this.fw.getFetcher().fetchNow("/ovaServices/demouser/DeleteAcqAbbFetch.jsp?tpcache=N&user_recid="+this._acc+"&time_stamp="+data_stp, this, this._esitoCancellazione);
  return true;
};

OvaAppManager.prototype._esitoCancellazione=function(obj) {
   if(obj!=null) 
   {
      if(obj.esito=='OK')
         this.getPlogger("***cancellazione_acquisti_vod_e_abbonamenti_per_utente_"+this.fw.getUserInfo().getAccountID()+"***")
      else if(obj.esito=='KO')
         this.getPlogger("***cancellazione_acquisti_vod_e_abbonamenti_per_utente_"+this.fw.getUserInfo().getAccountID()+"_KO!!***");
   }
   return true;
};

// ----- FINE GESTIONE DEMO -----

//-------------------------FINE METODI PROPRIETARI --------------------------------------------------
