 function OvaBTVHandler(){ };

 OvaBTVHandler.prototype.AC_DEFAULT_ACCESS_GRANT=-3;
 OvaBTVHandler.prototype.AC_DEFAULT_ACCESS_DENY=-2;
 OvaBTVHandler.prototype.AC_CHECK_OVERRIDDEN=-1;
 OvaBTVHandler.prototype.AC_ACCESS_GRANTED=0;
 OvaBTVHandler.prototype.AC_CHANNEL_BLOCKED_FOR_ACCOUNT=1;
 OvaBTVHandler.prototype.AC_CHANNEL_BLOCKED_FOR_USER=2;
 OvaBTVHandler.prototype.AC_NOT_RATED_FOR_CHANNEL=3;
 OvaBTVHandler.prototype.AC_NOT_RATED_FOR_PROGRAM=4;
 OvaBTVHandler.prototype.AC_PROGRAM_NOT_SUBSCRIBED=5;
 OvaBTVHandler.prototype.AC_PROGRAM_UNAVAILABLE=6;
 OvaBTVHandler.prototype.AC_CHANNEL_UNAVAILABLE=7;
 OvaBTVHandler.prototype.AC_PROGRAM_CANCELLED=8;
 OvaBTVHandler.prototype.AC_PROGRAM_CHANGED=9;
 OvaBTVHandler.prototype.AC_CHANNEL_OFFLINE=10;

 OvaBTVHandler.prototype.create=function(){ };

 OvaBTVHandler.prototype.onTVTunerCheckAccess=function(caller, slot){
 	this.fw.getDebug().logInfo("OvaBTVHandler: onTVTunerCheckAccess");
 	var channelAvailability=this.AC_ACCESS_GRANTED;
 	if( slot ){
		 if( slot.channel!=null ){
			 if( slot.channel.url!=null ){
					 if( slot.channel.status!='OFFLINE' ){
						 if( this.fw.getRatings().userAllowed( slot.channel.ratingRecid ) ){
							 if( ! this.fw.getUserInfo().isChannelBlockedForUser( slot.channel.recid ) ){
								 if( ! this.fw.getUserInfo().isChannelBlockedForAcc( slot.channel.recid ) ){
									 if( slot.program ){
										 if( ! slot.program.isEmpty ){
											if( ! slot.program.cancelled ){
												if( this.fw.getRatings().userAllowed( slot.program.ratingid ) ){
													switch (slot.program.type){
													case "PPV": if(
								!this.fw.getUserInfo().isPpvProgramPurchased( slot.program.schdid ) ){
										 channelAvailability=this.AC_PROGRAM_NOT_SUBSCRIBED;
 											} break;
 													case "NVOD": if(
								!this.fw.getUserInfo().isNvodProgramPurchased( slot.program.id ) ){
										channelAvailability=this.AC_PROGRAM_NOT_SUBSCRIBED;
 										} break;
 								}
								} else {
									channelAvailability=this.AC_NOT_RATED_FOR_PROGRAM;
 								}
								} else {
									channelAvailability=this.AC_PROGRAM_CANCELLED;
 								}
								} else {
									channelAvailability=this.AC_PROGRAM_UNAVAILABLE;
 								}
								}
								} else {
									channelAvailability=this.AC_CHANNEL_BLOCKED_FOR_ACCOUNT;
 								}
								} else {
									channelAvailability=this.AC_CHANNEL_BLOCKED_FOR_USER;
 								}
								} else {
									channelAvailability=this.AC_NOT_RATED_FOR_CHANNEL;
 								}
								} else {
									channelAvailability=this.AC_CHANNEL_OFFLINE;
 								}
								} else {
									channelAvailability=this.AC_CHANNEL_UNAVAILABLE;
 								}
								} else {
									channelAvailability=this.AC_CHANNEL_UNAVAILABLE;
 								}
								} else {
									channelAvailability=this.AC_CHANNEL_UNAVAILABLE;
 								} this.fw.getDebug().logInfo("exiting OvaBTVHandler: channelAvailability = " +channelAvailability);
 								return channelAvailability;
 };

 OvaBTVHandler.prototype.onTVTunerAfterTuning=function(caller, newSlot, oldSlot, code){ this.fw.getEventManager().handleEvent("eventTunerChanged", code, newSlot);
 return true;
 };
 OvaBTVHandler.prototype.onTVTunerDeactivate=function(caller){ var vc=this.fw.getVideoControl();
 vc.setPlayRate(vc.MODE_STOP);
 vc.videoOff();
 };
 
