 OvaChangeUser.prototype.MODE_INACTIVE=1;
 OvaChangeUser.prototype.MODE_SELECT =2;
 OvaChangeUser.prototype.MODE_PIN =3;
 OvaChangeUser.prototype.MODE_ERROR =4;
 OvaChangeUser.prototype.MODE_NO_USERS=5;

 function OvaChangeUser(){ }

 OvaChangeUser.prototype.create=function(){
	this._mode=this.MODE_INACTIVE;
 };

 OvaChangeUser.prototype.start=function(){ 
 this._eventHandlerId = this.fw.getEventManager().registerEventHandler(this, "OvaChangeUser");
 this._users=this.fw.getUserInfo().getUsers();
 this._user=this._users[0];
 this._mode=this.MODE_SELECT;
 this._index=0;
 if(this._user.type=='F')this._nextUser();
 this.fw.getEventManager().handleEvent("eventChangeUserStart");
 return true;
 };

 OvaChangeUser.prototype.eventKeyHot1=function() { if(!this.isActive()) return false;
 if(this._mode==this.MODE_PIN||this._mode==this.MODE_ERROR){ this.fw.getEventManager().handleEvent("eventChangeUserSubmitPin", this._pinForm);
 return this.eventFormSubmit(this._pinForm);
 } else if(this._mode==this.MODE_NO_USERS){ } else { this._nextUser();
 this.fw.getEventManager().handleEvent("eventChangeUserFocusUser", this._user);
 } return true;
 };
 OvaChangeUser.prototype.eventKeyHot2=function(){ if(!this.isActive()) return false;
 this._cancel();
 this.fw.getEventManager().handleEvent("eventChangeUserCancel");
 return true;
 };
 OvaChangeUser.prototype.eventKeyHot3=function(){ if(!this.isActive()) return false;
 if(this._mode==this.MODE_SELECT||(this._mode==this.MODE_NO_USERS)){ this._user=this._getFamilyUser();
 this._cancel();
 this.fw.getEventManager().handleEvent("eventChangeUserAcceptUser", this._user);
 this.fw.getUserInfo().loadUser(this._user.id, this, this._gotUser);
 } return true;
 };
 OvaChangeUser.prototype.eventKeyEnter=function(){ if(!this.isActive()) return false;
 if(this._mode==this.MODE_SELECT){ if(this._user==null)return true;
 if(this._user.type!='F'){ this._mode=this.MODE_PIN;
 this.fw.getEventManager().handleEvent("eventChangeUserSelectUser", this._user);
 } else { this._cancel();
 this.fw.getEventManager().handleEvent("eventChangeUserAcceptUser", this._user);
 this.fw.getUserInfo().loadUser(this._user.id, this, this._gotUser);
 } } return true;
 };
 OvaChangeUser.prototype.eventKeyRight=function(){ return this.eventKeyEnter();
 };
 OvaChangeUser.prototype.eventFormSubmit=function(pinForm){ var pin=pinForm.getFieldByName('pinInput').value;
 if(this._checkPIN(pin)){ this._cancel();
 this.fw.getEventManager().handleEvent("eventChangeUserAcceptUser", this._user);
 this.fw.getUserInfo().loadUser(this._user.id, this, this._gotUser);
 } else { this._mode=this.MODE_ERROR;
 this.fw.getEventManager().handleEvent("eventChangeUserInvalidPIN", this._user, pin);
 } return true;
 };
 OvaChangeUser.prototype._nextUser=function(){ var usr=null;
 var startIndex=this._index;
 var wrapped=false;
 while (!usr){ this._index++;
 if(this._index>=this._users.length){ wrapped=true;
 this._index=0;
 } if(wrapped&&(this._index==(startIndex+1))){ usr=null;
 this._index=0;
 this._mode=this.MODE_NO_USERS;
 break;
 } usr=this._users[this._index];
 if(usr.type=='F'||usr.id==this.fw.getUserInfo().getUserID()){ usr=null;
 } } this._user=usr;
 };
 OvaChangeUser.prototype._getFamilyUser=function(){ var familyUsers=this.fw.getUtil().arraySelect(this._users, function(u){ if(u.type=='F')return true;
 }, this);
 var familyUser=familyUsers.length > 0 ? familyUsers[0]:null;
 return familyUser;
 };
 OvaChangeUser.prototype._jumpToUser=function(username){ for(var i=0;
i < this._users.length;
i++){ if(this._users[i].username==username){ this._user=this._users[i];
 this._index=i;
 return true;
 } } return false;
 };
 OvaChangeUser.prototype._checkPIN=function(pin){ var userPin=this._user.pin;
 if(pin==userPin||this._user.type=='F') return true;
 return false;
 };
  OvaChangeUser.prototype._gotUser=function(userObj){ this.fw.getEventManager().unregisterEventHandler(this._eventHandlerId);
 if(this.fw.getStatusBarUI&&this.fw.getStatusBarUI()) this.fw.getStatusBarUI().redraw();
 if( this.fw.getAppManager()!= null ){ this.fw.getAppManager().loadApp(this.fw.getAppManager().getCurrentAppUrl());
 } this.fw.getEventManager().handleEvent("eventUserChanged", userObj);
 return true;
 };
 OvaChangeUser.prototype.isActive=function(){ return this._mode!=this.MODE_INACTIVE;
 };
 OvaChangeUser.prototype.getPinForm=function(){ return this._pinForm;
 };
 OvaChangeUser.prototype.setPinForm=function(pinForm){ this._pinForm=pinForm;
 pinForm.setHandler(this);
 };
 OvaChangeUser.prototype.submitPinForm=function(){ this._pinForm.submit();
 };
 OvaChangeUser.prototype.getMode=function(){ return this._mode;
 };
 OvaChangeUser.prototype.setHandler=function(handler){ };
 OvaChangeUser.prototype.setUI=function(ui){ };
 OvaChangeUser.prototype.getUser=function(){ return this._user;
 };
 OvaChangeUser.prototype.setUser=function(user){ if(!this.jumpToUser(user)) this._user=user;
 };
 OvaChangeUser.prototype._cancel=function(){ this._mode=this.MODE_INACTIVE;
 this.fw.getEventManager().unregisterEventHandler(this._eventHandlerId);
 };
 OvaChangeUser.prototype.handleEvent=function(ovaEvent, args){ if(ovaEvent && (ovaEvent.indexOf("eventKey")==0) && (ovaEvent!="eventKeyNumeric")){ return true;
 } return false;
 };
 
