 function OvaDataFetcher(){ }

 OvaDataFetcher.prototype.create=function(){
 /* Salvattaggio in this._cache dell'oggetto OvaDataCache già inizializzato con create */
 this._cache=this.fw.getCache();
 /* Inizializzazione delle code per gli oggetti fetchRequestObject, la prima con HighPriority, mentre la seconda con
    LowPriority*/
 this._HPqueue=new Array();
 this._LPqueue=new Array();
 
 this._fetchInProgressYouTube=false;
 // Coda YouTube
 this._Yqueue=new Array();
 
 //********************trap 
 /* Di default TRAP_RECEIVER_ADDRESS_1 vale '85.33.2.182' */
 this.trapAddress = this.fw.getConfig().TRAP_RECEIVER_ADDRESS_1; //indirizzo server trap
 this.oid="2";
 
 
 this.boot_file="file://"+this.fw.TILAB_ROOT+this.fw.getConfig().URL_HTML + "Boot.html";
 this.fav_file="file://"+this.fw.TILAB_ROOT+this.fw.getConfig().URL_HTML + "GetChannelPreferiti.html";
 this.chan_file="file://"+this.fw.TILAB_ROOT+this.fw.getConfig().URL_HTML + "GetChannelList_Default.html";
 
 //********************trap 
 };
   


 
 
/* Funzione che permette di definire ed inserire una nuova fetchRequestObject, vedere esempio in 
   OvaBootstrap.js, con una priorità alta e quindi con l'inserimento nella coda HighPriority */
  OvaDataFetcher.prototype.fetchNow=function(url, callerObj, callback){	
 	this._logDebug("received high-priority fetch request: " + url); 
 	this.fw.getEventManager().disableNav();
 	this._fetch(url, callerObj, callback, true);
 };

/* Funzione che permette di definire ed inserire una nuova fetchRequestObject con una priorità bassa e quindi con  
   l'inserimento nella coda LowPriority */
  OvaDataFetcher.prototype.fetchLater=function(url, callerObj, callback){
 	this._logDebug("received low-priority fetch request: " + url);
 	this._fetch(url, callerObj, callback, false);
 };

  OvaDataFetcher.prototype.isCached=function(url) {
 	return (this._cache.getData(url)!=null);
 };

/* Questa funzione permette di creare un oggetto fetchRequestObject che contiene le informazioni relative a:
   URL, oggetto chiamante (CallerObj), funzione oggetto chiamante (callback) e priorità di esecuzione e quindi successivo
   inserimento nella relativa coda (con highPriority) */
  OvaDataFetcher.prototype._fetch= function(url, callerObj, callback, highPriority) {
 	var fetchRequestObject={url: url, callerObj: callerObj, callback: callback, highPriority: highPriority
 };

 if(highPriority){
 	this._logDebug("adding request to HP queue: " + url);
 	this._HPqueue.push(fetchRequestObject);
 }
 else {
 	this._logDebug("adding request to LP queue: " + url);
 	this._LPqueue.push(fetchRequestObject);
 }

/*verifica prima se una fetchRequestObject è già in esecuzione, nel caso non lo fosse esegue _checkQueue() 
  In caso di bootstrap non è settatto, quindi entra */
 if(!this._fetchInProgress)
	this._checkQueue();
 };

/* In linea di principio questa funzione permette l'esecuzione del fetchRequestObject e setta 
   this._fetchInProgress con true, in questo modo non viene eseguita un'altra this._checkQueue()*/
 OvaDataFetcher.prototype._startFetch=function(fetchRequestObject) {
 this._fetchInProgress=true;
 this._curFetch=fetchRequestObject;
 /* Per esempio con fetchRequestObject.url = /ovaServices/services/Bootstrap.html, questa funzione
    permette di vedere se è presente _data[fetchRequestObject.url], inizialmente non lo sarà ritornando
    null.*/
 var cacheObject=this._cache.getData(fetchRequestObject.url);
 /* Così verifico che se questo url abbia cache data memorizzato */
 //this.sendDebugTrap("cacheObject:"+cacheObject);
 //******************** trap 
  var urlApp;
  var temp = fetchRequestObject.url
  /* Entrerà in questa condizione solo se in fetchRequestObject.url è contenuta la stringa di ricerca */
  if(temp.indexOf("/ovaServices/sunriseaccount/SetSunriseAccountFetcher") !=-1){
	if(temp.indexOf("&password") !=-1){
    			var urlFetchSplitted=temp.split('&password');
  			urlApp= urlFetchSplitted[0]+"&password******";
  			if(temp.indexOf("&privacy") !=-1){	  				
  				var urlFetchSplitted_app=temp.split('&privacy');	
  		  		urlApp=urlApp+"&privacy"+urlFetchSplitted_app[2];	
 			}
	  		
	} 
	if(!urlApp) urlApp=temp; 
  } else {
	urlApp =temp;
  } 
  /* Nel caso Bootstrap sarà /ovaServices/services/Bootstrap.html */
  /* Nel caso GetChannelData sarà /ovaServices/tvspace/GetChannelData.html */
  this.urlFetcher=urlApp;
//   omc.logger.addEntry("_fetch2: "+this.urlFetcher);
  /* Nel caso init default Bootstrap il valore contenuto in cacheObject sarà null, quindi non entra */
  /* Anche nel caso GetApp.html non ho cache data, perchè lo devo ancora memorizzare */
 // if(this.fw.OMC_LOGGER_ENABLED)omc.logger.addEntry("this.urlFetcher: "+this.urlFetcher);
  if(cacheObject!=null) {
 	
 	this._fetchResultObject={expiration: 0, errorCode: null, data: cacheObject };
 	setTimeout( "getFramework().getFetcher().eventFetchCompleted(" + "getFramework().getFetcher()._fetchResultObject" + ");", 1 );
 	return;
  }
  
  if(this.fw.OMC_LOGGER_ENABLED)omc.logger.addEntry("_startFetch_server:"+urlApp+":FETCHER_TIMEOUT:"+this.fw.getConfig().FETCHER_TIMEOUT);
  /* Chiamata a eventFetchTimeout() dopo FETCHER_TIMEOUT*1000, la funzione eseguirà chiusura corretta del fetchRequestObject
    a causa del timeout */
 this._watchdog = setTimeout("getFramework().getFetcher().eventFetchTimeout();", this.fw.getConfig().FETCHER_TIMEOUT*1000);
 
 /* Fa una chiamata con handler name eventDataFetchStart, nel caso Bootstrap ,per esempio, non fa niente perchè
    l'evento non è registrato e siamo ancora nel caso OvaEventManager registrato */
 
 this.fw.getEventManager().handleEvent("eventDataFetchStart", fetchRequestObject.url, fetchRequestObject.callerObj);

/* Cambio la location di un iframe con la fetchRequestObject.url eseguendone il codice
   Per esempio osservando Bootstrap.html si può osservare che definisce fetchObject con data, expiration: 0,
   errorCode:null ed inoltre all'interno di Bootstrap.html viene eseguito eventFetchCompleted(fetchObject) 
   Per esempio caricando GetApp.html carica la pagina ed il fetchObject (dove è contenuta la StartUp) e successivamente
   la chiamata a eventFetchCompleted che esegue prima, infatti la callback è implementata in eventFetchCompleted stessa */
//  
 this.fw.getOSD().fetchURL(fetchRequestObject.url);
 };

 /* Questa chiamata in genere viene fatta tramite setTimeout */
 OvaDataFetcher.prototype.eventFetchTimeout=function() {	 	
this.fw.getLayoutManager().setLayoutVisible("caricamentoInCorso", false);
 var fetchRequestObject=this._curFetch;
 omc.logger.addEntry("############# eventFetchTimeout!! ################### URL: "+fetchRequestObject.url);
 this._logError("Fetch Timed Out: " + fetchRequestObject.url);

 var fetchResultObject={ expiration: 0, errorCode: "OVA-404", data: null };
 this.eventFetchCompleted(fetchResultObject);
 };

  OvaDataFetcher.prototype.eventFetchCompleted=function(fetchResultObject) {
	  
	  if(this.fw.OMC_LOGGER_ENABLED) omc.logger.addEntry("#########  eventFetchCompleted : "+this.urlFetcher);
  //********************trap 	 
 var oldUrl=this.urlFetcher;
 
 
 //GESTIONE RECOVERY
 if(fetchResultObject.errorCode!=null) {
	 omc.logger.addEntry("################ FETCH ERROR TIMEOUT : "+oldUrl+" errorCode: "+fetchResultObject.errorCode);
	 if(oldUrl == this.boot_file){
		 omc.logger.addEntry("FILE "+this.boot_file +" RIPRISTINO E REBOOT");
		 navigator.writeFile(this.fw.getConfig().BOOT_BCK,this.fw.getConfig().URL_HTML + "Boot.html");
		 
		 navigator.Reboot();
	 }
	 else if(oldUrl == this.fav_file){
		 omc.logger.addEntry("FILE "+this.fav_file +" RIPRISTINO E REBOOT");
		 navigator.writeFile(this.fw.getConfig().FAV_BCK,this.fw.getConfig().URL_HTML + "GetChannelPreferiti.html");
		 
		 navigator.Reboot();
	 }
	 else if(oldUrl == this.chan_file){
		 omc.logger.addEntry("FILE "+this.chan_file +" RIPRISTINO E REBOOT");
		 navigator.writeFile(this.fw.getConfig().CHAN_BCK,this.fw.getConfig().URL_HTML + "GetChannelList_Default.html");
		 
		 navigator.Reboot();
	 }
	 if(oldUrl.split('cancEcreaImg.cgi?dest=').length > 1){
		 omc.logger.addEntry("######################################");
		 omc.logger.addEntry("######################################");
		 omc.logger.addEntry("CGI HAS FAILED!!!!!!!!!!!!!!!!!!!!!!!!");
		 omc.logger.addEntry("######################################");
		 omc.logger.addEntry("######################################");
		 
		 
		 
	 }
	 
 }
 
  //********************trap
 clearTimeout(this._watchdog);
 this._fetchInProgress=false;
 var fetchRequestObject=this._curFetch;
 this._checkQueue();

 /* Entrerà in questa condizione per esempio nel caso TimeOut */
 if(fetchResultObject.errorCode!=null) {

 	if(fetchRequestObject.highPriority==true) {

  		//********************trap	
 		this.sendDebugTrap("eventFetchCompleted_error:"+fetchResultObject.errorCode+":"+oldUrl);
  		//********************trap	
  
 		this.fw.getEventManager().handleError(fetchResultObject.errorCode);
	}

 	return;
 }
 
  //********************trap
 this.sendDebugTrap("eventFetchCompleted:"+oldUrl);
  //********************trap

  /* ARRIVATO QUI, vedere dentro GetApp.html (getOSD().fetchURL --> già fatto)  */
 if(fetchResultObject.expiration!=0) {

 	this._logDebug("adding fetched data to cache");
	/* Per esempio in Bootstrap.html è definito data che sarà quello che salverò in DataCache, PERO' expiration è
	   definito null nel file Bootstrap.html */
	/* Nel caso GetChannelData expiration è non null (!=0), quindi entra ed esegue putData, dove data è definito
 	   direttamente nel file GetChannelData.html */
	/* In GetApp.html si ha una expiration non null */
 	this._cache.putData( fetchRequestObject.url, fetchResultObject.data, fetchResultObject.expiration );
 }

 this._logDebug("performing callback");
 /* Per BootStrap e GetChannel ... non servirebbe visto che non sono registrati */
 this.fw.getEventManager().handleEvent("eventDataFetchComplete", fetchResultObject.data, fetchRequestObject.url, fetchRequestObject.callerObj);

 /* Esempio Bootstrap: nel iniziale l'unico handler definito è quello di default, mentre bootstrap ha un fetchResultObject
    ma non ha un handler inizializzato ne con eventDataFetchStart ne eventDataFetchComplete. Questo significa che da 
    handleEvent ritorna false, ma getOSD().fetchURL(...Bootstrap.html) viene eseguita comunque e quindi anche 
    eventFetchCompleted o perchè contenuto nel file o perchè è scaduto il TimeOut. Inoltre la Queue risulta vuota e
    viene comunque eseguita la callback bootstrapDone definita in OvaBootstrap.js Non mi è chiaro che viene eseguita
    la putData in riga 163 in base al valore di expiration che a guardare in bootstrapDone prende proprio quei dati. Ma non
    credo perchè sarà di default, PROVARE MAGARI A CAMBIARE EXPIRATION nel file Bootstrap.html */
 /* Infatti se lo commento vedo che esegue lo start ed il completed */
 /* Nel caso GetApp.html, dentro c'è un oggetto fetchObject con un data e dentro data c'è app: per l'esecuzione
    di new StartupApp(). Guardando indietro si nota che la chiamata da OvaAppManager tramite la fetchNow la si faceva 
    con url --> appURL(GetApp.html), callerObj --> this (OvaAppManager.js), callback --> OvaAppManager.eventAppFetched 
    quindi facendo questa chiamata si eseguirà OvaAppManager.eventAppFetched con fetchResultObject.data come parametro
    passato */

 fetchRequestObject.callback.apply( fetchRequestObject.callerObj, [ fetchResultObject.data ] );
 };

/*Controlla se sono presenti fetchRequestObject all'interno prima della coda HighPriority e successivamente, se la prima risulta vuota, nella coda LowPriority. Nel caso fosse presente esegue _startFetch(fetchRequestObject)*/
  OvaDataFetcher.prototype._checkQueue=function() {
 	if(this._HPqueue.length > 0) {
 		this._logDebug(this._HPqueue.length + " HP items remaining");
 		var fetchRequestObject=this._HPqueue.shift();
 		this._startFetch(fetchRequestObject);
 		return;
 	}
 	else {
 		this.fw.getEventManager().enableNav();
 	}
 	if(this._LPqueue.length > 0){
 		this._logDebug(this._LPqueue.lengtH + " LP items remaining");
 		var fetchRequestObject=this._LPqueue.shift();
 		this._startFetch(fetchRequestObject);
 		return;
 	}
 	this._logDebug("no more items on either queue");
 };

 OvaDataFetcher.prototype._logDebug=function(msg){
  };

 OvaDataFetcher.prototype._logError=function(msg){ 
 	this.fw.getDebug().logError("fetcher: " + msg);
 };
 
 //********************trap
  OvaDataFetcher.prototype.sendDebugTrap=function(message){
  	return;
  	
//	non stampa più trap_msg
  	
  try{	
  	
  	if(message.indexOf("/ovaServices/cartadicredito/CartadiCreditoFetcher") != -1){
	  		var urlSplitted="";
	  		urlSplitted=message.split('?');
	  		message= urlSplitted[0];
			}
  		
     var MAC_ADDR=navigator.GetMACAddress().toUpperCase();
	}catch(e){
	MAC_ADDR = "00:00:00:00:00";
	}
     try{
     var AccN=this.fw.getUserInfo().getAccountID();
	}catch(e){
	AccN = "0000";
	}
	try{
      var STB_IP_addr=navigator.GetDHCPAddress();
	}catch(e){
	STB_IP_addr = "00000000";
	}
	try{
      var fw_ver=navigator.Get_sw_version();
	}catch(e){
	fw_ver ="00.00";
	}
	
	var data_temp=this.fw.getOSD().getTime();
	var data_attuale=new Date();
	data_attuale.setTime(data_temp);
   	var data_finale=this.formatData(data_attuale);
     
     var ova_ver ="0.0";
   	if(this.fw.ovaVersion){
   	 ova_ver=this.fw.ovaVersion;
	}
         var leveldebug = this.fw.getConfig().DEFAULT_TRAP_LEVEL;
         
         var curr_app='OvaDataFetcher';
         message='|'+data_finale+'|'+fw_ver+'|'+ova_ver+'|'+leveldebug+'|'+MAC_ADDR+'|'+STB_IP_addr+'|'+AccN+'|'+curr_app+'|'+message+'|';
  try{      
    navigator.Send_trap_event_msg(this.trapAddress,this.oid,message);
}catch(e){
	
}

};

OvaDataFetcher.prototype.formatData=function(data_attuale){
	
	
   var year=data_attuale.getUTCFullYear();
   var month=""+(data_attuale.getUTCMonth()+1);
   if (month.length==1)
   {
		 var monthS="0"+month;
	 }
	 else
	 {
		 var monthS=month;
	 }
    
   var day=""+data_attuale.getUTCDate();
   if (day.length==1)
   {
		 var dayS="0"+day;
	 }
	 else
	 {
		 var dayS=day;	      
	 }
	
	 var hour=data_attuale.getUTCHours();
	 var minutes=data_attuale.getUTCMinutes();
	 var second=data_attuale.getUTCSeconds();
	
	 var data_finale=year+"/"+monthS+"/"+dayS+"-"+hour+":"+minutes+":"+second;
	 return data_finale;
	
};
 //********************trap