 function OvaEPG(){ } OvaEPG.prototype.create=function(){
 this.reset();
 };

  OvaEPG.prototype.reset=function(){
 this._chanSchds=null;
 this._chans=null;
 this._numberToIndex=null;
 this._recidToIndex=null;
 this._urlToIndex=null;
 this._chanIndex=null;
 this._slotIndex=null;
 this._slot=null;
 this._emptySlot={};
 this._browseEmptySlots=false;
 this._btv_chans=null;
 };

 OvaEPG.prototype.getBrowseEmptySlots=function(){ return this._browseEmptySlots;
 };

 OvaEPG.prototype.setBrowseEmptySlots=function(value){
 this._browseEmptySlots=value;
 };

 OvaEPG.prototype.removeOldSlotsByChanRecid=function(chanRecid, moveToLast){ if(this._chanSchds==null||this._chans==null)return null;
 var chanIndex=this._recidToIndex[chanRecid];
 this.removeOldSlots(chanIndex, moveToLast);
 };
 OvaEPG.prototype.removeOldSlotsByChanNumber=function(chanNum, moveToLast){ if(this._chanSchds==null||this._chans==null)return null;
 var chanIndex=this._numberToIndex[chanNum];
 this.removeOldSlots(chanIndex, moveToLast);
 };
 OvaEPG.prototype.removeOldSlots=function(chanIndex, moveToLast){  if(this._chanSchds==null||this._chans==null)return;
 if(chanIndex==null) chanIndex=this._chanIndex;
 var chanRecid=this._chans[chanIndex].recid;
 var schd=this._chanSchds[chanRecid];
 if(schd.length==0) return;
 var now=this.fw.getOSD().getTime();
 var numToDelete=0;
 var lastSlot=schd[schd.length-1];
 if(lastSlot.program!=null&&lastSlot.program.enddate < now){ numToDelete=schd.length;
 } else { numToDelete=this.findSlotIndexByTime(chanRecid, null, true);
 } if(numToDelete==null||numToDelete==0) return;
 schd.splice(0, numToDelete);
  if(schd.length==0){ this._chanSchds[chanRecid]=null;
 } if(chanIndex!=this._chanIndex) return;
 var newIndex=this._slotIndex-numToDelete;
 if(newIndex < 0){ if(moveToLast) newIndex=schd.length-1;
 else newIndex=0;
 } this._setSlotIndex(newIndex);
  };
  OvaEPG.prototype.nextChannel=function(timeOrIndex, isIndex){ return this.jumpToChannel(this._chanIndex+1, timeOrIndex, isIndex);
 };
 OvaEPG.prototype.prevChannel=function(timeOrIndex, isIndex){ return this.jumpToChannel(this._chanIndex-1, timeOrIndex, isIndex);
 };
 OvaEPG.prototype.nextSlot=function(){ if(this._chanSchds==null||this._chans==null)return null;
 this._setSlotIndex(this._slotIndex+1);
 return this._slot;
 };
 OvaEPG.prototype.prevSlot=function(){ if(this._chanSchds==null||this._chans==null)return null;
 this._setSlotIndex(this._slotIndex-1);
 return this._slot;
 };
 OvaEPG.prototype.getNumChannels=function(){ if(this._chanSchds==null||this._chans==null)return 0;
 return this._chans.length;
 };
 OvaEPG.prototype.getSelected=function(){ if(this._chanSchds==null||this._chans==null)return null;
 return this._slot;
 };
  OvaEPG.prototype.getSelectedChannel=function(){ if(this._chans==null)return null;
 return this._chans[this._chanIndex] };

 OvaEPG.prototype.getChannelByChanRecid=function( chanRecid ){
 var channel=null;
 if( this._chans!=null ){
 	var chanIndex=this._recidToIndex[chanRecid];
 	channel=this._chans[ chanIndex ];
 } return channel;
 };
 
 OvaEPG.prototype.getChannelByURL=function( url ){ 
 var idx;
 
 if(this._chans==null)return null;
 
 if(!this._urlToIndex) {
 	this._urlToIndex = this._createIndexAssocArray(this._chans, "url");
 } 
  var chanIndex=this._urlToIndex[url];
 channel=this._chans[ chanIndex ];
 return channel;
 };

 OvaEPG.prototype.jumpToChannel=function(chanIndex, timeOrIndex, isIndex){
 if(this._chanSchds==null||this._chans==null)
	return;
 this._setChanIndex(chanIndex);
 if(isIndex){
	this._setSlotIndex(timeOrIndex);
 } else { 
	this._setSlotIndexByTime(timeOrIndex);
 }
  return this._slot;
 };

 OvaEPG.prototype.channelNumberToIndex=function(chanNum){ if(this._chanSchds==null||this._chans==null)return null;
 return this._numberToIndex[chanNum];
 };
 OvaEPG.prototype.jumpToChannelByNumber=function(chanNum, timeOrIndex, isIndex){ if(this._chanSchds==null||this._chans==null)return null;
 var chanIndex=this._numberToIndex[chanNum];
 return this.jumpToChannel(chanIndex, timeOrIndex, isIndex);
 };
 OvaEPG.prototype.channelRecidToIndex=function(chanRecid){ if(this._chanSchds==null||this._chans==null)return null;
 return this._recidToIndex[chanRecid];
 };

 OvaEPG.prototype.jumpToChannelByRecid=function(chanRecid, timeOrIndex, isIndex){ if(this._chanSchds==null||this._chans==null)return null;
 var chanIndex=this._recidToIndex[chanRecid];
//  omc.logger.addEntry("chanIndex: "+chanIndex);
 return this.jumpToChannel(chanIndex, timeOrIndex, isIndex);
 };

 OvaEPG.prototype.scanChannels=function(filterObj, filterFunc, timeOrIndex, isIndex){ if(this._chanSchds==null||this._chans==null)return null;
 var bk=this.createBookmark();
 if(this._chanIndex==null){ var startIndex=0;
 } else { var startIndex=this._chanIndex+1;
 } for(var i=0;
i < this._chans.length;
i++){ this.jumpToChannel(i+startIndex, timeOrIndex, isIndex);
 if(filterFunc.call(filterObj, this._slot)){  return this._slot;
 }  } this.jumpToBookmark(bk);
 return null;
 };

 OvaEPG.prototype.setData=function(chanSchedules, channels){
 /* Nel caso GetChannelData e GetProgramData ho 2 argomenti quindi entro nella seconda scelta (2) */
 if(arguments.length==1){
 	this._chanSchds=chanSchedules._chanSchds;
 	this._chans=chanSchedules._chans;
 	this._btv_chans=chanSchedules._chans;
 } else if (arguments.length==2){
 	this._chanSchds=chanSchedules;
 	this._chans=channels;
 	this._btv_chans=channels;
 } else {
 	throw new Error('OvaEPG.setData() Unknown type');
 }
 /* Occhio a GetDTT, perchè istanzia omc e non solo. Da guardare bene ...*/
 var dtt=this.fw.getDTT();
 /* Per creare i canali DTT e non solo quelli creati in GetChannelData.html */
 if( dtt ) {
	/* INTERESSANTE, sulla console rappresentano le scritte rosse */
	 if (this.fw.OMC_LOGGER_ENABLED)omc.logger.addEntry("####################################################################################################");
	 if (this.fw.OMC_LOGGER_ENABLED)omc.logger.addEntry("####################################################################################################");
	 if(this._localChannels)if (this.fw.OMC_LOGGER_ENABLED)omc.logger.addEntry("########################## OvaEPG.setData ## 1 ##  this._localChannels:"+ this._localChannels.length);
	 if (this.fw.OMC_LOGGER_ENABLED)omc.logger.addEntry("####################################################################################################");
	 if (this.fw.OMC_LOGGER_ENABLED)omc.logger.addEntry("####################################################################################################");
 	var dtt_chans=dtt.createChannels();
 } else {
 	this._recidToIndex = this._createIndexAssocArray(this._chans, "recid");
 	this._numberToIndex = this._createIndexAssocArray(this._chans, "number");
 	this._urlToIndex = this._createIndexAssocArray(this._chans, "url");
 }
 };

 OvaEPG.prototype.mergeDTTLocalChannels=function(dtt_chans) {
	 
 this._chans=this._btv_chans.concat(dtt_chans);
 this._recidToIndex = this._createIndexAssocArray(this._chans, "recid");
 this._numberToIndex = this._createIndexAssocArray(this._chans, "number");
 this._urlToIndex = this._createIndexAssocArray(this._chans, "url");
 };

  OvaEPG.prototype.clone=function(){ var newEPG=this.fw.createEPG();
 newEPG.setBrowseEmptySlots(this._browseEmptySlots);
 newEPG.setData(this);
 var sel=this.getSelected();
 if(sel!=null&&sel.channel!=null) newEPG.jumpToChannelByRecid(sel.channel.recid);
 return newEPG;
 };
  OvaEPG.prototype.filterChannelsBy=function(filterFunc){ var bk=this.createBookmark();
 var newChannels=this.fw.getUtil().arraySelect(this._chans, filterFunc);
 this.setData(this._chanSchds, newChannels);
 this.jumpToBookmark(bk, true);
 };
  OvaEPG.prototype.filterChannelsByRating=function(maxRating){ var filterFunc=function(item){ return (this.fw.getRatings().compareRatings(maxRating, item)>=0);
 };
 this.filterChannelsBy(filterFunc);
 };
  OvaEPG.prototype.filterChannelsByUserRating=function(){ var ratings=this.fw.getRatings();
 var filterFunc=function(item){ return ratings.userAllowed(item.ratingRecid);
 };
 this.filterChannelsBy(filterFunc);
 };
 OvaEPG.prototype.filterChannelsByCategory=function(id){ var filterFunc=function(item){ return (item.categoryRecid==id);
 };
 this.filterChannelsBy(filterFunc);
 };
 OvaEPG.prototype.filterChannelsByType=function(type){ var filterFunc=function(item){ return (item.chanType==type);
 };
 this.filterChannelsBy(filterFunc);
 };

 OvaEPG.prototype.filterBlockedChannels=function(){
 var fw=this.fw;
 var filterFunc=function(item){
 if(fw.getUserInfo().isChannelBlockedForUser(item.recid)){
 	return false;
 } else if (fw.getUserInfo().isChannelBlockedForAcc(item.recid)){
 	return false;
 } else {
	return true;
 }
 };

 this.filterChannelsBy(filterFunc);
 };
 OvaEPG.prototype.excludeChannelsByType=function(type){ var filterFunc=function(item){ return (item.chanType!=type);
 };
 this.filterChannelsBy(filterFunc);
 };
 OvaEPG.prototype.createChannelScheduleByRecid=function(chanRecid, startTime, endTime){ if(this._chanSchds==null||this._chans==null)return null;
 var chanIndex=this._recidToIndex[chanRecid];
 return this.createChannelSchedule(chanIndex, startTime, endTime);
 };
 OvaEPG.prototype.createChannelSchedule=function(chanIndex, startTime, endTime){ if(this._chanSchds==null||this._chans==null)return null;
 var chan=this._chans[chanIndex];
 var chanSchd=this._chanSchds[chan.recid];
 var startIndex, endIndex;
 var calc=_OvaEPG_calcSlotIndexByTime(chanSchd, startTime);
 var slots=null;
 if(calc.found){ startIndex=calc.index;
 } else if (calc.upper==Number.POSITIVE_INFINITY){ slots=[];
 } else if (calc.lower==Number.NEGATIVE_INFINITY){ startIndex=0;
 } else { startIndex=calc.upper;
 } var calc=_OvaEPG_calcSlotIndexByTime(chanSchd, endTime);
 if(calc.found){ endIndex=calc.index;
 } else if (calc.upper==Number.POSITIVE_INFINITY){ endIndex=chanSchd.length-1;
 } else if (calc.lower==Number.NEGATIVE_INFINITY){ slots=[];
 } else { endIndex=calc.lower;
 } if(slots==null){ slots=chanSchd.slice(startIndex, endIndex+1);
 } return (new _OvaEPG_channelSchedule(slots));
 };
 OvaEPG.prototype.getChannels=function(){ if(this._chanSchds==null||this._chans==null)return null;
 return this._chans;
 };

 OvaEPG.prototype.getChannelSchedule=function(chanRecid){
 if(this._chanSchds==null||this._chans==null)
	return null;
 return this._chanSchds[chanRecid];
 };

 OvaEPG.prototype._createIndexAssocArray=function(arr, propName){
 var ret={};
 for(var i=0; i < arr.length; i++){
 	var elt=arr[i];
 	ret[elt[propName]]=i;
 	
 } 
 return ret;
 };

 OvaEPG.prototype._setChanIndex=function(chanIndex){ if(chanIndex==null||this._chans.length==0){ this._chanIndex=null;
 this._slotIndex=null;
 this._slot=this._emptySlot;
 this._slot.channel=null;
 return;
 } chanIndex=this.fw.getUtil().wrap(chanIndex, this._chans.length);
 this._chanIndex=chanIndex;
 };
 OvaEPG.prototype._setSlotIndex=function(slotIndex){ var chan=this._chans[this._chanIndex];
 if(chan==null){ this._slotIndex=null;
 this._slot=this._emptySlot;
 this._slot.channel=null;
 return;
 } var chanSchd=this._chanSchds[chan.recid];
 if(chanSchd==null||chanSchd.length==0){ this._slotIndex=null;
 this._slot=this._emptySlot;
 this._slot.channel=chan;
 return;
 } slotIndex=this.fw.getUtil().wrap(slotIndex, chanSchd.length);
 this._slotIndex=slotIndex;
 this._slot=chanSchd[slotIndex];
 this._slot.channel=chan;
 };
 OvaEPG.prototype._setSlotIndexByTime=function(time){ var chan=this._chans[this._chanIndex];
 if(chan==null){ this._slotIndex=null;
 this._slot=this._emptySlot;
 this._slot.channel=null;
 return;
 } var chanSchd=this._chanSchds[chan.recid];
 if(chanSchd==null){ this._slotIndex=null;
 this._slot=this._emptySlot;
 this._slot.channel=chan;
 return;
 } if(time==null)time=this.fw.getOSD().getTime();
 else time=this.fw.getUtil().getValidDate(time);
 var calc=_OvaEPG_calcSlotIndexByTime(chanSchd, time, this._browseEmptySlots);
 if(calc.found){ this._slotIndex=calc.index;
 this._slot=chanSchd[this._slotIndex];
 this._slot.channel=chan;
 } else { this._slotIndex=null;
 this._slot=this._emptySlot;
 this._slot.channel=chan;
 } };

 OvaEPG.prototype.findSlotIndexByTime=function(chanRecid, time, searchEmptySlots){
 var chanSchd=this._chanSchds[chanRecid];
 if(chanSchd==null){
 	return null;
 }
 if(time==null)
	time=this.fw.getOSD().getTime();
 else 
	time=this.fw.getUtil().getValidDate(time);
 var calc=_OvaEPG_calcSlotIndexByTime(chanSchd, time, searchEmptySlots);
 if(calc.found){
 	return calc.index;
 } else {
	 return null;
 } 
};

 OvaEPG.prototype.findSlotByChannelRecid=function(chanRecid, time, searchEmptySlots){ var i=this.findSlotIndexByTime(chanRecid, time, searchEmptySlots);
 if(i==null){ return null;
 } else { var chanSchd=this._chanSchds[chanRecid];
 return chanSchd[i];
 } };
 OvaEPG.prototype.findNextSlotIndexByTime=function(chanRecid, time, searchEmptySlots){ var chanSchd=this._chanSchds[chanRecid];
 if(chanSchd==null){ return null;
 } if(time==null)time=this.fw.getOSD().getTime();
 else time=this.fw.getUtil().getValidDate(time);
 var calc=_OvaEPG_calcSlotIndexByTime(chanSchd, time, searchEmptySlots);
 if(calc.found){ return calc.index;
 } else { return calc.upper;
 } };
 OvaEPG.prototype.findSlotByScheduleId=function(schdRecid){ var found=null;
 for(var i in this._chanSchds){ var chanSchd=this._chanSchds[i];
 for(var j=0;
j < chanSchd.length;
j++){ var slot=chanSchd[j];
 if(slot.program!=null&&!slot.program.isEmpty){ if(slot.program.schdid==schdRecid){ found=slot;
 break;
 } } } if(found){ found.channel=this._chans[i-1];
 break;
 } } return found;
 };

OvaEPG.prototype.findSlotByScheduleIds=function(schdRecids){ 
 var foundSlots= new Array();
 for(var i in this._chanSchds){ 
	var chanSchd=this._chanSchds[i];
 	for(var j=0; j < chanSchd.length; j++){
		var slot=chanSchd[j];
 		if(slot.program!=null&&!slot.program.isEmpty){
			if(schdRecids[slot.program.schdid]==true){
				slot.channel=i;
 				foundSlots.push(slot);
 				break;
 			}
		}
	}
 } return foundSlots;
 };

  OvaEPG.prototype.findSlotByProgramId=function(pgmRecid, prgType){ var foundSlot=null;
 var currentTime=this.fw.getOSD().getTime();
 for(var chan in this._chanSchds){ var foundForChannel=false;
 var chanSchd=this._chanSchds[chan];
 for(var slotNo=0;
slotNo < chanSchd.length&&! foundForChannel;
slotNo++){ var slot=chanSchd[slotNo];
 if(slot.program!=null&&! slot.program.isEmpty ){ if(slot.program.type==prgType){ if(slot.program.id==pgmRecid){ if( currentTime < slot.program.startdate ){ if( foundSlot==null ){ foundSlot=slot;
 }else{ if( slot.program.startdate < foundSlot.startdate ){ foundSlot=slot;
 } } foundForChannel=true;
 foundSlot.channel=this._chans[i-1];
 } } } } } } return foundSlot;
 };
  OvaEPG.prototype.createBookmark=function(){ if(this._chanSchds==null||this._chans==null)return null;
 return { _chanIndex: this._chanIndex, _slotIndex: this._slotIndex, _slot: this._slot };
 };
 OvaEPG.prototype.jumpToBookmark=function(bk, doDefault){ if(this._chanSchds==null||this._chans==null)return null;
 var origChanIndex=this._chanIndex;
 var origSlotIndex=this._slotIndex;
 var origSlot=this._slot;
 try { this._setChanIndex(bk._chanIndex);
 this._setSlotIndex(bk._slotIndex);
 if(this._slot==bk._slot) return;
 var slot=bk._slot;
 if(slot==null||slot.program==null||slot.program.isEmpty){ if(doDefault) this.jumpToChannel(0);
 } else if (slot.program.startdate!=null&&slot.program.enddate!=null){ this.jumpToChannelByRecid(slot.channel.recid, (slot.program.startdate+slot.program.enddate) / 2, false);
 } else { if(doDefault) this.jumpToChannelByRecid(slot.channel.recid);
 } } catch (e){  this._chanIndex=origChanIndex;
 this._slotIndex=origSlotIndex;
 this._slot=origSlot;
 } };
 function _OvaEPG_channelSchedule(slots){ this._slots=slots;
 } _OvaEPG_channelSchedule.prototype.getIndexByTime=function(time, browseEmptySlots){ if(this._slots==null||this._slots.length==0){ return null;
 } var calc=_OvaEPG_calcSlotIndexByTime(this._slots, time, browseEmptySlots);
 if(calc.found){ return calc.index;
 } else { return null;
 } };
 _OvaEPG_channelSchedule.prototype.getSlots=function(){ return this._slots;
 };

 _OvaEPG_calcSlotIndexByTime=function(chanSchd, time, browseEmptySlots){
 if(browseEmptySlots){
	var doFind=function(slot){
 		return ( slot!=null && slot.program!=null && slot.program.startdate!=null && slot.program.enddate!=null );
 }
 } else {
 	var doFind=function(slot){ 
		return ( slot!=null && slot.program!=null && ! slot.program.isEmpty );
 	}
 }
 var find=function(slot){
 	if(doFind(slot)){
		var startTime=slot.program.startdate;
 		var endTime=slot.program.enddate;
 		if(startTime<=time&&time < endTime){
			return 0;
 		} else if (time < startTime){
			return -1;
 		} else if (endTime<=time){
			return 1;
 		}
	}
 };
 return getFramework().getUtil().binSearch(chanSchd, find);
 };
 
