 OvaPinDialog.prototype.MODE_INACTIVE=1;
 OvaPinDialog.prototype.MODE_ENTER =2;
 OvaPinDialog.prototype.MODE_ERROR =3;
 OvaPinDialog.prototype.ACTION_ACCEPT=1;
 OvaPinDialog.prototype.ACTION_CANCEL=2;

 function OvaPinDialog(){ }

 OvaPinDialog.prototype.create=function(){
 this._mode=this.MODE_INACTIVE;
 this._eventMap=new Object();
 this._useDefaultEvents=true;
 this._defaultEventMap={ eventKeyHot1: this.ACTION_ACCEPT, eventKeyHot2: this.ACTION_CANCEL };
 };

 OvaPinDialog.prototype.start=function(passNonActiveEvents) { this._passNonActiveEvents=(passNonActiveEvents==true);
 this._eventHandlerId = this.fw.getEventManager().registerEventHandler(this, "OvaPinDialog");
 this._mode=this.MODE_ENTER;
 this.fw.getEventManager().handleEvent("eventPinDialogStart", this);
 return true;
 };
 OvaPinDialog.prototype.cancel=function(){ this._mode=this.MODE_INACTIVE;
 this.fw.getEventManager().unregisterEventHandler(this._eventHandlerId);
 this.fw.getEventManager().handleEvent("eventPinDialogCancel", this);
 return true;
 };
 OvaPinDialog.prototype.getPinForm=function(){ return this._pinForm;
 };
 OvaPinDialog.prototype.setPinForm=function(pinForm){ this._pinForm=pinForm;
 pinForm.setHandler(this);
 };
 OvaPinDialog.prototype.setUseDefaultEvents=function(val){ this._useDefaultEvents=val;
 };
 OvaPinDialog.prototype.getUseDefaultEvents=function(){ return this._useDefaultEvents;
 };
 OvaPinDialog.prototype.getMode=function(){ return this._mode;
 };
 OvaPinDialog.prototype.eventFormSubmit=function(pinForm){ var pin=pinForm.getFieldByName('pinInput').value;
 this.acceptPin(pin);
 };
 OvaPinDialog.prototype.acceptPin=function(param){ var userPin=this.fw.getUserInfo().getPin();
 if(param==userPin){ this._mode=this.MODE_INACTIVE;
 this.fw.getEventManager().unregisterEventHandler(this._eventHandlerId);
 this.fw.getEventManager().handleEvent("eventPinDialogValidPIN", this);
 } else { this._mode=this.MODE_ERROR;
 this.fw.getEventManager().handleEvent("eventPinDialogInvalidPIN", this);
 } };
 OvaPinDialog.prototype.handleEvent=function(ovaEvent, args){ var act=this._eventMap[ovaEvent];
 if(!act&&this._useDefaultEvents) act=this._defaultEventMap[ovaEvent];
 if(act){ if(act==this.ACTION_ACCEPT)return this._actionAccept();
 else if(act==this.ACTION_CANCEL)return this._actionCancel();
 } if(this._mode==this.MODE_INACTIVE||this._passNonActiveEvents)return false;
 else if(ovaEvent.indexOf('eventPinDialog')== 0) return false;
 else return (ovaEvent != "eventKeyNumeric");
 };
 OvaPinDialog.prototype.mapEvent=function(ovaEvent, action){ this._eventMap[ovaEvent]=action;
 };
 OvaPinDialog.prototype.unmapEvent=function(ovaEvent){ this._eventMap[ovaEvent]=null;
 };
 OvaPinDialog.prototype.clearEventMap=function(){ this._eventMap=new Object();
 };
 OvaPinDialog.prototype._actionAccept=function(args){ this.fw.getEventManager().handleEvent("eventPinDialogAccept", this);
 return true;
 };
 OvaPinDialog.prototype._actionCancel=function(args){ this.cancel();
 return true;
 };
  OvaPinDialog.prototype.setHandler=function(handler){};
  OvaPinDialog.prototype.setUI=function(ui){};

