 function OvaUserInfo(){ } 
 
OvaUserInfo.prototype.create=function(){
 this._doReload=true;
 /* Di default ENABLE_DRM vale 'false' */
 this.DRM_ENABLED=eval(this.fw.getConfig().ENABLE_DRM);
 this._authLastUpdate=0;
 this._authRefreshDate=null;
 };

 OvaUserInfo.prototype.setUser=function(user, dontSetNotifications) {
 if(this._userReloadTimer){ 
 	this.fw.getDebug().logInfo("clearing current user reload timer...");
 	this.fw.getTimer().clearTimeout(this._userReloadTimer);
 	this._userReloadTimer=null;
 } 
 this._user=user;
 if(user){
 	var reloadInterval=eval(this.fw.getConfig().RELOAD_INTERVAL_USER);
 	if(reloadInterval!=0){ 
		this.fw.getDebug().logInfo("user info reload in " + reloadInterval + " seconds");
 		this._userReloadTimer=this.fw.getTimer().setTimeout(reloadInterval*1000, this.loadUser, this);
 	}
 }
 if(!dontSetNotifications)this.setFavouritesNotifications();
 };

 OvaUserInfo.prototype.setFavouritesNotifications=function(){ this.fw.getNotifications().setProgramNotifications(this.getFavouritePrograms(), 'FAV');
 };

 OvaUserInfo.prototype.setPPVNotifications=function(){
 	this.fw.getNotifications().setNotificationsByScheduleIds(this.getPpvPrograms(), 'PPV');
 };

 OvaUserInfo.prototype.setNvodNotifications=function(){ this.fw.getNotifications().setNotificationsByProgramIds(this.getNvodPrograms(), 'NVOD');
 };
 OvaUserInfo.prototype.setAccount=function(account, dontSetNotifications) {  this._account=account;
 this.fw.getOSD().setTime(this._account.localtime);
 this.fw.getOSD().setTimezoneOffset(this._account.tzoffset);
 if(this._accReloadTimer){ this.fw.getDebug().logInfo("clearing current account reload timer...");
 this.fw.getTimer().clearTimeout(this._accReloadTimer);
 this._accReloadTimer=null;
 }  if(account){ var reloadInterval=eval(this.fw.getConfig().RELOAD_INTERVAL_ACCOUNT);
 if(reloadInterval!=0){ this.fw.getDebug().logInfo("user info reload in " + reloadInterval + " seconds");
 this._accReloadTimer=this.fw.getTimer().setTimeout(reloadInterval*1000, this.loadAccount, this);
 } } if(!dontSetNotifications){ this.setPPVNotifications();
 this.setNvodNotifications();
 } };
 OvaUserInfo.prototype.setInventory=function(inventory) {  if(this._invReloadTimer){ this.fw.getDebug().logInfo("clearing current inventory reload timer...");
 this.fw.getTimer().clearTimeout(this._invReloadTimer);
 this._invReloadTimer=null;
 } if(inventory.authinfo!=null&&inventory.authinfo.length > 0){ this._inventory=inventory;
 this._authRefreshDate=this._authLastUpdate;
 this._authLastUpdate=inventory.authlastupdate;
 } if(this.DRM_ENABLED){ this.fw.getDRM().init();
 }  if(this.DRM_ENABLED){ var reloadInterval=eval(this.fw.getConfig().RELOAD_INTERVAL_INVENTORY);
 if(reloadInterval!=0){ this.fw.getDebug().logInfo("inventory data reload in " + reloadInterval + " seconds");
 this._invReloadTimer=this.fw.getTimer().setTimeout(reloadInterval*1000, this.loadInventory, this);
 } } };
 OvaUserInfo.prototype.loadInventory=function(){ if(this._invReloadTimer){ this.fw.getDebug().logInfo("clearing current inventory reload timer...");
 this.fw.getTimer().clearTimeout(this._invReloadTimer);
 this._invReloadTimer=null;
 } var url='/ovaServices/services/GetInventory.jsp?';
 this._load(url, this, this._invLoaded, false);
 var reloadInterval=eval(this.fw.getConfig().RELOAD_INTERVAL_INVENTORY);
 if(reloadInterval!=0){ this.fw.getDebug().logInfo("inventory data reload in " + reloadInterval + " seconds");
 this._invReloadTimer=this.fw.getTimer().setTimeout(reloadInterval*1000, this.loadInventory, this);
 } };
 OvaUserInfo.prototype._invLoaded=function(obj){ this.fw.getDebug().logInfo("inventory loaded");
 if(obj.authinfo!=null&&obj.authinfo.length > 0){ this._inventory=obj;
 this._authRefreshDate=this._authLastUpdate;
 this._authLastUpdate=obj.authlastupdate;
 } if(this.DRM_ENABLED){ this.fw.getDRM().init();
 } };
 OvaUserInfo.prototype.loadUser=function(userRecid, callbackObj, callback, fetchLater) { if(this._userReloadTimer){ this.fw.getDebug().logInfo("clearing current user reload timer...");
 this.fw.getTimer().clearTimeout(this._userReloadTimer);
 this._userReloadTimer=null;
 } if(!userRecid)userRecid=this.getUserID();
 var url='/ovaServices/services/GetUser.jsp?usr_recid='+userRecid;
 this._userLoadCallBackObj=callbackObj;
 this._userLoadCallBackFunc=callback;
 if(fetchLater==undefined)fetchLater=(callbackObj==undefined);
 this._load(url, this, this._userLoaded, fetchLater);
 var reloadInterval=eval(this.fw.getConfig().RELOAD_INTERVAL_USER);
 if(reloadInterval!=0){ this.fw.getDebug().logInfo("user info reload in " + reloadInterval + " seconds");
 this._userReloadTimer=this.fw.getTimer().setTimeout(reloadInterval*1000, this.loadUser, this);
 } };
 OvaUserInfo.prototype._userLoaded=function(obj){ this.fw.getDebug().logInfo("user loaded");
 this._user=obj.user;
 this.setFavouritesNotifications();
 this.fw.getEPGManager().refresh();
 if(this._userLoadCallBackFunc!=null){ this._userLoadCallBackFunc.apply(this._userLoadCallBackObj, [ obj ]);
 } this._userLoadCallBackObj=null;
 this._userLoadCallBackFunc=null;
 };
  OvaUserInfo.prototype.loadAccount=function(accRecid, callbackObj, callback, fetchLater){ if(!accRecid)accRecid=this.getAccountID();
 var url='/ovaServices/services/GetAccount.jsp?acc_recid='+accRecid;
 if(!this._account.isEnabled){  var stringURL='';
 this.fw.getAppManager().getCurrentApp().fin();
 this.fw.getOSD().reloadFramework(stringURL);
 }else { if(this._accReloadTimer){ this.fw.getDebug().logInfo("clearing current account reload timer...");
 this.fw.getTimer().clearTimeout(this._accReloadTimer);
 this._accReloadTimer=null;
 } this._accLoadCallBackObj=callbackObj;
 this._accLoadCallBackFunc=callback;
 if(fetchLater==undefined)fetchLater=(callbackObj==undefined);
 this._load(url, this, this._accLoaded, fetchLater);
 var reloadInterval=eval(this.fw.getConfig().RELOAD_INTERVAL_ACCOUNT);
 if(reloadInterval!=0){ this.fw.getDebug().logInfo("user info reload in " + reloadInterval + " seconds");
 this._accReloadTimer=this.fw.getTimer().setTimeout(reloadInterval*1000, this.loadAccount, this);
 } } };
 OvaUserInfo.prototype._accLoaded=function(obj){ this.fw.getDebug().logInfo("account loaded");
 this._account=obj.account;
 this.fw.getOSD().setTime(this._account.localtime);
 this.fw.getOSD().setTimezoneOffset(this._account.tzoffset);
 this.setPPVNotifications();
 this.setNvodNotifications();
 this.fw.getEPGManager().refresh();
 if(this.DRM_ENABLED){ this.fw.getDRM().init();
 } if(this._accLoadCallBackFunc!=null){ this._accLoadCallBackFunc.apply(this._accLoadCallBackObj, [ obj ]);
 } this._accLoadCallBackObj=null;
 this._accLoadCallBackFunc=null;
 };
 OvaUserInfo.prototype._load=function(url, callbackObj, callback, fetchLater) { this.fw.getDebug().logInfo("loading user: " + url);
 if(!fetchLater) this.fw.getFetcher().fetchNow(url, callbackObj, callback);
 else this.fw.getFetcher().fetchLater(url, callbackObj, callback);
 };
  OvaUserInfo.prototype.formatName=function(formatStr){ if(!formatStr)formatStr = "%f %l";
 formatStr=formatStr.replace(/%f/i, this.getFirstName());
 formatStr=formatStr.replace(/%l/i, this.getLastName());
 return formatStr;
 };
 OvaUserInfo.prototype.isEnabled=function(){ return this._account.isEnabled;
};
 OvaUserInfo.prototype.isAdult=function(){ return this._account.isAdult;
};
 OvaUserInfo.prototype.isQA=function(){ return this._account.isQA;
};

 OvaUserInfo.prototype.getUsers=function(){
 return this._account.users;
};

 OvaUserInfo.prototype.getAccountID=function(){ return this._account.id;
};
 OvaUserInfo.prototype.getAccountNumber=function(){ return this._account.number;
};
 OvaUserInfo.prototype.getAccountAuthInfo=function(){ return this._account.authInfo;
};
 OvaUserInfo.prototype.clearAccountAuthInfo=function(){ this._account.authInfo=null;
};
 OvaUserInfo.prototype.getServices=function(){ return this._account.services;
};
 OvaUserInfo.prototype.isSubscribedService=function(recid){ return this._account.services[recid] ? true:false;
};

 OvaUserInfo.prototype.getPackages=function(){
 	return this._account.packages;
 };

 OvaUserInfo.prototype.getChannels=function(){ return this._account.channels;
};
 OvaUserInfo.prototype.getGMTTime=function(){ return this._account.gmttime;
};
 OvaUserInfo.prototype.getTimeZone=function(){ return this._account.timezone;
};
 OvaUserInfo.prototype.getTimeZoneOffset=function(){ return this._account.tzoffset;
};
 OvaUserInfo.prototype.getAccessPoint=function(){ return this._account.accesspoint;
};
 OvaUserInfo.prototype.isVideoLockerShared=function(){ return this._account.isVideoLockerShared ? 'Y':'N';
};

 OvaUserInfo.prototype.showBlockedChannels=function(){
 return this._account.showBlockedChannel;
 };

 OvaUserInfo.prototype.setVideoLocker=function(flag){this._account.isVideoLockerShared=flag;
};

 OvaUserInfo.prototype.setShowBlockedChannels=function(flag){
 this._account.showBlockedChannel=flag;
 };

 OvaUserInfo.prototype.clearInventoryAuthInfo=function(){ this._inventory.authInfo=null;
};
 OvaUserInfo.prototype.getAuthRefreshDate=function(){return this._authRefreshDate;
};
 OvaUserInfo.prototype.getAuthLastUpdate=function(){return this._authLastUpdate;
};
 OvaUserInfo.prototype.getInventoryAuthInfo=function(){return this._inventory.authinfo;
};
 OvaUserInfo.prototype.getLoginName=function(){ return this._user.loginname;
};
 OvaUserInfo.prototype.getUserID=function(){ return this._user.id;
};
 OvaUserInfo.prototype.getType=function(){ return this._user.type;
};
 OvaUserInfo.prototype.getFirstName=function(){ return this._user.firstname;
};
 OvaUserInfo.prototype.getLastName=function(){ return this._user.lastname;
};
 OvaUserInfo.prototype.getRating=function(){ return this._user.rating;
};
 OvaUserInfo.prototype.setRating=function(rating){ this._user.rating=rating;
};
 OvaUserInfo.prototype.getRatingID=function(){ return this._user.ratingid;
};
 OvaUserInfo.prototype.setRatingID=function(ratingid){ this._user.ratingid=ratingid;
};
 OvaUserInfo.prototype.getPin=function(){ return this._user.pin;
};
 OvaUserInfo.prototype.setPin=function(pin){ this._user.pin=pin;
};
 OvaUserInfo.prototype.getCanChangePin=function(){ return this._user.canchangepin;
};
 OvaUserInfo.prototype.setCanChangePin=function(flag){ this._user.canchangepin=flag;
};

 OvaUserInfo.prototype.getLocale=function(){ 
 return this._user.locale;
 };

 OvaUserInfo.prototype.setHomePage=function(homepage){ this._user.homepage=homepage;
};
 OvaUserInfo.prototype.getHomePage=function(){ return this._user.homepage;
};
 OvaUserInfo.prototype.setSearchPage=function(searchpage){ this._user.searchpage=searchpage;
};
 OvaUserInfo.prototype.getSearchPage=function(){ return this._user.searchpage;
};
 OvaUserInfo.prototype.setDisplayColour=function(displaycolour){ this._user.displaycolour=displaycolour;
};
 OvaUserInfo.prototype.getDisplayColour=function(){ return this._user.displaycolour;
};
 OvaUserInfo.prototype.getConfirmPurchases=function(){ return this._user.confirmpurchases;
};
 OvaUserInfo.prototype.setConfirmPurchases=function(val){ this._user.confirmpurchases=val;
};
 OvaUserInfo.prototype.getFavouriteChannels=function(){ return this._user.favourites.channels;
};
 OvaUserInfo.prototype.getFavouritePrograms=function(){ return this._user.favourites.programs;
};
 OvaUserInfo.prototype.getFavouriteSeries=function(){ return this._user.favourites.series;
};
 OvaUserInfo.prototype.isFavouriteChannel=function(recid){ return this._user.favourites.channels[recid] ? true:false;
};
 OvaUserInfo.prototype.addFavouriteChannel=function(recid){ this._user.favourites.channels[recid]=true;
};
 OvaUserInfo.prototype.removeFavouriteChannel=function(recid){ this._user.favourites.channels[recid]=false;
};
 OvaUserInfo.prototype.isFavouriteProgram=function(recid){ return this._user.favourites.programs[recid] ? true:false;
};
 OvaUserInfo.prototype.isMailEnabled=function(){return this._user.mailenabled;
};
 OvaUserInfo.prototype.addFavouriteProgram=function(recid){ this._user.favourites.programs[recid]=true;
 this.fw.getNotifications().setProgramNotification(recid, 'FAV');
 };
 OvaUserInfo.prototype.removeFavouriteProgram=function(recid){ this._user.favourites.programs[recid]=false;
 this.fw.getNotifications().clearProgramNotification(recid, 'FAV');
 };
 OvaUserInfo.prototype.isFavouriteSeries=function(recid){ return this._user.favourites.series[recid] ? true:false;
};
 OvaUserInfo.prototype.addFavouriteSeries=function(recid){ this._user.favourites.series[recid]=true;
};
 OvaUserInfo.prototype.removeFavouriteSeries=function(recid){ this._user.favourites.series[recid]=false;
};
 OvaUserInfo.prototype.addPpvBundle=function(recid){ this._account.ppv.bundles[recid]=true;
};
 OvaUserInfo.prototype.removePpvBundle=function(recid){ this._account.ppv.bundles[recid]=false;
};
 OvaUserInfo.prototype.getPpvBundles=function(){ return this._account.ppv.bundles;
};
 OvaUserInfo.prototype.isPpvBundlePurchased=function(recid){ return this._account.ppv.bundles[recid] ? true:false;
};

 OvaUserInfo.prototype.getPpvPrograms=function(){ 
	return this._account.ppv.programs;
};

 OvaUserInfo.prototype.isPpvProgramPurchased=function(recid){ return this._account.ppv.programs[recid] ? true:false;
};
 OvaUserInfo.prototype.addPpvProgram=function(recid){ this._account.ppv.programs[recid]=true;
 this.fw.getNotifications().setNotificationsByProgramIds(this.getPpvPrograms(), 'PPV');
 };
 OvaUserInfo.prototype.removePpvProgram=function(recid){ this._account.ppv.programs[recid]=false;
 this.fw.getNotifications().clearProgramNotification(recid, 'PPV');
 };
 OvaUserInfo.prototype.addNvodProgram=function(recid){ this._account.nvod.programs[recid]=true;
 this.fw.getNotifications().setNotificationsByProgramIds(this.getNvodPrograms(), 'NVOD');
 };
 OvaUserInfo.prototype.removeNvodProgram=function(recid){ this._account.nvod.programs[recid]=false;
 this.fw.getNotifications().clearProgramNotification(recid, 'NVOD');
 };
 OvaUserInfo.prototype.getNvodPrograms=function(){ return this._account.nvod.programs;
};
 OvaUserInfo.prototype.isNvodProgramPurchased=function(recid){ return this._account.nvod.programs[recid] ? true:false;
};
 OvaUserInfo.prototype.getSpendingLimit=function(){ return this._user.spendinglimit;
};
 OvaUserInfo.prototype.setSpendingLimit=function(spLimit){ this._user.spendinglimit=spLimit;
};
 OvaUserInfo.prototype.getAmountSpent=function(){ return this._user.amountspent;
};
 OvaUserInfo.prototype.blockChannelForUser=function(recid){ this._user.blockchannels[recid]=true;
};
 OvaUserInfo.prototype.unBlockChannelForUser=function(recid){ this._user.blockchannels[recid]=false;
};
 OvaUserInfo.prototype.getPpgUsersChannels=function(){ return this._user.blockchannels;
};

 OvaUserInfo.prototype.isChannelBlockedForUser=function(recid){
 	return this._user.blockchannels[recid] ? true:false;
 };

 OvaUserInfo.prototype.blockChannelForAcc=function(recid){ this._account.blockchannels[recid]=true;
};
 OvaUserInfo.prototype.unBlockChannelForAcc=function(recid){ this._account.blockchannels[recid]=false;
};
 OvaUserInfo.prototype.getPpgAccsChannels=function(){ return this._account.blockchannels;
};
 OvaUserInfo.prototype.isChannelBlockedForAcc=function(recid){ return this._account.blockchannels[recid] ? true:false;
};
 OvaUserInfo.prototype.addUser=function(id, username, pin, type){ this._account.users.push({ id: id, username: username, pin: pin, type: type });
 };
 OvaUserInfo.prototype.removeUser=function(id){ var users=this._account.users;
 var at=-1;
 for(var i=0;
i < users.length;
i++){ if(users[i].id==id){ at=i;
 break;
 } } if(at!=-1){ users.splice(at, 1);
 } };
 OvaUserInfo.prototype.filterServices=function(svclist){ var services=[];
 if(svclist){ var i=0;
 for(i=0;
i < svclist.length;
i++){ var svc=svclist[i];
 var addsvc=true;
 if(svc.type == "APPLICATION"){ addsvc=(this.isSubscribedService(svc.id)) ? true:false;
 } if(svc.type != "CATEGORY"){ if(addsvc){ if(svc.subscriberonly){ addsvc = (this.getType() == "S" || this.getType() == "P");
 } } } if(addsvc){ services.push(svc);
 } } } return services;
 };
  OvaUserInfo.prototype.clearUserAccountTimers=function(){ if( this.fw.getTimer()){ if(this._userReloadTimer){ this.fw.getTimer().clearTimeout(this._userReloadTimer);
 this._userReloadTimer=null;
 } if(this._accReloadTimer){ this.fw.getTimer().clearTimeout(this._accReloadTimer);
 this._accReloadTimer=null;
 } } };
 OvaUserInfo.prototype.getUsersFirstAvailableChannelId=function(){ var channel=null;
 var channels=this.getChannels();
 var foundChannel=false;
 if( channels ){ for( var counter=0;
counter< channels.length&&! foundChannel;
counter++ ){ channel=channels [ counter ];
 if( ! this.isChannelBlockedForUser( channel )){ foundChannel=true;
 } } } return channel;
 };
 