function OvaKeyMap() {
}
OvaKeyMap.prototype.create = function() {
	if (this.fw.getOSD().isPC()) {
		this._KEY_MAP = {
			32 :"eventKeySpace",
			46 :"eventKeyDot",
			48 :"eventKey0",
			49 :"eventKey1",
			50 :"eventKey2",
			51 :"eventKey3",
			52 :"eventKey4",
			53 :"eventKey5",
			54 :"eventKey6",
			55 :"eventKey7",
			56 :"eventKey8",
			57 :"eventKey9",
			97 :"eventKeya",
			98 :"eventKeyb",
			99 :"eventKeyc",
			100 :"eventKeyd",
			101 :"eventKeye",
			102 :"eventKeyf",
			103 :"eventKeyg",
			104 :"eventKeyh",
			105 :"eventKeyi",
			106 :"eventKeyj",
			107 :"eventKeyk",
			108 :"eventKeyl",
			109 :"eventKeym",
			110 :"eventKeyn",
			111 :"eventKeyo",
			112 :"eventKeyp",
			113 :"eventKeyq",
			114 :"eventKeyr",
			115 :"eventKeys",
			116 :"eventKeyt",
			117 :"eventKeyu",
			118 :"eventKeyv",
			119 :"eventKeyw",
			120 :"eventKeyx",
			121 :"eventKeyy",
			122 :"eventKeyz",
			1073741825 :"eventKeyBack",
			1073741828 :"eventKeyEnter",
			1073741836 :"eventKeyScrollUp",
			1073741837 :"eventKeyScrollDown",
			1073741838 :"eventKeyUp",
			1073741839 :"eventKeyDown",
			1073741840 :"eventKeyLeft",
			1073741841 :"eventKeyRight",
			1073741853 :"eventKeyUp",
			1073741854 :"eventKeyScrollUp",
			1073741855 :"eventKeyLeft",
			1073741857 :"eventKeyRight",
			1073741859 :"eventKeyDown",
			1073741860 :"eventKeyScrollDown",
			1073741861 :"eventKeyEnter",
			1073741921 :"eventKeyMenu",
			1073741922 :"eventKeyTV",
			1073741923 :"eventKeyWeb",
			1073741924 :"eventKeyPortal",
			1073741925 :"eventKeyStop",
			1073741926 :"eventKeyPlay",
			1073741927 :"eventKeyRwd",
			1073741928 :"eventKeyFwd",
			1140850785 :"eventKeyHot1",
			1140850786 :"eventKeyHot2",
			1140850787 :"eventKeyHot3",
			1140850788 :"eventKeyHot4",
			1140850789 :"eventKeyMute",
			1140850790 :"eventKeyPause",
			1140850791 :"eventKeyVolUp",
			1140850792 :"eventKeyVolDown"
		};
	} else {
		this._KEY_MAP = {
			32 :"eventKeySpace",
			46 :"eventKeyDot",
			48 :"eventKey0",
			49 :"eventKey1",
			50 :"eventKey2",
			51 :"eventKey3",
			52 :"eventKey4",
			53 :"eventKey5",
			54 :"eventKey6",
			55 :"eventKey7",
			56 :"eventKey8",
			57 :"eventKey9",
			97 :"eventKeya",
			98 :"eventKeyb",
			99 :"eventKeyc",
			100 :"eventKeyd",
			101 :"eventKeye",
			102 :"eventKeyf",
			103 :"eventKeyg",
			104 :"eventKeyh",
			105 :"eventKeyi",
			106 :"eventKeyj",
			107 :"eventKeyk",
			108 :"eventKeyl",
			109 :"eventKeym",
			110 :"eventKeyn",
			111 :"eventKeyo",
			112 :"eventKeyp",
			113 :"eventKeyq",
			114 :"eventKeyr",
			115 :"eventKeys",
			116 :"eventKeyt",
			117 :"eventKeyu",
			118 :"eventKeyv",
			119 :"eventKeyw",
			120 :"eventKeyx",
			121 :"eventKeyy",
			122 :"eventKeyz",
			0x40000004 :"eventKeyEnter",
			0x4000000E :"eventKeyUp",
			0x4000000F :"eventKeyDown",
			0x40000010 :"eventKeyLeft",
			0x40000011 :"eventKeyRight",
			0x4000000C :"eventKeyScrollUp",
			0x4000000D :"eventKeyScrollDown",
			0x40000101 :"eventKeyPause",
			0x40000102 :"eventKeyStop",
			0x40000100 :"eventKeyPlay",
			0x40000105 :"eventKeyRwd",
			0x40000104 :"eventKeyFwd",
			0x40000097 :"eventKeyVolUp",
			0x40000098 :"eventKeyVolDown",
			0x40000099 :"eventKeyMute",
			0x40000088 :"eventKeyMenu",
			0x40000084 :"eventKeyHot1",
			0x40000085 :"eventKeyHot2",
			0x40000086 :"eventKeyHot3",
			0x40000087 :"eventKeyHot4",
			0x40000001 :"eventKeyBack",
			0x400000A4 :"eventKeyPower",
			0x4000009E :"eventKeyInternet",
			0x400000A5 :"eventKeyVideo",
			1073741827 :"eventKeyDel",
			0x40000089 :"eventKeyInfo",
			0x4000000A :"eventKeyEye",
			0x40000081 :"eventKeyEsc",
			0x40000083 :"eventKeyGuide",
			0x40000096 :"eventKeyOptions",
			1073741983 :"eventKeyText"
		};
	}
	window.frames["layout"].document.onkeypress = this.handleKey;
	window.frames["layout"].document.onfocus = this.handleNullEvent;
};
OvaKeyMap.prototype.mapKey = function(keyEvent) {
	return this._KEY_MAP[Math.round(keyEvent.which)];
};
OvaKeyMap.prototype.handleKey = function(keyEvent) {
	var fw = getFramework();
	var keymap = fw.getKeyMap();
	// if(keymap._ignoreAll) { return true; }
	var ovaEvent = keymap.mapKey(keyEvent);
	if (ovaEvent) {
		keymap._currentOvaEvent = ovaEvent;
		/*
		 * if (keymap._ignoreCursorKeys&& (
		 * ovaEvent=='eventKeyUp'||ovaEvent=='eventKeyLeft'||
		 * ovaEvent=='eventKeyDown'||ovaEvent=='eventKeyRight')) { return true; }
		 */

		var consumed = fw.getEventManager().handleKeyEvent(ovaEvent);
		if (consumed) {
			return false;
		}
	}
	var debugKey = String.fromCharCode(keyEvent.which);
	if (debugKey) {
		var consumed = fw.getDebug().handleDebugKey(debugKey);
		if (consumed) {
			return false;
		}
	}
	if (keyEvent.which == 2147483696) {
		return true;
	}
	if ((ovaEvent == "eventKeyEnter") || (keyEvent.which == 1073741827)
			|| (keyEvent.which <= 65535)) {
		return true;
	}
	return false;
};
OvaKeyMap.prototype.getCurrentOvaEvent = function() {
	return this._currentOvaEvent;
};
OvaKeyMap.prototype.setIgnoreCursorKeys = function(blnIgnore) {
	this._ignoreCursorKeys = blnIgnore;
};
OvaKeyMap.prototype.handleNullEvent = function() {
	return false;
};
OvaKeyMap.prototype.setIgnoreAllKeys = function(blnIgnore) {
	this._ignoreAll = blnIgnore;
};
