 function OvaLayoutManager(){} 

OvaLayoutManager.prototype.create=function(){
 this._find_caches=new Array(); 
 this._curLayoutId=""; 
/* In Index.html sono definiti diversi <iframe name=...> tra cui vi è layout, imposto uiframe con iframe = "layout" che
   corrisponde a /ovaUI/pirelli_dtt/layoutMod.html */
 this._uiFrame = top.frames["layout"];
 this._have_popups=false;
 this._curLayoutId=null;
 this._lastLayoutId=null; 
/* URL locale */
 this.hostname=document.URL;
 this.lastFocusLayout=""; 
 this.lastFocusElement="";
/* ritorna l'indice del carattere di ricerca, nel nostro caso "?" */
 var i = this.hostname.indexOf("?");
 if(i > 0){
	/* preleva l'hostname eliminando ulteriori valori successivi nell'URL completa come CGI */
 	this.hostname=this.hostname.substring( 0,i ); 
 }
 };

 OvaLayoutManager.prototype.buildPopups=function(){ 
 /* Inizialmente ci dovrebbe essere _uiframe="layout" che corrisponde /ovaUI/pirelli_dtt/layoutMod.html, vedere il
    create, osservando layoutMod.html c'è un campo definito layoutInfo*/
 for(i in this._uiFrame.layoutInfo) { 
	var info=this._uiFrame.layoutInfo[i]; 
	/* cerca quelli con type = "popup" */
	if(info.type == "popup") {
		/* se lo trova lo apre */
 		info._curPopup=open(info.src, i, info.location ); 
		this._uiFrame.toFront();
		/* Per ogni layout in layoutInfo di layoutMod, imposta l'handleKey. Se commento non funziona
		   il tasto KeyEye della pagina iniziale */
 		info._curPopup.document.onkeypress=this.fw.getKeyMap().handleKey;
 		info._visible=false;
 	}
 } this._have_popups=true;
 };

OvaLayoutManager.prototype.setLayout=function( layoutId ) { 
 /* Per esempio nel caso di chiamata da StartupApp.js il layoutId = loadingLayout ed essendo la prima volta 
    non entrerà in questo if case */
 if(!layoutId||this._curLayoutId==layoutId){ 
	this.CURRENT_ELEMENT=null;
 	this.fw.getKeyMap().setIgnoreCursorKeys(false); 
	return; 
 }
 if(this._curPopup){ 
	this._curPopup.toBack();
 	this._curPopup=null; 
 } 
 /* Essendo la prima volta dovrebbe entrare, DA VERIFICARE */
 if(!this._have_popups){ 
	this.buildPopups(); 
 }
 /* Non essendo definito un keyEvent dovrebbe tornare false */
 /* setta _currentOvaEvent (keymap) = ovaEvent; */
 this._uiFrame.document.onkeypress=this.fw.getKeyMap().handleKey;
 /* verifico se mi sposto sugli elementi della pagina, ritorna comunque false */
 this._uiFrame.document.onfocus=this.onFrameFocus;
 /* cerca in _uiframe.layoutInfo -> quindi in layoutMod.html nel campo layoutInfo, cerco "loadingLayout" 
    che esiste */
 /* oppure ritorna info relativo a homeTVLayout */
 var info=this._uiFrame.layoutInfo[layoutId];
 
 /* mi salvo il type, se esiste il campo */
 var type=info.type;
 /* In fase di inizializzazione il layoutId dovrebbe essere "layout" --> layoutMod.html e quindi è anche
    il _curLayoutId che diventerà il _lastLayoutId */
 this._lastLayoutId=this._curLayoutId;
 this._curLayoutId=layoutId; 
 /* type dovrebbe essere null nel caso homeTvApp */
 if(type==null || type == "fullscreen"){ 
	if(info.y!=null){
		/* Guardando layoutMod.html, la prima volta non dovrebbe (y=0) entrare qui */
 		/* se commento questo non parte il portale, per entrare in questo caso
		   bisogna osservare dentro layoutMod.html, per il caso specifico (per esempio per 
		   homeTVLayout ) */
		this._uiFrame.scroll( 0, info.y );
 		this._last_location=info.src; 
		this._last_visible=true;
 		this._uiFrame.focus(); 
 	}
	/* ritorna il i-frame "loadingLayout" definito, nel caso corrente, in layoutMod.html 
	   quindi la getLayout() prende da _uiframe corrente il frame specificato, in questo caso "loadingLayout" */
 	var layoutFrame=this.getLayout(layoutId);
	/* imposta due parametri */
 	layoutFrame.document.onkeypress=this.fw.getKeyMap().handleKey;
	/* Inizialmente, la prima volta, ritorna true e lo imposta al frame loadingLayout */
 	layoutFrame.document.onfocus=this.onLayoutFocus;
 	/* La prima volta, in questo layoutId si intende "loadingLayout" */
	this.CURRENT_LAYOUT_ID=layoutId;
 	this.CURRENT_ELEMENT_POSITION=0;
	/* Il layoutFrame è "loadingLayout" e non ha forms */
 	this.mapElementEvents(layoutFrame); 
 } else if (type == "popup"){ 
	this.CURRENT_ELEMENT=null; 
	this._curPopup=info._curPopup; this._curPopup.toFront();
 	this._curPopup.document.onkeypress=this.fw.getKeyMap().handleKey; 
 } 
};

/* val può essere true o false */
 OvaLayoutManager.prototype.setLayoutVisible=function(layoutId, val) { 
/* inizialmente carica layoutId = diretteCalcioAcquistiLayoutZ3  */
 var info=this._uiFrame.layoutInfo[layoutId];
/* ed è anche type = "popup" */
 if(info!=null && info.type == "popup"){
 	if(info._visible!=val){ 
		if(val){/* nel file redrawRequired è settato false */
 			if(eval(info.redrawRequired)){
 				this._curPopup=info._curPopup;
 			} 
			/* porta in avanti il popup */
			info._curPopup.toFront();
// 			omc.logger.addEntry("OvaLayoutManager.prototype.setLayoutVisible: "+layoutId);
			info._curPopup.document.onkeypress=this.fw.getKeyMap().handleKey;
 		} else {
			/* porta in indietro il popup */
 			info._curPopup.toBack();
 		}
 		info._visible=val;
 	} 
 } 
}; 

 OvaLayoutManager.prototype.scrollElement=function(layoutId, elementId, scroll_amount) { 
var layout_cache=this.getElements( layoutId ); 
var element=null;
 if( layout_cache!=null ) {
 element=layout_cache[ elementId ]; 
} if(element!=null) {
 { 
element.scroll=scroll_amount;
 var el=this.getElement(layoutId, elementId); 
el.scroll(0,scroll_amount);
 }
 }
 }
 OvaLayoutManager.prototype.setElementVisible=function(layoutId, elementId, val){
 var layout_cache=this.getElements( layoutId ); 
var element=null;
 if( layout_cache!=null ){
 element=layout_cache[ elementId ];
 } if(element!=null){
 if(element.hidden!=!val){
 var old_data=element.block;
 element.hidden=!val;
 if(!old_data||!val){
 this.getLayout( layoutId ).window.replaceFrameContents( "literal:<BODY></BODY>", element.name ); 
}else {
 this.writeBlock( layoutId, elementId, null, "cache" ); 
}
 }
 } 
}; 
 OvaLayoutManager.prototype.lastLayout=function() { 
this.setLayout(this._lastLayoutId);
 if(this._curPopup) { 
this._curPopup.close();
 this._curPopup=null;
 }
 };

/* chiamata da OvaSimpleFormUI con this._layoutId, "message", '', 'html' */
 OvaLayoutManager.prototype.writeBlock=function(layoutId, elementId, block, type, params){ 
 var elements=this.getElements( layoutId );
 if( elements!=null ){
 	element=elements[ elementId ];
 } 
 if(element==null){
 	elements[ elementId ]={ s: '', hidden: true, name: elementId, ovaType: "ova:frame", innerstyle: null, cssinclude: null, scroll: 0 }; 
	element=elements[ elementId ]; 
 } 
 if( element!=null ){
 	var write_data=!element.hidden&&(!element.block ||element.block!=block); 
	if(type == "cache"){ 
		block=element.block;
 		type=element.type;
 		params=element.params;
 		write_data=block!=null;
 	}
 element.block =block; 
 element.type=type;
 element.params=params;
 if(write_data){
 	var new_data; 
	var start_css=""; 
	var end_css=""; 
	var CSS_include=element.cssinclude; 
	if(CSS_include==""){
 	} 
	if(CSS_include!=null){
 		CSS_include = '<link rel="stylesheet" type="text/css" href="'.concat(CSS_include, '">'); 
	} else {
 		CSS_include = '<link rel="stylesheet" type="text/css" href="/ovaUI/amino/OvaAmino.css">'; 
	} if(element.innerstyle!=null&&element.innerstyle!=""){
 		start_css = '<span><TABLE border="0" cellpadding="0" cellspacing="0" class="'.concat( element.innerstyle, '"><TR><TD>');
 		end_css='</TD></TR></TABLE><span>';
 	} if(!type || (type == "html" || type == "text")){ 
		new_data = "literal:<base href='".concat( this.hostname , "'>" , CSS_include , start_css , block , end_css);
 	}else if (type == "image"){ 
		new_data = "literal:<HTML><BODY><base href='".concat( this.hostname, "'>", start_css, "<IMG src='", block, "'" ); 
		if(params && params.width)
			new_data = new_data.concat( " width='", params.width, "'" ); 
		if(params && params.height)
			new_data = new_data.concat( " height='", params.height, "'" ); 
			new_data = new_data.concat( ">", end_css, "</BODY></HTML>"); 
	}  if( this.getLayout( layoutId )){ 
		if( this.getLayout( layoutId ).window ){
 			this.getLayout( layoutId ).window.replaceFrameContents( new_data, element.name );
 		} 
	} 
 }
 }
 };

 OvaLayoutManager.prototype.getLayout=function( layoutId ) { 
 var frame=null;
 /* si preleva iframe da layoutMod.html, in fase di inizializzazione (OvaLayoutManager.create) si era salvato in 
    _uiframe proprio "layout" (layoutMod.html). Ora preleva loadingLayout.html e lo mette in frame */
 frame=this._uiFrame.frames[ layoutId ];
 if(frame==null) { 
	/* se non c'è la definizione <iframe ... > prova a cercarlo in layoutInfo */
	frame=this._uiFrame.layoutInfo[ layoutId ];
 	if(frame!=null) { 
 		frame=frame._curPopup; 
  	} 
 } return frame;
 } 

OvaLayoutManager.prototype.buildLayoutCache=function(layoutId, prefix_layoutId, prefix_elementId, xframes ) {
 var i;
 for(i=0;i < xframes.length;i++) {
	if(xframes[i]!=null) {
		/* ciclo su tutti gli elementi presenti nella pagina, inoltre in homeTvLayout è presente 
		   homeTvFrameLayout.html, inoltre dentro homeTvFrameLayout.html è presente un altro frame 
		   chiamato provaSEGP.html. Il ciclo entra in modo ricorsivo in ogni frame */
		var elementId=xframes[i].name;
// 		top.getFetcher().sendDebugTrap("Ci sono: "+xframes[i].name);
		this.buildLayoutCache_insert( layoutId, elementId, prefix_layoutId, prefix_elementId, "\"" + elementId + "\"", xframes[i] );
		this.buildLayoutCache( layoutId, layoutId, elementId, xframes[i].frames ); 
	}
 }
};

OvaLayoutManager.prototype.buildLayoutCache_insert=function(layoutId, elementId, prefix_layoutId, prefix_elementId, index, frame ) {
var str = "a = function(t){ return t.getElement( \"" + prefix_layoutId +"\",\"" + prefix_elementId + "\").frames[" + index + "];};a";
var hasOuterName=frame.outername!=null&&frame.outername!=frame.name;
var element={ s: str, hidden: hasOuterName, name: frame.name, ovaType: "ova:" + frame.ovaType, innerstyle: frame.innerstyle, cssinclude: frame.cssinclude, scroll: 0};
this._find_caches[ layoutId ][ elementId ]=element;
if(hasOuterName) {
	this._find_caches[ layoutId ][ frame.outername ]=element; 
}
}; 

/* layoutId = "HomeTvLayout" */
OvaLayoutManager.prototype.getElements=function( layoutId ) {
 if(layoutId==null) {
 	layoutId=this._curLayoutId;
 }
 /* Nel caso layout_cache fosse vuoto, carica la pagina ed il relativo frame
    infatti in homeTvLayout c'è frame con un name layout. Tramite i valori che trova 
    carica layout_cache */
 var layout_cache=this._find_caches[ layoutId ];
 if( layout_cache==null ) {
 	var layout= this.getLayout( layoutId ); 
	this._find_caches[ layoutId ]=new Array();
 	if(layout) { 
		/* layout.frames --> si intendono i frame all'interno di homeTvLayout.html */
		this.buildLayoutCache( layoutId, "", layoutId, layout.frames ); 
	} 
	layout_cache=this._find_caches[ layoutId ];
 } return layout_cache;
 };  

OvaLayoutManager.prototype.getElement=function(layoutId, elementId) {
 var element=null; 
var layout_cache=this.getElements( layoutId );
 if(layoutId=="") {
 	 return this.getLayout( elementId );
 	  } 
 if( layout_cache!=null ) { 
 	element=layout_cache[ elementId ]; 
 	if(element!=null) { 
 		if(element.f==null&&element.s!=null) { 
 			element.f=eval( element.s );
 			 element.s=null; 
 		} if(element.f!=null) { 
 			 	return element.f(this);
 		} } } return null; };

 OvaLayoutManager.prototype.getCurrentLayout=function() { 
 			 	 	var currLayout=null;
 			 	 	 if(this._curLayoutId!=null)
 			 	 	  currLayout=this.getLayout(this._curLayoutId);
 			 	 	   return currLayout; 
 			 	 	   };

OvaLayoutManager.prototype.refocusOn=function(layoutId, elementId) { 
 			 	 	    	this.focusOn( this.lastFocusLayout, this.lastFocusElement );
 			 	 	    	 }

 OvaLayoutManager.prototype.focusOn=function(layoutId, elementId) {
 this.lastFocusLayout=layoutId;
 this.lastFocusElement=elementId;
 if(layoutId==null||elementId==null){
 	var layout=this.getCurrentLayout();
	if(layout!=null){
		layout.focus();
	}
 } else {
	if( this.CURRENT_ELEMENT ){
		var nextElement=this._getNextElement( layoutId, this.CURRENT_ELEMENT );
		var moveElement=this.CURRENT_FORM.elements[nextElement];
		moveElement.focus();
		this.CURRENT_ELEMENT=nextElement; 
	}else {
		var layout=this.getLayout( layoutId );
		this.focusOn_helper( layout, elementId ); 
	}
 }
};
 
OvaLayoutManager.prototype.focusOnElement=function( layout, elementId ) { var fw=getFramework(); var layoutMgr=fw.getLayoutManager(); var elementFocusedPos=0; var foundPos=false; var foundName=false; var cursorToElement=null; if( layout ){ var currentElements=this.CURRENT_FORM.elements; for( var j=0;j < currentElements.length&&! foundPos;j++ ){ 
 			 	 		var currentElement=currentElements[j]; if( currentElement.name==elementId ){ currentElement.focus(); layoutMgr.CURRENT_ELEMENT=elementId; layoutMgr.setCurrentElementPosition(); foundPos=true; } } } return cursorToElement; };  OvaLayoutManager.prototype._getNextElement=function( layout, elementId ) { var fw=getFramework(); var layoutMgr=fw.getLayoutManager(); var elementFocusedPos=0; var foundPos=false; var foundName=false; var cursorToElement=null; if( layout ){ var currentElements=this.CURRENT_FORM.elements; for( var j=0;j < currentElements.length&&! foundPos;j++ ){ var currentElement=currentElements[j]; if( currentElement.name==elementId ){ elementFocusedPos=j+1; if( elementFocusedPos>=currentElements.length ){ elementFocusedPos=0; } foundPos=true; } } if( foundPos ){ for( var k=0;k < currentElements.length&&! foundName;k++ ){ if( elementFocusedPos==k ){ cursorToElement=currentElements[k].name; foundName=true; } } } } return cursorToElement; }; OvaLayoutManager.prototype.focusOn_helper=function(layout, elementId){ if(layout){ var xforms=layout.document.forms; var i; for(i=0;i < xforms.length;i++){ var el=xforms[i]; if(el&&el.elements.length > 0){
 elts=el.elements;
 for(var j=0;j < elts.length;j++){ 
if(elts[j].name==elementId ){ 
elts[j].focus();
 return true; 
} 
} 
}
 }
 var xframes=layout.frames;
 for(i=0;i < xframes.length;i++){
 var q=this.focusOn_helper( xframes[i], elementId );
 if(q){ return true; }
 }
 } return false; }
; 
OvaLayoutManager.prototype.getCurrentLayoutId=function(){
 return this._curLayoutId; 
};

OvaLayoutManager.prototype.getInputElementsByTagName=function(srcForm) {
var result=new Array(); 
for(var count=0;count < srcForm.elements.length;count++) { 
	id=srcForm.elements[count].name; 
	result[result.length]=srcForm.elements[count];
} return result; 
}; 

OvaLayoutManager.prototype.mapElementEvents=function(layout) {
 var fw=getFramework(); 
 var layoutMgr=fw.getLayoutManager();
 fw.getKeyMap().setIgnoreCursorKeys(false);
 if(layout){ 
	/* La prima volta, quindi con layout = "loadingLayout.html", non ha forms e così non entra */
	var xforms=layout.document.forms; 
	if( xforms ){ 
		for(var i=0;i < xforms.length;i++){
 			var currentForm=xforms[i]; 
			if( currentForm ){ 
				this.fw.getKeyMap().setIgnoreCursorKeys(true);
 				layoutMgr.CURRENT_FORM=currentForm;
 				var currentElements=currentForm.elements;
 				if( currentElements.length > 0){
 					for( var j=0;j < currentElements.length;j++ ){ 
						var currentElement=currentElements[j]; 
					} 
				} 
			}
 		}
 	}
 }
 };
 
OvaLayoutManager.prototype.setLastElementFocused=function( strElementId ) {
 var fw=getFramework();
 var layoutMgr=fw.getLayoutManager(); 
 layoutMgr.LAST_ELEMENT_FOCUSED=strElementId; 
}; 

OvaLayoutManager.prototype.onFrameFocus=function() {
 var fw=getFramework(); 
 var layoutMgr=fw.getLayoutManager();
 /*Con getCurrentOvaEvent() ritorna ovaEvent da OvaKeyMap.js. Questa è definita:
   var ovaEvent = keymap.mapKey(keyEvent); */ 
 var keyPressed=fw.getKeyMap().getCurrentOvaEvent(); 
 /* Inizialmente questa non dovrebbe fare niente, infatti commentandola non cambia */
 layoutMgr.setCurrentElementPosition();
 layoutMgr.HAS_MOVED=false; 
 var elementToMoveTo=null; 
 /* Anche in questo caso non dovrebbe entrare, visto che LAST_ELEMENT_FOCUSED non è ancora definita */
 if( layoutMgr.LAST_ELEMENT_FOCUSED ){ 
 	if(keyPressed=='eventKeyLeft'){
 		elementToMoveTo = layoutMgr._focusOnElement("previous");
 	} 
	if(keyPressed=='eventKeyRight'){ 
		elementToMoveTo = layoutMgr._focusOnElement("next"); 
	}
	if(keyPressed=='eventKeyUp'){ 
		elementToMoveTo = layoutMgr._focusOnElement("last");
	} 
	if(keyPressed=='eventKeyDown'){ 
		elementToMoveTo = layoutMgr._focusOnElement("next"); 
	} 
	if( elementToMoveTo !=null ){ 
		var moveElement=layoutMgr.CURRENT_FORM.elements[elementToMoveTo]; 
		if(moveElement.type=='image'){ 
			fw.getKeyMap().setIgnoreCursorKeys(false);
			layoutMgr.CURRENT_ELEMENT=elementToMoveTo; 
		} else {
			fw.getKeyMap().setIgnoreCursorKeys( false ); 
		}
		moveElement.focus(); 
		layoutMgr.HAS_MOVED=true; 
		layoutMgr.LAST_ELEMENT_FOCUSED=""; 
		}
} 
return false;
};

OvaLayoutManager.prototype.onLayoutFocus=function() {
var fw=getFramework();
var layoutMgr=fw.getLayoutManager();
 /*Con getCurrentOvaEvent() ritorna ovaEvent da OvaKeyMap.js. Questa è definita:
   var ovaEvent = keymap.mapKey(keyEvent); */  
var keyPressed=fw.getKeyMap().getCurrentOvaEvent();
var elementToMoveTo=null;
/* Inizialmente questa non dovrebbe fare niente, infatti commentandola non cambia */
layoutMgr.setCurrentElementPosition();
/* Inizialmente ritorna true, convieen vedere la funzione */
if( layoutMgr.isValidForm()){ 
	/* Inizialmente non dovrebbe entrare */
	if( layoutMgr.LAST_ELEMENT_FOCUSED ){ 
		if( ! layoutMgr.HAS_MOVED ){
			if(keyPressed=='eventKeyDown'||keyPressed=='eventKeyRight'){
				elementToMoveTo = layoutMgr._focusOnElement("next");
			}
			if(keyPressed=='eventKeyUp'||keyPressed=='eventKeyLeft'){
				elementToMoveTo = layoutMgr._focusOnElement("previous"); 
			}
		} else {
			elementToMoveTo=layoutMgr._getCurrentElement();
		}
		layoutMgr.LAST_ELEMENT_FOCUSED="";
		layoutMgr.HAS_MOVED=false;
		if( elementToMoveTo !=null ){
			var moveElement=layoutMgr.CURRENT_FORM.elements[elementToMoveTo];
			if(moveElement.type=='image'){
				fw.getKeyMap().setIgnoreCursorKeys( false ); 
			} else { 
				fw.getKeyMap().setIgnoreCursorKeys( true ); 
			} layoutMgr.CURRENT_ELEMENT=elementToMoveTo;
			layoutMgr.setCurrentElementPosition();
			moveElement.focus();
		}
	} else {
		fw.getKeyMap().setIgnoreCursorKeys( false );
	}
} else {
	fw.getKeyMap().setIgnoreCursorKeys( false );
}
return true;
};

OvaLayoutManager.prototype._focusOnElement=function( direction ) {
var elementFocusedPos=0; 
this.CURRENT_ELEMENT_POSITION=0; 
var fw=getFramework(); 
var layoutMgr=fw.getLayoutManager(); 
var foundPos=false; 
var foundName=false; 
var cursorToElement=null; 
if( layoutMgr.CURRENT_FORM ){ 
	var currentElements=layoutMgr.CURRENT_FORM.elements;
	if( currentElements.length > 0){
		for( var i=0;i < currentElements.length&&! foundPos;i++ ){ 
			var currentElement=currentElements[i];
			if( currentElement.name==layoutMgr.LAST_ELEMENT_FOCUSED ){
				if( direction == "next" ){
					elementFocusedPos=i+1;
					if( elementFocusedPos > currentElements.length ){
						elementFocusedPos=0; 
					}
				} else if ( direction == "previous" ){
					elementFocusedPos=i-1;
					if( elementFocusedPos < 0 ){
						elementFocusedPos=currentElements.length-1;
					}
				} else if ( direction == "first" ){
					elementFocusedPos=0;
				} else if ( direction == "last" ){ 
					elementFocusedPos=currentElements.length-1;
				} else {
					elementFocusedPos=0;
				}
				foundPos=true;
			}
		}
		if( foundPos ){
			for( var j=0;j < currentElements.length&&! foundName;j++ ){
				if( elementFocusedPos==j ){
					cursorToElement=currentElements[j].name;
					foundName=true;
				} 
			}
		}
	}
}
return cursorToElement;
};

OvaLayoutManager.prototype._getCurrentElement=function( ) { var elementFocusedPos=0; this.CURRENT_ELEMENT_POSITION=0; var fw=getFramework(); var layoutMgr=fw.getLayoutManager(); var foundPos=false; var foundName=false; var cursorToElement=null; if( layoutMgr.CURRENT_FORM ){ var currentElements=layoutMgr.CURRENT_FORM.elements; if( currentElements.length > 0){ for( var i=0;i < currentElements.length&&! foundPos;i++ ){ var currentElement=currentElements[i]; if( currentElement.name==layoutMgr.LAST_ELEMENT_FOCUSED ){ cursorToElement=currentElements[i].name; foundPos=true; } } } } return cursorToElement; }; OvaLayoutManager.prototype.clearLayout=function() { this.lastFocusElement=null; var fw=getFramework(); fw.getKeyMap().setIgnoreCursorKeys( false ); }; OvaLayoutManager.prototype.hasMovedToElement=function( blnHasMoved ) { this.blnMOVED_TO_ELEMENT=blnHasMoved; var fw=getFramework(); fw.getKeyMap().setIgnoreCursorKeys( false ); };

OvaLayoutManager.prototype.getCurrentElementPosition=function() {
 return this.CURRENT_ELEMENT_POSITION;
};

OvaLayoutManager.prototype.setCurrentElementPosition=function() {
var fw=getFramework();
/* Questa variabile mi dice se ho trovato la posizione */
var foundPos=false; 
var layoutMgr=fw.getLayoutManager();
/* La prima volta non dovrebbe passare, questo perchè nessuna fino ad ora ha settato CURRENT_FORM */
if( layoutMgr.CURRENT_FORM ){
	var currentElements=layoutMgr.CURRENT_FORM.elements;
	if( currentElements.length > 0){
		for( var i=0;i < currentElements.length&&! foundPos;i++ ){
			var currentElement=currentElements[i];
			if( currentElement.name==layoutMgr.CURRENT_ELEMENT){
				this.CURRENT_ELEMENT_POSITION=i;
				foundPos=true; 
			}
		}
	}
}
};

OvaLayoutManager.prototype.isValidForm=function() {
var fw=getFramework();
var validForm=true;
var layoutMgr=fw.getLayoutManager();
if( layoutMgr.CURRENT_FORM ){
	var currentElements=layoutMgr.CURRENT_FORM.elements; 
	if( currentElements.length > 0){
		if( currentElements.length==1&&currentElements[0].type=='image' ){
			validForm=false;
		}
	}
}
return validForm;
};

OvaLayoutManager.prototype.clearCurrentElement=function() {
this.CURRENT_ELEMENT=null; 
};