 OvaStatusBarUI.prototype=new OvaBaseUI();

 // FG OvaStatusBarUI.prototype._SPACE_IMAGES={ tvspace: '/ovaImages/SectionTvSpace.gif', videospace: '/ovaImages/SectionVideoSpace.gif', openspace: '/ovaImages/SectionOpenSpace.gif', yourspace: '/ovaImages/SectionYourSpace.gif' };

 function OvaStatusBarUI(){ this._lastTime=-1;

 this._userColor=null;

 } OvaStatusBarUI.prototype.create=function(layoutId){ this._create(layoutId);

 this._lastTime=-1;

 this._userColor=null;

 this._visible=true;

 this._refreshTime=this.fw.getConfig().UI_CLOCK_REFRESH_INTERVAL;

 };

 OvaStatusBarUI.prototype.setStatus=function(status){ this._status=status;

 };

 OvaStatusBarUI.prototype.setUserColor=function(clr){ this._userColor=clr;

 };

 OvaStatusBarUI.prototype.setVisible=function(val){ this._visible=val;

 };

 OvaStatusBarUI.prototype.getVisible=function(){ return this._visible;

 };

 OvaStatusBarUI.prototype.redraw=function() {

 var user=this._status.getUser();

 var layoutManager=this.fw.getLayoutManager();

 layoutManager.setLayoutVisible("statusBarLayout", this._visible);

//layoutManager.setLayoutVisible("headerLayout", this._visible);

//layoutManager.setLayoutVisible("footerLayout", this._visible);

 

if(this._visible)

{ 

 // FG var space=this._status.getSpace();

 // FG var spaceImg=this._SPACE_IMAGES[space];

 // FG  layoutManager.writeBlock("statusBarLayout", "space", spaceImg, "image", { width: 76, height: 99 });

 	if(!this._clockRefresh)

 	{

 		this._drawTime();

 	}

 

  // FG  var user=this._status.getUser();



  // FG if(user && user.length > 8)user = user.substring(0, 6) + "..";

 

  // FG layoutManager.writeBlock("statusBarLayout", "user", '<div class="userInfo">' + user + '</div>', "text");

 

 	var clr=this.fw.getUserInfo().getDisplayColour();

 } 

 else 

 { 

 	if(this._clockRefresh)

 	{ 

 		this.fw.getTimer().clearTimeout(this._clockRefresh);

 		this._clockRefresh=null;

 	} 

 } 

 };

 

 OvaStatusBarUI.prototype._drawTime=function() {

 var time=this._status.getTime();	 

 var layoutManager=this.fw.getLayoutManager();

 layoutManager.writeBlock("statusBarLayout", "time", time, "text");

  this._lastTime=time;

 if(this._refreshTime!=0){ this._clockRefresh=this.fw.getTimer().setTimeout(this._refreshTime*1000, this._drawTime, this);

 } };



OvaStatusBarUI.prototype.setText=function(nomeTag,val) {

 

  var layoutManager=this.fw.getLayoutManager();

 

 layoutManager.writeBlock("statusBarLayout", nomeTag,  val, "html");

 

  };

 OvaStatusBarUI.prototype.setImg=function(nomeTag,img) {

 

  var layoutManager=this.fw.getLayoutManager();

  variabile='<IMG SRC="/ovaImages/'+img+'" width="16" height="16" border="0">'; 

 layoutManager.writeBlock("statusBarLayout", nomeTag,  variabile, "html");

 

  };

  

 /*

  * Metodo utilizzato per settare la label verde per l'HELP.

  **/ 

 OvaStatusBarUI.prototype.setGreenKey=function(val) {

 

 	this.setText("labelGreen",val); 

  };

 /*

  * Metodo utilizzato per settare la label rossa.

  **/ 

 OvaStatusBarUI.prototype.setRedKey=function(val) {

 

 	this.setText("labelRed",val); 

  };

 /*

  * Metodo utilizzato per settare la label gialla per il SETUP.

  **/ 

 OvaStatusBarUI.prototype.setYellowKey=function(val) {

 

 	this.setText("labelYellow",val); 

  };

 /*

  * Metodo utilizzato per settare la label blu.

  **/ 

 OvaStatusBarUI.prototype.setBluKey=function(val) {

 

 	this.setText("labelBlu",val); 

  };



 /*

  * Metodo utilizzato per settare l'immagine verde.

  * param flag - Se true attiva l'immagine altrimenti disattiva

  **/ 

 OvaStatusBarUI.prototype.setGreenButton=function(flag) {

 

 	if(flag)

 	   this.setImg("imgGreen",'button_color_green_active.gif');

 	else

 	   this.setImg("imgGreen",'button_color_green_inactive.gif');

 		 

  };

 /*

  * Metodo utilizzato per settare l'immagine rossa.

  * param flag - Se true attiva l'immagine altrimenti disattiva

  **/ 

 OvaStatusBarUI.prototype.setRedButton=function(flag) {

 

 	if(flag)

 	   this.setImg("imgRed",'button_color_red_active.gif');

 	else

 	   this.setImg("imgRed",'button_color_red_inactive.gif');

  };

 /*

  * Metodo utilizzato per settare l'immagine verde.

  * param flag - Se true attiva l'immagine altrimenti disattiva

  **/ 

 OvaStatusBarUI.prototype.setYellowButton=function(flag) {

 

 	if(flag)

 	   this.setImg("imgYellow",'button_color_yellow_active.gif');

 	else

 	   this.setImg("imgYellow",'button_color_yellow_inactiv.gif');

  };

 /*

  * Metodo utilizzato per settare l'immagine verde.

  * param flag - Se true attiva l'immagine altrimenti disattiva

  **/ 

 OvaStatusBarUI.prototype.setBluButton=function(flag) {

 

 	if(flag)

 	   this.setImg("imgBlu",'button_color_blue_active.gif');

 	else

 	   this.setImg("imgBlu",'button_color_blue_inactive.gif');

  };

