/*
*/

/*

*/
//DTTConfermaApp.prototype.DOMAIN = "OVA/SERVICE/PPVNVOD";
DTTConfermaApp.prototype=top.getFramework().createBaseApp();

function DTTConfermaApp(){
	this._form=null;
};
DTTConfermaApp.prototype.create=function(){
	try{
		this._objErrorInfo = new Object();
		this._objErrorInfo._applicationName = "DTTConfermaApp.js";
		this._objErrorInfo._methodName = "";
		this._objErrorInfo._obException = new Object();
		
	}catch(ecc){
		this._objErrorInfo._methodName = "create";
		this._objErrorInfo._obException = ecc;
		this.handleError();	
	}
	return true;	
};

DTTConfermaApp.prototype.destroy=function(){ return true; };

DTTConfermaApp.prototype.createForm=function(){
	try{
		this._form = this.fw.createForm("nascosto");
		this._form.addField({ name: 'hidd', type: this._form.TYPE_HIDDEN });
		this._form.setHandler(this);
		return this._form;
	}catch(ecc){
		this._objErrorInfo._methodName = "createForm";
		this._objErrorInfo._obException = ecc;
		this.handleError();
		return null;
	}
};

DTTConfermaApp.prototype.init=function(obj){
	try{
		this.fw.getLayoutManager().setLayoutVisible("caricamentoInCorso", false);	
		this.sendLoadAppTrap("DTTConfermaApp");
		this.name_layout = "dttConfermaLayout";
		this._ui = this.fw.createSimpleFormUI(this.name_layout);
		// Valorizzazione variabile pageLayout
    	this.pageLayout = this.fw.getLayoutManager().getLayout(this.name_layout);
		this._ui.setForm(this.createForm());
		
		if(obj != null && obj != undefined){
			this._obj = obj;
			this.pageCall = this._obj.pageCall;
	    	this.parameter = this._obj.parameter;
	    	var imgHeader = this._obj.imgSrc;
	  	 	var titolo = this._obj.titleTxt;
	  	 	var testo = "";
	  	 	if( this._obj.textPopUp ){
	  	 		testo = this._obj.textPopUp;
	  	 	}else{
	  	 		testo = '<br>Per rendere effettiva la configurazione riavviare<br>Alice home TV Box.';
	  	 	}
	    }else{
	    	this.fw.backFromExApp = true;
	    	this.loadApp( this.getHomeUrl(),null,null,null,null );
	    }
	 	this.referImageToLayout(this.name_layout,'padre',imgHeader); 
	 	this.referImageToLayout(this.name_layout,'riavvia','/ovaImages/layout/impostazioni/confermaOn.png');
	 	var prefix = "<span><font size=\"4\" color=\"#FFFFFF\">";
		var suffix = "</font></span>";
		this._ui.setLabelText("./titolo",prefix+titolo+suffix); 
		this._ui.setLabelText("./testo",prefix+testo+suffix);

		this._ui.redraw();
	}catch(ecc){
		this._objErrorInfo._methodName = "init";
		this._objErrorInfo._obException = ecc;
		this.handleError();
		return null;
	}
};

DTTConfermaApp.prototype.eventKeyEnter = function() {
	try{
///////////////////////////////CONTROLLO DEL TASTIERINO NUMERICO//////////////////
		if(this.BoxChangeChannel == true){
			 this.EnterNumericDigit();
//////////////////////////////////////////////////////////////////////////////////
 	  }else{
			switch(this.pageCall){
				case 1:
					//this.fw.getFetcher().fetchNow("/ovaServices/dtt/SetEnableDTTFetcher.jsp?usrRecid="+this.fw.getUserInfo().getAccountID()+"&flagDTT="+this.parameter, this, this.checkSetEnable);
				break;
				case 2:
					this.setFormatParameters(this.parameter, this._obj.funciont2call);
				break;
			}
			//Evento tasto riavvia
		
		  	navigator.Reboot();
		}
	}catch(ecc){
		this._objErrorInfo._methodName = 'eventKeyEnter';
		this._objErrorInfo._obException = ecc;
		this.handleError();
	}
	finally{ return true; }	
};

DTTConfermaApp.prototype.eventKeyRight=function(){
	try{

    return;
		
	}catch(ecc){
		this._objErrorInfo._methodName = 'eventKeyEnter';
		this._objErrorInfo._obException = ecc;
		this.handleError();
	}
		return true;	
};


DTTConfermaApp.prototype.eventKeyLeft=function(){
	try{
		return;
		
	}catch(ecc){
		this._objErrorInfo._methodName = 'eventKeyLeft';
		this._objErrorInfo._obException = ecc;
		this.handleError();
	}
		return true;	
};


DTTConfermaApp.prototype.eventKeyUp=function(){
	try{
		return;
		
	}catch(ecc){
		this._objErrorInfo._methodName = 'eventKeyUp';
		this._objErrorInfo._obException = ecc;
		this.handleError();
	}
		return true;	
};


DTTConfermaApp.prototype.eventKeyDown=function(){
	try{
		return;
	}catch(ecc){
		this._objErrorInfo._methodName = 'eventKeyDown';
		this._objErrorInfo._obException = ecc;
		this.handleError();
	}
		return true;	
};

DTTConfermaApp.prototype.fin=function(){
		return true;	
};

DTTConfermaApp.prototype.eventKeyBack= function(){
	return true;
};

DTTConfermaApp.prototype.eventKeyEsc= function(){
	return true;
};

DTTConfermaApp.prototype.eventKeyHot2=function(){
		return true;
};

DTTConfermaApp.prototype.eventKeyHot3=function(){ 
	  return true;
};

DTTConfermaApp.prototype.eventKeyHot1=function(){ 
	  return true;
};


DTTConfermaApp.prototype.eventKeyEye  = function(){	
	try{						   
		var diretteIndex = (this.fw.menuObj && this.fw.menuObj.menuDiretteIndex) ? this.fw.menuObj.menuDiretteIndex : 2;			   
		if (this.fw.menuArray && this.fw.menuArray[diretteIndex]){
			this.fw.menuArray[diretteIndex].lastChildIndexSelected=0;
		}
		this.goToHomePage();		 
	}catch(ecc){
		this._objErrorInfo._methodName="eventKeyEye";
		this._objErrorInfo._obException = ecc;
		this.handleError();
  }finally{
	  return true;
	}
}


DTTConfermaApp.prototype.checkSetEnable = function(obj) {  
	try
	{
		if(obj == null || (obj && obj.content[0].esito=='OK')){
				this.fw.UserEnableDTT = this.parameter; 
		}
		//Evento tasto riavvia
	
		  navigator.Reboot();
	}catch(ecc){
		this._objErrorInfo._methodName = 'checkSetEnable';
		this._objErrorInfo._obException = ecc;
		this.handleError();
	}
	return true;
};

DTTConfermaApp.prototype.setFormatParameters=function(videoFormat, function2call){
	try{
		switch( function2call ){
			case 0: navigator.Set_tv_format(videoFormat); return true;
			case 1: navigator.Set_tv_out(videoFormat); return true;
			default: return true;
		}
	}catch(e){
		this._objErrorInfo._methodName = "setFormatParameters";
		this._objErrorInfo._obException = e;
		this.handleError();
	}
};
DTTConfermaApp.prototype.eventKeyBack = function(){ this.eventKeyEsc(); }
DTTConfermaApp.prototype.eventKeyEsc= function(){ 
	try{
///////////////////////////////CONTROLLO DEL TASTIERINO NUMERICO//////////////////
		if(this.BoxChangeChannel == true){
			 this.DeleteNumericDigit();
//////////////////////////////////////////////////////////////////////////////////
		}else{
			this.fw.backFromExApp = true;
			this.loadApp(this.getHomeUrl(),null,null,null,null); 
		}
	}catch(e){
		this._objErrorInfo._methodName = "eventKeyEsc";
		this._objErrorInfo._obException = e;
		this.handleError();
	}
};