

EnableDTTSettingsApp.prototype = top.getFramework().createBaseApp();

function EnableDTTSettingsApp() {
}

EnableDTTSettingsApp.prototype.create = function() {  
	try
	{
		this._objErrorInfo = new Object();
		this._objErrorInfo._applicationName = 'EnableDTTSettingsApp';
		this._ui = this.fw.createSimpleFormUI("EnableDTTSettingsLayout");	
		this._ui.setForm(this.createForm());
		this.pageLayout = this.fw.getLayoutManager().getLayout("EnableDTTSettingsLayout");
				
		
	}catch(ecc){
		this._objErrorInfo._methodName = 'create';
		this._objErrorInfo._obException = ecc;
		this.handleError();
	}
	return true;
}; 

EnableDTTSettingsApp.prototype.createForm=function() {

	try{	
		
		
		this._form = this.fw.createForm("helpForm");
		this._form.addField({ name: 'hiddenField', type: this._form.TYPE_HIDDEN, value:'' });
		this._form.setHandler(this);
		
		return this._form;
	}catch(ecc)
	{
		this._objErrorInfo._methodName ='createForm';
		this._objErrorInfo._obException = ecc;
		this.handleError();
	}
};


/*
*la seguente funzione testa se l'utente � al primo accesso. Nel caso del primo accesso l'applicazione 
*mostra delle pagine per confermare la linea telefonica sulla quale si sta accedendo all'applicazione
*nel secondo caso invece viene invocato un fetcher che controlla se il MAC address fisico � uguale 
*al MAC address provisionato e se la linea su cui il STB � connesso � uguale alla linea su cui l'utente 
*� provisionato 
*/
EnableDTTSettingsApp.prototype.init = function() { 
	try{
		this.fw.getLayoutManager().setLayoutVisible("caricamentoInCorso", false);	
		this.sendLoadAppTrap("EnableDTTSettingsApp");
		
		//this.fw.getFetcher().fetchNow("/ovaServices/dtt/GetEnableDTTFetcher.html", this, this.checkGetEnable);
	
		if(this.fw.UserEnableDTT == 'Y')
		{
			this.flagDTT = 'Y';		
			this.yPos=6;
			this.aggiornaCheck(1);
		}
		else
		{
			this.flagDTT = 'N';
			this.yPos=5;
			this.aggiornaCheck(2);
		}
	
	this.referImageToLayout("EnableDTTSettingsLayout","./rolloverRossoAlice","/ovaImages/1pixelclear.gif");
		
		this.referImageToLayout("EnableDTTSettingsLayout","./btnconferma","/ovaImages/common/button/button_conferma.gif");
		this.referImageToLayout("EnableDTTSettingsLayout","./rolloverRicerca","/ovaImages/ricercabutton.gif");
		this.referImageToLayout("EnableDTTSettingsLayout","./rolloverAbilitazione","/ovaImages/abilitazionebutton_mid.gif");
		this.setInitHoriz();
		this.setHorizOnFocus(this.catList[0].catId);
		
		this._ui.redraw();
		
	}catch(ecc){
		this._objErrorInfo._methodName = 'init';
		this._objErrorInfo._obException = ecc;
		this.handleError();
	}
	return true;  
	
};

EnableDTTSettingsApp.prototype.checkSetEnable = function(obj) {  
	try
	{
		//this.getPlogger("content.esito:"+obj.content[0].esito);
		if(obj == null || (obj && obj.content[0].esito=='OK')){
				this.fw.UserEnableDTT = this.flagDTT; 
		}
		this.loadApp("/ovaServices/getapp/GetApp.jsp?urlapp=impostazioni&app1=ConfermaDTTApp");
	}catch(ecc){
		this._objErrorInfo._methodName = 'checkSetEnable';
		this._objErrorInfo._obException = ecc;
		this.handleError();
	}
	return true;
};

EnableDTTSettingsApp.prototype.checkGetEnable = function(obj) {  
	try
	{
		//this.getPlogger("content.flagDTTEnable:"+obj.content[0].flagDTTEnabled);
		if(obj.content[0].flagDTTEnabled == 'Y')
		{
			this.fw.UserEnableDTT = 'Y'; 
			this.flagDTT = 'Y';		
			this.yPos=6;
			this.aggiornaCheck(1);
		}
		else
		{
			this.fw.UserEnableDTT = 'N'; 
			this.flagDTT = 'N';
			this.yPos=5;
			this.aggiornaCheck(2);
		}
		
		//this.aggiornaCheck(0);
		this._ui.redraw();
	}catch(ecc){
		this._objErrorInfo._methodName = 'checkGetEnable';
		this._objErrorInfo._obException = ecc;
		this.handleError();
	}
	return true;
};

EnableDTTSettingsApp.prototype.aggiornaCheck = function(mode) {
	try
	{	
		if(mode==0){
			if (this.flagDTT=='Y'){
				this.referImageToLayout("EnableDTTSettingsLayout","./chk1","/ovaImages/checkbutton_chk.gif");
				this.referImageToLayout("EnableDTTSettingsLayout","./chk2","/ovaImages/checkbutton.gif");
			}else{
				this.referImageToLayout("EnableDTTSettingsLayout","./chk1","/ovaImages/checkbutton.gif");
				this.referImageToLayout("EnableDTTSettingsLayout","./chk2","/ovaImages/checkbutton_chk.gif");
			}
		}else	if(mode==1){
			if (this.flagDTT=='Y'){
				this.referImageToLayout("EnableDTTSettingsLayout","./chk1","/ovaImages/checkbutton_chkon.gif");
				this.referImageToLayout("EnableDTTSettingsLayout","./chk2","/ovaImages/checkbutton.gif");
			}else{
				this.referImageToLayout("EnableDTTSettingsLayout","./chk1","/ovaImages/checkbutton_on.gif");
				this.referImageToLayout("EnableDTTSettingsLayout","./chk2","/ovaImages/checkbutton_chk.gif");
			}
		}
		
	  else	if(mode==3){
			//Inserisco mod 3 per Memoria Last Pos
			
			if (this.flagDTT=='Y' && this.LastPos==6){
				  
				  this.referImageToLayout("EnableDTTSettingsLayout","./chk1","/ovaImages/checkbutton_chkon.gif");
					this.referImageToLayout("EnableDTTSettingsLayout","./chk2","/ovaImages/checkbutton.gif");
			}
		  else if (this.flagDTT=='Y' && this.LastPos==5){
				this.referImageToLayout("EnableDTTSettingsLayout","./chk1","/ovaImages/checkbutton_chk.gif");
				this.referImageToLayout("EnableDTTSettingsLayout","./chk2","/ovaImages/checkbutton_on.gif");
			}
			else if(this.flagDTT=='N' && this.LastPos==5){
				this.referImageToLayout("EnableDTTSettingsLayout","./chk1","/ovaImages/checkbutton.gif");
				this.referImageToLayout("EnableDTTSettingsLayout","./chk2","/ovaImages/checkbutton_chkon.gif");
			}
			else{
				this.referImageToLayout("EnableDTTSettingsLayout","./chk1","/ovaImages/checkbutton_on.gif");
				this.referImageToLayout("EnableDTTSettingsLayout","./chk2","/ovaImages/checkbutton_chk.gif");
			}
		
			
		}
		
		else{
			if (this.flagDTT=='Y'){
				this.referImageToLayout("EnableDTTSettingsLayout","./chk1","/ovaImages/checkbutton_chk.gif");
				this.referImageToLayout("EnableDTTSettingsLayout","./chk2","/ovaImages/checkbutton_on.gif");
			}else{
				this.referImageToLayout("EnableDTTSettingsLayout","./chk1","/ovaImages/checkbutton.gif");
				this.referImageToLayout("EnableDTTSettingsLayout","./chk2","/ovaImages/checkbutton_chkon.gif");
			}
		}
	}catch(ecc){
		this._objErrorInfo._methodName = 'aggiornaCheck';
		this._objErrorInfo._obException = ecc;
		this.handleError();
	}
	return true;
};

EnableDTTSettingsApp.prototype.fin = function() {
	try{
		//niente
	}catch(ecc){
		this._objErrorInfo._methodName = 'fin';
		this._objErrorInfo._obException = ecc;
		this.handleError();
	}
	return true;
	
};


EnableDTTSettingsApp.prototype.eventKeyEnter = function() {
	try{
	switch(this.yPos){
		case 0: // rosso alice
			this.goToHomePage();
			break;	
		case 1:
			this.menuoriz=this.catList[0].catId;					
			switch (this.menuoriz){
			case '1':
				//profilo cliente
				this.loadApp("/ovaServices/getapp/GetApp.jsp?urlapp=settings&app1=YourAccountListingApp");
				break;
			case '2':
				//change pin
				this.loadApp("/ovaServices/getapp/GetApp.jsp?urlapp=impostazioni&app1=ChangePinApp","acquisto",2);
				break;
			case '3':
				//parental control
				this.loadApp("/ovaServices/getapp/GetApp.jsp?urlapp=impostazioni&app1=ParentalControlSettingsApp");
				break;
			case '4':
				//controllo acquisti
				this.loadApp("/ovaServices/getapp/GetApp.jsp?urlapp=impostazioni&app1=ControlloAcquistiApp&app2=ControlloAcquistiAppElementUI");
				break;
			case '5':
				//note legali
				this.loadApp("/ovaServices/getapp/GetApp.jsp?urlapp=impostazioni&app1=NoteLegaliApp");
				break;
			case '6': // impostazioni stb
					this.loadApp("/ovaServices/getapp/GetApp.jsp?urlapp=impostazioni&app1=ImpostazioniSTBApp");
				break;
			case '7':
				this.loadApp("/ovaServices/getapp/GetApp.jsp?urlapp=impostazioni&app1=ChangePinApp","ricorda",7);	
				break;	
			case '8':
				this.loadApp("/ovaServices/getapp/GetApp.jsp?urlapp=impostazioni&app1=AreaTestApp");
				break;	
			case '9':
				//this.loadApp("/ovaServices/getapp/GetApp.jsp?urlapp=DTT&app1=EnableDTTSettingsApp");	
				break;	
			}				
			break;
		case 2:
			//Evento tasto conferma
			this.fw.getFetcher().fetchNow("/ovaServices/dtt/SetEnableDTTFetcher.jsp?usrRecid="+this.fw.getUserInfo().getAccountID()+"&flagDTT="+this.flagDTT, this, this.checkSetEnable);
			break;
		case 5:
			//Check disattiva canali
			this.flagDTT = 'N';
			this.LastPos=5;
			this.yPos=2;
			this.aggiornaCheck(0);
			this.referImageToLayout("EnableDTTSettingsLayout","./btnconferma","/ovaImages/common/button/button_conferma_on.gif");
			break;
		case 6:
			//Check attiva canali
			this.flagDTT = 'Y';
			this.LastPos=6;
			this.yPos=2;
			this.aggiornaCheck(0);
			this.referImageToLayout("EnableDTTSettingsLayout","./btnconferma","/ovaImages/common/button/button_conferma_on.gif");				
			break;
		case 4:
			this.loadApp("/ovaServices/getapp/GetApp.jsp?urlapp=impostazioni&app1=ScanDTTSettingsApp");
			break;
			break;
	}	

	}catch(ecc){
		this._objErrorInfo._methodName = 'eventKeyEnter';
		this._objErrorInfo._obException = ecc;
		this.handleError();
	}
		return true;	
};


EnableDTTSettingsApp.prototype.eventKeyScrollUp = function() {
	return true;
};

EnableDTTSettingsApp.prototype.eventKeyScrollDown = function() {
	return true;
};


EnableDTTSettingsApp.prototype.eventKeyHot1 = function() {
	return true;
};

EnableDTTSettingsApp.prototype.eventKeyHot2 = function() {
	
	return true;
};

EnableDTTSettingsApp.prototype.eventKeyHot3 = function() {
	return true;
};


EnableDTTSettingsApp.prototype.eventKeyBack= function(){  	
	return true;
};

EnableDTTSettingsApp.prototype.eventKeyEsc= function(){  	
	return true;
};

EnableDTTSettingsApp.prototype.eventKeyHot4 = function() {	  
	return true;
};


EnableDTTSettingsApp.prototype.eventKeyUp = function() {
	try{
		
		if(this.yPos==1){
				this.yPos=0;
				this.setHorizOnFocus(this.catList[0].catId);
				this.referImageToLayout("EnableDTTSettingsLayout","./rolloverRossoAlice","/ovaImages/common/header/bt_RossoAlice_active.gif");
				
			}else if(this.yPos==6){
				this.yPos=3;
				this.referImageToLayout("EnableDTTSettingsLayout","./rolloverAbilitazione","/ovaImages/abilitazionebutton_mid_on.gif");
				this.aggiornaCheck(0);
			}else if(this.yPos==2){
				this.yPos=this.LastPos;//Ultima pos navigata
				this.referImageToLayout("EnableDTTSettingsLayout","./btnconferma","/ovaImages/common/button/button_conferma.gif");
				this.aggiornaCheck(3);
			}else if(this.yPos==5){
				this.yPos=6;// attiva
				this.aggiornaCheck(1);
			}else if(this.yPos==3){
				this.yPos=4;
				this.referImageToLayout("EnableDTTSettingsLayout","./rolloverAbilitazione","/ovaImages/abilitazionebutton_mid.gif");
				this.referImageToLayout("EnableDTTSettingsLayout","./rolloverRicerca","/ovaImages/ricercabutton_on.gif");
			}else if(this.yPos==4){
				this.yPos=1;
				this.referImageToLayout("EnableDTTSettingsLayout","./rolloverRicerca","/ovaImages/ricercabutton.gif");
				this.setHorizMidFocus(this.catList[0].catId);
				}
				
		this._ui.redraw();
		}catch(ecc){
		this._objErrorInfo._methodName = 'eventKeyUp';
		this._objErrorInfo._obException = ecc;
		this.handleError();
	}
		return true;
		
};


EnableDTTSettingsApp.prototype.eventKeyDown = function() {
	
	try{
		if(this.yPos==0){
			this.yPos=1;
			this.setHorizMidFocus(this.catList[0].catId);
			this.referImageToLayout("EnableDTTSettingsLayout","./rolloverRossoAlice","/ovaImages/1pixelclear.gif");
			
		}else if(this.yPos==1 && this.catList[0].catId==9){//MENU ORIZ
			this.yPos=4;
			this.setHorizOnFocus(this.catList[0].catId);
			this.referImageToLayout("EnableDTTSettingsLayout","./rolloverRicerca","/ovaImages/ricercabutton_on.gif");
		}else if(this.yPos==4){
			this.yPos=3;
			this.referImageToLayout("EnableDTTSettingsLayout","./rolloverRicerca","/ovaImages/ricercabutton.gif");
			this.referImageToLayout("EnableDTTSettingsLayout","./rolloverAbilitazione","/ovaImages/abilitazionebutton_mid_on.gif");
		}else if(this.yPos==3){
			this.yPos=6;
			this.referImageToLayout("EnableDTTSettingsLayout","./rolloverAbilitazione","/ovaImages/abilitazionebutton_mid.gif");
			this.aggiornaCheck(1);
		}else if(this.yPos==6){
			this.yPos=5;
			this.aggiornaCheck(2);
		}else if(this.yPos==5){
			this.LastPos=5;
			this.yPos=2;
			this.aggiornaCheck(0);
			this.referImageToLayout("EnableDTTSettingsLayout","./btnconferma","/ovaImages/common/button/button_conferma_on.gif");
		}
		this._ui.redraw();
	}catch(ecc){
	this._objErrorInfo._methodName = 'eventKeyDown';
	this._objErrorInfo._obException = ecc;
	this.handleError();
	}
	return true;
};


EnableDTTSettingsApp.prototype.eventKeyLeft = function() {
	try{
	if(this.yPos==1){
			this.rotateRight();
			this.fillMenu(this.catList[0].catId);
		}
	}catch(ecc){
		this._objErrorInfo._methodName = 'eventKeyLeft';
		this._objErrorInfo._obException = ecc;
		this.handleError();
	}
	return true;
};

EnableDTTSettingsApp.prototype.eventKeyRight = function() {
	try{
	if(this.yPos==1){
			this.rotateLeft();
			this.fillMenu(this.catList[0].catId);
		}
	}catch(ecc){
		this._objErrorInfo._methodName = 'eventKeyRight';
		this._objErrorInfo._obException = ecc;
		this.handleError();
	}
	return true;
};


EnableDTTSettingsApp.prototype.eventKeyMenu = function() {
	try
	{		
		this.eventKeyEye();	
	}catch(ecc){
		this._objErrorInfo._methodName = 'eventKeyMenu';
		this._objErrorInfo._obException = ecc;
		this.handleError();
	}finally{
		return true;
	}
};

EnableDTTSettingsApp.prototype.setInitHoriz=function(){
	try{
		
		this._ui.setLabelText("./ITEM_1_LABEL"," ");
		var stringone="";
		
			stringone=
		"{catId:'9',catName:'dtt'},"+
		"{catId:'1',catName:'prof_cli'},"+
		"{catId:'2',catName:'pin_acq'},"+
		"{catId:'3',catName:'par_ctrl'},"+
		"{catId:'4',catName:'ctrl_acq'},"+
		"{catId:'5',catName:'not_leg'},"+
		"{catId:'6',catName:'imp_stb'},"+
		"{catId:'7',catName:'ric_pin'},"+
		"{catId:'8',catName:'area_test'}";
		
		
		this.catList ="["+stringone+"]";
		this.catList=eval(this.catList);
		//this.fillMenu(this.catList[0].catId);
		return true;
	}catch(ecc){
		this._objErrorInfo._methodName = "setInitHoriz";
		this._objErrorInfo._obException=ecc;
		this.handleError();
	}
};

EnableDTTSettingsApp.prototype.setHorizMidFocus=function(catid){
	try{  
			testlabel100='<img src="/ovaImages/menu/lb_s'+catid+'_dtt_mid.gif">';
		this._ui.setLabelHtml("./ITEM_1_LABEL",testlabel100);
	}catch(ecc){
		this._objErrorInfo._methodName = "setHorizMidFocus";
		this._objErrorInfo._obException=ecc;
		this.handleError();
	}
	return true;
};

EnableDTTSettingsApp.prototype.setHorizOnFocus=function(catid){
	try{
			testlabel100='<img src="/ovaImages/menu/lb_s'+catid+'_dtt_on.gif">';
		this._ui.setLabelHtml("./ITEM_1_LABEL",testlabel100);
	}catch(ecc){
		this._objErrorInfo._methodName = "setHorizOnFocus";
		this._objErrorInfo._obException=ecc;
		this.handleError();
	}
	return true;
};

EnableDTTSettingsApp.prototype.rotateLeft = function(){
	try{
		
			var vatList_temp = this.catList[0];
			this.catList[0]=this.catList[1];
			this.catList[1]=this.catList[2];
			this.catList[2]=this.catList[3];
			this.catList[3]=this.catList[4];
			this.catList[4]=this.catList[5];
			this.catList[5]=this.catList[6];
			this.catList[6]=this.catList[7];	
			this.catList[7]=this.catList[8];
			this.catList[8]=vatList_temp;
		
		return true;
	}catch(ecc){
		this._objErrorInfo._methodName = "rotateLeft";
		this._objErrorInfo._obException=ecc;
		this.handleError();
	}	
}; 	


EnableDTTSettingsApp.prototype.rotateRight = function(){
	try{
		
			var catList_temp = this.catList[8];
			this.catList[8]=this.catList[7];
			this.catList[7]=this.catList[6];
			this.catList[6]=this.catList[5];
			this.catList[5]=this.catList[4];
			this.catList[4]=this.catList[3];
			this.catList[3]=this.catList[2];
			this.catList[2]=this.catList[1];
			this.catList[1]=this.catList[0]; 			
			this.catList[0]=catList_temp;
			
		
		return true;
	}catch(ecc){
		this._objErrorInfo._methodName = "rotateRight";
		this._objErrorInfo._obException=ecc;
		this.handleError();
	}
}; 



EnableDTTSettingsApp.prototype.fillMenu = function(catid1){
	try{
		
		testlabel1='<img src="/ovaImages/menu/lb_s'+catid1+'_dtt_mid.gif">';
		this._ui.setLabelHtml("./ITEM_1_LABEL",testlabel1);
		this._ui.redraw();
		return true;
	}catch(ecc){
		this._objErrorInfo._methodName = "fillMenu";
		this._objErrorInfo._obException=ecc;
		this.handleError();
	}
};