//ImpostazioniSTBApp.prototype.DOMAIN = "OVA/SERVICE/PPVNVOD";

ImpostazioniSTBApp.prototype=top.getFramework().createBaseApp();

ImpostazioniSTBApp.prototype.createForm=function(){
	try{
		this._form = this.fw.createForm("nascosto");
		this._form.addField({ name: 'hidd', type: this._form.TYPE_HIDDEN });
		this._form.setHandler(this);
		return this._form;
	}catch(ecc){
		this._objErrorInfo._methodName = "createForm";
		this._objErrorInfo._obException = ecc;
		this.handleError();
		return null;
	}
};

function ImpostazioniSTBApp(){
	//inizializzazione delle variabili
	this.layout=null; this.pageLayout = null; this._ui = null;
	this.videoFormat = null; this.videoOut = null; this.volume = null;
	this.videoFormatOld = null; this.videoOutOld = null; this.volumeOld = null;
};

ImpostazioniSTBApp.prototype.create=function(){
	try{
		this._objErrorInfo = new Object();
		this._objErrorInfo._applicationName = "ImpostazioniSTBApp.js";
		this._objErrorInfo._methodName = "";
		this._objErrorInfo._obException = new Object();
		/* In questo modo in HomeTvApp carica la cache con le immagini per lo zapperone */
		this.fw.refreshImmagZapper=1;
	}catch(e){
		this._objErrorInfo._methodName = "create";
		this._objErrorInfo._obException = e;
		this.handleError();
	}
};
ImpostazioniSTBApp.prototype.init=function(){
	try{
		this.fw.getLayoutManager().setLayoutVisible("caricamentoInCorso", false);	
		this.sendLoadAppTrap("ImpostazioniSTBApp");
		//inizializzazione array di navigazione
		this.confirmOff='/ovaImages/layout/impostazioni/confermaOff.png'; this.confirmOn='/ovaImages/layout/impostazioni/confermaOn.png';
		this.clearImage = '/ovaImages/1pixelclear.gif';
		//Not Check, Not Check Selected, Checked, Checked Selected
		this.imageArray = new Array( '/ovaImages/layout/impostazioni/bg_check.png','/ovaImages/layout/impostazioni/bg_check_selected.png','/ovaImages/layout/impostazioni/checkOn.png','/ovaImages/layout/impostazioni/checkOnSelected.png' );
		this.volumeImageArray = new Array( '/ovaImages/layout/impostazioni/audioOff_v1.png', '/ovaImages/layout/impostazioni/audioOff_v2.png', '/ovaImages/layout/impostazioni/audioOff_v3.png','/ovaImages/layout/impostazioni/audioOff_v4.png', '/ovaImages/layout/impostazioni/audioOff_v5.png','/ovaImages/layout/impostazioni/audioOff.png');
		this.volumeImageArrayOn = new Array( '/ovaImages/layout/impostazioni/audio_v1.png', '/ovaImages/layout/impostazioni/audio_v2.png', '/ovaImages/layout/impostazioni/audio_v3.png','/ovaImages/layout/impostazioni/audio_v4.png', '/ovaImages/layout/impostazioni/audio_v5.png','/ovaImages/layout/impostazioni/audio_on.png' );
		
		this.videoFormatArray = new Array( 'N', 'L', 'W' ); // 4:3, 4:3 letterBox, 16:9
		this.videoOutArray = new Array( 'R','C' ); //RGB, RGB Composito
		this.HDMIout = new Array('P','I');
		
		this.videoOutPossible = new Array('R','C','P','I');
		
		this.volumeArray  = new Array( 0,4,8,12,16,20 );
		this.videoFormatLayoutArray = new Array( 'QuattroTerzi','letterBox','SediciNoni' );
		this.videoOutLayoutArray = new Array( 'RGB','RGB_Composito' );
		
		this.HDMIlayout = new Array('HDMI_720p','HDMI_1080i');
		
		this.verticalPosition = 0; //0,1,2,3 posizioni ammissibili
		this.horizontalPosition = 0; //0,1,2 - 0,1 - 0
		this.selectedFormat = 0; this.selectedOut = 0;
		
		this.layout="impoTVLayout";
		
		this._ui = this.fw.createSimpleFormUI(this.layout);
		this._ui.setForm(this.createForm());
		this.pageLayout = this.fw.getLayoutManager().getLayout(this.layout);
		
		this.referImageToLayout(this.layout, 'confirm', this.confirmOff);
		this.inizializza();
		this.getSetting(); //recupera i settaggi del STB
		this.setInterface(); //imposta i parametri attuali a video
		
		this._ui.redraw();
	}catch(e){
		this._objErrorInfo._methodName = "init";
		this._objErrorInfo._obException = e;
		this.handleError();
	}
};
ImpostazioniSTBApp.prototype.fin=function(){
	try{
		//this.clearInterface();
		//distruzione delle variabili
		for( i=0; i<this.videoFormatLayoutArray.length; i++ ) this.referImageToLayout(this.layout, this.videoFormatLayoutArray[i], this.clearImage);
		for( i=0; i<this.videoOutLayoutArray.length; i++ ) this.referImageToLayout(this.layout, this.videoOutLayoutArray[i], this.clearImage);
		for( i=0; i<this.HDMIlayout.length; i++ ) this.referImageToLayout(this.layout, this.HDMIlayout[i], this.clearImage);
		this.layout=null; this.pageLayout = null; this._ui = null;
		this.confirmOff = null; this.confirmOn = null; 
		this.imageArray = null; this.clearImage = null; this.volumeImageArray = null;
		this.videoFormat = null; this.videoOut = null; this.volume = null;
		this.videoFormatOld = null; this.videoOutOld = null; this.volumeOld = null;
		this.videoFormatArray = null; this.videoOutArray = null; this.volumeArray = null;
		this.selectedFormat = null; this.selectedOut = null;

	}catch(e){
		this._objErrorInfo._methodName = "fin";
		this._objErrorInfo._obException = e;
		this.handleError();
	}
};
ImpostazioniSTBApp.prototype.inizializza=function(){
	try{
		//this.clearInterface();
		//distruzione delle variabili
		for( i=0; i<this.videoFormatLayoutArray.length; i++ ) this.referImageToLayout(this.layout, this.videoFormatLayoutArray[i], this.imageArray[0]);
		for( i=0; i<this.videoOutLayoutArray.length; i++ ) this.referImageToLayout(this.layout, this.videoOutLayoutArray[i], this.imageArray[0]);
		for( i=0; i<this.HDMIlayout.length; i++ ) this.referImageToLayout(this.layout, this.HDMIlayout[i], this.imageArray[0]);
		

	}catch(e){
		this._objErrorInfo._methodName = "inizializza";
		this._objErrorInfo._obException = e;
		this.handleError();
	}
};
ImpostazioniSTBApp.prototype.eventKeyRight=function(){ 
	try{
		switch( this.verticalPosition ){
			case 0://video Format
				this.horizontalPosition++;
				if( this.horizontalPosition > this.videoFormatArray.length-1 ) this.horizontalPosition = this.videoFormatArray.length-1; //chek sulla consistenza di navigazione
				if( this.horizontalPosition <= this.videoFormatArray.length-1 ){
					var newOff = this.horizontalPosition == 0 ? 0 : (this.horizontalPosition-1);
					if( this.videoFormat == this.videoFormatArray[newOff] ){	this.referImageToLayout(this.layout, this.videoFormatLayoutArray[newOff], this.imageArray[2]); }else{ this.referImageToLayout(this.layout, this.videoFormatLayoutArray[newOff], this.imageArray[0]);}
					if( this.videoFormat == this.videoFormatArray[this.horizontalPosition] ){ this.referImageToLayout(this.layout, this.videoFormatLayoutArray[this.horizontalPosition], this.imageArray[3]); }else{ this.referImageToLayout(this.layout, this.videoFormatLayoutArray[this.horizontalPosition], this.imageArray[1]); }
					newoff = null;
				}
			break;
			case 1://video Out
				this.horizontalPosition++;
				if( this.horizontalPosition > (this.videoOutArray.length-1) ) this.horizontalPosition = this.videoOutArray.length-1; //chek sulla consistenza di navigazione
				if( this.horizontalPosition <= (this.videoOutArray.length-1) ){
					var newOff = this.horizontalPosition == 0 ? 0 : (this.horizontalPosition-1);
					if( this.videoOut == this.videoOutArray[newOff] ){	this.referImageToLayout(this.layout, this.videoOutLayoutArray[newOff], this.imageArray[2]); }else{ this.referImageToLayout(this.layout,this.videoOutLayoutArray[newOff], this.imageArray[0]);}
					if( this.videoOut == this.videoOutArray[this.horizontalPosition] ){ this.referImageToLayout(this.layout, this.videoOutLayoutArray[this.horizontalPosition], this.imageArray[3]); }else{ this.referImageToLayout(this.layout, this.videoOutLayoutArray[this.horizontalPosition], this.imageArray[1]); }
					newoff = null;
				}
			break;
			case 2://HDMI
				this.horizontalPosition++;
				if( this.horizontalPosition > (this.HDMIout.length-1) ) this.horizontalPosition = this.HDMIout.length-1; //chek sulla consistenza di navigazione
				if( this.horizontalPosition <= (this.HDMIout.length-1) ){
					var newOff = this.horizontalPosition == 0 ? 0 : (this.horizontalPosition-1);
					if( this.videoOut == this.HDMIout[newOff] ){	this.referImageToLayout(this.layout, this.HDMIlayout[newOff], this.imageArray[2]); }else{ this.referImageToLayout(this.layout,this.HDMIlayout[newOff], this.imageArray[0]);}
					if( this.videoOut == this.HDMIout[this.horizontalPosition] ){ this.referImageToLayout(this.layout, this.HDMIlayout[this.horizontalPosition], this.imageArray[3]); }else{ this.referImageToLayout(this.layout, this.HDMIlayout[this.horizontalPosition], this.imageArray[1]); }
					newoff = null;
				}
			break;
			case 3://Volume
				this.volume+=4;
				if( this.volume > 20 ) this.volume = 20;
				if( this.volumeArray ){
					switch( this.volume ){ 
						case 0: 
							this.referImageToLayout(this.layout, 'volume', this.volumeImageArrayOn[5]); 
							break; 
						case 4:
							this.referImageToLayout( this.layout, 'volume', this.volumeImageArrayOn[0] ); 
							break;
						case 8:
							this.referImageToLayout( this.layout, 'volume', this.volumeImageArrayOn[1] );
							break;
						case 12:
							this.referImageToLayout( this.layout, 'volume', this.volumeImageArrayOn[2] );
							break;
						case 16:
							this.referImageToLayout( this.layout, 'volume', this.volumeImageArrayOn[3] ); 
							break; 
						case 20: 
							this.referImageToLayout( this.layout, 'volume', this.volumeImageArrayOn[4] );
							break;
						default: { 
							try{ 
								navigator.Set_tv_audio(12);
							}
							catch(e){
							} 
							this.referImageToLayout(this.layout, 'volume', this.volumeImageArrayOn[2]);
						}
					}
				}
			break;
			case 4:	break;
			default: return true;
		}
		this._ui.redraw();
	}catch(e){
		this._objErrorInfo._methodName = "eventKeyRight";
		this._objErrorInfo._obException = e;
		this.handleError();
	}
 };
 
ImpostazioniSTBApp.prototype.eventKeyLeft=function(){
	try{
		switch( this.verticalPosition ){
			case 0://video Format
				this.horizontalPosition--;
				if( this.horizontalPosition < 0) this.horizontalPosition = 0; //chek sulla consistenza di navigazione
				var newOff = this.horizontalPosition == (this.videoFormatArray.length-1) ? 0 : (this.horizontalPosition+1);
				if( this.videoFormat == this.videoFormatArray[newOff] ){	this.referImageToLayout(this.layout, this.videoFormatLayoutArray[newOff], this.imageArray[2]); }else{ this.referImageToLayout(this.layout, this.videoFormatLayoutArray[newOff], this.imageArray[0]);}
				if( this.videoFormat == this.videoFormatArray[this.horizontalPosition] ){ this.referImageToLayout(this.layout, this.videoFormatLayoutArray[this.horizontalPosition], this.imageArray[3]); }else{ this.referImageToLayout(this.layout, this.videoFormatLayoutArray[this.horizontalPosition], this.imageArray[1]); }
				newoff = null;
			break;
			case 1://video Out
				this.horizontalPosition--;
				if( this.horizontalPosition < 0 ) this.horizontalPosition = 0; //chek sulla consistenza di navigazione
				var newOff = this.horizontalPosition == (this.videoOutArray.length-1) ? 0 : (this.horizontalPosition+1);
				if( this.videoOut == this.videoOutArray[newOff] ){	this.referImageToLayout(this.layout, this.videoOutLayoutArray[newOff], this.imageArray[2]); }else{ this.referImageToLayout(this.layout,this.videoOutLayoutArray[newOff], this.imageArray[0]);}
				if( this.videoOut == this.videoOutArray[this.horizontalPosition] ){ this.referImageToLayout(this.layout, this.videoOutLayoutArray[this.horizontalPosition], this.imageArray[3]); }else{ this.referImageToLayout(this.layout, this.videoOutLayoutArray[this.horizontalPosition], this.imageArray[1]); }
				newoff = null;
			break;
			case 2://HDMI
				this.horizontalPosition--;
				if( this.horizontalPosition < 0 ) this.horizontalPosition = 0; //chek sulla consistenza di navigazione
				var newOff = this.horizontalPosition == (this.HDMIout.length-1) ? 0 : (this.horizontalPosition+1);
				if( this.videoOut == this.HDMIout[newOff] ){	this.referImageToLayout(this.layout, this.HDMIlayout[newOff], this.imageArray[2]); }else{ this.referImageToLayout(this.layout,this.HDMIlayout[newOff], this.imageArray[0]);}
				if( this.videoOut == this.HDMIout[this.horizontalPosition] ){ this.referImageToLayout(this.layout, this.HDMIlayout[this.horizontalPosition], this.imageArray[3]); }else{ this.referImageToLayout(this.layout, this.HDMIlayout[this.horizontalPosition], this.imageArray[1]); }
				newoff = null;
			break;
			case 3://Volume
				this.volume-=4;
				if( this.volume < 0 ) this.volume = 0;
				if( this.volumeArray ){
					switch( this.volume ){ 
						case 0: this.referImageToLayout(this.layout, 'volume', this.volumeImageArrayOn[5]); break; case 4: this.referImageToLayout( this.layout, 'volume', this.volumeImageArrayOn[0] ); break;
						case 8: this.referImageToLayout( this.layout, 'volume', this.volumeImageArrayOn[1] ); break; case 12: this.referImageToLayout( this.layout, 'volume', this.volumeImageArrayOn[2] ); break;
						case 16: this.referImageToLayout( this.layout, 'volume', this.volumeImageArrayOn[3] ); break; case 20: this.referImageToLayout( this.layout, 'volume', this.volumeImageArrayOn[4] ); break;
						default: { try{ navigator.Set_tv_audio(12);}catch(e){} this.referImageToLayout(this.layout, 'volume', this.volumeImageArrayOn[2]); }
					}
				}
			break;
			case 4:	break;
			default: return true;
		}
		this._ui.redraw();
	}catch(e){
		this._objErrorInfo._methodName = "eventKeyLeft";
		this._objErrorInfo._obException = e;
		this.handleError();
	}
 };
ImpostazioniSTBApp.prototype.eventKeyDown=function(){
	try{
		switch( this.verticalPosition ){
			case 0:
				this.verticalPosition++;
				if( this.videoFormat == this.videoFormatArray[this.horizontalPosition] ){ this.referImageToLayout(this.layout, this.videoFormatLayoutArray[this.horizontalPosition], this.imageArray[2]); }else{ this.referImageToLayout(this.layout, this.videoFormatLayoutArray[this.horizontalPosition], this.imageArray[0]);}
				this.horizontalPosition=0;
				if( this.videoOut == this.videoOutArray[this.horizontalPosition] ){ this.referImageToLayout(this.layout, this.videoOutLayoutArray[this.horizontalPosition], this.imageArray[3]); }else{ this.referImageToLayout(this.layout, this.videoOutLayoutArray[this.horizontalPosition], this.imageArray[1]); }
				break;
			case 1:
				this.verticalPosition++;
				if( this.videoOut == this.videoOutArray[this.horizontalPosition] ){ this.referImageToLayout(this.layout, this.videoOutLayoutArray[this.horizontalPosition], this.imageArray[2]);}else{this.referImageToLayout(this.layout, this.videoOutLayoutArray[this.horizontalPosition], this.imageArray[0]);}
				this.horizontalPosition=0;
				if( this.videoOut == this.HDMIout[this.horizontalPosition] ){ this.referImageToLayout(this.layout, this.HDMIlayout[this.horizontalPosition], this.imageArray[3]); }else{ this.referImageToLayout(this.layout, this.HDMIlayout[this.horizontalPosition], this.imageArray[1]); }
			break;
			case 2:
				this.verticalPosition++;
				if( this.videoOut == this.HDMIout[this.horizontalPosition] ){this.referImageToLayout(this.layout, this.HDMIlayout[this.horizontalPosition], this.imageArray[2]);}else{this.referImageToLayout(this.layout, this.HDMIlayout[this.horizontalPosition], this.imageArray[0]);}
				this.horizontalPosition=0;
				switch( this.volume ){ 
					case 0: this.referImageToLayout(this.layout, 'volume', this.volumeImageArrayOn[5]); break; case 4: this.referImageToLayout( this.layout, 'volume', this.volumeImageArrayOn[0] ); break;
					case 8: this.referImageToLayout( this.layout, 'volume', this.volumeImageArrayOn[1] ); break; case 12: this.referImageToLayout( this.layout, 'volume', this.volumeImageArrayOn[2] ); break;
					case 16: this.referImageToLayout( this.layout, 'volume', this.volumeImageArrayOn[3] ); break; case 20: this.referImageToLayout( this.layout, 'volume', this.volumeImageArrayOn[4] ); break;
					default: { try{ navigator.Set_tv_audio(12);}catch(e){} this.referImageToLayout(this.layout, 'volume', this.volumeImageArrayOn[2]); }
				}
			break;
			case 3:
				this.verticalPosition++;
				switch( this.volume ){ 
					case 0: this.referImageToLayout(this.layout, 'volume', this.volumeImageArray[5]); break; case 4: this.referImageToLayout( this.layout, 'volume', this.volumeImageArray[0] ); break;
					case 8: this.referImageToLayout( this.layout, 'volume', this.volumeImageArray[1] ); break; case 12: this.referImageToLayout( this.layout, 'volume', this.volumeImageArray[2] ); break;
					case 16: this.referImageToLayout( this.layout, 'volume', this.volumeImageArray[3] ); break; case 20: this.referImageToLayout( this.layout, 'volume', this.volumeImageArray[4] ); break;
					default: { try{ navigator.Set_tv_audio(12);}catch(e){} this.referImageToLayout(this.layout, 'volume', this.volumeImageArray[2]); }
				}
				this.referImageToLayout(this.layout, 'confirm', this.confirmOn);
				break;
			case 4:
				//this.verticalPosition = 0;
				//this.referImageToLayout(this.layout, 'confirm', this.confirmOff);
				//if( this.videoFormat == this.videoFormatArray[this.horizontalPosition] ){ this.referImageToLayout(this.layout, this.videoFormatLayoutArray[this.horizontalPosition], this.imageArray[3]); }else{ this.referImageToLayout(this.layout, this.videoFormatLayoutArray[this.horizontalPosition], this.imageArray[1]); }
			break;
			default: return true;
		}
	}catch(e){
		this._objErrorInfo._methodName = "eventKeyDown";
		this._objErrorInfo._obException = e;
		this.handleError();
	}
 };
ImpostazioniSTBApp.prototype.eventKeyUp=function(){
	try{
		switch( this.verticalPosition ){
			case 0:	break;
			case 1:
				this.verticalPosition--;
				if( this.videoOut == this.videoOutArray[this.horizontalPosition] ){ this.referImageToLayout(this.layout, this.videoOutLayoutArray[this.horizontalPosition], this.imageArray[2]); }else{ this.referImageToLayout(this.layout, this.videoOutLayoutArray[this.horizontalPosition], this.imageArray[0]); }
				this.horizontalPosition=0;
				if( this.videoFormat == this.videoFormatArray[this.horizontalPosition] ){ this.referImageToLayout(this.layout, this.videoFormatLayoutArray[this.horizontalPosition], this.imageArray[3]); }else{ this.referImageToLayout(this.layout, this.videoFormatLayoutArray[this.horizontalPosition], this.imageArray[1]); }
			break;
			case 2: //video out
				this.verticalPosition--;
				if( this.videoOut == this.HDMIout[this.horizontalPosition] ){ this.referImageToLayout(this.layout, this.HDMIlayout[this.horizontalPosition], this.imageArray[2]); }else{ this.referImageToLayout(this.layout, this.HDMIlayout[this.horizontalPosition], this.imageArray[0]); }
				this.horizontalPosition=0;
				if( this.videoOut == this.videoOutArray[this.horizontalPosition] ){ this.referImageToLayout(this.layout, this.videoOutLayoutArray[this.horizontalPosition], this.imageArray[3]); }else{ this.referImageToLayout(this.layout, this.videoOutLayoutArray[this.horizontalPosition], this.imageArray[1]); }
			break;
			case 3: //HDMI
				this.verticalPosition--;
				switch( this.volume ){ 
					case 0: this.referImageToLayout(this.layout, 'volume', this.volumeImageArray[5]); break; case 4: this.referImageToLayout( this.layout, 'volume', this.volumeImageArray[0] ); break;
					case 8: this.referImageToLayout( this.layout, 'volume', this.volumeImageArray[1] ); break; case 12: this.referImageToLayout( this.layout, 'volume', this.volumeImageArray[2] ); break;
					case 16: this.referImageToLayout( this.layout, 'volume', this.volumeImageArray[3] ); break; case 20: this.referImageToLayout( this.layout, 'volume', this.volumeImageArray[4] ); break;
					default: { try{ navigator.Set_tv_audio(12);}catch(e){} this.referImageToLayout(this.layout, 'volume', this.volumeImageArray[2]); }
				}
				this.horizontalPosition=0;
				if( this.videoOut == this.HDMIout[this.horizontalPosition] ){ this.referImageToLayout(this.layout, this.HDMIlayout[this.horizontalPosition], this.imageArray[3]); }else{ this.referImageToLayout(this.layout, this.HDMIlayout[this.horizontalPosition], this.imageArray[1]); }
			break;
			case 4:
				this.verticalPosition--;
				this.referImageToLayout(this.layout, 'confirm', this.confirmOff);
				switch( this.volume ){ 
					case 0: this.referImageToLayout(this.layout, 'volume', this.volumeImageArrayOn[5]); break; case 4: this.referImageToLayout( this.layout, 'volume', this.volumeImageArrayOn[0] ); break;
					case 8: this.referImageToLayout( this.layout, 'volume', this.volumeImageArrayOn[1] ); break; case 12: this.referImageToLayout( this.layout, 'volume', this.volumeImageArrayOn[2] ); break;
					case 16: this.referImageToLayout( this.layout, 'volume', this.volumeImageArrayOn[3] ); break; case 20: this.referImageToLayout( this.layout, 'volume', this.volumeImageArrayOn[4] ); break;
					default: { try{ navigator.Set_tv_audio(12);}catch(e){} this.referImageToLayout(this.layout, 'volume', this.volumeImageArrayOn[2]); }
				}
			break;
			default: return true;
		}
	}catch(e){
		this._objErrorInfo._methodName = "eventKeyUp";
		this._objErrorInfo._obException = e;
		this.handleError();
	}
};

ImpostazioniSTBApp.prototype.eventKeyEnter=function(){ 
	try{
///////////////////////////////CONTROLLO DEL TASTIERINO NUMERICO//////////////////
		if(this.BoxChangeChannel == true){
			 this.EnterNumericDigit();
//////////////////////////////////////////////////////////////////////////////////
 	  }else{		
		
				switch( this.verticalPosition ){
					case 0:
						if( this.horizontalPosition > this.videoFormatArray.length ) this.horizontalPosition = 0;
						this.videoFormat = this.videoFormatArray[ this.horizontalPosition ];
						this.referImageToLayout(this.layout, this.videoFormatLayoutArray[this.selectedFormat], this.imageArray[0]);
						this.selectedFormat = this.horizontalPosition;
						this.referImageToLayout(this.layout, this.videoFormatLayoutArray[this.horizontalPosition], this.imageArray[3]);
						break;
					case 1:
						if( this.horizontalPosition > this.videoOutArray.length ) this.horizontalPosition = 0;
						if( this.videoOut == 'P' || this.videoOut == 'I' ){this.referImageToLayout(this.layout, this.HDMIlayout[this.selectedOut], this.imageArray[0]);}else{this.referImageToLayout(this.layout, this.videoOutLayoutArray[this.selectedOut], this.imageArray[0]);}
						this.videoOut = this.videoOutArray[this.horizontalPosition];
						this.selectedOut = this.horizontalPosition;
						this.referImageToLayout(this.layout, this.videoOutLayoutArray[this.horizontalPosition], this.imageArray[3]);
					break;
					case 2:
						if( this.horizontalPosition > this.HDMIout.length ) this.horizontalPosition = 0;
						if( this.videoOut == 'P' || this.videoOut == 'I' ){this.referImageToLayout(this.layout, this.HDMIlayout[this.selectedOut], this.imageArray[0]);}else{this.referImageToLayout(this.layout, this.videoOutLayoutArray[this.selectedOut], this.imageArray[0]);}
						this.videoOut = this.HDMIout[this.horizontalPosition];
						this.referImageToLayout(this.layout, this.HDMIlayout[this.selectedOut], this.imageArray[0]);
						this.selectedOut = this.horizontalPosition;
						this.referImageToLayout(this.layout, this.HDMIlayout[this.horizontalPosition], this.imageArray[3]);
					break;
					case 3: return true;
					case 4:
						if( (this.videoOut != this.videoOutOld && (this.videoOut != 'P' && this.videoOut != 'I')) || this.volume != this.volumeOld ) 
							try{ this.setFormatParameters(this.videoOut, this.volume ); }catch(e){ return false; }
						
						if( this.videoFormat != this.videoFormatOld || (this.videoOut != this.videoOutOld && (this.videoOut == 'P' || this.videoOut == 'I')) ){
							var objSend = new Object();
							objSend.pageCall = 2;
							objSend.imgSrc = "/ovaImages/layout/impostazioni/stb_1.png";
							objSend.titleTxt = "ABILITAZIONE IMPOSTAZIONI SET TOP BOX";
							if( this.videoFormat != this.videoFormatOld ){ 
								objSend.parameter = this.videoFormat; objSend.funciont2call=0; objSend.textPopUp='<br>Per rendere effettiva la configurazione riavviare<br>Alice home TV Box.';
							}else if( this.videoOut != this.videoOutOld && this.videoOut == 'P'  ){ 
								objSend.parameter = this.videoOut; objSend.funciont2call=1; objSend.textPopUp='<br>Per rendere effettiva la configurazione riavviare<br>Alice home TV Box.';
							}else if( this.videoOut != this.videoOutOld && this.videoOut == 'I'  ){ 
								objSend.parameter = this.videoOut; objSend.funciont2call=1; objSend.textPopUp='<br>Per rendere effettiva la configurazione riavviare<br>Alice home TV Box.<br><br> ATTENZIONE abilitando l\'opzione HDMI 1800i la visualizzazione su uscita SCART risulter&agrave; NON corretta sar&agrave; necessario utilizzare l\'uscita HDMI';
							}
							omc.logger.addEntry("###################### DTTConfermaApp ############");
							this.loadApp("/ovaServices/getapp/DTTApp.html?urlapp=impostazioni&app1=DTTConfermaApp", objSend);
						}else{
							this.fw.backFromExApp = true;
							this.loadApp(this.getHomeUrl(),null,null,null,null); 
						}
						break;
					default: 
						return true;
				}
		}
	}catch(e){
		this._objErrorInfo._methodName = "eventKeyUp";
		this._objErrorInfo._obException = e;
		this.handleError();
	}
};

ImpostazioniSTBApp.prototype.eventKeyScrollUp=function(){ return true; };
ImpostazioniSTBApp.prototype.eventKeyScrollDown=function(){ return true; };
ImpostazioniSTBApp.prototype.eventKeyEye=function(){ return true; };

ImpostazioniSTBApp.prototype.eventKeyBack = function(){ this.eventKeyEsc(); }
ImpostazioniSTBApp.prototype.eventKeyEsc= function(){ 
	try{
///////////////////////////////CONTROLLO DEL TASTIERINO NUMERICO//////////////////
		if(this.BoxChangeChannel == true){
			 this.DeleteNumericDigit();
//////////////////////////////////////////////////////////////////////////////////
		}else{
			this.fw.backFromExApp = true;
			this.loadApp(this.getHomeUrl(),null,null,null,null); 
		}
	}catch(e){
		this._objErrorInfo._methodName = "eventKeyUp";
		this._objErrorInfo._obException = e;
		this.handleError();
	}
};

ImpostazioniSTBApp.prototype.getSetting=function(){
	try{
		try{ this.videoFormatOld = this.videoFormat = navigator.Get_tv_format(); }catch(e){ this.videoFormatOld = this.videoFormat = 'N'; /* Default 4/3 */ }
		try{ this.videoOutOld = this.videoOut = navigator.Get_tv_out(); }catch(e){ this.videoOutOld = this.videoOut = 'C'; /* Default RGB+Composito */ }
		try{ this.volumeOld = this.volume = parseInt(navigator.Get_tv_audio()); }catch(e){ this.volumeOld = this.volume = 12; }
	}catch(e){
		this._objErrorInfo._methodName = "getSetting";
		this._objErrorInfo._obException = e;
		this.handleError();
	}
};

ImpostazioniSTBApp.prototype.setInterface=function(){
	try{		
		if( this.videoFormatArray && this.imageArray && this.videoFormatLayoutArray ){
			if( this.videoFormat == this.videoFormatArray[0] ){ 
				this.referImageToLayout(this.layout, this.videoFormatLayoutArray[0], this.imageArray[3]);
				this.selectedFormat = 0;
			}else if( this.videoFormat == this.videoFormatArray[1] ) { 
				this.referImageToLayout(this.layout, this.videoFormatLayoutArray[0], this.imageArray[1]);
				this.referImageToLayout(this.layout, this.videoFormatLayoutArray[1], this.imageArray[2]);
				this.selectedFormat = 1;
			}else if( this.videoFormat == this.videoFormatArray[2] ) {
				this.referImageToLayout(this.layout, this.videoFormatLayoutArray[0], this.imageArray[1]);
				this.referImageToLayout(this.layout, this.videoFormatLayoutArray[2], this.imageArray[2]);
				this.selectedFormat = 2;
			}
		}
		if( this.videoOutArray && this.imageArray && this.videoOutLayoutArray ){
				
			if( this.videoOut == this.videoOutArray[0] || this.videoOut == this.HDMIout[0] ){ 
				this.selectedOut = 0; 
			}else if( this.videoOut == this.videoOutArray[1] || this.videoOut == this.HDMIout[1] ){ 
				this.selectedOut = 1; 
			}
			if( this.videoOut=='P'||this.videoOut=='I' ){
				this.referImageToLayout(this.layout, this.HDMIlayout[this.selectedOut], this.imageArray[2]);
			}else{
				this.referImageToLayout(this.layout, this.videoOutLayoutArray[this.selectedOut], this.imageArray[2]);
			}
			
		}
		if( this.volumeArray ){
			switch( this.volume ){
				case 0: this.referImageToLayout(this.layout, 'volume', this.clearImage); break;	case 4: this.referImageToLayout( this.layout, 'volume', this.volumeImageArray[0] ); break;
				case 8: this.referImageToLayout( this.layout, 'volume', this.volumeImageArray[1] ); break; case 12: this.referImageToLayout( this.layout, 'volume', this.volumeImageArray[2] ); break;
				case 16: this.referImageToLayout( this.layout, 'volume', this.volumeImageArray[3] ); break; case 20: this.referImageToLayout( this.layout, 'volume', this.volumeImageArray[4] ); break;
				default: { try{ navigator.Set_tv_audio(12);}catch(e){} this.referImageToLayout(this.layout, 'volume', this.volumeImageArray[2]); this.volume = 12; }
			}
		}
	}catch(e){
		this._objErrorInfo._methodName = "setInterface";
		this._objErrorInfo._obException = e;
		this.handleError();
	}
};

ImpostazioniSTBApp.prototype.clearInterface=function(){
	try{		
		this.referImageToLayout(this.layout, 'confirm', this.clearImage);
		if( this.videoFormatArray && this.imageArray && this.videoFormatLayoutArray ){
			if( this.videoFormat == this.videoFormatArray[0] ){ 
				this.referImageToLayout(this.layout, this.videoFormatLayoutArray[0], this.clearImage);
				this.selectedFormat = 0;
			}else if( this.videoFormat == this.videoFormatArray[1] ) { 
				this.referImageToLayout(this.layout, this.videoFormatLayoutArray[0], this.clearImage);
				this.referImageToLayout(this.layout, this.videoFormatLayoutArray[1], this.clearImage);
				this.selectedFormat = 1;
			}else if( this.videoFormat == this.videoFormatArray[2] ) {
				this.referImageToLayout(this.layout, this.videoFormatLayoutArray[0], this.clearImage);
				this.referImageToLayout(this.layout, this.videoFormatLayoutArray[2], this.clearImage);
				this.selectedFormat = 2;
			}
		}
		if( this.videoOutArray && this.imageArray && this.videoOutLayoutArray ){
				
			if( this.videoOut == this.videoOutArray[0] || this.videoOut == this.HDMIout[0] ){ 
				this.selectedOut = 0; 
			}else if( this.videoOut == this.videoOutArray[1] || this.videoOut == this.HDMIout[1] ){ 
				this.selectedOut = 1; 
			}
			if( this.videoOut=='P'||this.videoOut=='I' ){
				this.referImageToLayout(this.layout, this.HDMIlayout[this.selectedOut], this.clearImage);
			}else{
				this.referImageToLayout(this.layout, this.videoOutLayoutArray[this.selectedOut], this.clearImage);
			}
			
		}
		if( this.volumeArray ){
			switch( this.volume ){
				case 0: this.referImageToLayout(this.layout, 'volume', this.clearImage); break;	case 4: this.referImageToLayout( this.layout, 'volume', this.clearImage ); break;
				case 8: this.referImageToLayout( this.layout, 'volume', this.clearImage ); break; case 12: this.referImageToLayout( this.layout, 'volume', this.clearImage ); break;
				case 16: this.referImageToLayout( this.layout, 'volume', this.clearImage ); break; case 20: this.referImageToLayout( this.layout, 'volume', this.clearImage ); break;
				default: { try{ navigator.Set_tv_audio(12);}catch(e){} this.referImageToLayout(this.layout, 'volume', this.clearImage); this.volume = 12; }
			}
		}
	}catch(e){
		this._objErrorInfo._methodName = "setInterface";
		this._objErrorInfo._obException = e;
		this.handleError();
	}
};

ImpostazioniSTBApp.prototype.setFormatParameters=function(videoOut, volume){
	try{
		navigator.Set_tv_out(videoOut);
		navigator.Set_tv_audio(volume);
	}catch(e){
		this._objErrorInfo._methodName = "setFormatParameters";
		this._objErrorInfo._obException = e;
		this.handleError();
	}
	finally{
		return true;
	}
};
