//PreferitiApp.prototype.DOMAIN = "OVA/SERVICE/PPVNVOD";

PreferitiApp.prototype = top.getFramework().createBaseApp();

PreferitiApp.prototype.createForm = function() {
	try {
		this._form = this.fw.createForm("nascosto");
		this._form.addField( {
			name :'hidd',
			type :this._form.TYPE_HIDDEN
		});
		this._form.setHandler(this);
		return this._form;
	} catch (ecc) {
		this._objErrorInfo._methodName = "createForm";
		this._objErrorInfo._obException = ecc;
		this.handleError();
		return null;
	}
};

function PreferitiApp() {
	this.leftPanel = "sx";
	this.rightPanel = "dx";
	this.frecce = "Arrow_dx_";
	this.frecce_muovi_fav = "/ovaImages/restyling/arrows/muovi_preferito.png";
	this.frecce_muovi_fav_up = "/ovaImages/restyling/arrows/active_up.png";
	this.frecce_muovi_fav_down = "/ovaImages/restyling/arrows/active_down.png";
	this.onePixClear = '/ovaImages/1pixelclear.gif';

	this.bottoneBACK = "/ovaImages/restyling/buttons/back.png";
	this.bottoneBACK_Label = "backPref";
	
	this.bottoneOK = "/ovaImages/restyling/buttons/ok_footer_small.png";
	this.bottoneOK_Label = "seleziona";

	//this.bottoneATTIVA = "/ovaImages/restyling/buttons/attiva.png";
	this.bottoneATTIVA = "/ovaImages/1pixelclear.gif";	
	this.bottoneATTIVA_Label = "attiva";

	//this.bottoneSALVA = "/ovaImages/restyling/buttons/salva.png";
	this.bottoneSALVA = "/ovaImages/restyling/buttons/salva_preferiti.png";
	
	this.bottoneSALVA_Label = "salva";

	this.bottoneELIMINA = "/ovaImages/restyling/buttons/elimina.png";
	this.bottoneELIMINA_Label = "elimina";

	

	this.leftPanelUpperArrow = 'leftPanelUpperArrow';
	this.leftPanelLowerArrow = 'leftPanelLowerArrow';
	this.rightPanelUpperArrow = 'rightPanelUpperArrow';
	this.rightPanelLowerArrow = 'rightPanelLowerArrow';
	
	this.titoloCANALI_ON="/ovaImages/canali_on.png";
	this.titoloCANALI_OFF="/ovaImages/canali_off.png";
	this.titoloCANALI_Label="titoloCANALI";
	this.titoloPREFERITI_ON="/ovaImages/preferiti_on.png";
	this.titoloPREFERITI_OFF="/ovaImages/preferiti_off.png";
	this.titoloPREFERITI_Label="titoloPREFERITI";

	

	
	
};

PreferitiApp.prototype.create = function() {
	try {
		this._objErrorInfo = new Object();
		this._objErrorInfo._applicationName = "PreferitiApp.js";
		this._objErrorInfo._methodName = "";
		this._objErrorInfo._obException = new Object();
		/*
		 * In questo modo in HomeTvApp carica la cache con le immagini per lo
		 * zapperone
		 */
		this.fw.refreshImmagZapper = 1;
	} catch (e) {
		this._objErrorInfo._methodName = "create";
		this._objErrorInfo._obException = e;
		this.handleError();
	}
};

PreferitiApp.prototype.init = function() {
	try {

		this.fw.getLayoutManager().setLayoutVisible("caricamentoInCorso", false);

		this.sendLoadAppTrap("PreferitiApp");

		this._layoutId = "PreferitiLayout";

		this._ui = this.fw.createSimpleFormUI(this._layoutId);

		this._ui.setForm(this.createForm());

		this.pageLayout = this.fw.getLayoutManager().getLayout(this._layoutId);
		this.pageLayout.document.bgColor = '#00000000';
		
		this.modificaFav = false;
		this.navigationMenuPanel = this.leftPanel;
		
		this.LevelSize = 5;

		this.popUpActionName = "";

		this.checkExit = true;
		
		this.salvatoListaPreferiti = false;
		this.attivatoListaPreferitiExtApp = false;
		
		this.modificatListaFav = false;
		
		this.setNavigationPositionPanel(this.leftPanel);
		this.ImagePreferitiTempOn = new Array();
		this.ImagePreferitiTempOff = new Array();
		this.ListaFavoritiTemp = new Array();
		this.NewLista = new Array();
		this.listaZapperCanali = this.getZapperSaved();

		for (i = 0; i < this.fw.ListaFavoriti.length; i++) {
			this.ListaFavoritiTemp[i] = this.fw.ListaFavoriti[i];
		}

		this.ImagePreferitiTempOff = this.fw.ImagePreferitiOff;
		this.ImagePreferitiTempOn = this.fw.ImagePreferitiOn;

		this._mySelectedChannel = 0;
		this._mySelectedChannelPreferiti = 0;
		
		this.fillEpgGridLayers('down', true);
		
		this.fillEpgGridLayersPreferiti('down', true);
		
		if (this.ListaFavoritiTemp.length != 0) {
			var selectedIndex = this.getSelectedChannelPreferiti()
					% this.LevelSize;
			this
					.referImageToLayout(
							this._layoutId,
							'Tab_dx_' + (selectedIndex + 1),
							this.ImagePreferitiTempOff[this.ListaFavoritiTemp[this._mySelectedChannelPreferiti].chanrecid].src);
		}
		
		this._ui.redraw();
		omc.logger.addEntry("######### PreferitiApp init---- FINE ######");
	} catch (e) {
		omc.logger.addEntry("######### PreferitiApp.init ECCEZIONE : "+e.message);
		this._objErrorInfo._methodName = "init";
		this._objErrorInfo._obException = e;
		this.handleError();
	}
};

PreferitiApp.prototype.fin = function() {
	try {
		this.ImagePreferitiTempOn = null;
		this.ImagePreferitiTempOff = null;
		this.ListaFavoritiTemp = null;
	} catch (e) {
		this._objErrorInfo._methodName = "fin";
		this._objErrorInfo._obException = e;
		this.handleError();
	}
};

/*******************************************************************************
 * FUNCTION: manageSectionActivity PARAMETRI: action (stringa) DESCRIPTION: la
 * funzione gestisce in maniera centralizzata gli eventi lanciati dal
 * telecomando
 ******************************************************************************/
PreferitiApp.prototype.manageSectionActivity = function(action) {
	try {
		if (this.fw.OMC_LOGGER_ENABLED)
			omc.logger.addEntry("######### PreferitiApp ---- ###### PreferitiApp.manageSectionActivity "+ action+" this.modificaFav: "+this.modificaFav+" this.attivatoListaPreferitiExtApp: "+this.attivatoListaPreferitiExtApp+" this.salvatoListaPreferiti: "+this.salvatoListaPreferiti+" this.modificatListaFav: "+this.modificatListaFav);
		var strIcon = "Counter_sx_";
		var canaleFav_on = '/ovaImages/canale_pref_on.png';
		var canaleFav_off = '/ovaImages/canale_pref_off.png';
		var canale_arrow_on = '/ovaImages/restyling/arrows/freccia_active_fav.png';
		
		
		if(!this.fw.cgiHasFinished)
			return true;
		
		if (!this.modificaFav)
			switch (this.popUpActionName) {
			case 'esc':
				switch (action) {
				case 'enter':
					this.popUpActionName = "";
					this.fw.getLayoutManager().setLayoutVisible("exitWithoutSave",
							false);
					this.checkExit = false;
					this.eventKeyBack();
					break;
					/*
				case 'back':
				case 'esc':
					this.popUpActionName = "";
					this.fw.getLayoutManager().setLayoutVisible("exitWithoutSave",
							false);
					break;
					*/
				default:
					break;
	
				}
				return true;
				break;
	
			case 'attiva':
				switch (action) {
				case 'enter':
					this.popUpActionName = "";
					this.fw.getLayoutManager().setLayoutVisible("exitWithoutSave",false);
					this.checkExit = false;
					this.fw.ShowPreferiti = 1;					
					this.attivaListaPreferiti();
					break;
					/*
				case 'back':
				case 'esc':
					this.popUpActionName = "";
					this.fw.getLayoutManager().setLayoutVisible("exitWithoutSave",
							false);
					break;
					*/
				default:
					break;
	
				}
				return true;
				break;
	
			default:
				break;
	
			}
		if(this.attivatoListaPreferitiExtApp){
			if(action=='enter'){
				this.fw.getLayoutManager().setLayoutVisible("attivatoListaPreferiti", false);
				this.attivatoListaPreferitiExtApp = false;
				this.fw.getLayoutManager().setLayoutVisible("caricamentoInCorso",true);
				this.writeOnPopUp("caricamentoInCorso", null,"/ovaImages/caricamentoInCorso.gif", 0);
				this.eventKeyEsc();
				return true;
			}else
				return true;
		}
		if(this.salvatoListaPreferiti){
			if(action=='enter'){
				this.fw.getLayoutManager().setLayoutVisible("salvaListaPreferiti", false);
				this.salvatoListaPreferiti = false;
				return true;
			}else
				return true;
		}
		
		switch (action) {
		case 'left':
			if (this.getNavigationPositionPanel() == this.rightPanel) {
				if (this.modificaFav)
					return true;
				this.setNavigationPositionPanel(this.leftPanel);
				this.fillEpgGridLayers('down', true);
				var selectedIndex = this.getSelectedChannelPreferiti()	% this.LevelSize;
				this.referImageToLayout(this._layoutId, this.frecce+ (selectedIndex + 1), this.onePixClear);
				this.referImageToLayout(this._layoutId,'Tab_dx_' + (selectedIndex + 1),this.ImagePreferitiTempOff[this.ListaFavoritiTemp[this._mySelectedChannelPreferiti].chanrecid].src);
				if(this.modificatListaFav){
					this.referImageToLayout(this._layoutId, this.bottoneATTIVA_Label, this.onePixClear);
					this.referImageToLayout(this._layoutId, this.bottoneSALVA_Label, this.bottoneSALVA);
				}else{
					this.referImageToLayout(this._layoutId, this.bottoneATTIVA_Label, this.bottoneATTIVA);
					this.referImageToLayout(this._layoutId, this.bottoneSALVA_Label, this.onePixClear);
				}
				


			}
			break;

		case 'right':
			if (this.getNavigationPositionPanel() == this.leftPanel) {
				if (this.fw.OMC_LOGGER_ENABLED)
					omc.logger
							.addEntry("######### PreferitiApp ---- this.ListaFavoritiTemp.length: "
									+ this.ListaFavoritiTemp.length);
				if (this.ListaFavoritiTemp.length != 0) {
					this.setNavigationPositionPanel(this.rightPanel);
					var selectedIndex = this.getSelectedChannel()
							% this.LevelSize;
					this
							.referImageToLayout(
									this._layoutId,
									'Tab_sx_' + (selectedIndex + 1),
									this.fw.ImageLibOffCGI[this.listaZapperCanali[this._mySelectedChannel].chanrecid].src);
					if (this
							.isCanaleDefaultInPreferiti(this.listaZapperCanali[this._mySelectedChannel].ChanName)) {
						this.referImageToLayout(this._layoutId, strIcon
								+ (selectedIndex + 1), canaleFav_off);
					} else {
						this.referImageToLayout(this._layoutId, strIcon
								+ (selectedIndex + 1), this.onePixClear);
					}
					this.fillEpgGridLayersPreferiti('down', true);
				

				}
			}
			break;

		case 'down':
			if (this.getNavigationPositionPanel() == this.leftPanel) {
				if (this._mySelectedChannel < this.listaZapperCanali.length - 1) {
					this._myPrevSelectedChannel = this._mySelectedChannel;
					this._mySelectedChannel++;
				} else {
					this._myPrevSelectedChannel = this._mySelectedChannel;
					this._mySelectedChannel = 0;
				}
				this.fillEpgGridLayers(action, false);
			} else {

				if (this.modificaFav) {
					if (this._mySelectedChannelPreferiti < this.ListaFavoritiTemp.length - 1) {
						this.spostaPreferito('down');
						return true;
					} else
						return true;
				}

				if (this._mySelectedChannelPreferiti < this.ListaFavoritiTemp.length - 1) {
					this._myPrevSelectedChannelPreferiti = this._mySelectedChannelPreferiti;
					this._mySelectedChannelPreferiti++;
				} else {
					this._myPrevSelectedChannelPreferiti = this._mySelectedChannelPreferiti;
					this._mySelectedChannelPreferiti = 0;
				}
				this.fillEpgGridLayersPreferiti(action, false);
			}
			break;

		case 'up':
			if (this.getNavigationPositionPanel() == this.leftPanel) {
				if (this._mySelectedChannel > 0) {
					this._myPrevSelectedChannel = this._mySelectedChannel;
					this._mySelectedChannel--;
					this.fillEpgGridLayers(action, false);
				} else {
					this._mySelectedChannel = this.listaZapperCanali.length - 1;
					this.fillEpgGridLayers(action, true);
				}
			} else {

				if (this.modificaFav) {
					if (this._mySelectedChannelPreferiti > 0) {
						this.spostaPreferito('up');
						return true;
					} else
						return true;
				}

				if (this._mySelectedChannelPreferiti > 0) {
					this._myPrevSelectedChannelPreferiti = this._mySelectedChannelPreferiti;
					this._mySelectedChannelPreferiti--;
					this.fillEpgGridLayersPreferiti(action, false);
				} else {
					this._mySelectedChannelPreferiti = this.ListaFavoritiTemp.length - 1;
					this.fillEpgGridLayersPreferiti(action, true);
				}
			}
			break;

		case 'enter':
			if (this.getNavigationPositionPanel() == this.leftPanel) {
				if (!this
						.isCanaleDefaultInPreferiti(this.listaZapperCanali[this._mySelectedChannel].ChanName)) {
					this
							.aggiungoCanaleToPreferiti(this.listaZapperCanali[this._mySelectedChannel]);

				}
			} else if (this.getNavigationPositionPanel() == this.rightPanel) {
				if (this.modificaFav) {
					if (this.fw.OMC_LOGGER_ENABLED)omc.logger.addEntry("######### PreferitiApp ESCO DALLA MODALITA' MODIFICA PREFERITI: "+ this._mySelectedChannelPreferiti);
					this.modificaFav = false;
					this.referImageToLayout(this._layoutId, this.frecce+ (this._mySelectedChannelPreferiti% this.LevelSize + 1), this.onePixClear);
					
			
				
					
					if(this.modificatListaFav){
						this.referImageToLayout(this._layoutId, this.bottoneATTIVA_Label, this.onePixClear);
						this.referImageToLayout(this._layoutId, this.bottoneSALVA_Label, this.bottoneSALVA);
					}else{
						this.referImageToLayout(this._layoutId, this.bottoneATTIVA_Label, this.bottoneATTIVA);
						this.referImageToLayout(this._layoutId, this.bottoneSALVA_Label, this.onePixClear);
					}
					
					
					this.referImageToLayout(this._layoutId, this.bottoneELIMINA_Label, this.bottoneELIMINA);
					this.referImageToLayout(this._layoutId, this.bottoneBACK_Label, this.bottoneBACK);
					
				} else {
					if (this.fw.OMC_LOGGER_ENABLED)
						omc.logger
								.addEntry("######### PreferitiApp ENTRO NELLA MODALITA' MODIFICA PREFERITI: "
										+ this._mySelectedChannelPreferiti);
					this.modificaFav = true;
					this.referImageToLayout(this._layoutId, this.frecce	+ (this._mySelectedChannelPreferiti% this.LevelSize + 1),this.frecce_muovi_fav);
					
					if(this._mySelectedChannelPreferiti == 0){
						this.referImageToLayout(this._layoutId, this.frecce	+ (this._mySelectedChannelPreferiti% this.LevelSize + 1),this.frecce_muovi_fav_down);
					}else if(this._mySelectedChannelPreferiti == this.ListaFavoritiTemp.length -1){
						this.referImageToLayout(this._layoutId, this.frecce	+ (this._mySelectedChannelPreferiti% this.LevelSize + 1),this.frecce_muovi_fav_up);
					}
					
					this.referImageToLayout(this._layoutId, this.bottoneATTIVA_Label, this.onePixClear);
					this.referImageToLayout(this._layoutId, this.bottoneSALVA_Label, this.onePixClear);
					this.referImageToLayout(this._layoutId, this.bottoneELIMINA_Label, this.onePixClear);
					this.referImageToLayout(this._layoutId, this.bottoneBACK_Label, this.onePixClear);

				}

			}

			break;

		case 'scrollUp':
			break;

		case 'scrollDown':
			break;

		case 'info':
			this.fw.getLayoutManager().setLayoutVisible("caricamentoInCorso",true);
			if(this.modificaFav)
				this.modificaFav = false;
			this.referImageToLayout(this._layoutId, this.bottoneATTIVA_Label, this.bottoneATTIVA);
			this.referImageToLayout(this._layoutId, this.bottoneSALVA_Label, this.bottoneSALVA);
			this.referImageToLayout(this._layoutId, this.bottoneELIMINA_Label, this.bottoneELIMINA);
			this.referImageToLayout(this._layoutId, this.bottoneBACK_Label, this.bottoneBACK);
			this.referImageToLayout(this._layoutId, this.frecce+ (this._mySelectedChannelPreferiti% this.LevelSize + 1), this.onePixClear);
			this.fw.helpPreferitiFromPreferiti = true;
			this.loadApp("/ovaServices/getapp/GetAppHelpPreferiti.html?urlapp=help&app1=HelpPreferiti");
			break;

		case 'hot1':
			if (this.modificaFav) {

				return true;
			}
			if (this.getNavigationPositionPanel() == this.rightPanel) {
				if (this.ListaFavoritiTemp.length > 0) {
					this.zapElement = this.getZapperElement();
		//			var NewLista = new Array();
		//			this.NewLista = new Array();
					//Svuoto appoggio
					var lunghezzaArrayAppoggio =  this.NewLista.length;				
					for (i = 0; i <lunghezzaArrayAppoggio; i++) {
						this.NewLista.pop();						
					}
				
					var z = 0;
					//Popolo appoggio con gli elementi non eliminati
					for (i = 0; i < this.ListaFavoritiTemp.length; i++) {
						if (i != this._mySelectedChannelPreferiti) {
		//					NewLista[z] = this.ListaFavoritiTemp[i];
							this.NewLista.push(this.ListaFavoritiTemp[i]);
							z++;
						}
					}
		//			this.ListaFavoritiTemp = NewLista;
					//this.ListaFavoritiTemp = this.NewLista;
					
					//Svuoto la lista temperanea
					var lunghezzaArrayTemp =  this.ListaFavoritiTemp.length;				
					for (i = 0; i <lunghezzaArrayTemp; i++) {
						this.ListaFavoritiTemp.pop();						
					}
					
					//copio in temp gli elementi di appoggio
					lunghezzaArrayAppoggio =  this.NewLista.length;				
					for (i = 0; i <lunghezzaArrayAppoggio; i++) {
						this.ListaFavoritiTemp.push(this.NewLista[i]);						
					}
					
					
					if (this.ListaFavoritiTemp.length != 0) {
						if (this._mySelectedChannelPreferiti > (this.ListaFavoritiTemp.length - 1)) {
							this._mySelectedChannelPreferiti--;
						}
						this.fillEpgGridLayersPreferiti('down', true);

					} else {
						this.setNavigationPositionPanel(this.leftPanel);
						this.fillEpgGridLayers('down', true);
						this.referImageToLayout(this._layoutId, 'Tab_dx_1',	this.onePixClear);
					}
					this.checkAllDefaultInPreferiti();
					var selectedIndex = this.getSelectedChannel()% this.LevelSize;

					if (this.ListaFavoritiTemp.length != 0) {
						this.referImageToLayout(this._layoutId,'Tab_sx_' + (selectedIndex + 1),this.fw.ImageLibOffCGI[this.listaZapperCanali[this._mySelectedChannel].chanrecid].src);
						if (this.isCanaleDefaultInPreferiti(this.listaZapperCanali[this._mySelectedChannel].ChanName)) {
							this.referImageToLayout(this._layoutId, strIcon+ (selectedIndex + 1), canaleFav_off);
						} else {
							this.referImageToLayout(this._layoutId, strIcon+ (selectedIndex + 1), this.onePixClear);
						}
					}
					this.modificatListaFav = true;
					this.referImageToLayout(this._layoutId, this.bottoneATTIVA_Label, this.onePixClear);
					this.referImageToLayout(this._layoutId, this.bottoneSALVA_Label, this.bottoneSALVA);
					omc.logger.addEntry("######### PreferitiApp ---- ###### PreferitiApp.manageSectionActivity "+ action+" this.modificatListaFav: "+this.modificatListaFav);						
					
				

				}
			}
			break;
		case 'hot2': // SALVA LISTA
			if (this.modificaFav || !this.modificatListaFav) {

				return true;
			}
			try {
				if (this.fw.OMC_LOGGER_ENABLED)
					omc.logger
							.addEntry("######### PreferitiApp.eventKeyHot2 ### 1 ###");
				this.fw.getLayoutManager().setLayoutVisible(
						"caricamentoInCorso", true);
				this.writeOnPopUp("caricamentoInCorso", null,
						"/ovaImages/caricamentoInCorso.gif", 0);
				this.salvaListaPreferiti();
			} catch (e) {
				if (this.fw.OMC_LOGGER_ENABLED)	omc.logger.addEntry("######### PreferitiApp SALVATAGGIO FILE");
				this.handleError();

			}
			break;

		case 'hot3':

			break;

		case 'hot4': // ATTIVA LISTA PREFERITI
			// E' stato disabilitato il tasto attiva (vedi mail del 31/03/09)
			return true;
			if (this.ListaFavoritiTemp.length == 0 || this.modificaFav || this.modificatListaFav)
				return true;		
			if (this.isModificheSenzaSalvataggio() && this.checkExit) {
				this.popUpActionName = "attiva";
				omc.logger.addEntry("############## ATTIVA ATTENZIONE CI SONO DELLE MODIFICHE CHE NON HAI SALVATO!!!!!!!!");
				this.fw.getLayoutManager().setLayoutVisible("exitWithoutSave",true);
				this.writeOnPopUp("exitWithoutSave", null,"/ovaImages/exitWithoutSave.png", 0);
				// LOAD POPUP
				return true;
			}
			this.attivaListaPreferiti();

			break;

		case 'esc':
			try {

				if (this.isModificheSenzaSalvataggio() && this.checkExit) {
					this.popUpActionName = "esc";
					omc.logger
							.addEntry("############## ESC ATTENZIONE CI SONO DELLE MODIFICHE CHE NON HAI SALVATO!!!!!!!!");
					this.fw.getLayoutManager().setLayoutVisible(
							"exitWithoutSave", true);
					this.writeOnPopUp("exitWithoutSave", null,
							"/ovaImages/exitWithoutSave.png", 0);
					return true;
				}
				if (this.fw.ListaFavoriti.length == 0)
					this.fw.ShowPreferiti = 0;
				this.fw.getLayoutManager().setLayoutVisible(
						"caricamentoInCorso", true);
				this.writeOnPopUp("caricamentoInCorso", null,
						"/ovaImages/caricamentoInCorso.gif", 0);

				if (this.fw.OMC_LOGGER_ENABLED)
					omc.logger
							.addEntry("############## PreferitiApp.eventKeyEsc this.ListaFavoritiTemp.length: "
									+ this.ListaFavoritiTemp.length);
				if (this.fw.OMC_LOGGER_ENABLED)
					omc.logger
							.addEntry("##############à  PreferitiApp.eventKeyEsc this.fw.ListaFavoriti.length: "
									+ this.fw.ListaFavoriti.length);
				this.modificaFav = false;
				this.checkExit = true;
				
				this.loadApp(this.getHomeUrl(), null, null, null, null);
			} catch (e) {
				this._objErrorInfo._methodName = "eventKeyEsc";
				this._objErrorInfo._obException = e;
				this.handleError();
			}
			break;

		case 'back':

			try {
				if (this.modificaFav) {
					return true;
				}
				if (this.isModificheSenzaSalvataggio() && this.checkExit) {
					this.popUpActionName = "esc";
					this.fw.getLayoutManager().setLayoutVisible(
							"exitWithoutSave", true);
					this.writeOnPopUp("exitWithoutSave", null,
							"/ovaImages/exitWithoutSave.png", 0);
					omc.logger
							.addEntry("############## BACK ATTENZIONE CI SONO DELLE MODIFICHE CHE NON HAI SALVATO!!!!!!!!");
					return true;
				}
				if (this.fw.ListaFavoriti.length == 0)
					this.fw.ShowPreferiti = 0;
				this.fw.getLayoutManager().setLayoutVisible(
						"caricamentoInCorso", true);
				this.writeOnPopUp("caricamentoInCorso", null,
						"/ovaImages/caricamentoInCorso.gif", 0);

				if (this.fw.OMC_LOGGER_ENABLED)
					omc.logger
							.addEntry("############## PreferitiApp.eventKeyBack this.ListaFavoritiTemp.length: "
									+ this.ListaFavoritiTemp.length);
				if (this.fw.OMC_LOGGER_ENABLED)
					omc.logger
							.addEntry("##############à  PreferitiApp.eventKeyBack this.fw.ListaFavoriti.length: "
									+ this.fw.ListaFavoriti.length);

				this.modificaFav = false;
				this.fw.backFromExApp = true;
				this.checkExit = true;
				
				this.loadApp(this.getHomeUrl(), null, null, null, null);
			} catch (e) {
				this._objErrorInfo._methodName = "eventKeyBack";
				this._objErrorInfo._obException = e;
				this.handleError();
			}
			break;

		case 'eye':
			break;

		case 'options':
			break;

		default:
			return true;
			break;
		}
	} catch (ecc) {
		this._objErrorInfo._methodName = "manageSectionActivity";
		this._objErrorInfo._obException = ecc;
		this.handleError();
	}
};

PreferitiApp.prototype.isModificheSenzaSalvataggio = function() {

	try {
		if (this.ListaFavoritiTemp.length != this.fw.ListaFavoriti.length) {
			omc.logger
					.addEntry("######## isModificheSenzaSalvataggio this.ListaFavoritiTemp.length: "
							+ this.ListaFavoritiTemp.length
							+ "this.fw.ListaFavoriti.length :"
							+ this.fw.ListaFavoriti.length);
			return true;
		}
		for (f = 0; f < this.ListaFavoritiTemp.length; f++) {
			if (this.ListaFavoritiTemp[f].chanrecid != this.fw.ListaFavoriti[f].chanrecid) {
				omc.logger
						.addEntry("######## isModificheSenzaSalvataggio this.ListaFavoritiTemp[f].ChanName: "
								+ this.ListaFavoritiTemp[f].ChanName
								+ "this.fw.ListaFavoriti[f].ChanName :"
								+ this.fw.ListaFavoriti[f].ChanName);
				return true;
			}
		}

	} catch (e) {
		omc.logger.addEntry("ECCEZIONE PreferitiApp.isModificheSenzaSalvataggio ecc: "	+ e.message);
		this.handleError();
	}

	return false;

};

PreferitiApp.prototype.EventImageUpdated = function() {
	if (this.fw.OMC_LOGGER_ENABLED)
		omc.logger
				.addEntry("################     PreferitiApp.EventImageUpdated CALLBACK errorcode: "
						+ obj.errorCode);
	if (this.fw.OMC_LOGGER_ENABLED)
		omc.logger
				.addEntry("######### PreferitiApp ---- Generazione img preferiti effettuata con SUCCESSO!!");

	this.fw.getTimer().setTimeout(10, this.aggiornaFileHTMLCanaliPref, this);

	return true;

};
PreferitiApp.prototype.attivaListaPreferiti = function() {
	try{
		if (this.fw.OMC_LOGGER_ENABLED)omc.logger.addEntry("######## PreferitiApp.attivaListaPreferiti this.fw.ShowPreferiti: "+this.fw.ShowPreferiti);
		if (this.fw.ListaFavoriti.length == 0){
			this.fw.ShowPreferiti = 0;
			this.fw.getLayoutManager().setLayoutVisible("caricamentoInCorso",true);
			this.writeOnPopUp("caricamentoInCorso", null,"/ovaImages/caricamentoInCorso.gif", 0);
			this.salvaFileBootHTML();
			this.eventKeyEsc();
			return true;
		}
		
		
		if (this.fw.ShowPreferiti == 0){
			this.fw.getLayoutManager().setLayoutVisible("attivatoListaPreferiti", true);
			this.attivatoListaPreferitiExtApp = true;			
			this.fw.ShowPreferiti = 1;
			this.salvaFileBootHTML();
		}else{			
			this.fw.getLayoutManager().setLayoutVisible("caricamentoInCorso",true);
			this.writeOnPopUp("caricamentoInCorso", null,"/ovaImages/caricamentoInCorso.gif", 0);
			this.salvaFileBootHTML();
			this.eventKeyEsc();
		}
		
		
	}catch(e){
		omc.logger.addEntry("ECCZIONE PreferitiApp.attivaListaPreferiti ecc: "+e.message);
		this.handleError();
		
	}
};
PreferitiApp.prototype.aggiungoCanaleToPreferiti = function(canaleDaAggiungere) {

	try {
		if (this.fw.OMC_LOGGER_ENABLED)
			omc.logger.addEntry("######### PreferitiApp.aggiungoCanaleToPreferiti ### 1 ### "+ canaleDaAggiungere.ChanName);
		this.ImagePreferitiTempOff[canaleDaAggiungere.chanrecid] = new Image(200, 34);
		this.ImagePreferitiTempOn[canaleDaAggiungere.chanrecid] = new Image(200,34);
		if (this.fw.OMC_LOGGER_ENABLED)
			omc.logger.addEntry("######### PreferitiApp.aggiungoCanaleToPreferiti ### 2 ### "+ this.fw.ImageLibOffCGI[canaleDaAggiungere.chanrecid].src);
		this.ImagePreferitiTempOff[canaleDaAggiungere.chanrecid].src = this.fw.ImageLibOffCGI[canaleDaAggiungere.chanrecid].src;
		this.ImagePreferitiTempOn[canaleDaAggiungere.chanrecid].src = this.fw.ImageLibOnCGI[canaleDaAggiungere.chanrecid].src;
		if (this.fw.OMC_LOGGER_ENABLED)
			omc.logger.addEntry("######### PreferitiApp.aggiungoCanaleToPreferiti ### 3 ###");

		omc.logger.addEntry("############## PreferitiApp.aggiungoCanaleToPreferiti this.ListaFavoritiTemp.length: "+ this.ListaFavoritiTemp.length);
		omc.logger.addEntry("##############  PreferitiApp.aggiungoCanaleToPreferiti this.fw.ListaFavoriti.length: "+ this.fw.ListaFavoriti.length);
/*
		var NewLista = new Array();
		for (i = 0; i < this.ListaFavoritiTemp.length; i++) {
			NewLista[i] = this.ListaFavoritiTemp[i];
		}
*/
	//	this.ListaFavoritiTemp[this.ListaFavoritiTemp.length] = canaleDaAggiungere;
		//this.ListaFavoritiTemp = NewLista;
		 this.ListaFavoritiTemp.push(canaleDaAggiungere);
		if (this.fw.OMC_LOGGER_ENABLED)
			omc.logger.addEntry("############## PreferitiApp.aggiungoCanaleToPreferiti this.ListaFavoritiTemp.length: "+ this.ListaFavoritiTemp.length);
		if (this.fw.OMC_LOGGER_ENABLED)
			omc.logger.addEntry("##############à  PreferitiApp.aggiungoCanaleToPreferiti this.fw.ListaFavoriti.length: "+ this.fw.ListaFavoriti.length);

		this.fillEpgGridLayersPreferiti('down', true);

		if (this.fw.OMC_LOGGER_ENABLED)
			omc.logger.addEntry("######### PreferitiApp.aggiungoCanaleToPreferiti ---- Canale:"+ this.listaZapperCanali[this._mySelectedChannel].ChanName+ " AGGIUNTO!!! NELLA LISTA PREFERITI");
		if (this.fw.OMC_LOGGER_ENABLED)
			omc.logger.addEntry("######### PreferitiApp.aggiungoCanaleToPreferiti ---- this._mySelectedChannelPreferiti: "+ this._mySelectedChannelPreferiti);
		var selectedIndex = this.getSelectedChannelPreferiti() % this.LevelSize;
		if (this.fw.OMC_LOGGER_ENABLED)
			omc.logger.addEntry("######### PreferitiApp.aggiungoCanaleToPreferiti ---- this.listaZapperCanali.length: "+ this.listaZapperCanali.length);
		if (this.fw.OMC_LOGGER_ENABLED)
			omc.logger.addEntry("######### PreferitiApp.aggiungoCanaleToPreferiti ---- Spengo nella lista pref : "+ (selectedIndex + 1)+ " "+ this.ImagePreferitiTempOff[this.ListaFavoritiTemp[this._mySelectedChannelPreferiti].chanrecid].src);
		this.referImageToLayout(this._layoutId,'Tab_dx_' + (selectedIndex + 1),	this.ImagePreferitiTempOff[this.ListaFavoritiTemp[this._mySelectedChannelPreferiti].chanrecid].src);

		this.checkAllDefaultInPreferiti();
		
		this.modificatListaFav = true;
		this.referImageToLayout(this._layoutId, this.bottoneATTIVA_Label, this.onePixClear);
		this.referImageToLayout(this._layoutId, this.bottoneSALVA_Label, this.bottoneSALVA);
		
		
	} catch (e) {
		omc.logger.addEntry("########## PreferitiApp.aggiungoCanaleToPreferiti ECCEZIONE: "	+ e.message);
		this.handleError();

	}

	return true;

};

PreferitiApp.prototype.eventKeyEye = function() {

	return true;

};

PreferitiApp.prototype.eventKeyDown = function() {
	try {
		this.manageSectionActivity('down');
	} catch (ecc) {
		this._objErrorInfo._methodName = "eventKeyDown";
		this._objErrorInfo._obException = ecc;
		this.handleError();
	} finally {
		return true;
	}
};

PreferitiApp.prototype.eventKeyUp = function() {
	try {
		this.manageSectionActivity('up');
	} catch (ecc) {
		this._objErrorInfo._methodName = "eventKeyUp";
		this._objErrorInfo._obException = ecc;
		this.handleError();

	} finally {
		return true;
	}
};

PreferitiApp.prototype.eventKeyLeft = function() {
	try {
		this.manageSectionActivity('left');
	} catch (ecc) {
		this._objErrorInfo._methodName = "eventKeyLeft";
		this._objErrorInfo._obException = ecc;
		this.handleError();
	} finally {
		return true;
	}
};

PreferitiApp.prototype.eventKeyHot1 = function() {
	try {
		this.manageSectionActivity('hot1');
	} catch (ecc) {
		this._objErrorInfo._methodName = "eventKeyHot1";
		this._objErrorInfo._obException = ecc;
		this.handleError();
	} finally {
		return true;
	}
};
PreferitiApp.prototype.eventKeyHot2 = function() {
	try {
		this.manageSectionActivity('hot2');
	} catch (ecc) {
		this._objErrorInfo._methodName = "eventKeyHot2";
		this._objErrorInfo._obException = ecc;
		this.handleError();
	} finally {
		return true;
	}
};
PreferitiApp.prototype.eventKeyHot3 = function() {
	try {
		this.manageSectionActivity('hot3');
	} catch (ecc) {
		this._objErrorInfo._methodName = "eventKeyHot3";
		this._objErrorInfo._obException = ecc;
		this.handleError();
	} finally {
		return true;
	}
};
PreferitiApp.prototype.eventKeyHot4 = function() {
	try {
		this.manageSectionActivity('hot4');
	} catch (ecc) {
		this._objErrorInfo._methodName = "eventKeyHot4";
		this._objErrorInfo._obException = ecc;
		this.handleError();
	} finally {
		return true;
	}
};

PreferitiApp.prototype.eventKeyEnter = function() {
	try {
		this.manageSectionActivity('enter');
	} catch (ecc) {
		this._objErrorInfo._methodName = "eventKeyLeft";
		this._objErrorInfo._obException = ecc;
		this.handleError();
	} finally {
		return true;
	}
};

PreferitiApp.prototype.eventKeyInfo = function() {
	try {
		this.manageSectionActivity('info');
	} catch (ecc) {
		this._objErrorInfo._methodName = "eventKeyInfo";
		this._objErrorInfo._obException = ecc;
		this.handleError();
	} finally {
		return true;
	}
};

PreferitiApp.prototype.eventKeyRight = function() {
	try {
		this.manageSectionActivity('right');
	} catch (ecc) {
		this._objErrorInfo._methodName = "eventKeyRight";
		this._objErrorInfo._obException = ecc;
		this.handleError();
	} finally {
		return true;
	}
};

PreferitiApp.prototype.eventKeyScrollUp = function() {
	try {
		this.manageSectionActivity('scrollUp');
	} catch (ecc) {
		this._objErrorInfo._methodName = "eventKeyScrollUp";
		this._objErrorInfo._obException = ecc;
		this.handleError();
	} finally {
		return true;
	}
};

PreferitiApp.prototype.eventKeyScrollDown = function() {
	try {
		this.manageSectionActivity('scrollDown');
	} catch (ecc) {
		this._objErrorInfo._methodName = "eventKeyScrollDown";
		this._objErrorInfo._obException = ecc;
		this.handleError();
	} finally {
		return true;
	}
};

PreferitiApp.prototype.eventKeyBack = function() {

	try {
		this.manageSectionActivity('back');
	} catch (ecc) {
		this._objErrorInfo._methodName = "eventKeyBack";
		this._objErrorInfo._obException = ecc;
		this.handleError();
	} finally {
		return true;
	}

}

PreferitiApp.prototype.eventKeyEsc = function() {

	try {
		this.manageSectionActivity('esc');
	} catch (ecc) {
		this._objErrorInfo._methodName = "eventKeyEsc";
		this._objErrorInfo._obException = ecc;
		this.handleError();
	} finally {
		return true;
	}

};

PreferitiApp.prototype.eventKeyPower = function(riavvioForzato) {
	try {

		this.popUpActionName = "";
		this.fw.getLayoutManager().setLayoutVisible("exitWithoutSave", false);
		this.fw.getLayoutManager()
				.setLayoutVisible("caricamentoInCorso", false);
		this.fw.backFromExApp = true;
		this.checkExit = true;

		if (riavvioForzato || this.fw.recoveryStatus)
			this.riavvioForzato = true;

		if (this.altStandBy == true) { // controllo per la doppia chiamata in
			// standby
			this.altStandBy = false;
			if (this.fw.power == true || this.fw.power == null) {
				// la funzione spegne il STB

				// la funzione spegne il STB

				this.fw.power = false;
				this.goStandby();

			} else {
				// la funzione riaccende il STB
				this.fw.power = true;
				this.resumeStandby();

			}
			this.fw.getTimer().clearTimeout(this._timePower);
			this._timePower = null;
			this.fw.arrTimer[4] = this._timePower;
			this._timePower = this.fw.getTimer().setTimeout(1000,
					this.abilitaEventKeyPower, this);
		}

		return true;

	} catch (ecc) {
		this._objErrorInfo._methodName = 'eventKeyPower';
		this._objErrorInfo._obException = ecc;
		this.handleError();
	} finally {
		return true;
	}
};

/*******************************************************************************
 * FUNCTION: setNavigationPositionPanel PARAMETRI: directionPanel (intero)
 * DESCRIPTION: Metodo che disegna i bottoni del men� in base allo status
 * passato come parametro
 ******************************************************************************/
PreferitiApp.prototype.setNavigationPositionPanel = function(directionPanel) {
	try {
		this.navigationMenuPanel = directionPanel.toLowerCase();
		this.setPanelArrows();
		return true;
	} catch (ecc) {
		this._objErrorInfo._methodName = "setNavigationPositionPanel";
		this._objErrorInfo._obException = ecc;
		this.handleError();
	}
};

PreferitiApp.prototype.setPanelArrows = function() {
	try {

		if (this.getNavigationPositionPanel() == this.leftPanel) {
			this.referImageToLayout(this._layoutId, this.leftPanelUpperArrow,
					"/ovaImages/restyling/arrows/active_up.png");
			this.referImageToLayout(this._layoutId, this.leftPanelLowerArrow,
					"/ovaImages/restyling/arrows/active_down.png");
			this.referImageToLayout(this._layoutId, this.rightPanelUpperArrow,
					"/ovaImages/restyling/arrows/inactive_up.png");
			this.referImageToLayout(this._layoutId, this.rightPanelLowerArrow,
					"/ovaImages/restyling/arrows/inactive_down.png");

			this.referImageToLayout(this._layoutId, this.bottoneELIMINA_Label,
					this.onePixClear);
			
			
			this.referImageToLayout(this._layoutId, this.titoloCANALI_Label, this.titoloCANALI_ON);
			this.referImageToLayout(this._layoutId, this.titoloPREFERITI_Label, this.titoloPREFERITI_OFF);
		} else {
			this.referImageToLayout(this._layoutId, this.leftPanelUpperArrow,
					"/ovaImages/restyling/arrows/inactive_up.png");
			this.referImageToLayout(this._layoutId, this.leftPanelLowerArrow,
					"/ovaImages/restyling/arrows/inactive_down.png");
			this.referImageToLayout(this._layoutId, this.rightPanelUpperArrow,
					"/ovaImages/restyling/arrows/active_up.png");
			this.referImageToLayout(this._layoutId, this.rightPanelLowerArrow,
					"/ovaImages/restyling/arrows/active_down.png");
			
			this.referImageToLayout(this._layoutId, this.bottoneELIMINA_Label,
					this.bottoneELIMINA);
			
			this.referImageToLayout(this._layoutId, this.titoloCANALI_Label, this.titoloCANALI_OFF);
			this.referImageToLayout(this._layoutId, this.titoloPREFERITI_Label, this.titoloPREFERITI_ON);
		}
	} catch (ecc) {
		this._objErrorInfo._methodName = 'setPanelArrows';
		this._objErrorInfo._obException = ecc;
		this.handleError();
	}
};

/*******************************************************************************
 * FUNCTION: getNavigationPositionPanel PARAMETRI: DESCRIPTION: ritorna il
 * pannello attivo
 ******************************************************************************/
PreferitiApp.prototype.getNavigationPositionPanel = function() {
	try {
		return this.navigationMenuPanel;
	} catch (ecc) {
		this._objErrorInfo._methodName = "getNavigationPositionPanel";
		this._objErrorInfo._obException = ecc;
		this.handleError();
	}
};

PreferitiApp.prototype.fillEpgGridLayers = function(action, forceRedraw) {
	try {
		
		omc.logger.addEntry("######### PreferitiApp fillEpgGridLayers---- ######  ## 1 ##");
		// var size = this.LevelSize;
		var selectedIndex = this.getSelectedChannel() % this.LevelSize;
		var imgTabLevel = 'Tab_sx_';
		// this.onePixClear = '/ovaImages/1pixelclear.gif';

		var strIcon = "Counter_sx_";
		var nomeImg = "/ovaImages/canaleIsFav.png";
		var canaleFav_on = '/ovaImages/canale_pref_on.png';
		var canaleFav_off = '/ovaImages/canale_pref_off.png';
		var canale_arrow_on = '/ovaImages/restyling/arrows/freccia_active_fav.png';

		/*
		if (this.ListaFavoritiTemp.length == 0) {
			this.referImageToLayout(this._layoutId, this.bottoneATTIVA_Label,
					this.onePixClear);
			if (this.fw.OMC_LOGGER_ENABLED)
				omc.logger
						.addEntry("######### PreferitiApp  NASCONDO IL BOTTONE ATTIVA");
		} else {
			this.referImageToLayout(this._layoutId, this.bottoneATTIVA_Label,
					this.bottoneATTIVA);
			if (this.fw.OMC_LOGGER_ENABLED)
				omc.logger
						.addEntry("######### PreferitiApp  MOSTRO IL BOTTONE ATTIVA");
		}
*/
		var initIndex = Math
				.floor((this.getSelectedChannel() / this.LevelSize))
				* this.LevelSize;
		if (this.fw.OMC_LOGGER_ENABLED)
			omc.logger.addEntry("######### PreferitiApp ---- initIndex: "
					+ initIndex + " this.LevelSize: " + this.LevelSize);
		if (this.fw.OMC_LOGGER_ENABLED)
			omc.logger
					.addEntry("######### PreferitiApp ---- this.listaZapperCanali.length: "
							+ this.listaZapperCanali.length);
		for (i = initIndex; i < initIndex + this.LevelSize; i++) {
		
			var indxArray = 0;
			var indxTable = 0;

			if (action == "down" || forceRedraw) {
				// set dei valori per il caso down
				indxArray = i;
				indxTable = i - initIndex;
			} else if (action == "up" || forceRedraw) {
				// set dei valori per il caso up
				indxArray = 2 * initIndex + this.LevelSize - 1 - i;
				indxTable = this.LevelSize - 1 - i + initIndex;
			} else if (action == "left" || forceRedraw) {
				// set dei valori per il caso left
				indxArray = i;
				indxTable = i - initIndex;
			} else if (action == "right" || forceRedraw) {
				// set dei valori per il caso right
				indxArray = i;
				indxTable = i - initIndex;
			}
		
			if (indxArray < this.listaZapperCanali.length) {
		
				if (selectedIndex == indxTable) {
		
					/*
					 * se per esempio initIndex + this.LevelSize vale 11, qui
					 * entra 1 volta per creare il zapperone, tranne quello
					 * selezionato
					 */
					
					try{
						this.referImageToLayout(this._layoutId,imgTabLevel + (indxTable + 1),this.fw.ImageLibOnCGI[this.listaZapperCanali[indxArray].chanrecid].src);
					}catch(e){
						omc.logger.addEntry("ECCEZIONE PreferitiApp.fillEpgGridLayers ImageLibOnCGI");
						this.caricaImmaginiZapperDefault();
						this.handleError();
					}
				
					if (this.isCanaleDefaultInPreferiti(this.listaZapperCanali[indxArray].ChanName)) {
				
						this.referImageToLayout(this._layoutId, strIcon+ (indxTable + 1), canaleFav_on);
					} else {
				
						this.referImageToLayout(this._layoutId, strIcon+ (indxTable + 1), canale_arrow_on);
					}
				} else {
					/*
					 * se per esempio initIndex + this.LevelSize vale 10, qui
					 * entra 9 volte per creare il zapperone, tranne quello
					 * selezionato
					 */
					try{
						this.referImageToLayout(this._layoutId,imgTabLevel + (indxTable + 1),this.fw.ImageLibOffCGI[this.listaZapperCanali[indxArray].chanrecid].src);
					}catch(e){
						omc.logger.addEntry("ECCEZIONE PreferitiApp.fillEpgGridLayers ImageLibOffCGI");
						this.caricaImmaginiZapperDefault();
						this.handleError();
					}
					
				
					if (this.isCanaleDefaultInPreferiti(this.listaZapperCanali[indxArray].ChanName)) {
				
						this.referImageToLayout(this._layoutId, strIcon+ (indxTable + 1), canaleFav_off);
					} else {
				
						this.referImageToLayout(this._layoutId, strIcon+ (indxTable + 1), this.onePixClear);
					}
				}
			} else {
			
				this.referImageToLayout(this._layoutId, imgTabLevel+ (indxTable + 1), this.onePixClear);
			
				this.referImageToLayout(this._layoutId, strIcon+ (indxTable + 1), this.onePixClear);
			
			}
		}
		
		 if(this.modificatListaFav ){
			
			this.referImageToLayout(this._layoutId, this.bottoneSALVA_Label, this.bottoneSALVA);
		}else if(this.ListaFavoritiTemp.length ==0){
			
			this.referImageToLayout(this._layoutId, this.bottoneSALVA_Label, this.onePixClear);
		}else{
			
			this.referImageToLayout(this._layoutId, this.bottoneSALVA_Label, this.onePixClear);
		}
		 
		
		// }
	} catch (ecc) {
		omc.logger.addEntry("ECCEZIONE PreferitiApp.fillEpgGridLayers "+ecc.message);
		this._objErrorInfo._methodName = "fillEpgGridLayers";
		this._objErrorInfo._obException = ecc;
		this.handleError();
	}
};

/** ********************************************************* */
PreferitiApp.prototype.switchFocus = function(action) {
	try {
		// var onePixClear = '/ovaImages/1pixelclear.gif';
		var rows = this.LevelSize;
		var index = this._mySelectedChannel % rows;
		var index_prev = (action == 'up') ? index + 1 : index - 1;

		var imgTabLevel = 'Tab_sx_';
		var strIcon = "Counter_sx_";
		var canaleFav_on = '/ovaImages/canale_pref_on.png';
		var canaleFav_off = '/ovaImages/canale_pref_off.png';
		var canale_arrow_on = '/ovaImages/restyling/arrows/freccia_active_fav.png';
		if (action == 'up') {
			this
					.referImageToLayout(
							this._layoutId,
							imgTabLevel + (index_prev + 1),
							this.fw.ImageLibOffCGI[this.listaZapperCanali[this._myPrevSelectedChannel].chanrecid].src);
			this
					.referImageToLayout(
							this._layoutId,
							imgTabLevel + (index + 1),
							this.fw.ImageLibOnCGI[this.listaZapperCanali[this._mySelectedChannel].chanrecid].src);
			if (this
					.isCanaleDefaultInPreferiti(this.listaZapperCanali[this._myPrevSelectedChannel].ChanName)) {
				this.referImageToLayout(this._layoutId, strIcon
						+ (index_prev + 1), canaleFav_off);
			} else {
				this.referImageToLayout(this._layoutId, strIcon
						+ (index_prev + 1), this.onePixClear);
			}
			if (this
					.isCanaleDefaultInPreferiti(this.listaZapperCanali[this._mySelectedChannel].ChanName)) {
				this.referImageToLayout(this._layoutId, strIcon + (index + 1),
						canaleFav_on);
			} else {
				this.referImageToLayout(this._layoutId, strIcon + (index + 1),
						canale_arrow_on);
			}
		} else {
			this
					.referImageToLayout(
							this._layoutId,
							imgTabLevel + (index_prev + 1),
							this.fw.ImageLibOffCGI[this.listaZapperCanali[this._myPrevSelectedChannel].chanrecid].src);
			this
					.referImageToLayout(
							this._layoutId,
							imgTabLevel + (index + 1),
							this.fw.ImageLibOnCGI[this.listaZapperCanali[this._mySelectedChannel].chanrecid].src);
			if (this
					.isCanaleDefaultInPreferiti(this.listaZapperCanali[this._myPrevSelectedChannel].ChanName)) {
				this.referImageToLayout(this._layoutId, strIcon
						+ (index_prev + 1), canaleFav_off);
			} else {
				this.referImageToLayout(this._layoutId, strIcon
						+ (index_prev + 1), this.onePixClear);
			}
			if (this
					.isCanaleDefaultInPreferiti(this.listaZapperCanali[this._mySelectedChannel].ChanName)) {
				this.referImageToLayout(this._layoutId, strIcon + (index + 1),
						canaleFav_on);
			} else {
				this.referImageToLayout(this._layoutId, strIcon + (index + 1),
						canale_arrow_on);
			}
		}
	} catch (ecc) {
		this._objErrorInfo._methodName = 'switchFocus';
		this._objErrorInfo._obException = ecc;
		this.handleError();
	}
};

PreferitiApp.prototype.fillEpgGridLayersPreferiti = function(action,
		forceRedraw) {
	try {
		// var size = this.LevelSize;
		var selectedIndex = this.getSelectedChannelPreferiti() % this.LevelSize;
		var imgTabLevel = 'Tab_dx_';
		// var onePixClear = '/ovaImages/1pixelclear.gif';

		if ((forceRedraw != true && !(selectedIndex == 0 && action == 'down') && !(selectedIndex == (this.LevelSize - 1) && action == 'up'))) {
			if (this.fw.OMC_LOGGER_ENABLED)
				omc.logger
						.addEntry("######### PreferitiApp ---- Sono dentro ............. che scorro ");
			this.switchFocusPreferiti(action);
		} else {
			if (forceRedraw != true) {
				// prima di ridisegnare la nuova pagina spengo l'ultimo elemento
				// visitato
				// per evitare il problema del doppio focus
				var index_prev = this._myPrevSelectedChannelPreferiti
						% this.LevelSize;
				if (action == 'up') {
					this.referImageToLayout(this._layoutId, this.frecce
							+ (index_prev + 1), this.onePixClear);
					this
							.referImageToLayout(
									this._layoutId,
									imgTabLevel + (index_prev + 1),
									this.ImagePreferitiTempOff[this.ListaFavoritiTemp[this._myPrevSelectedChannelPreferiti].chanrecid].src);
				} else {
					this.referImageToLayout(this._layoutId, this.frecce
							+ (index_prev + 1), this.onePixClear);
					this
							.referImageToLayout(
									this._layoutId,
									imgTabLevel + (index_prev + 1),
									this.ImagePreferitiTempOff[this.ListaFavoritiTemp[this._myPrevSelectedChannelPreferiti].chanrecid].src);
				}
			}

			var initIndex = Math
					.floor((this.getSelectedChannelPreferiti() / this.LevelSize))
					* this.LevelSize;
			if (this.fw.OMC_LOGGER_ENABLED)
				omc.logger.addEntry("######### PreferitiApp ---- initIndex: "
						+ initIndex + " this.LevelSize: " + this.LevelSize);
			if (this.fw.OMC_LOGGER_ENABLED)
				omc.logger
						.addEntry("######### PreferitiApp ---- this.preferiti.length: "
								+ this.ListaFavoritiTemp.length);
			for (i = initIndex; i < initIndex + this.LevelSize; i++) {
				var indxArray = 0;
				var indxTable = 0;

				if (action == "down" || forceRedraw) {
					// set dei valori per il caso down
					indxArray = i;
					indxTable = i - initIndex;
				} else if (action == "up" || forceRedraw) {
					// set dei valori per il caso up
					indxArray = 2 * initIndex + this.LevelSize - 1 - i;
					indxTable = this.LevelSize - 1 - i + initIndex;
				} else if (action == "left" || forceRedraw) {
					// set dei valori per il caso left
					indxArray = i;
					indxTable = i - initIndex;
				} else if (action == "right" || forceRedraw) {
					// set dei valori per il caso right
					indxArray = i;
					indxTable = i - initIndex;
				}
				if (this.fw.OMC_LOGGER_ENABLED)
					omc.logger
							.addEntry("######### PreferitiApp ---- indxArray: "
									+ indxArray);
				if (indxArray < this.ListaFavoritiTemp.length) {
					if (selectedIndex == indxTable) {

						/*
						 * se per esempio initIndex + this.LevelSize vale 11,
						 * qui entra 1 volta per creare il zapperone, tranne
						 * quello selezionato
						 */
						if (this.modificaFav)
							this.referImageToLayout(this._layoutId, this.frecce
									+ (indxTable + 1), this.frecce_muovi_fav);

						this
								.referImageToLayout(
										this._layoutId,
										imgTabLevel + (indxTable + 1),
										this.ImagePreferitiTempOn[this.ListaFavoritiTemp[indxArray].chanrecid].src);
					} else {

						if (this.modificaFav)
							this.referImageToLayout(this._layoutId, this.frecce
									+ (indxTable + 1), this.onePixClear);
						/*
						 * se per esempio initIndex + this.LevelSize vale 10,
						 * qui entra 9 volte per creare il zapperone, tranne
						 * quello selezionato
						 */
						 if(this.fw.OMC_LOGGER_ENABLED)omc.logger.addEntry("######### PreferitiApp ---- imgTabLevel+(indxTable+1)"+imgTabLevel+(indxTable+1));
						 if(this.fw.OMC_LOGGER_ENABLED)omc.logger.addEntry("#########PreferitiApp ----ImagePreferitiOn[this.ListaFavoritiTemp[indxArray].ChanName].src"+this.ImagePreferitiTempOff[this.ListaFavoritiTemp[indxArray].chanrecid].src);
						this
								.referImageToLayout(
										this._layoutId,
										imgTabLevel + (indxTable + 1),
										this.ImagePreferitiTempOff[this.ListaFavoritiTemp[indxArray].chanrecid].src);
					}
				} else {

					this.referImageToLayout(this._layoutId, imgTabLevel
							+ (indxTable + 1), this.onePixClear);
				}
			}
		}
	} catch (ecc) {
		omc.logger.addEntry("ECCEZIONE PreferitiApp.fillEpgGridLayersPreferiti "+ecc.message);
		this._objErrorInfo._methodName = "fillEpgGridLayersPreferiti";
		this._objErrorInfo._obException = ecc;
		this.handleError();
	}
};

/** ********************************************************* */
PreferitiApp.prototype.switchFocusPreferiti = function(action) {
	try {
		// var val = 0;
		// var onePixClear = '/ovaImages/1pixelclear.gif';
		// var date = this._myDate;
		var rows = this.LevelSize;
		var index = this._mySelectedChannelPreferiti % rows;
		var index_prev = (action == 'up') ? index + 1 : index - 1;

		var imgTabLevel = 'Tab_dx_';
		if (this.modificaFav) {
			this.referImageToLayout(this._layoutId, this.frecce
					+ (index_prev + 1), this.onePixClear);
			this.referImageToLayout(this._layoutId, this.frecce + (index + 1),
					this.frecce_muovi_fav);
		}

		if (action == 'up') {
			this
					.referImageToLayout(
							this._layoutId,
							imgTabLevel + (index_prev + 1),
							this.ImagePreferitiTempOff[this.ListaFavoritiTemp[this._myPrevSelectedChannelPreferiti].chanrecid].src);
			this
					.referImageToLayout(
							this._layoutId,
							imgTabLevel + (index + 1),
							this.ImagePreferitiTempOn[this.ListaFavoritiTemp[this._mySelectedChannelPreferiti].chanrecid].src);

		} else {
			this
					.referImageToLayout(
							this._layoutId,
							imgTabLevel + (index_prev + 1),
							this.ImagePreferitiTempOff[this.ListaFavoritiTemp[this._myPrevSelectedChannelPreferiti].chanrecid].src);
			this
					.referImageToLayout(
							this._layoutId,
							imgTabLevel + (index + 1),
							this.ImagePreferitiTempOn[this.ListaFavoritiTemp[this._mySelectedChannelPreferiti].chanrecid].src);

		}
	} catch (ecc) {
		this._objErrorInfo._methodName = 'switchFocusPreferiti';
		this._objErrorInfo._obException = ecc;
		this.handleError();
	}
};

PreferitiApp.prototype.getSelectedChannel = function() {
	try {
		return this._mySelectedChannel;
	} catch (ecc) {
		this._objErrorInfo._methodName = "getSelectedChannel";
		this._objErrorInfo._obException = ecc;
		this.handleError();
	}
};

PreferitiApp.prototype.salvaListaPreferiti = function() {
	try {
		var stringaskygrid = 'skygrid_';
		var prefissoHTML = "<html>"
				+ "<head>"
				+ "<meta http-equiv='cache-control' content='no-cache, must-revalidate, max-age=0'>"
				+ "<title>GetChannelPreferiti.html</title>"
				+ "<script language=\"javascript\">"
				+ "var time_ini = new Date();"
				+ "var zapperObject = { data: {zapper: [";
		var suffissoHTML = "]},expiration: 1,errorCode: null};" + "\n"
				+ "zapperObject.data.time_in = time_ini.getTime();" + "\n"
				+ "var time1 = new Date();" + "\n"
				+ "zapperObject.data.time_out = time1.getTime();" + "\n"
				+ "top.getFetcher().eventFetchCompleted(zapperObject);" + "\n"
				+ "</script></head><body></body></html>";

		var stringaCanaliPreferiti = this.costruisciStringaHTMLPreferiti();
		if (this.fw.OMC_LOGGER_ENABLED)
			omc.logger.addEntry("######### PreferitiApp ---- Salvo file: "
					+ prefissoHTML + stringaCanaliPreferiti + suffissoHTML);

		for (l = 0; l < this.ListaFavoritiTemp.length; l++) {
			this.fw.ListaFavoriti[l] = this.ListaFavoritiTemp[l];
		}
		// this.fw.ListaFavoriti =this.ListaFavoritiTemp;

		this.fw.ImagePreferitiOn = this.ImagePreferitiTempOn;
		this.fw.ImagePreferitiOff = this.ImagePreferitiTempOff;

		

		// *********************************************************************************************************************
		try {
			this.fw.cgiHasFinished = false;
			this.salvaFileBootHTML();
			
			navigator.writeFile(prefissoHTML + stringaCanaliPreferiti
					+ suffissoHTML, this.fw.URL_HTML
					+ "GetChannelPreferiti.html");
			this.fw.getTimer().setTimeout(1, this.caricaZapperInfoPreferiti,
					this);
			this.fw.getTimer().setTimeout(2000,
					this.creaImmaginiZapperPreferiti, this);

		} catch (e) {
			var stringa = '';
			var chID = null;
			var channel = null;
			for (i = 0; i < this.ListaFavoritiTemp.length; i++) {
				chID = this.ListaFavoritiTemp[i].chanrecid;
				 channel = this.fw.getBTVTuner().getEPG().getChannelByChanRecid(this.ListaFavoritiTemp[i].chanrecid);
				if(chID == 240 || chID == 241 || chID == 242 || chID == 243 
						|| chID == 244  || chID == 245  || chID == 272  || chID == 273 ){
					stringa += (i + 1) + '%20'
					+ this.spaceBlank(this.ListaFavoritiTemp[i].ChanName)
					+ ':' + stringaskygrid + (i + 1) + '_'
					+ this.ListaFavoritiTemp[i].chanrecid + ';';
				}else{
					stringa += (i + 1) + '%20'
					+ this.spaceBlank(channel.callLetters)
					+ ':' + stringaskygrid + (i + 1) + '_'
					+ this.ListaFavoritiTemp[i].chanrecid + ';';
				}
				
			}
			if (this.fw.OMC_LOGGER_ENABLED)
				omc.logger
						.addEntry("######### PreferitiApp.eventKeyHot4 ### 4 ### nuove IMG PREF: :"
								+ stringa);
			this.fw.getFetcher().fetchNow(
					'/cgi-bin/cancEcreaImg.cgi?dest=' + this.fw.TILAB_ROOT
							+ this.fw.URL_IMG_ZAPP_FAV + '&lista=' + stringa,
					this, this.EventImageUpdated);
			this.caricaImmaginiZapperPreferiti();
			omc.logger
					.addEntry("############################# FRESCO SENZA JSEXT NAVIGATOR:writeFile()#############");
			this.handleError();

		}
	} catch (ecc) {

		this.eventKeyBack();
		this._objErrorInfo._methodName = "aggiornaCanaliPref";
		this._objErrorInfo._obException = ecc;
		this.handleError();
	}
};


PreferitiApp.prototype.creaImmaginiZapperPreferiti = function() {

	this.preferiti = this.getPreferiti();
	var stringaskygrid = 'skygrid_';
	var stringa = '';
	var chID = null;
	var channel = null;
	for (i = 0; i < this.preferiti.length; i++) {
		chID = this.preferiti[i].chanrecid;
		channel = this.fw.getBTVTuner().getEPG().getChannelByChanRecid(this.preferiti[i].chanrecid);
		if(chID == 240 || chID == 241 || chID == 242 || chID == 243 
				|| chID == 244  || chID == 245  || chID == 272  || chID == 273 ){
			stringa += (i + 1) + '%20' + this.spaceBlank(this.preferiti[i].ChanName)
			+ ':' + stringaskygrid + (i + 1) + '_'
			+ this.preferiti[i].chanrecid + ';';
			omc.logger.addEntry("NOME CANALE : "+this.spaceBlank(this.preferiti[i].ChanName)+" chanRecid : "+chID);
		}else{
			stringa += (i + 1) + '%20' + this.spaceBlank(channel.callLetters)
			+ ':' + stringaskygrid + (i + 1) + '_'
			+ this.preferiti[i].chanrecid + ';';
			omc.logger.addEntry("NOME CANALE : "+this.spaceBlank(channel.callLetters)+" chanRecid : "+chID);
		}
		
	}
	if(this.fw.OMC_LOGGER_ENABLED)omc.logger.addEntry("################     PreferitiApp.creaImmaginiZapperPreferiti stringa: "+stringa);
	this.fw.getFetcher().fetchNow(
			'/cgi-bin/cancEcreaImg.cgi?dest='+this.fw.TILAB_ROOT+this.fw.URL_IMG_ZAPP_FAV+'&lista=' + stringa, this,
			this.caricaPreferitiReturn);
}

PreferitiApp.prototype.caricaPreferitiReturn = function(obj) {
	
	
	if(this.fw.OMC_LOGGER_ENABLED)omc.logger.addEntry("################     PreferitiApp.caricaPreferitiReturn CALLBACK codice: "+eval(obj.codice));
	this.fw.getTimer().setTimeout(10, this.caricaImmaginiZapperPreferiti, this);
	this.fw.getTimer().setTimeout(10, this.cgiHasFinished, this);
	return true;
}

PreferitiApp.prototype.caricaImmaginiZapperPreferiti = function() {
	this.preferiti = this.getPreferiti();
	this.fw.ImagePreferitiOn = new Array();
	this.fw.ImagePreferitiOff = new Array();
	for (j = 0; j < this.preferiti.length; j++) {
		if (this.fw.OMC_LOGGER_ENABLED)omc.logger.addEntry("this.fw.ImagePreferitiOff[this.preferiti[j].ChanName].src : "+ this.fw.URL_IMG_ZAPP_FAV+ 'skygrid_'+ (j + 1)+  '_off.png');
		if (this.fw.OMC_LOGGER_ENABLED)omc.logger.addEntry("this.fw.ImagePreferitiOn[this.preferiti[j].ChanName].src : "+ this.fw.URL_IMG_ZAPP_FAV+ 'skygrid_'+ (j + 1)+ '_on.png');
		this.fw.ImagePreferitiOff[this.preferiti[j].chanrecid] = new Image(200,34);
		this.fw.ImagePreferitiOn[this.preferiti[j].chanrecid] = new Image(200,34);
		this.fw.ImagePreferitiOff[this.preferiti[j].chanrecid].src = "file://"+this.fw.TILAB_ROOT+this.fw.URL_IMG_ZAPP_FAV
				+ '/skygrid_'
				+ (j + 1)
				+ '_'
				+ this.preferiti[j].chanrecid
				+ '_off.png';
		this.fw.ImagePreferitiOn[this.preferiti[j].chanrecid].src = "file://"+this.fw.TILAB_ROOT+this.fw.URL_IMG_ZAPP_FAV
				+ '/skygrid_'
				+ (j + 1)
				+ '_'
				+ this.preferiti[j].chanrecid
				+ '_on.png';
		
		
		if(this.fw.OMC_LOGGER_ENABLED)omc.logger.addEntry("PreferitiApp.caricaImmaginiZapperPreferiti imgOn hasLoaded: " +this.fw.ImagePreferitiOn[this.preferiti[j].chanrecid].complete);
		if(this.fw.OMC_LOGGER_ENABLED)omc.logger.addEntry("PreferitiApp.caricaImmaginiZapperPreferiti imgoff hasLoaded: " + this.fw.ImagePreferitiOff[this.preferiti[j].chanrecid].complete);
		if(this.fw.ImagePreferitiOn[this.preferiti[j].chanrecid].complete == 0 || this.fw.ImagePreferitiOff[this.preferiti[j].chanrecid].complete == 0){
			omc.logger.addEntry("PreferitiApp caricaImmaginiZapperPreferiti MANCA IMMAGINE RICREO IMMAGINI");
			this.fw.getTimer().setTimeout(10, this.creaImmaginiZapperPreferiti, this);
			return true;
		}	
	}
	
	if(this.fw.OMC_LOGGER_ENABLED)omc.logger.addEntry("Caricamento Immagini Preferiti on off .... Eseguito!!! ");
	this.fw.getLayoutManager().setLayoutVisible("caricamentoInCorso", false);
	this.fw.getLayoutManager().setLayoutVisible("salvaListaPreferiti",true);
	this.writeOnPopUp("salvaListaPreferiti", null,"/ovaImages/salvaListaPreferiti.png", 0);
	this.salvatoListaPreferiti=true;
	
	this.modificatListaFav = false;
	//this.referImageToLayout(this._layoutId, this.bottoneATTIVA_Label, this.bottoneATTIVA);
	this.referImageToLayout(this._layoutId, this.bottoneSALVA_Label, this.onePixClear);
	
	if (this.fw.OMC_LOGGER_ENABLED)
		omc.logger
				.addEntry("######### PreferitiApp ---- aggiornamento file HTML pref effettuato con SUCCESSO!!");
	if (this.fw.ListaFavoriti.length == 0) {
		this.salvaFileBootHTML();
		this.fw.ShowPreferiti = 0;
		
		//this.referImageToLayout(this._layoutId, this.bottoneATTIVA_Label, this.onePixClear);
	}else{
		this.ListaFavoritiTemp = new Array();
		this.ImagePreferitiTempOn = new Array();
		this.ImagePreferitiTempOff = new Array();
		for (l = 0; l < this.fw.ListaFavoriti.length; l++) {
			this.ListaFavoritiTemp[l] = this.fw.ListaFavoriti[l];
		}
		// this.fw.ListaFavoriti =this.ListaFavoritiTemp;

		this.ImagePreferitiTempOn = this.fw.ImagePreferitiOn ;
		this.ImagePreferitiTempOff = this.fw.ImagePreferitiOff ;

		this.fillEpgGridLayersPreferiti('down', true);
		if(this.navigationMenuPanel ==this.leftPanel){
			var selectedIndex = this.getSelectedChannelPreferiti()	% this.LevelSize;
			this.referImageToLayout(this._layoutId,	'Tab_dx_' + (selectedIndex + 1),this.ImagePreferitiTempOff[this.ListaFavoritiTemp[this._mySelectedChannelPreferiti].chanrecid].src);
		}
		
	}
}


PreferitiApp.prototype.backFunction = function() {

	try {
		// this.fw.getLayoutManager().setLayoutVisible("caricamentoInCorso",
		// false);
		this.eventKeyBack();
	} catch (ecc) {
		this._objErrorInfo._methodName = "backFunction";
		this._objErrorInfo._obException = ecc;
		this.handleError();
	}
	return true;
};

PreferitiApp.prototype.costruisciStringaHTMLPreferiti = function() {
	var stringa = "";
	var channel = null;
	var chID= null;
	try {

		for (p = 0; p < this.ListaFavoritiTemp.length; p++) {
			stringa += "{\n";
			stringa += "chantype:\'" + this.ListaFavoritiTemp[p].chantype
					+ "\',\n";
			// stringa +=
			// "ZappingId:\'"+this.ListaFavoritiTemp[p].ZappingId+"\'\n";
			stringa += "ZappingId:\'" + (p + 1) + "\',\n";
			 chID = this.ListaFavoritiTemp[p].chanrecid;	
			 channel = this.fw.getBTVTuner().getEPG().getChannelByChanRecid(this.ListaFavoritiTemp[p].chanrecid);
			if(chID == 240 || chID == 241 || chID == 242 || chID == 243 
					|| chID == 244  || chID == 245  || chID == 272  || chID == 273 ){
				stringa += "ChanName:\'" + this.ListaFavoritiTemp[p].ChanName
				+ "\',\n";
				omc.logger.addEntry("NOME CANALE : "+this.ListaFavoritiTemp[p].ChanName+" chanRecid : "+chID);
			}else{
				stringa += "ChanName:\'" + channel.callLetters
				+ "\',\n";
				omc.logger.addEntry("NOME CANALE : "+channel.callLetters+" chanRecid : "+chID);
			}
			
			stringa += "pkgrecid:\'" + this.ListaFavoritiTemp[p].pkgrecid
					+ "\',\n";
			stringa += "chanrecid:\'" + this.ListaFavoritiTemp[p].chanrecid
					+ "\',\n";
			stringa += "skyType:\'" + this.ListaFavoritiTemp[p].skyType
					+ "\',\n";
			stringa += "adultFlag:\'" + this.ListaFavoritiTemp[p].adultFlag
					+ "\',\n";
			stringa += "},\n";
		}
		// if(this.fw.OMC_LOGGER_ENABLED)omc.logger.addEntry("#########
		// PreferitiApp.costruisciStringaHTMLPreferiti ---- stringa:"+stringa);

	} catch (ecc) {
		this._objErrorInfo._methodName = "costruisciStringaHTMLPreferiti";
		this._objErrorInfo._obException = ecc;
		this.handleError();
	}
	return stringa;
};

PreferitiApp.prototype.isCanaleDefaultInPreferiti = function(
		nomeCanaleDaCercare) {
	if (this.fw.OMC_LOGGER_ENABLED)
		omc.logger.addEntry("######### PreferitiApp.isCanaleDefaultInPreferiti ###  1 ### CERCO "+ nomeCanaleDaCercare);
	var trovato = false;
	try {
		var chID = null;	
		var channel = null;
		var nomeFav = null;
		if (this.ListaFavoritiTemp.length > 0) {
			for (j = 0; j <= this.ListaFavoritiTemp.length - 1; j++) {
			
				chID = this.ListaFavoritiTemp[j].chanrecid;
			
				channel = this.fw.getBTVTuner().getEPG().getChannelByChanRecid(this.ListaFavoritiTemp[j].chanrecid);
			
				if(chID == 240 || chID == 241 || chID == 242 || chID == 243 
						|| chID == 244  || chID == 245  || chID == 272  || chID == 273 ){
			
					nomeFav = this.ListaFavoritiTemp[j].ChanName;		
			
				}else{
					nomeFav =  channel.callLetters;
				}
				if (nomeCanaleDaCercare == nomeFav) {
					if (this.fw.OMC_LOGGER_ENABLED)
						omc.logger
								.addEntry("######### PreferitiApp.isCanaleDefaultInPreferiti ###  3 ### TROVATO "
										+ nomeCanaleDaCercare);
					trovato = true;
				}
			}
		}
	} catch (ecc) {
		omc.logger.addEntry("######### ECCEZIONE PreferitiApp.isCanaleDefaultInPreferiti : "+ecc.message);
		this.handleError();
		
	}
	return trovato;
};




PreferitiApp.prototype.checkAllDefaultInPreferiti = function() {
	if (this.fw.OMC_LOGGER_ENABLED)
		omc.logger
				.addEntry("######### PreferitiApp.checkAllDefaultInPreferiti AGGIORNO ICONE ##############");
	try {
		var selectedIndex = this.getSelectedChannel() % this.LevelSize;

		var imgTabLevel = 'Tab_sx_';
		// var onePixClear = '/ovaImages/1pixelclear.gif';
		var strIcon = "counter_sx_";
		var nomeImg = "/ovaImages/canaleIsFav.png";

		var initIndex = Math
				.floor((this.getSelectedChannel() / this.LevelSize))
				* this.LevelSize;
		for (i = initIndex; i < initIndex + this.LevelSize; i++) {
			var indxArray = 0;
			var indxTable = 0;

			indxArray = i;
			indxTable = i - initIndex;

			if (indxArray < this.listaZapperCanali.length) {
				if (this
						.isCanaleDefaultInPreferiti(this.listaZapperCanali[indxArray].ChanName)) {
					this.referImageToLayout(this._layoutId, strIcon
							+ (indxTable + 1), nomeImg);
				} else {
					this.referImageToLayout(this._layoutId, strIcon
							+ (indxTable + 1), this.onePixClear);
				}
			}
		}
		if (this.fw.OMC_LOGGER_ENABLED)
			omc.logger
					.addEntry("######### PreferitiApp.checkAllDefaultInPreferiti this._ui.redraw() ##############");
		// this._ui.redraw();
		this.fillEpgGridLayers('down', true);
	} catch (ecc) {
		this._objErrorInfo._methodName = "fillEpgGridLayers";
		this._objErrorInfo._obException = ecc;
		this.handleError();
	}
	return true;
};

PreferitiApp.prototype.getSelectedChannelPreferiti = function() {
	try {
		return this._mySelectedChannelPreferiti;
	} catch (ecc) {
		this._objErrorInfo._methodName = "getSelectedChannelPreferiti";
		this._objErrorInfo._obException = ecc;
		this.handleError();
	}
};

PreferitiApp.prototype.spostaPreferito = function(action) {
	try {
		omc.logger
				.addEntry("######### PreferitiApp ---- ######  spostaPreferito "
						+ action
						+ " indice Fav:"
						+ this._mySelectedChannelPreferiti);
		switch (action) {
		case 'up':

			var prevFav = this.ListaFavoritiTemp[this._mySelectedChannelPreferiti];
			var nexFav = this.ListaFavoritiTemp[this._mySelectedChannelPreferiti - 1];
			omc.logger
					.addEntry("######### PreferitiApp ---- ######  spostaPreferito  prevFav:"
							+ prevFav.ChanName);
			omc.logger
					.addEntry("######### PreferitiApp ---- ######  spostaPreferito nexFav: "
							+ nexFav.ChanName);
			this.ListaFavoritiTemp[this._mySelectedChannelPreferiti] = nexFav;
			this.ListaFavoritiTemp[this._mySelectedChannelPreferiti - 1] = prevFav;
			this._myPrevSelectedChannelPreferiti = this._mySelectedChannelPreferiti;
			this._mySelectedChannelPreferiti--;
			this.modificatListaFav = true;
			//this.referImageToLayout(this._layoutId, this.bottoneATTIVA_Label, this.onePixClear);
			this.referImageToLayout(this._layoutId, this.bottoneSALVA_Label, this.onePixClear);
			break;

		case 'down':

			var prevFav = this.ListaFavoritiTemp[this._mySelectedChannelPreferiti];
			var nexFav = this.ListaFavoritiTemp[this._mySelectedChannelPreferiti + 1];

			omc.logger
					.addEntry("######### PreferitiApp ---- ######  spostaPreferito  prevFav:"
							+ prevFav.ChanName);
			omc.logger
					.addEntry("######### PreferitiApp ---- ######  spostaPreferito nexFav: "
							+ nexFav.ChanName);
			this.ListaFavoritiTemp[this._mySelectedChannelPreferiti] = nexFav;
			this.ListaFavoritiTemp[this._mySelectedChannelPreferiti + 1] = prevFav;
			this._myPrevSelectedChannelPreferiti = this._mySelectedChannelPreferiti;
			this._mySelectedChannelPreferiti++;
			this.modificatListaFav = true;
			//this.referImageToLayout(this._layoutId, this.bottoneATTIVA_Label, this.onePixClear);
			this.referImageToLayout(this._layoutId, this.bottoneSALVA_Label, this.onePixClear);
			break;

		}
		this.fillEpgGridLayersPreferiti(action, false);
		this.referImageToLayout(this._layoutId, this.frecce+ (this._myPrevSelectedChannelPreferiti + 1), this.onePixClear);
		this.referImageToLayout(this._layoutId, this.frecce+ (this._mySelectedChannelPreferiti + 1),this.frecce_muovi_fav);
		if(this._mySelectedChannelPreferiti == 0){
			this.referImageToLayout(this._layoutId, this.frecce	+ (this._mySelectedChannelPreferiti% this.LevelSize + 1),this.frecce_muovi_fav_down);
		}else if(this._mySelectedChannelPreferiti == this.ListaFavoritiTemp.length -1){
			this.referImageToLayout(this._layoutId, this.frecce	+ (this._mySelectedChannelPreferiti% this.LevelSize + 1),this.frecce_muovi_fav_up);
		}
	} catch (ecc) {
		this._objErrorInfo._methodName = "spostaPreferito";
		this._objErrorInfo._obException = ecc;
		this.handleError();
	}
	return true;
};

PreferitiApp.prototype.areArraysEqual = function(array1, array2) {
	var temp = new Array();
	if ((!array1[0]) || (!array2[0])) { // If either is not an array
		return false;
	}
	if (array1.length != array2.length) {
		return false;
	}
	// Put all the elements from array1 into a "tagged" array
	for ( var a = 0; a < array1.length; a++) {
		key = (typeof array1[a]) + "~" + array1[a];
		// Use "typeof" so a number 1 isn't equal to a string "1".
		if (temp[key]) {
			temp[key]++;
		} else {
			temp[key] = 1;
		}
		// temp[key] = # of occurrences of the value (so an element could appear
		// multiple times)
	}
	// Go through array2 - if same tag missing in "tagged" array, not equal
	for ( var a = 0; a < array2.length; a++) {
		key = (typeof array2[a]) + "~" + array2[a];
		if (temp[key]) {
			if (temp[key] == 0) {
				return false;
			} else {
				temp[key]--;
			}
			// Subtract to keep track of # of appearances in array2
		} else { // Key didn't appear in array1, arrays are not equal.
			return false;
		}
	}
	// If we get to this point, then every generated key in array1 showed up the
	// exact same
	// number of times in array2, so the arrays are equal.
	return true;
};
PreferitiApp.prototype.handleError = function() {
	/*
	var lunghezzaArrayTemp =  this.fw.ListaFavoriti.length;				
	for (i = 0; i <lunghezzaArrayTemp; i++) {
		this.fw.ListaFavoriti.pop();						
	}
	*/
	//this.aggiornaPrefDopoScansione();
	//this.loadApp(this.getHomeUrl(), null, null, null, null);
	return false;
};