/*   
 /ovaServices/getapp/GetApp.jsp?urlapp=startup&app1=StartupApp&app2=Logger&app3=Sender  
   
   var message_obj=new Object();
   message_obj.PIPPO="Sig.Pippo!";
   message_obj.PLUTO="Sig.Pluto!";
   this.fw.LoggerApp.debugLog(message_obj);

*/

Logger.prototype = top.getFramework().createBaseApp();
/* *********************************************************************
function Logger
parametr fw

L'oggetto Logger � istanziato nel metodo create di StartupApp.js 
con lo scopo di formattare i messaggi che verranno inviati dal Sender
 sottoforma di tap(conprotocollo snmp )
 
oid="1.1";
oid="0.1";
oid="0.2";
oid="0.3";
********************************************************************* */
function Logger(fw){
   this.fw=fw;
   
   this.Sender=new Sender(this.fw);

  /* this.INFO=0;
   this.WARNING=1;
   this.ERROR=2;
   this.DEBUG=3;
   */
   /* TIMER_TRAP_SETTING_DELAY = 86400000 */
   this._trapSettingDelay=this.fw.getConfig().TIMER_TRAP_SETTING_DELAY;//24 ore
   var time=new Date();	
	/* Impostazioni definite in index.html */
	/* DEFAULT_TRAP_LEVEL = 15 */
   	this._debugLevel=this.fw.getConfig().DEFAULT_TRAP_LEVEL;
	/* ACTIVITY_TRAP_INTERVAL = 1200 */
	this.interval=this.fw.getConfig().ACTIVITY_TRAP_INTERVAL;
	/* TRAP_RECEIVER_ADDRESS_1 = 85.33.2.182 */
	this.trap_address0=this.fw.getConfig().TRAP_RECEIVER_ADDRESS_1;
	/* TRAP_RECEIVER_ADDRESS_2 = 85.33.2.182 */
	this.trap_address1=this.fw.getConfig().TRAP_RECEIVER_ADDRESS_2;
	/* queste variabili sono tutte definite quindi non entra */
  	if(!this._debugLevel)
  	{
  			this.getPlogger("	DEFAULT_TRAP_LEVEL_NOT_PRESENT");
  	}
  	if(!this.interval)
  	{
			this.getPlogger("	ACTIVITY_TRAP_INTERVAL_NOT_PRESENT");
	}		
	if(!this.trap_address0)
	{
		this.getPlogger("	TRAP_RECEIVER_ADDRESS_1_NOT_PRESENT");
	}
	if(!this.trap_address1)
	{
		this.getPlogger("	TRAP_RECEIVER_ADDRESS_2_NOT_PRESENT");
   	}
	this.setTrap();
  
 }

Logger.prototype.setTrap=function(obj){
try{	
	
	this.DELAY_TRAP=this.interval*1000;
	this.fw.Trap_Address=this.trap_address0;
	/* Permette di lanciare una Send_trap_event_msg */
	this.startLog("SIGNON");
	this.fw._trapTimer=this.fw.getTimer().setTimeout(this.DELAY_TRAP, this.sendPeriodicalTrap, this);
	this.fw.arrTimer[0]=this.fw._trapTimer;//memorizza ID del timer in un array
	this.periodicalTrap();

}catch(ecc){
	return true;
}

	return true;

};  

	
Logger.prototype.sendPeriodicalTrap=function(){
try{
  	
   this.fw.getTimer().clearTimeout(this.fw._trapTimer);
   this.fw._trapTimer=null;
   this.fw._trapTimer=this.fw.getTimer().setTimeout(this.DELAY_TRAP, this.sendPeriodicalTrap, this);
   this.fw.arrTimer[0]=this.fw._trapTimer;//memorizza ID del timer in un array	
   
   this.periodicalTrap();
   return true;
  }catch(ecc){
  	return true;
}

};

Logger.prototype.periodicalTrap=function(){ 
	try{
 		if(this._debugLevel & 1) {
			/* La prima volta non ci sono channel (slot) */
			var BTVtuner=this.fw.getBTVTuner().getCurrentChannel(); 
			var oid="";
			var curr_app=this.fw.getAppManager().getCurrentAppUrl();
   			if(curr_app == "/ovaServices/getapp/GetApp.jsp?urlapp=videospace&app1=FullScreenVideoApp") {
   				oid="0.1";
   	 			this.vodLog(null,oid,true);
   		} else if(curr_app == "/ovaServices/getapp/GetApp.jsp?urlapp=tvspace&app1=TvFullScreenApp"|| (curr_app == "/ovaServices/getapp/GetApp.jsp?urlapp=home&app1=HomeTvApp" && !this.fw.standby)) {	    	
    	 		try{ 
   		 		var slot=this.getProgramSlot(BTVtuner.recid);
  			}catch(e){
				slot=null;
			}	
    			if(slot!=null && slot.program.type!=null && slot.program.type=="PPV" && !this.isSky(BTVtuner)) {
    				oid="0.2";
   		 		var obj=this.ppv_info();
   			}	 
   			else {	
   				oid="0.3";
   		 		var obj=this.btv_info();
   			}	
   	 		this.send(obj,this._debugLevel,oid);
		//variabile che indica lo stato di standby
   		} else if(this.fw.power==false) {
   			oid="0.4";
   			var msg="STANDBY";
   			this.send(msg,this._debugLevel,oid);
   		}
   		else if(curr_app=="/ovaServices/getapp/GetApp.jsp?urlapp=screensaver&app1=ScreenSaverApp") {
   			oid="0.4";
   			var msg="SCREENSAVER";
   			this.send(msg,this._debugLevel,oid);
   		}
   		else if(curr_app=="/ovaServices/getapp/GetApp.jsp?urlapp=portal&app1=PortalApp&app2=PortalElementUI") {	
   			oid="0.4";
   			var msg="MAIL";
   			this.send(msg,this._debugLevel,oid);
   		}
    		else if(curr_app == "/ovaServices/getapp/GetApp.jsp?urlapp=standby&app1=BrowserStandbyApp") {	
    			oid="0.4";
   			var msg="INTERNET";
   			this.send(msg,this._debugLevel,oid);
   		} else {
			/* Questo è il messaggio che appare sulla console dopo SIGNON */	
   			oid="0.4";
   			var msg="BROWSING";
   			this.send(msg,this._debugLevel,oid);
   		}
		}
		return true;
	}catch(ecc){
		return true;
	}

};	


Logger.prototype.btv_info=function(){  
  try{  
    var obj=new Object();
    var BTVtuner=this.fw.getBTVTuner().getCurrentChannel(); 
   
   	try{ 
   		var slot=this.getProgramSlot(BTVtuner.recid);
   	}catch(e){
			slot=null;
		}
 		try{
   		obj.chn_rec_id=BTVtuner.recid;
    }catch(e){
    	obj.chn_rec_id="";
    }
    
    try{
    	if(slot && slot.program && slot.program.schdid){
     		obj.sch_rec_id=slot.program.schdid;
      }else{
      	obj.sch_rec_id="";
      }	 
    }catch(e){
    	obj.sch_rec_id="";
    }
    
    try{
    	obj.catid=slot.program.catid;
		}catch(e){
			obj.catid="";
		}
		
		try{
			obj.chanType=BTVtuner.chanType;
		}catch(e){
			obj.chanType='BTV';
		}
		
		try{
			if (BTVtuner.chanType=='DVBT'){
				if (slot && slot.channel)
					obj.ip_multicast=BTVtuner.url+';'+slot.channel.callLetters;
				else
					obj.ip_multicast=BTVtuner.url+';'+BTVtuner.callLetters;
			}else{
				obj.ip_multicast=BTVtuner.url;
			}
		}catch(e){
			obj.ip_multicast="";
		}
		
		if (BTVtuner.chanType=='DVBT'){
		  try{
		   	obj.service_type=BTVtuner.service_type;
		  }catch(e){
		  	obj.service_type="";
		  }
		  try{
		  	obj.ber=BTVtuner.ber;
		  }catch(e){
		   	obj.ber=0;
		  }
		  try{
		   	obj.snr=BTVtuner.snr;
		  }catch(e){
		   	obj.snr=0;
		  }
		}
		
		if ((BTVtuner) && (BTVtuner.chanType.toLowerCase() == 'dvbt' ) && (this.fw.getDTT().getChannelByURL(BTVtuner.url) == null)){
			//caso canale dvbt non ancora scannerizzato dal stb
			this.flagNotScanned=true;
		}else{
			this.flagNotScanned=false;
		}
		
    return obj;
	}catch(ecc){
		var str='';
		return str;
	}
};


Logger.prototype.join_multicastLog=function(){
	try{ 
if(this._debugLevel & 2)
{	
 
   var oid="1.3";
   var obj=this.btv_info();
 
   obj.cmd="JOIN";
   this.send(obj,this._debugLevel,oid);
 }
 return true;
}catch(ecc){
	
	return true;
}

};

Logger.prototype.leave_multicastLog=function(){
	try{
if(this._debugLevel & 2)
 {   
   var oid="1.3";
   var obj=this.btv_info();
   obj.cmd="LEAVE";
   this.send(obj,this._debugLevel,oid);
}
return true;
}catch(ecc){
	return true;
}

};


Logger.prototype.vodPlayLog=function(){
	try{
	this.vodLog("PLAY");
	return true;
	}catch(ecc){
		return true;
}

};





Logger.prototype.vodStopLog=function(){
	try{
	this.vodLog("STOP");
	return true;
	}catch(ecc){
		return true;
}

};



Logger.prototype.errorLog=function(errorCode,flagEncode){
	try{
if(this._debugLevel & 8)
{
	var oid="3.1";
	if(flagEncode=='Y'){
		 this.sendNoEncode(errorCode,this._debugLevel,oid);
	} else
	 this.send(errorCode,this._debugLevel,oid);
}
return true;
}catch(ecc){
	return true;
}

};

Logger.prototype.startLog=function(code){
try{
if(this._debugLevel & 2)
{	/* La prima volta code vale "SIGNON", e lo si può vedere su console */
	var oid="1.4";
	//var codeSend=code+"||";
	/* Questa eseguirà il metodo send del sender */
	 this.sendNoEncode(code+"||",this._debugLevel,oid);
}
return true;
}catch(ecc){
	return true;
}

};


Logger.prototype.vodLog=function(play_state,oid,flag_periodical,vod_position){
try{
	
	  if(flag_periodical != true){
		  flag_periodical = false;
	  }
		if( (this._debugLevel & 2)  || flag_periodical)
		{	
		   var curr_app=this.fw.getAppManager().getCurrentAppUrl();
		   if(curr_app=="/ovaServices/getapp/GetApp.jsp?urlapp=videospace&app1=FullScreenVideoApp")	
		   {
		   	if(oid==null)
		   	  oid="1.1";  
		      var lista_parm=this.fw.getAppManager().getCurrentAppParam();// prende la lista dei parametri passati all'applicazione corrente (gi� in forma di array)
		      var obj=new Object();
		      var vc=this.fw.getVideoControl();
		      if(play_state==null)
		      {
			      var STATE_STOPPED =0;
			      var STATE_PLAYING =1;
			      var STATE_PAUSED =2;
			      var STATE_REWINDING =3;
			      var STATE_FAST_FORWARDING =4;
			      var STREAM_LOST=-101;
			      obj.cmd="UNKNOWN";
			      if(vc.getState()== STATE_STOPPED)
			         obj.cmd="STOP";
			      else if(vc.getState()== STATE_PLAYING)
			         obj.cmd="PLAY";
			      else if(vc.getState()== STATE_PAUSED)
			         obj.cmd="PAUSE";
			      else if(vc.getState()== STATE_REWINDING)
			         obj.cmd="RWD";
			      else if(vc.getState()== STATE_FAST_FORWARDING)
			         obj.cmd="FFD";
			      else if(vc.getState()== STREAM_LOST)
			         obj.cmd="STREAM_LOST";   
			         
			         //se si trova in fullscreenVideo non possono arrivare trap periodiche di stop
		      		if(oid=="0.1" && obj.cmd=="STOP"){
		      			oid="0.4";
		   				var msg="BROWSING";
		   				this.send(msg,this._debugLevel,oid);
		   				return true;
		      		}      
		      } else
		       {
				       /*
				       E' il caso di invio trap periodica relativa a fruizione vod e il player si trova in stato di
				       STREAM_LOST oppure di STREAM_INIT_FAILED.In tal caso la trap periodica deve
				        riportare nel msg il valore 'BROWSING'.
				       */	
						obj.cmd=play_state;	
						if(oid=="0.1" &&( obj.cmd=="STREAM_LOST" ))
				   		{	var msg="PLAY";
				   			this.send(msg,this._debugLevel,oid);
				   			return true;
				      	} 
				      	if(oid=="0.1" &&( obj.cmd=="STREAM_INIT_FAILED" ))
				   		{	var msg="BROWSING";
				   			this.send(msg,this._debugLevel,oid);
				   			return true;
				      	}                 
				}
		    
			   try{  
			   		if(lista_parm[1].svr_address) 
			      			obj.v_server=lista_parm[1].svr_address;
			      		else
			      			obj.v_server="";	
				}catch(e)
			     {
			     		obj.v_server="";
					}
			   try{
			      		 	obj.vod_rec_id=lista_parm[3]._item.id;
			      		 	if (obj.vod_rec_id==null || obj.vod_rec_id==undefined){
										obj.vod_rec_id=lista_parm[3].vod_recid;
									}   			
				}catch(e)
			     {
			     		try{ 
			     			obj.vod_rec_id=lista_parm[4].id;
			     		}catch(e)
			     		{
			     			obj.vod_rec_id="";
			     		}
				}
				try{	
					if(lista_parm[3].categoryId)
		       		 	obj.cat_recid=lista_parm[3].categoryId;
		       	else
		       		 	obj.cat_recid=lista_parm[4].cat_id;	 		
				}catch(e)
		     	{
		     		obj.cat_recid="";
		     	}
				try{  
				
				 if(vod_position!=null)
		       		 obj.cursor=parseInt(vod_position);
		        else{	 
		           	obj.cursor=parseInt(this.fw.getVideoControl().getPosition());
		       	}
		       if(obj.cursor < 0)
		       	obj.cursor="0";	
			   }catch(e)
		   	    {
		     		obj.cursor="0";
			    }
			     this.send(obj,this._debugLevel,oid);
		  }//if(curr_app=="/ovaServices/videospace_acc/FullScreenVideo.jsp")    
		}//if( (this._debugLevel & 2)  || flag_periodical)      
}catch(ecc){
		return true;
}
return true;
};


Logger.prototype.ppv_info=function(){
 try{  
    var obj=new Object();
    var BTVtuner=this.fw.getBTVTuner().getCurrentChannel(); 
    var slot;
   try{ 
       slot=this.getProgramSlot(BTVtuner.recid);
   }catch(e){
	     slot=null;
   }
    try{
        if(slot && slot.program && slot.program.schdid){
	     	 obj.sch_rec_id=slot.program.schdid;
	     }else{
	     	obj.sch_rec_id="";
	     }
    }catch(e)
    {
     	      obj.sch_rec_id="";
    }
    try{
    	  obj.catid=slot.program.catid;
	}catch(e){
		obj.catid="";
	}
    try{
       obj.ip_multicast=BTVtuner.url;
    }catch(e){
    	obj.ip_multicast="";
    }
    try{
   	   obj.chn_rec_id=BTVtuner.recid;
    }catch(e){
     	  obj.chn_rec_id="";
    } 
    return obj;
}catch(ecc){
	obj=null;
	 return obj;
}

};


Logger.prototype.join_ppvLog=function(){
try{
if(this._debugLevel & 2)
{	
   
      var oid="1.2";
      var obj=this.ppv_info();
      obj.cmd="JOIN";
      this.send(obj,this._debugLevel,oid);
}      
 return true;     
}catch(ecc){
	return true;
}
};

Logger.prototype.leave_ppvLog=function(){
try{
	if(this._debugLevel & 2)
	{
	 		
	      var oid="1.2";
	      var obj=this.ppv_info();
	      obj.cmd="LEAVE";
	      this.send(obj,this._debugLevel,oid);
	 }
	 return true;
}catch(ecc){
	return true;
} 
};


// livello pi� generico accetta in input una stringa, un oggetto o nessun parametro (corrisponde all'invocazione 
// sulla lista di parametri passati alla init dell'applicazione corrente)
Logger.prototype.debugLog=function(obj){
try{
		if(this._debugLevel & 4)
		{	
		   var oid="2";
		   this.send(obj,this._debugLevel,oid);
		}   
		 return true;
}catch(ecc){
		return true;
}
};

Logger.prototype.serialize=function(obj,oid)
{
try{
     var serialize_obj=""; 
     if(obj!=null)
     {
        if(typeof obj=='string') // se � una stringa mandala direttamente senza serializzarla...
            serialize_obj=this.encodeStringa(obj);
        else // serializza il singolo oggetto fino ad una profondit� di 3 oggetti incorporati uno nell'altro
     		serialize_obj=this.NewSerializeObj(obj,oid);
     } else // se non si passano parametri, serializza tutti i parametri presenti nell'init della pagina invocante il logdebug  
     { 
         var lista_parm=this.fw.getAppManager().getCurrentAppParam();// prende la lista dei parametri passati all'applicazione corrente (gi� in forma di array)
         serialize_obj=this.serializeArrayParam(lista_parm);
     }
     return serialize_obj;
  }catch(ecc){
  	   serialize_obj="";
  	   return serialize_obj;
}
};

Logger.prototype.serializeArrayParam=function(lista){
try{
		 var  serialize_obj="";
		 for (i=0;i<lista.length;i++)
		   {
		      if(lista[i]==null)
		       	serialize_obj=serialize_obj+"Arg["+i+"]="+lista[i]+";";
		      else if(typeof lista[i]=='object')
		          serialize_obj=serialize_obj+"Arg["+i+"]={"+this.serializeObj(lista[i])+"};";
		       else
		          serialize_obj=serialize_obj+"Arg["+i+"]="+lista[i]+";";
		   }
		 serialize_obj=serialize_obj.substring(0,serialize_obj.length-1);
		 return serialize_obj;
}catch(e){
		 serialize_obj="";
		  return serialize_obj;
}
};


Logger.prototype.serializeObj=function(obj){
try{
   serialize_obj="";
   for (var j in obj)
   {
      if(typeof obj[j]=='object' && obj[j]!=null) 
      {
         serialize_obj=serialize_obj+j+"={";
         for (var k in obj[j])
         {  
	             if(typeof obj[j][k]=='object' && obj[j][k]!=null) 
	             {
	                serialize_obj=serialize_obj+k+"={";
	                for (var h in obj[j][k])
	                {
	                   
	                  if(typeof obj[j][k][h]=='string')
	                     serialize_obj=serialize_obj+h+'="'+this.encodeStringa(obj[j][k][h])+'",'; 
	                  else
	                     serialize_obj=serialize_obj+h+"="+obj[j][k][h]+",";  
	                }
	                serialize_obj=serialize_obj.substring(0,serialize_obj.length-1)+"},"; 
	             }else if(obj[j][k]==null)
	                				serialize_obj=serialize_obj+k+"=null,"                  
	            			 else
	         				  {
				                
				                if(typeof obj[j][k]=='string')
				                  serialize_obj=serialize_obj+k+'="'+this.encodeStringa(obj[j][k])+'",'; 
				                else
				                  serialize_obj=serialize_obj+k+"="+obj[j][k]+","; 
				             }
         }
         serialize_obj=serialize_obj.substring(0,serialize_obj.length-1)+"},";
      } else if(obj[j]==null)
      {
         serialize_obj=serialize_obj+j+"=null,";
       } else  // non � un oggetto ma un parametro atomico
      {
         
         if(typeof obj[j]=='string')
            serialize_obj=serialize_obj+j+'="'+this.encodeStringa(obj[j])+'",'; 
         else
            serialize_obj=serialize_obj+j+"="+obj[j]+","; 
      	}
   }
   serialize_obj=serialize_obj.substring(0,serialize_obj.length-1);
   return serialize_obj;
}catch(ecc){
	serialize_obj='';
	 return serialize_obj;
}
};


Logger.prototype.send=function(obj,levelDebug,oid){
try{
  var mess=this.serialize(obj,oid);
   this.Sender.send(mess,levelDebug,oid);
   return true;
}catch(ecc){
	return true;
}

};


Logger.prototype.NewSerializeObj=function(obj,oid){
try{
serialize_obj="";

switch(oid)
	{
		case "0.2": //periodicalTrap ppv
			serialize_obj=obj.catid+"|"+obj.chn_rec_id+"|"+obj.sch_rec_id+"|"+obj.ip_multicast;
			break;	
		case "0.3": //periodical trap btv
			serialize_obj=obj.catid+"|"+obj.chn_rec_id+"|"+obj.sch_rec_id+"|"+obj.ip_multicast;
			if (obj.chanType.toUpperCase()=='DVBT'){
				if (this.flagNotScanned==true){
					serialize_obj=serialize_obj+"|ND";
				}else{
					obj.snr=this.formatSnr(obj.snr,4);
					obj.ber=this.formatBer(obj.ber,10);
					obj.service_type=this.formatSnr(obj.service_type,4);
					serialize_obj=serialize_obj+"|"+obj.snr+","+obj.ber+","+obj.service_type;
				}
			}else{
				serialize_obj=serialize_obj+"|";
			}
			break;
		case "1.1": case "0.1": //vod trap e periodical trap vod
			serialize_obj=obj.cat_recid+"|"+obj.vod_rec_id+"|"+obj.v_server+"|"+obj.cmd+"|"+obj.cursor;
			break;
		case "1.2":  //ppv trap
			serialize_obj=obj.catid+"|"+obj.chn_rec_id+"|"+obj.sch_rec_id+"|"+obj.ip_multicast+"|"+obj.cmd;
			break;	
		case "1.3": //btv Trap
			serialize_obj=obj.catid+"|"+obj.chn_rec_id+"|"+obj.sch_rec_id+"|"+obj.ip_multicast+"|"+obj.cmd;
			if (obj.chanType.toUpperCase()=='DVBT'){
				if (this.flagNotScanned==true){
					serialize_obj=serialize_obj+"|ND";
				}else{
					obj.snr=this.formatSnr(obj.snr,4);
					obj.ber=this.formatBer(obj.ber,10);
					obj.service_type=this.formatSnr(obj.service_type,4);
					serialize_obj=serialize_obj+"|"+obj.snr+","+obj.ber+","+obj.service_type;
				}
			}else{
				serialize_obj=serialize_obj+"|";
			}
			break;	
		case "1.4": //dtt Trap
		if (obj.typeTrap=='DTT_SERVICE_LIST'){
					obj.snr=this.formatSnr(obj.snr,4);
					obj.ber=this.formatBer(obj.ber,10);
					obj.service_type=this.formatSnr(obj.service_type,4);
			 	  serialize_obj=obj.typeTrap+"|"+obj.url+";"+obj.callLetters+"|"+obj.snr+","+obj.ber+","+obj.service_type;
			}else{
				 //btv Trap
					serialize_obj=obj.name+"|"+obj.callerApp+"|"+obj.currentApp;
			}			
			break;	
		case "3.1": //error Trap
		   serialize_obj=obj._applicationName+"|"+obj._methodName+"|"+obj.message_id+"|"+obj.message+"|" +obj._fetcherName;
			break;		
		
			
	}
   
   
   
  // serialize_obj=serialize_obj.substring(0,serialize_obj.length-1);
   return serialize_obj;	
}catch(ecc){
	serialize_obj='';	
	return serialize_obj;
}

	
};

Logger.prototype.encodeStringa=function(stringa){
try{		
  //  replace / -> //
  // 	replace " -> /�
  //  replace | -> <PIPE>
 
 // stringa=stringa.replace(/\//g,'//');
 // stringa=stringa.replace(/"/g,'/"');
  stringa=stringa.replace(/\|/g,'<PIPE>');
  return stringa;
 }catch(ecc){
 	var str='';
 	return str;
}
};

Logger.prototype.vodStreamErrorLog=function(typeStream){
try{ 
	var str=typeStream.toUpperCase() ;
 if(str =='STREAM_LOST')
 		 this.vodLog("STREAM_LOST");
 else
    if(str=='STREAM_INIT_FAILED');
    			this.vodLog("VOD_INIT_FAILED",null,null,0);   
 return true;
}catch(ecc){
	 
		return true;
}
};	

Logger.prototype.multicastStreamErrorLog=function(typeStream){
	try{ 
var ret;		
if(this._debugLevel & 2)
{	
 
   var oid="1.3";
   var obj=this.btv_info();
    var str='';
   try{	
			str=typeStream.toUpperCase() ;
  	}catch(ec){
  			str='';
  	}
   if(str=='STREAM_LOST'){
 		  obj.cmd="STREAM_LOST";
   }else{
    	if(str =='STREAM_INIT_FAILED')
      		obj.cmd="STREAM_INIT_FAILED";
    	else 	if(str =='STREAM_UNAVAILABLE')
    		      	obj.cmd='STREAM_UNAVAILABLE';
    		      	
       	  
    }      
   this.send(obj,this._debugLevel,oid);
 }
 ret=true;
}catch(ecc){
	ret=true;
}7
return ret;
};	

Logger.prototype.ppvStreamErrorLog=function(typeStream){
	try{ 
		 var ret;		
		 if(this._debugLevel & 2)
		 {	
		   
		   var oid="1.2";
		   var obj=this.btv_info();
		   var str='';
		   try{	
					str=typeStream.toUpperCase() ;
		  	}catch(ec){
		  			str='';
		  	}
		   if(str=='STREAM_LOST')
			   obj.cmd="STREAM_LOST";
		   else{
			    	if(str=='STREAM_INIT_FAILED')
			     		 obj.cmd="STREAM_INIT_FAILED";
			    	else if(str =='STREAM_UNAVAILABLE')
		    		      	obj.cmd='STREAM_UNAVAILABLE';
			        
			     }      
		   this.send(obj,this._debugLevel,oid);
		 }
		 ret=true;
	}catch(ecc){
		 ret=true;
	}
	return ret;
};

Logger.prototype.sendNoEncode=function(obj,levelDebug,oid){
		try{
			 var ret;
		    /* Esempio di chiamata code +"||",this._debugLevel,oid 
		       dove code = "SIGNON||", this._debugLevel --> DEFAULT_TRAP_LEVEL = 15  e oid impostato a 1.4 */
		    this.Sender.send(obj,levelDebug,oid);
		    ret=true;
		}catch(ecc){
			ret=true;
		}
		return ret;
};

Logger.prototype.loadAppTrap=function(callerApp,currentApp){
		try{
			var ret;
			if(this._debugLevel & 2){
				var oid="1.4"
				var obj=new Object();
				obj.name="LOADAPP";
				obj.callerApp=callerApp;
				obj.currentApp=currentApp;
				/* Crea un oggetto conforme al sender */
				this.send(obj,this._debugLevel ,oid);
			}
			ret=true;
		}catch(ecc){
			ret=true;
		}
		 return ret;
};

Logger.prototype.activityTrap=function(sActivity,sDescription){
	try{
		var ret;
		if (this.fw.power==true || this.fw.power==null){ //se non sto in standby
			if(this._debugLevel & 2){
				var oid="1.4"
				var obj=new Object();
				obj.name=sActivity;
				obj.callerApp=sDescription;
				obj.currentApp="";
				this.send(obj,this._debugLevel ,oid);
			}
		}
		ret=true;
	}catch(ecc){
		ret=true;
	}
	 return ret;
};

Logger.prototype.selectTabTrap=function(sActivity,sDescription,sType,sCategoryName){
	try{
		var ret;
		if (this.fw.power==true || this.fw.power==null){ //se non sto in standby
			if(this._debugLevel & 2){
				var oid="1.4"
				var obj=new Object();
				obj.name=sActivity;
				obj.callerApp=sDescription;
				if (sCategoryName==null || sCategoryName==undefined || sCategoryName==""){
					obj.currentApp=sType;
				}else{
					obj.currentApp=sType+";"+sCategoryName;
				}
				this.send(obj,this._debugLevel ,oid);
			}
		}
		ret=true;
	}catch(ecc){
		ret=true;
	}
	 return ret;
};

Logger.prototype.statTrap=function(teamA,teamB){
		try{
			var ret;
			if(this._debugLevel & 2){
				var oid="1.4"
				var obj=new Object();
				obj.name="STATISTICHE";
				obj.callerApp=teamA;
				obj.currentApp=teamB;
				this.send(obj,this._debugLevel ,oid);
			}
			ret=true;
		}catch(ecc){
			ret=true;
		}
		 return ret;
};


Logger.prototype.formatBer=function(val,dim){  

	var str=new String(val);
	var i=str.length;
	var ind=str.indexOf(".");
	var ap="";
	if(ind != (-1)){
		 if (parseInt(i)>0 && parseInt(i)>parseInt(dim)){
			str=str.substring(0,dim);
		}else{
		   for (;i<dim;i++){
				ap=ap+'0';
			}
	
			str=str+ap;
			}
}else {
	str=this.formatSnr(val,dim);
}
return str;
};	


Logger.prototype.formatSnr=function(val,dim){  
	var str=new String(val);
	var  i=str.length;
	var ap="";
	
	 if (parseInt(i)>0 && parseInt(i)>parseInt(dim)){
			str=str.substring(0,dim);
	}else{
	for (var j=i;j<dim;j++){
			if (parseInt(str)<0){
				ap=ap+' ';
			}else{
				ap=ap+'0';
			}
		}
	}
	str=ap+str;
	return str;
};	


Logger.prototype.serviceList_info=function(){  
  try{  
    		var oid="1.4";
				var obj=new Object();
				var chList = this.fw.getDTT().getChannels();
				var dim= chList.length;
				var obList=new Array(dim);
				var i;
				
				for (i=0;i<dim; i++)
				{ 
						 obList[i]=new Object();
						 obList[i].typeTrap='DTT_SERVICE_LIST';
						 obList[i].callLetters=chList[i].callLetters;
						 obList[i].service_type=chList[i].service_type;
						 obList[i].ber=chList[i].ber;
						 obList[i].snr=chList[i].snr;
						 obList[i].url=chList[i].url;
				     this.send(obList[i],this._debugLevel,oid);
				 }
    
}catch(e){
	return null;
}
return true;
};


/****************************************************************
FUNCTION 		: getCurrentProgramSlotIndex
PARAMETER 	: 1) chanRecid - recid del canale
DESCRIPTION : metodo che recupera l'indice del program slot attuale
							del canale identificato da chanRecid
RETURN			:	1) idx - indice slot attuale
*****************************************************************/
Logger.prototype.getCurrentProgramSlotIndex = function(chanRecid) {
	try{		
		time = this.fw.getOSD().getTime();		  	  
		//timei=time + parseInt(this.fw.getConfig().OFFSET_ORA_LEGALE);		 
		this._epg = this.fw.getBTVTuner().getEPG();
		//var idx=this._epg.findSlotIndexByTime(chanRecid,timei);
		var idx=this._epg.findSlotIndexByTime(chanRecid,time);
		if (idx==null || idx==undefined)
			idx=0; //valore di default
		return idx;
	}catch(ecc){
		this._objErrorInfo._methodName = 'getCurrentProgramSlotIndex'; 
		this._objErrorInfo._obException = ecc;
		this.handleError();
		return 0;
	}	       	
};

/****************************************************************
FUNCTION 		: getProgramSlot
PARAMETER 	: 1) chanRecid - recid del canale di cui prendere lo slot
DESCRIPTION : metodo che restituisce il program slot del canale
							identificato da chanRecid per l'indice attuale
RETURN			:	1) epgSlot - program slot restituito, null se non
													c'� schedulazione o se index � errato
*****************************************************************/
Logger.prototype.getProgramSlot = function(chanRecid) {
	try{
		//recupero lo slot index attuale
		index=this.getCurrentProgramSlotIndex(chanRecid);
		//recupero il canale attuale
		var chan = this._epg.getChannelByChanRecid(chanRecid);
		
		if(chan!= null){
			if(chan.isLocal!=true){	//caso canale non locale sia dtt che bvt
				//prendo lo slot dal db tramite epg
				var schd = this._epg.getChannelSchedule(chanRecid);
				var ret=null;
				if (schd != null && 0 <= index && index < schd.length){
					this.maxIndex = schd.length;
					ret=schd[index];
				}	
			}else if (this.isDTTEnabled() == true){ //caso canale locale dtt
				//prendo lo slot direttamente dalla ovaDTT
				var schd = this.fw.getDTT().getSchedule(chan.url,false);
				if (schd != null && schd.length>0){
					this.initIndex = 0;
					ret = schd[0];
					//ret.longdescription = schd[0].program.shortDescription;
					ret.nonUsareOffset = true;
				}else{
					ret = null;
				}	
			}
		}else if (this.isDTTEnabled() == true){
			//caso canali locale non restituito dalla epg
			if (this.fw.getDTT().getChannelByRecid(chanRecid)){
				var schd = this.fw.getDTT().getSchedule(this.fw.getDTT().getChannelByRecid(chanRecid).url,false);
			}
			if (schd != null && schd.length>0){
				this.initIndex = 0;
				ret = schd[0];
				//ret.longdescription = schd[0].program.shortDescription;
				ret.nonUsareOffset = true;
			}else{
				ret = null;
			}
		}
	}catch(ecc){
		this._objErrorInfo._methodName = 'getProgramSlot'; 
		this._objErrorInfo._obException = ecc;
		this.handleError();
	}
	return ret;       
};