 function OvaBootstrap(){ }

OvaBootstrap.prototype.create=function(){
 this._resourceStrings={};
 this._errors={};
 
 
};

OvaBootstrap.prototype.start=function(bootstrapURL, defaultAppURL) {
 if(!defaultAppURL) 
	defaultAppURL=this.fw.getConfig().DEFAULT_APP_URL;

 if(!bootstrapURL) 
	bootstrapURL=this.fw.getConfig().BOOTSTRAP_URL;

 this._defaultAppURL=defaultAppURL;

/* Inserimento di una nuova fetchRequestObject, dove  bootstrapURL --> url, this --> callerObj, this.bootstrapDone -->callback*/
 this.fw.getFetcher().fetchNow( bootstrapURL, this, this.bootstrapDone );
 };

/* Dovrebbe ricevere il secondo campo della relativa chiamata definita in OvaDataFetcher.js nella funzione 
   eventFetchCompleted. Il campo data è definito in Bootstrap.html */
OvaBootstrap.prototype.bootstrapDone=function(bootstrapData) {
 /* questi campi si possono osservare in Bootstrap.html */ 
 this.fw.getUserInfo().setUser(bootstrapData.user, true);
 this.fw.getUserInfo().setAccount(bootstrapData.account, true);
 this.fw.getUserInfo().setInventory(bootstrapData.inventory);
 this._errors=bootstrapData.errors;
 this._resourceStrings=bootstrapData.resources;
 this.fw.getRatings().setData(bootstrapData.ratings);
/* all'interno di OvaEPGManager.init(), this rappresenta callBackObj e this.epgDone callBackFunc */
 this.fw.getEPGManager().init(this, this.epgDone);
 };

 OvaBootstrap.prototype.epgDone=function(){
 if(this._defaultAppURL){ 
	/* _defaultAppURL = /ovaServices/getapp/GetApp.html, definito in index.html */
 	this.fw.getAppManager().loadApp(this._defaultAppURL);
 }
 if(eval(this.fw.getConfig().SET_FAVOURITES_NOTIFICATIONS)) this.fw.getUserInfo().setFavouritesNotifications();
 if(eval(this.fw.getConfig().SET_PPV_NOTIFICATIONS)) this.fw.getUserInfo().setPPVNotifications();
 if(eval(this.fw.getConfig().SET_NVOD_NOTIFICATIONS)) this.fw.getUserInfo().setNvodNotifications();
 };

  OvaBootstrap.prototype.getResourceStrings=function(){ return this._resourceStrings;
 };

  OvaBootstrap.prototype.getErrors=function(){ return this._errors;
 };

