function getFramework(){
    return this;
}
//################################## TILAB #########################################

var lastUrlVideo = null;


var ImageLibOnCGI = new Array();
var ImageLibOffCGI = new Array();

var ImagePreferitiOn = new Array();
var ImagePreferitiOff = new Array();




var TILAB_ROOT = null;
var URL_IMG_ZAPP_DEFAULT = null;
var URL_IMG_ZAPP_FAV     = null;
var URL_HTML             = null;		
var OMC_LOGGER_ENABLED = null;

var PREFERITI_ENABLED = null;

var VERSIONE_MOD_CANALI = null;


var SCRITTO_FILE_BOOT_HTML = false;
var firstTimeBootBox = false;
var ORDINAMENTO_CANALI_FATTO = false;
var AGGIUNTI_CANALI_DTT_LOC = false;

var refreshImmagZapper = 1;

var myIndex = 0;	//inizializzazione variabili per navigazione menu HTvApp
var verticalMenuIndex = 0;

var ListaFavoriti = new Array();
var ShowPreferiti = 0;
var BOOT = true;

var backFromExApp = false;

var cgiHasFinished = true;


var arrayTempFavScansione = new Array();

var regioneCanaliDefault="Default";



try{
	TILAB_ROOT = navigator.getEnv("TILAB_ROOT");
}catch(e){
	omc.logger.addEntry("############################# FRESCO SENZA JSEXT NAVIGATOR:GETENV()#############");
	TILAB_ROOT = "/mnt/thttpd/tilab_root/";	
}


function setLastUrlVideo(value){lastUrlVideo = value;}
function getLastUrlVideo(){return lastUrlVideo;}




omc.logger.addEntry("*********** FRAMEWORK!!");

//################################## TILAB #########################################

/* L'ordine delle create sono importanti */
function initFramework(conf){
    _layoutManager = _create(OvaLayoutManager);
    _timer = _create(OvaTimer);
    _osd = _create(OvaOSD);
    _debug = _create(OvaDebug);
    _util = _create(OvaUtil);
    _keymap = _create(OvaKeyMap);
    /* Di default CACHE_SIZE vale 20 */
    _cache = _create(OvaDataCache, _config.CACHE_SIZE);
    _gameControl = _create(OvaGameControl);
    _changeUser = _create(OvaChangeUser);
    /* Definizione di this._defaultEventMap={ eventKeyHot1: this.ACTION_ACCEPT, eventKeyHot2: this.ACTION_CANCEL }; */
    _pinDialog = _create(OvaPinDialog);
    _notifications = _create(OvaNotifications);
    _eventManager = _create(OvaEventManager);
    _videoControl = _create(OvaVideoControl);
    _drm = _create(OvaDRM);
    _fetcher = _create(OvaDataFetcher);
    _appManager = _create(OvaAppManager);
    _userInfo = _create(OvaUserInfo);
    _multilingual = _create(OvaMultilingual);
    _volume = _create(OvaVolume);
    _btvHandler = _create(OvaBTVHandler);
    /* esecuzione della funzione create di OvaBTVTuner con handler --> _btvHandler e defaultAccess --> true */
    _btvTuner = _create(OvaBTVTuner, _btvHandler, true);
    _epgManager = _create(OvaEPGManager);
    _bootstrap = _create(OvaBootstrap);
    _status = _create(OvaStatus);
    _ratings = _create(OvaRatings);
    _locale = _create(OvaLocale);
    try {
    	
        _dtt = _create(OvaDTT);
        

    } 
    catch (e) {
        _dtt = null;
        _debug.logDebug("This platform does not support DTT");
    }
    _statusBarUI = null;
	// _debug.logDebug("Eseguita initFramework!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!");
}

function getAppManager(){
    return _appManager;
}

function getEventManager(){
    return _eventManager;
}

function getLayoutManager(){
    return _layoutManager;
}

function getOSD(){
    return _osd;
}

function getFetcher(){
    return _fetcher;
}

function getDebug(){
    return _debug;
}

function getKeyMap(){
    return _keymap;
}

function getMultilingual(){
    return _multilingual;
}

function getVolume(){
    return _volume;
}

function getVideoControl(){
    return _videoControl;
}

function getDRM(){
    return _drm;
}

function getGameControl(){
    return _gameControl;
}

function getBTVTuner(){
    return _btvTuner;
}

function getEPGManager(){
    return _epgManager;
}

function getUtil(){
    return _util;
}

function getCache(){
    return _cache;
}

function getUserInfo(){
    return _userInfo;
}

function getConfig(){
    return _config;
}

function getBootstrap(){
    return _bootstrap;
}

function getStatus(){
    return _status;
}

function getChangeUser(){
    return _changeUser;
}

function getPinDialog(){
    return _pinDialog;
}

function getRatings(){
    return _ratings;
}

function getTimer(){
    return _timer;
}

function getLocale(){
    return _locale;
}

function getNotifications(){
    return _notifications;
}

function getDTT(){
    return _dtt;
}

function getStatusBarUI(){
    if (_statusBarUI == null) {
        _statusBarUI = _create(OvaStatusBarUI, "statusBarLayout");
        _statusBarUI.setStatus(_status);
    }
    return _statusBarUI;
}

function createPortal(){
    return _create(OvaPortal);
}

function createGrid(rows, cols){
    return _create(OvaGrid, rows, cols);
}

function createGridUI(layoutId){
    return _create(OvaGridUI, layoutId);
}

function createDialog(){
    return _create(OvaDialog);
}

function createDialogUI(layoutId){
    return _create(OvaDialogUI, layoutId);
}

function createNotification(){
    return _create(OvaNotification);
}

function createNotificationUI(layoutId){
    return _create(OvaNotificationUI, layoutId);
}

function createCarousel(numSlots, wrap, selSlotIndex, selDataIndex){
    return _create(OvaCarousel, numSlots, wrap, selSlotIndex, selDataIndex);
}

function createCarouselUI(layoutId){
    return _create(OvaCarouselUI, layoutId);
}

function createList(numSlots, wrap, selSlotIndex, selDataIndex){
    return _create(OvaList, numSlots, wrap, selSlotIndex, selDataIndex);
}

function createListUI(layoutId){
    return _create(OvaListUI, layoutId);
}

function createFullScreenTVUI(layoutId){
    return _create(OvaFullScreenTVUI, layoutId);
}

function createFullScreenVideoUI(layoutId){
    return _create(OvaFullScreenVideoUI, layoutId);
}

function createForm(formName){
    return _create(OvaForm, formName);
}

function createTimedInput(){
    return _create(OvaTimedInput);
}

function createFormUI(layoutId){
    return _create(OvaFormUI, layoutId);
}

function createMailReadUI(layoutId){
    return _create(MailReadUI, layoutId);
}

function createMailFormUI(layoutId){
    return _create(MailFormUI, layoutId);
}

function createComposeMailUI(layoutId){
    return _create(OvaComposeMailUI, layoutId);
}

function createSimpleFormUI(layoutId){
    return _create(OvaSimpleFormUI, layoutId);
}

function createResourceStrings(){
    return _create(OvaResourceStrings);
}

function createErrors(){
    return _create(OvaErrors);
}

function createEPG(){
    return _create(OvaEPG);
}

function createMenu(numSlots, wrap, selDataIndex){
    return _create(OvaMenu, numSlots, wrap, selDataIndex);
}

function createMenuUI(layoutId){
    return _create(OvaMenuUI, layoutId);
}

// Patch TILAB
var baseApp = null;

function createBaseApp(){
	//if(baseApp != null){
	//_debug.logDebug(">>> Creazione BaseApp");
	//	return baseApp;
	//} 
	//_debug.logDebug(">>>2");
	//baseApp = new BaseApp();
	//_debug.logDebug(">>>3");
    return new BaseApp();
}

function createClock(){
    return _create(OvaClock);
}

function createPromptMessage(message, timeout){
    return _create(OvaPromptMessage, message, timeout);
}

function createPortalUI(layoutId){
    return _create(OvaPortalUI, layoutId);
}

function _create(theConstructor){
    var obj = new theConstructor();
    obj.fw = this;
    var arr = _argsToArr(arguments);
    arr.shift();
    obj.create.apply(obj, arr);
    return obj;
}

function _argsToArr(args){
    var arr = [];
    for (var i = 0; i < args.length; i++) 
        arr.push(args[i]);
    return arr;
}

function _handleJSError(e){
    if (_debug) 
        _debug.logError("Error: " + e);
    alert(e);
}

function bootstrap(conf){
    /* Di default BOOTSTRAP_URL vale '/ovaServices/services/Bootstrap.html' e 
       DEFAULT_APP_URL vale '/ovaServices/getapp/GetApp.html'*/
	
    getBootstrap().start(conf.bootstrap_url, conf.default_app_url);
    
}
