OvaOSD.prototype.EVENT_CONSUMED=true;
 OvaOSD.prototype.EVENT_NOT_CONSUMED=false;
 OvaOSD.prototype.KEY_NAVIGATION=1;
 OvaOSD.prototype.MOUSE_NAVIGATION=2;
 OvaOSD.prototype.STAND_BY_POWER_ON=0;
 OvaOSD.prototype.STAND_BY_POWER_OFF=1;
 OvaOSD.prototype.STAND_BY_WEB_BROWSER_ON=2;
 OvaOSD.prototype.POWER_ON=0;
 OvaOSD.prototype.POWER_OFF=1;
 OvaOSD.prototype.WEB_BROWSER_ON=2;
 OvaOSD.prototype.WEB_BROWSER_OFF=3;
 
function OvaOSD(){ } OvaOSD.prototype.create=function(){
 this._eventHandler=null;
 this._clockOffset=0;
 this._tzOffset=0;
 this._standByType= this.STAND_BY_POWER_ON;
 /* Default OMC_LOGGER_INIT --> false, provare a cambiare. In questo modo entra nella if */
 this._OMC_LOGGER_INIT=eval(top.getFramework().getConfig().OMC_LOGGER_INIT);
 this._OMC_LOGGER_URL=top.getFramework().getConfig().OMC_LOGGER_URL;
 this._OMC_LOGGER_LEVEL=eval(top.getFramework().getConfig().OMC_LOGGER_LEVEL);
 this._OMC_LOGGER_ENABLED=eval(top.getFramework().getConfig().OMC_LOGGER_ENABLED);
 this._OMC_LOGGER_UPLOAD_INTERVAL=eval(top.getFramework().getConfig().OMC_LOGGER_UPLOAD_INTERVAL);
 if(!this.isPC()&& this._OMC_LOGGER_INIT ) {
 	try {
		omc.logger.init(this._OMC_LOGGER_LEVEL, this._OMC_LOGGER_URL);
 		if( this._OMC_LOGGER_ENABLED ) { 
			omc.logger.enable();
 		} omc.logger.setUploadInterval(this._OMC_LOGGER_UPLOAD_INTERVAL);
 		omc.logger.addEntry("Logging Intialized", 1);
 	} catch(e){} 
 }
 };

 OvaOSD.prototype.disableLogging=function() { omc.logger.disable();
 };

 OvaOSD.prototype.setLoggingUploadInterval=function(interval) { omc.logger.setUploadInterval(interval);
 };

 OvaOSD.prototype.terminateLogging=function() { omc.logger.term();
 };
 
 /* Registrazione this._eventHandler con il parametro passato handler */
 OvaOSD.prototype.registerEventHandler=function(handler){ 
	this._eventHandler=handler;
 };

 OvaOSD.prototype.log=function(msg, level){ if(!this.isPC()) { try { return omc.logger.addEntry(msg, level);
 } catch(e){} } };
 OvaOSD.prototype.isPC=function(){ return (navigator.userAgent.indexOf("x86") != -1);
 };
 OvaOSD.prototype.setTimezoneOffset=function(tzoffset){ this._tzOffset=tzoffset;
 };
 OvaOSD.prototype.setTime=function(localtime){ var now=new Date().getTime();
 this._clockOffset=localtime-now+parseInt(this.fw.getConfig().OFFSET_ORA_LEGALE);
 };
 OvaOSD.prototype.getTime=function(longDate){ var now;
 if(longDate){ now=new Date(longDate).getTime();
 } else { now=new Date().getTime();
 } return (now+this._clockOffset);
 };
 OvaOSD.prototype.toLocalTime=function(longdate){ return (longdate+this._tzOffset);
 };
 OvaOSD.prototype.getSTBClockOffset=function(){ return this._clockOffset;
 };
 OvaOSD.prototype.getSTBTimezoneOffset=function(){ return new Date().getTimezoneOffset()*60*1000;
 };

 OvaOSD.prototype.fetchURL=function(url){
	/* nel framework richiama la window definita in index.html tramite <iframe name='fetcher' ..> e ridefinisce 
	   location.href, preimpostata a null, con la url passata*/
 	
	 try{
	 this.fw.window.frames['fetcher'].location.href=url;
	 }catch(e){
		 
		 omc.logger.addEntry("ECCEZIONE!!!!!!!!!!!! : "+e.message);
	 }
 	if(this.fw.OMC_LOGGER_ENABLED)omc.logger.addEntry("OvaOSD.prototype.fetchURL --> url: DOPO "+url);
 };

 OvaOSD.prototype.fetchURLYouTube=function(url){
	 	this.fw.window.frames['fetcherY'].location.href=url;
};
 
 OvaOSD.prototype.reloadFramework=function(url){ if(!this.isPC()) { try { omc.stb.exit();
 } catch(e) { this.log(e,1);
 } } else { self.location.replace('/ovaServices/signon/stbSignon.jsp?ova_platform=pirelli_dtt&state=provision');
 } };
 OvaOSD.prototype.togglePower=function(){ this.setStandByMode(!this.getStandByMode());
 };
 OvaOSD.prototype.isMethodDefined=function(func){ if(func){ return true;
} else { return false;
} };
 OvaOSD.prototype.setStandByMode=function(val){ this._inStandByMode=val;
 try { if(this._inStandByMode) { if(!this.isPC()&& (this._standByType==this.STAND_BY_POWER_ON)) { omc.stb.setStandby(this.POWER_OFF);
 } this._standByType=this.STAND_BY_POWER_OFF;
 } else { if(!this.isPC()) { if(this._standByType==this.STAND_BY_POWER_OFF) { omc.stb.setStandby(this.POWER_ON);
 this._standByType=this.STAND_BY_POWER_ON;
 } else if(this._standByType==this.STAND_BY_WEB_BROWSER_ON) { omc.stb.setStandby(this.WEB_BROWSER_OFF);
 this._standByType=this.STAND_BY_POWER_ON;
 } } } } catch(e) { this.log(e,1);
 } };
 OvaOSD.prototype.setWebBrowserStandByMode=function(val){ this._inStandByMode=val;
 try { if(this._inStandByMode){ if(!this.isPC()&& (this._standByType==this.STAND_BY_POWER_ON)){ omc.stb.setStandby(this.WEB_BROWSER_ON);
 this._standByType=this.STAND_BY_WEB_BROWSER_ON;
 } } else { if(!this.isPC()&& (this._standByType==this.STAND_BY_WEB_BROWSER_ON)){ omc.stb.setStandby(this.WEB_BROWSER_OFF);
 this._standByType=this.STAND_BY_POWER_ON;
 } } } catch(e) { this.log(e,1);
 } };
  OvaOSD.prototype.powerSetTopBox=function(){ var standByStatus=false;
 if(this._standByType==this.STAND_BY_POWER_ON){ standByStatus=true;
 } this.setStandByMode(standByStatus);
 return true;
 };
  OvaOSD.prototype.powerSetTopWebBrowser=function(){ var standByStatus=false;
 if(this._standByType==this.STAND_BY_POWER_ON){ standByStatus=true;
 } this.setWebBrowserStandByMode(standByStatus);
 return true;
 };
 OvaOSD.prototype.getStandByMode=function(){ return this._inStandByMode;
 };
 OvaOSD.prototype.setNavigationMode=function(val){ this._navigationMode=val;
 if(val==this.MOUSE_NAVIGATION) { if(!this.isPC()) { try { omc.stb.setPointerMode(1);
 } catch(e) { this.log(e,1);
 } } } else if(val==this.KEY_NAVIGATION) { if(!this.isPC()) { try { omc.stb.setPointerMode(0);
 } catch(e) { this.log(e,1);
 } } } else { throw new Error("Error: unsupported navigation mode");
 } };
 OvaOSD.prototype.getNavigationMode=function(){ return this._navigationMode;
 };
 