 OvaMenuUI.prototype=new OvaBaseUI();

 function OvaMenuUI(){ } OvaMenuUI.prototype.create=function(layoutId){ this._create(layoutId);

 this._refreshTime=this.fw.getConfig().UI_CLOCK_REFRESH_INTERVAL;

 };

 OvaMenuUI.prototype.setMenu=function(menu){ this._menu=menu;

 this._curSlot=null;

 this._prevSlot=null;

 this._userColor=null;

 this._lastTime=-1;

 };

 OvaMenuUI.prototype.setUserColor=function(userColor){ this._userColor=userColor;

 };

 OvaMenuUI.prototype.redraw=function() { 

	//this.drawVideo();
 	var layoutManager=this.fw.getLayoutManager();

 	layoutManager.setLayout( this._layoutId);

 	if(this._clockRefresh)
 	{ 
 		this.fw.getTimer().clearTimeout(this._clockRefresh);
		this._clockRefresh=null;

 	} 
 	if(this._statusBarVisible!=null) 
 		this._drawStatusBar();

 if(!this._prevSlot){ for(var i=0;

i < this._menu.getNumSlots();

i++){ this._drawSlot(i);

 } } else { var curSlot=this._menu.getSelDataIndex();

 this._drawSlot(curSlot);

 this._drawSlot(this._prevSlot);

 this._prevSlot=curSlot;

 } var clr=this.fw.getUserInfo().getDisplayColour();

 var status=this.fw.getStatus();

 var user=status.getUser();

 if(!this._curUser||(user!=this._curUser)){ this._curUser=user;

 if(user && user.length > 15)user = user.substring(0, 13) + "..";

 layoutManager.writeBlock(this._layoutId, "user", '<div class="userInfo">' + user + '</div>', "html");

 } var time=this.fw.getOSD().getTime();

 var dateString=this.fw.getUtil().formatDate(new Date(time), 'DY DD<br>HH:MI');

 if(!this._curDateString||(dateString!=this._curDateString)){ this._curDateString=dateString;

 layoutManager.writeBlock(this._layoutId, "date", '<div class="dateTime">' + dateString + '</div>', "html");

 } this._drawTime();

 this._redrawByTagName("ova:label", this._menu, this._getLabel, this);

 };

  OvaMenuUI.prototype.drawVideo=function(){ 
  	
//per la gestione dello schermo intero vedere il codice della piattaforma vecchia
  	var vc = this.fw.getVideoControl();
	vc.setWindow(315, 468, 345, 312);
 };

 OvaMenuUI.prototype.hideVideo=function(){ 
	var vc=this.fw.getVideoControl();
	
	//vc.videoOff();
	
	vc.setWindow(0, 0, 0, 0);

 };

 OvaMenuUI.prototype.stopVideo=function(){ var vc=this.fw.getVideoControl();

 vc.setPlayRate(vc.MODE_STOP);

 };

 OvaMenuUI.prototype.showVideoError=function(){ 
 
 
 
 var tuner = this.fw.getBTVTuner().getDefaultHandler();

 
//var layoutManager = this.fw.getLayoutManager();
 //alert("SONO DENTRO SHOW ERROR");
//alert(this.fw.getBTVTuner().getReasonCode());
if (this.fw.getBTVTuner().getReasonCode() == tuner.AC_CHANNEL_BLOCKED_FOR_USER) 
{
	//canale bloccato 
	this.hideVideo();
	this.redraw();
	
	//layoutManager.getElement(this._layoutId, "VideoError").scroll(0,180);
} 
else if (this.fw.getBTVTuner().getReasonCode() == tuner.AC_NOT_RATED_FOR_PROGRAM) 
{
	//canale bloccato 
	this.hideVideo();
	//layoutManager.getElement(this._layoutId, "VideoError").scroll(0,270);
	this.redraw();
}	
 
 
 
 };

 OvaMenuUI.prototype.hideVideoError=function(){ var layoutManager=this.fw.getLayoutManager();

 layoutManager.setElementVisible(this._layoutId, "videoMenuUnavailable", false );

 };

 OvaMenuUI.prototype._drawSlot=function(i){ var layoutManager=this.fw.getLayoutManager();
//alert(i);
 var slotId = "R" + (i + 1);
 //alert(slotId.toString());

 var slotData=this._elementUI.getMenuElement(this._menu, slotId);

 var el=layoutManager.getElement(this._layoutId, slotId);

 if(slotData&&el){ this.fw.getLayoutManager().writeBlock(this._layoutId, el.name, slotData.content, "html");

 } };

 OvaMenuUI.prototype._drawTime=function() { var time=this.fw.getStatus().getTime();

 if(time!=this._lastTime){ var layoutManager=this.fw.getLayoutManager();

 layoutManager.writeBlock(this._layoutId, "time", '<div class="dateTime">' + time + '</div>', "text");

 } this._lastTime=time;

 if(this._refreshTime!=0){ this._clockRefresh=this.fw.getTimer().setTimeout(this._refreshTime*1000, this._drawTime, this);

 } };

 
